function [ Dmat ] = setupCheb( Npoints )
% Initalize Cheb

NN = Npoints - 1 ;

ChebR = 0.5*(1 + cos(pi*(NN:-1:0)/NN)) ;

x = @(kk) ChebR(kk+1) ;

Dmat = zeros(NN+1,NN+1) ;

for ii = 1:NN-1
    for jj = 1:NN-1
   
     if ii==jj   
         Dmat(ii+1,jj+1) = -(x(jj) - 0.5)/(2*(1-x(jj))*x(jj)) ;
     else
         Dmat(ii+1,jj+1) = (-1)^(ii+jj)/(x(ii)-x(jj)) ;
     end
     
    end
end

Dmat(1,1) = - ( 2*NN^2 + 1 )/ 3 ;

for jj = 1:NN-1
    
    Dmat(1,jj+1) = -2*(-1)^jj/x(jj) ;
     
end

Dmat(1,NN+1) = -(-1)^NN ;


Dmat(NN+1,NN+1) = + ( 2*NN^2 + 1 )/ 3 ;


for jj = 1:NN-1
    
    Dmat(NN+1,jj+1) = 2*(-1)^(NN+jj)/(1 - x(jj)) ;
     
end

Dmat(NN+1,1) = +(-1)^NN ;

for ii = 1:NN-1
    
    Dmat(ii+1,1) = +0.5*(-1)^ii/x(ii) ;
     
end


for ii = 1:NN-1
    
    Dmat(ii+1,NN+1) = -0.5*(-1)^(NN+ii)/(1-x(ii)) ;
     
end


D2mat = Dmat*Dmat ;

% Checks

[ evec, evals ] = eig(D2mat(2:NN,2:NN)) ;

tmp = sort(abs(diag(evals))) ;

clear tmp2  ; 
for ii=1:NN-1
    tmp2(ii) = tmp(ii)/( pi^2*ii^2 ) ;
end
    
tmp2


end

