%
% Code *with* scalar source.
%
%
%

function [  ] = superSpecCN3( Npoints, totv )
% run

global zarr varr farr harr aarr tarr sarr parr ;
global eq1arr eq2arr eq3arr eq4arr eq5arr c1arr c2arr c3arr ;
global v scalvev Tvev ;


[ Cheb Dmat ] = setupCheb(Npoints) ;

z = Cheb ;

[ aval f h a t s ] = readin(Npoints) ;


% dv = (0.2/Npoints) 
dv = (0.1/Npoints) 

numsteps = floor(totv/dv) 


zarr = zeros([numsteps Npoints]) ;
varr = zeros([numsteps Npoints]) ;

farr = zeros([numsteps Npoints]) ;
harr = zeros([numsteps Npoints]) ;
aarr = zeros([numsteps Npoints]) ;
tarr = zeros([numsteps Npoints]) ;
sarr = zeros([numsteps Npoints]) ;


pos = 1 ;

zarr(pos,:) = z ;
varr(pos,:) = 0 ;

farr(pos,:) = f ;
harr(pos,:) = h ;
aarr(pos,:) = a ;
tarr(pos,:) = t ;
sarr(pos,:) = s ;



for ii = 1:numsteps

    fprintf(1,' ii = %d\n',ii) ;
    
  fold = f ;  
    
[ f h a t s ] = sol(aval, f, h, a, t, s, Npoints, z, Dmat, dv*(ii-1), dv) ;

pos = pos + 1 ;    
    
zarr(pos,:) = z ;
varr(pos,:) = dv*(pos-1) ;

farr(pos,:) = f ;
harr(pos,:) = h ;
aarr(pos,:) = a ;
tarr(pos,:) = t ;
sarr(pos,:) = s ;


end



eq1arr = zeros([numsteps+1 Npoints]) ;
eq2arr = zeros([numsteps+1 Npoints]) ;
eq3arr = zeros([numsteps+1 Npoints]) ;
eq4arr = zeros([numsteps+1 Npoints]) ;
eq5arr = zeros([numsteps+1 Npoints]) ;
c1arr = zeros([numsteps+1 Npoints]) ;
c2arr = zeros([numsteps+1 Npoints]) ;
c3arr = zeros([numsteps+1 Npoints]) ;


for ii = 2:numsteps
    
    v = varr(ii,1) ;
   
    f0 = farr(ii-1,:) ;
    h0 = harr(ii-1,:) ;
    a0 = aarr(ii-1,:) ;
    t0 = tarr(ii-1,:) ;
    s0 = sarr(ii-1,:) ;
    
    f1 = farr(ii,:) ;
    h1 = harr(ii,:) ;
    a1 = aarr(ii,:) ;
    t1 = tarr(ii,:) ;
    s1 = sarr(ii,:) ;
    
    f2 = farr(ii+1,:) ;
    h2 = harr(ii+1,:) ;
    a2 = aarr(ii+1,:) ;
    t2 = tarr(ii+1,:) ;
    s2 = sarr(ii+1,:) ;
         
    [ eq1, eq2, eq3, eq4, eq5, const1, const2, const3 ] = calcalleq( aval, f0, h0, a0, t0, s0, f1, h1, a1, t1, s1, f2, h2, a2, t2, s2, Npoints, z, Dmat, v, dv ) ;
   
    eq1arr(ii,:) = eq1 ;
    eq2arr(ii,:) = eq2 ;
    eq3arr(ii,:) = eq3 ;
    eq4arr(ii,:) = eq4 ;
    eq5arr(ii,:) = eq5 ;
    c1arr(ii,:) = const1 ;
    c2arr(ii,:) = const2 ;
    c3arr(ii,:) = const3 ;
    
end



subplot(2,5,1) ;
mesh(zarr(1:pos,:),varr(1:pos,:),farr(1:pos,:).*(zarr(1:pos,:)))
subplot(2,5,2) ;
mesh(zarr(1:pos,:),varr(1:pos,:),harr(1:pos,:).*(zarr(1:pos,:)))
subplot(2,5,3) ;
mesh(zarr(1:pos,:),varr(1:pos,:),aarr(1:pos,:).*(zarr(1:pos,:)))
subplot(2,5,4) ;
mesh(zarr(1:pos,:),varr(1:pos,:),tarr(1:pos,:).*(zarr(1:pos,:).^2))
subplot(2,5,5) ;
mesh(zarr(1:pos,:),varr(1:pos,:),sarr(1:pos,:).*(zarr(1:pos,:).^2))

cut=2;

subplot(2,5,6) ;
mesh(zarr(1:pos,cut:Npoints),varr(1:pos,cut:Npoints),farr(1:pos,cut:Npoints)./(zarr(1:pos,cut:Npoints)))
subplot(2,5,7) ;
mesh(zarr(1:pos,cut:Npoints),varr(1:pos,cut:Npoints),harr(1:pos,cut:Npoints)./(zarr(1:pos,cut:Npoints)))
subplot(2,5,8) ;
mesh(zarr(1:pos,cut:Npoints),varr(1:pos,cut:Npoints),aarr(1:pos,cut:Npoints))
subplot(2,5,9) ;
mesh(zarr(1:pos,cut:Npoints),varr(1:pos,cut:Npoints),tarr(1:pos,cut:Npoints)./(zarr(1:pos,cut:Npoints)))
subplot(2,5,10) ;
mesh(zarr(1:pos,cut:Npoints),varr(1:pos,cut:Npoints),sarr(1:pos,cut:Npoints)./(zarr(1:pos,cut:Npoints).^2))




% Additional analysis

parr = sqrt(farr.^2 + harr.^2) ;

size(parr(1,:))

size(Dmat)

for ii=1:pos
   
    v(ii) = varr(ii,1) ;
    
    tmp = Dmat*transpose(parr(ii,:)) ;
    
    scalvev(ii) = tmp(1) ;
    
    tmp = Dmat*transpose(tarr(ii,:)) ;
    
    Tvev(ii) = tmp(1) ;
    
end



steps = pos ;

end



function [ aval f h a t s ] = readin( Npoints )

infile = fopen('~/Work/AdSCMTDyn3/matlab/init.dat','r') ;

if(infile==-1) 
    fprintf(1,'\n\nProblem opening file\n\n') ; 
    return ;
end

f = zeros([ 1 Npoints ]) ;
h = zeros([ 1 Npoints ]) ;
a = zeros([ 1 Npoints ]) ;
t = zeros([ 1 Npoints ]) ;
s = zeros([ 1 Npoints ]) ;

aval = fread(infile,1,'double') ;

for ii=1:Npoints
        tmp = fread(infile,5,'double') ;
        f(ii) = tmp(1) ;
        h(ii) = tmp(2) ;
        a(ii) = tmp(3) ;
        t(ii) = tmp(4) ;
        s(ii) = tmp(5) ;
end

fclose(infile) ;

for ii=1:Npoints
   
    fprintf(1,'s = %e\n',s(ii)) ;
    
end

fprintf(1,'aval = %e\n',aval) ;



end




function [ m p pv pvv ] = calcm( aval, v )

amp = 0. ;

%m = 1 + amp*exp(-100*power(-0.5 + v,2)) ;

% m = aval ;

m = aval*(1 + amp*exp(-100*power(-0.5 + v,2))) ;

%amp2 = 0.52 ;


%amp2 = 0.3 ; -> m=4.5

 amp2 = 0.0 ;
 
 p = amp2*exp(-100*power(-0.5 + v,2)) ;
 
 pv = amp2*(100. - 200.*v)*exp(-100.*power(-0.5 + v,2)) ;
 
 pvv = amp2*exp(-100.*power(-0.5 + v,2))*(9800. - 40000.*v + 40000.*power(v,2)) ;


end






function [ fnew hnew anew tnew snew ] = sol( aval, f, h, a, t, s, Npoints, z, Dmat, v, dt )

fnew = f ;
hnew = h ;
anew = a ;
tnew = t ;
snew = s ;

err = 1 ;

counter = 0 ;

while err>1e-5
    
    eq = eqn( aval, f, h, a, t, s, fnew, hnew, anew, tnew, snew, Npoints, z, Dmat, v, dt ) ;
   
    Lich = calcLich( aval, f, h, a, t, s, fnew, hnew, anew, tnew, snew, Npoints, z, Dmat, v, dt ) ;
        
    step = transpose( -linsolve(Lich,transpose(eq)) ) ;

    fnew = fnew + step(1:Npoints) ;

    hnew = hnew + step(Npoints+1:2*Npoints) ;
    
    anew = anew + step(2*Npoints+1:3*Npoints) ;
    
    snew = snew + step(3*Npoints+1:4*Npoints) ;

    tnew = tnew + step(4*Npoints+1:5*Npoints) ;

 
  err = norm(eq) ;
    
    counter = counter + 1 ;
    
end

end



function [ Lich ] = calcLich( aval, f0, h0, a0, t0, s0, f1, h1, a1, t1, s1, Npoints, z, Dmat, v, dt )

delta = 1e-6 ;

Lich = zeros(5*Npoints,5*Npoints) ;
    
for ii=1:Npoints
   
    f2 = f1 ; 
    
    f2(ii) = f1(ii) + delta ;
    
    [ eq2 ] = eqn( aval, f0, h0, a0, t0, s0, f2, h1, a1, t1, s1, Npoints, z, Dmat, v, dt ) ;
    
    f2(ii) = f1(ii) - delta ;
    
    [ eq0 ] = eqn( aval, f0, h0, a0, t0, s0, f2, h1, a1, t1, s1, Npoints, z, Dmat, v, dt ) ;
    
    Lich(:,ii) = ( eq2 - eq0 )/(2*delta) ;
    
end

for ii=1:Npoints
   
    h2 = h1 ; 
    
    h2(ii) = h1(ii) + delta ;
    
    [ eq2 ] = eqn( aval, f0, h0, a0, t0, s0, f1, h2, a1, t1, s1, Npoints, z, Dmat, v, dt ) ;
    
    h2(ii) = h1(ii) - delta ;
    
    [ eq0 ] = eqn( aval, f0, h0, a0, t0, s0, f1, h2, a1, t1, s1, Npoints, z, Dmat, v, dt ) ;
    
    Lich(:,ii+Npoints) = ( eq2 - eq0 )/(2*delta) ;
    
end

for ii=1:Npoints
   
    a2 = a1 ; 
    
    a2(ii) = a1(ii) + delta ;
    
    [ eq2 ] = eqn( aval, f0, h0, a0, t0, s0, f1, h1, a2, t1, s1, Npoints, z, Dmat, v, dt ) ;
    
    a2(ii) = a1(ii) - delta ;
    
    [ eq0 ] = eqn( aval, f0, h0, a0, t0, s0, f1, h1, a2, t1, s1, Npoints, z, Dmat, v, dt ) ;
    
    Lich(:,ii+2*Npoints) = ( eq2 - eq0 )/(2*delta) ;
    
end

for ii=1:Npoints
   
    s2 = s1 ; 
    
    s2(ii) = s1(ii) + delta ;
    
    [ eq2 ] = eqn( aval, f0, h0, a0, t0, s0, f1, h1, a1, t1, s2, Npoints, z, Dmat, v, dt ) ;
    
    s2(ii) = s1(ii) - delta ;
    
    [ eq0 ] = eqn( aval, f0, h0, a0, t0, s0, f1, h1, a1, t1, s2, Npoints, z, Dmat, v, dt ) ;
    
    Lich(:,ii+3*Npoints) = ( eq2 - eq0 )/(2*delta) ;
    
end

for ii=1:Npoints
   
    t2 = t1 ; 
    
    t2(ii) = t1(ii) + delta ;
    
    [ eq2 ] = eqn( aval, f0, h0, a0, t0, s0, f1, h1, a1, t2, s1, Npoints, z, Dmat, v, dt ) ;
    
    t2(ii) = t1(ii) - delta ;
    
    [ eq0 ] = eqn( aval, f0, h0, a0, t0, s0, f1, h1, a1, t2, s1, Npoints, z, Dmat, v, dt ) ;
    
    Lich(:,ii+4*Npoints) = ( eq2 - eq0 )/(2*delta) ;
    
end


end





function [ eq ] = eqn( aval, f0, h0, a0, t0, s0, f1, h1, a1, t1, s1, Npoints, z, Dmat, v, dt )


[ m p pv pvv ] = calcm( aval, v + 0.5*dt ) ;


f0z  = transpose(Dmat*transpose(f0)) ;
f0zz = transpose(Dmat*transpose(f0z)) ;

h0z  = transpose(Dmat*transpose(h0)) ;
h0zz = transpose(Dmat*transpose(h0z)) ;

a0z  = transpose(Dmat*transpose(a0)) ;
a0zz = transpose(Dmat*transpose(a0z)) ;

t0z  = transpose(Dmat*transpose(t0)) ;
t0zz = transpose(Dmat*transpose(t0z)) ;

s0z  = transpose(Dmat*transpose(s0)) ;
s0zz = transpose(Dmat*transpose(s0z)) ;



f1z  = transpose(Dmat*transpose(f1)) ;
f1zz = transpose(Dmat*transpose(f1z)) ;

h1z  = transpose(Dmat*transpose(h1)) ;
h1zz = transpose(Dmat*transpose(h1z)) ;

a1z  = transpose(Dmat*transpose(a1)) ;
a1zz = transpose(Dmat*transpose(a1z)) ;

t1z  = transpose(Dmat*transpose(t1)) ;
t1zz = transpose(Dmat*transpose(t1z)) ;

s1z  = transpose(Dmat*transpose(s1)) ;
s1zz = transpose(Dmat*transpose(s1z)) ;




fzz  = 0.5*(f1zz + f0zz) ;
fz   = 0.5*(f1z  + f0z) ;
f    = 0.5*(f1   + f0) ;

fvz  = (f1z - f0z)/dt ;
fv   = (f1  - f0 )/dt ;


hzz  = 0.5*(h1zz + h0zz) ;
hz   = 0.5*(h1z  + h0z) ;
h    = 0.5*(h1   + h0) ;

hvz  = (h1z - h0z)/dt ;
hv   = (h1  - h0 )/dt ;


azz  = 0.5*(a1zz + a0zz) ;
az   = 0.5*(a1z  + a0z) ;
a    = 0.5*(a1   + a0) ;

avz  = (a1z - a0z)/dt ;
av   = (a1  - a0 )/dt ;


tzz  = 0.5*(t1zz + t0zz) ;
tz   = 0.5*(t1z  + t0z) ;
t    = 0.5*(t1   + t0) ;

tvz  = (t1z - t0z)/dt ;
tv   = (t1  - t0 )/dt ;


szz  = 0.5*(s1zz + s0zz) ;
sz   = 0.5*(s1z  + s0z) ;
s    = 0.5*(s1   + s0) ;

svz  = (s1z - s0z)/dt ;
sv   = (s1  - s0 )/dt ;



bc1 = f(1) - p ;

eq1 = fvz - (fzz - 2.*hz.*m + 4.*f.*s - h.*z.*(2.*m.*(2.*s + sz.*z) + az.*(1 + s.*power(z,2))) - a.*(2.*hz.*z.*(1 + s.*power(z,2)) + h.*(1 + 5.*s.*power(z,2) + 2.*sz.*power(z,3))) + z.*(2.*fz.*t - 2.*fz.*sv.*z - 2.*fv.*sz.*z + 2.*fz.*sz.*z + fzz.*t.*z + fz.*tz.*z + f.*(-2.*sv + tz + s.*z.*(4.*t + tz.*z) + 2.*sz.*(1 + t.*power(z,2))) + 2.*fz.*sz.*t.*power(z,3) + s.*(-4.*fv - 2.*hz.*m.*z + fzz.*z.*(1 + t.*power(z,2)) + fz.*(4 + 6.*t.*power(z,2) + tz.*power(z,3))))).*power(2 + 2.*s.*power(z,2),-1) ; 

bc2 = h(1) ;

eq2 = hvz - (hzz + 2.*fz.*m + az.*f.*z - 4.*hv.*s.*z + 4.*hz.*s.*z + 4.*f.*m.*s.*z + 2.*hz.*t.*z + h.*tz.*z - 2.*sv.*z.*(h + hz.*z) + hzz.*s.*power(z,2) + 2.*fz.*m.*s.*power(z,2) - 2.*hv.*sz.*power(z,2) + 2.*hz.*sz.*power(z,2) + 2.*f.*m.*sz.*power(z,2) + hzz.*t.*power(z,2) + hz.*tz.*power(z,2) + 2.*h.*sz.*z.*(1 + t.*power(z,2)) + az.*f.*s.*power(z,3) + 6.*hz.*s.*t.*power(z,3) + h.*s.*(4 + 4.*t.*power(z,2) + tz.*power(z,3)) + a.*(2.*fz.*z.*(1 + s.*power(z,2)) + f.*(1 + 5.*s.*power(z,2) + 2.*sz.*power(z,3))) + hzz.*s.*t.*power(z,4) + 2.*hz.*sz.*t.*power(z,4) + hz.*s.*tz.*power(z,4)).*power(2 + 2.*s.*power(z,2),-1) ; 

bc3 = av(1) + 2*p*(hz(1) + m*p) ;

eq3 = avz - z.*(-2.*sv.*(a + az.*z) - av.*power(z,-2).*(1 + s.*power(z,2)) - 2.*power(z,-2).*(1 + s.*power(z,2)).*(m.*power(f,2) + a.*z.*(power(f,2) + power(h,2)) + h.*(fv + h.*m - fz.*(1 + t.*power(z,2))) + f.*(-hv + hz.*(1 + t.*power(z,2))))).*power(1 + s.*power(z,2),-1) ; 

bc4 = s(1) + 0.25*p*p ;

eq4 = svz + (power(z,-4).*(1 + s.*power(z,2)).*(12 + 4.*(2.*t + tz.*z).*power(z,2) + 4.*power(f,2).*power(z,2) + 4.*power(h,2).*power(z,2) - power(z,4).*power(a + az.*z,2) + 2.*(1 + t.*power(z,2)).*(-6 + power(z,2).*power(f + fz.*z,2) + power(z,2).*power(h + hz.*z,2)) - 4.*(2.*s + sz.*z).*(-2.*sv.*z + (2.*s + sz.*z).*(1 + t.*power(z,2))).*power(z,4).*power(1 + s.*power(z,2),-2) + 16.*(2.*s + sz.*z).*power(z,2).*(1 + t.*power(z,2)).*power(1 + s.*power(z,2),-1) - 4.*(2.*s + sz.*z).*(2.*t + tz.*z).*power(z,4).*power(1 + s.*power(z,2),-1)))/8. ; 

bc5a = t(1) + 0.5*p*p ;

bc5b = tv(2) + m*p*(h(2) + m*z(2)*p) + p*fv(2) - z(2)*p*pvv ;

eq5 = tzz - (-2.*(6.*s - t + power(h,2)) + power(a,2).*power(z,2).*power(1 + s.*power(z,2),2) - 2.*power(f,2).*(1 + t.*power(z,2)).*power(1 + s.*power(z,2),2) - 2.*f.*z.*(-fv + hz.*m.*z + 2.*fz.*(1 + t.*power(z,2))).*power(1 + s.*power(z,2),2) + 2.*a.*(az + fz.*h - f.*hz).*power(z,3).*power(1 + s.*power(z,2),2) - z.*(2.*(-2.*sv + 6.*sz + tz) + 2.*z.*power(h,2).*(t + s.*(2 + s.*power(z,2)).*(1 + t.*power(z,2))) + z.*(-(power(az,2).*power(z,2)) + 2.*(-(fv.*fz) - hv.*hz + szz + power(hz,2) - sz.*(-2.*sv + sz).*power(z,2) + power(fz,2).*(1 + t.*power(z,2)) + t.*z.*(6.*sz + z.*(szz + power(hz,2) - power(sz,2).*power(z,2)))) + 2.*s.*(z.*(2.*(sv + sz + tz) + (2.*fz.*(-fv + fz) + 2.*hz.*(-hv + hz) + szz).*z - power(az,2).*power(z,3)) + t.*(4 + (szz.*z + 2.*(sz + z.*(power(fz,2) + power(hz,2)))).*power(z,3))) + power(s,2).*(2.*(2 + (tz + z.*(-(fv.*fz) - hv.*hz + power(fz,2) + power(hz,2))).*power(z,3)) - power(az,2).*power(z,6) + 2.*t.*(power(z,2) + (power(fz,2) + power(hz,2)).*power(z,6)))) + 2.*h.*(-hv - fz.*m.*z + 2.*hz.*(1 + t.*power(z,2))).*power(1 + s.*power(z,2),2))).*power(z + s.*power(z,3),-2) ; 


eq = zeros([ 1 5*Npoints ]) ;   
   
eq(1)                       = bc1 ;
eq(2:Npoints)               = eq1(2:Npoints) ;
eq(Npoints+1)               = bc2 ;
eq(Npoints+2:2*Npoints)     = eq2(2:Npoints) ;
eq(2*Npoints+1)             = bc3 ;
eq(2*Npoints+2:3*Npoints)   = eq3(2:Npoints) ;
eq(3*Npoints+1)             = bc4 ;
eq(3*Npoints+2:4*Npoints)   = eq4(2:Npoints) ;
eq(4*Npoints+1)             = bc5a ;
eq(4*Npoints+2)             = bc5b ;
eq(4*Npoints+3:5*Npoints)   = eq5(3:Npoints) ;


end






function [ eq1, eq2, eq3, eq4, eq5, const1, const2, const3 ] = calcalleq( aval, f0, h0, a0, t0, s0, f1, h1, a1, t1, s1, f2, h2, a2, t2, s2, Npoints, z, Dmat, v, dt )


[ m p pv pvv ] = calcm( aval, v ) ;



f0z  = transpose(Dmat*transpose(f0)) ;
f1z  = transpose(Dmat*transpose(f1)) ;
f2z  = transpose(Dmat*transpose(f2)) ;
f1zz = transpose(Dmat*transpose(f1z)) ;

h0z  = transpose(Dmat*transpose(h0)) ;
h1z  = transpose(Dmat*transpose(h1)) ;
h2z  = transpose(Dmat*transpose(h2)) ;
h1zz = transpose(Dmat*transpose(h1z)) ;

a0z  = transpose(Dmat*transpose(a0)) ;
a1z  = transpose(Dmat*transpose(a1)) ;
a2z  = transpose(Dmat*transpose(a2)) ;
a1zz = transpose(Dmat*transpose(a1z)) ;

t0z  = transpose(Dmat*transpose(t0)) ;
t1z  = transpose(Dmat*transpose(t1)) ;
t2z  = transpose(Dmat*transpose(t2)) ;
t1zz = transpose(Dmat*transpose(t1z)) ;

s0z  = transpose(Dmat*transpose(s0)) ;
s1z  = transpose(Dmat*transpose(s1)) ;
s2z  = transpose(Dmat*transpose(s2)) ;
s1zz = transpose(Dmat*transpose(s1z)) ;





fvv  = (f2 + f0 - 2*f1)/(dt^2) ;

fzz  = f1zz  ;
fz   = f1z ;
f    = f1 ;

fvz  = (f2z - f0z)/(2*dt) ;
fv   = (f2  - f0 )/(2*dt) ;



hvv  = (h2 + h0 - 2*h1)/(dt^2) ;

hzz  = h1zz  ;
hz   = h1z ;
h    = h1 ;

hvz  = (h2z - h0z)/(2*dt) ;
hv   = (h2  - h0 )/(2*dt) ;



avv  = (a2 + a0 - 2*a1)/(dt^2) ;

azz  = a1zz  ;
az   = a1z ;
a    = a1 ;

avz  = (a2z - a0z)/(2*dt) ;
av   = (a2  - a0 )/(2*dt) ;



tvv  = (t2 + t0 - 2*t1)/(dt^2) ;

tzz  = t1zz  ;
tz   = t1z ;
t    = t1 ;

tvz  = (t2z - t0z)/(2*dt) ;
tv   = (t2  - t0 )/(2*dt) ;



svv  = (s2 + s0 - 2*s1)/(dt^2) ;

szz  = s1zz  ;
sz   = s1z ;
s    = s1 ;

svz  = (s2z - s0z)/(2*dt) ;
sv   = (s2  - s0 )/(2*dt) ;


eq1 = fvz - (fzz - 2.*hz.*m + 4.*f.*s - h.*z.*(2.*m.*(2.*s + sz.*z) + az.*(1 + s.*power(z,2))) - a.*(2.*hz.*z.*(1 + s.*power(z,2)) + h.*(1 + 5.*s.*power(z,2) + 2.*sz.*power(z,3))) + z.*(2.*fz.*t - 2.*fz.*sv.*z - 2.*fv.*sz.*z + 2.*fz.*sz.*z + fzz.*t.*z + fz.*tz.*z + f.*(-2.*sv + tz + s.*z.*(4.*t + tz.*z) + 2.*sz.*(1 + t.*power(z,2))) + 2.*fz.*sz.*t.*power(z,3) + s.*(-4.*fv - 2.*hz.*m.*z + fzz.*z.*(1 + t.*power(z,2)) + fz.*(4 + 6.*t.*power(z,2) + tz.*power(z,3))))).*power(2 + 2.*s.*power(z,2),-1) ; 

eq2 = hvz - (hzz + 2.*fz.*m + az.*f.*z - 4.*hv.*s.*z + 4.*hz.*s.*z + 4.*f.*m.*s.*z + 2.*hz.*t.*z + h.*tz.*z - 2.*sv.*z.*(h + hz.*z) + hzz.*s.*power(z,2) + 2.*fz.*m.*s.*power(z,2) - 2.*hv.*sz.*power(z,2) + 2.*hz.*sz.*power(z,2) + 2.*f.*m.*sz.*power(z,2) + hzz.*t.*power(z,2) + hz.*tz.*power(z,2) + 2.*h.*sz.*z.*(1 + t.*power(z,2)) + az.*f.*s.*power(z,3) + 6.*hz.*s.*t.*power(z,3) + h.*s.*(4 + 4.*t.*power(z,2) + tz.*power(z,3)) + a.*(2.*fz.*z.*(1 + s.*power(z,2)) + f.*(1 + 5.*s.*power(z,2) + 2.*sz.*power(z,3))) + hzz.*s.*t.*power(z,4) + 2.*hz.*sz.*t.*power(z,4) + hz.*s.*tz.*power(z,4)).*power(2 + 2.*s.*power(z,2),-1) ; 

eq3 = avz - z.*(-2.*sv.*(a + az.*z) - av.*power(z,-2).*(1 + s.*power(z,2)) - 2.*power(z,-2).*(1 + s.*power(z,2)).*(m.*power(f,2) + a.*z.*(power(f,2) + power(h,2)) + h.*(fv + h.*m - fz.*(1 + t.*power(z,2))) + f.*(-hv + hz.*(1 + t.*power(z,2))))).*power(1 + s.*power(z,2),-1) ; 

eq4 = svz + (power(z,-4).*(1 + s.*power(z,2)).*(12 + 4.*(2.*t + tz.*z).*power(z,2) + 4.*power(f,2).*power(z,2) + 4.*power(h,2).*power(z,2) - power(z,4).*power(a + az.*z,2) + 2.*(1 + t.*power(z,2)).*(-6 + power(z,2).*power(f + fz.*z,2) + power(z,2).*power(h + hz.*z,2)) - 4.*(2.*s + sz.*z).*(-2.*sv.*z + (2.*s + sz.*z).*(1 + t.*power(z,2))).*power(z,4).*power(1 + s.*power(z,2),-2) + 16.*(2.*s + sz.*z).*power(z,2).*(1 + t.*power(z,2)).*power(1 + s.*power(z,2),-1) - 4.*(2.*s + sz.*z).*(2.*t + tz.*z).*power(z,4).*power(1 + s.*power(z,2),-1)))/8. ; 

eq5 = tzz - (-2.*(6.*s - t + power(h,2)) + power(a,2).*power(z,2).*power(1 + s.*power(z,2),2) - 2.*power(f,2).*(1 + t.*power(z,2)).*power(1 + s.*power(z,2),2) - 2.*f.*z.*(-fv + hz.*m.*z + 2.*fz.*(1 + t.*power(z,2))).*power(1 + s.*power(z,2),2) + 2.*a.*(az + fz.*h - f.*hz).*power(z,3).*power(1 + s.*power(z,2),2) - z.*(2.*(-2.*sv + 6.*sz + tz) + 2.*z.*power(h,2).*(t + s.*(2 + s.*power(z,2)).*(1 + t.*power(z,2))) + z.*(-(power(az,2).*power(z,2)) + 2.*(-(fv.*fz) - hv.*hz + szz + power(hz,2) - sz.*(-2.*sv + sz).*power(z,2) + power(fz,2).*(1 + t.*power(z,2)) + t.*z.*(6.*sz + z.*(szz + power(hz,2) - power(sz,2).*power(z,2)))) + 2.*s.*(z.*(2.*(sv + sz + tz) + (2.*fz.*(-fv + fz) + 2.*hz.*(-hv + hz) + szz).*z - power(az,2).*power(z,3)) + t.*(4 + (szz.*z + 2.*(sz + z.*(power(fz,2) + power(hz,2)))).*power(z,3))) + power(s,2).*(2.*(2 + (tz + z.*(-(fv.*fz) - hv.*hz + power(fz,2) + power(hz,2))).*power(z,3)) - power(az,2).*power(z,6) + 2.*t.*(power(z,2) + (power(fz,2) + power(hz,2)).*power(z,6)))) + 2.*h.*(-hv - fz.*m.*z + 2.*hz.*(1 + t.*power(z,2))).*power(1 + s.*power(z,2),2))).*power(z + s.*power(z,3),-2) ; 

const1 = szz + (power(z,-2).*(4.*s + 8.*sz.*z + 2.*f.*fz.*z.*(1 + s.*power(z,2)) + power(f,2).*(1 + s.*power(z,2)) + (1 + s.*power(z,2)).*(power(fz,2).*power(z,2) + power(h + hz.*z,2))))/2. ; 

const2 = azz + 2.*(a.*z.*(2.*s + sz.*z) - (fz.*h - f.*hz).*(1 + s.*power(z,2)) + az.*(1 + 3.*s.*power(z,2) + sz.*power(z,3))).*power(z + s.*power(z,3),-1) ; 

const3 = svv + ((32.*s - 4.*t + 6.*power(h,2) + power(a,2).*power(z,2).*(-1 + (-t + 4.*(power(f,2) + power(h,2))).*power(z,2)).*power(1 + s.*power(z,2),2) + 4.*f.*z.*(-2.*hv.*m.*z + (1 + t.*power(z,2)).*(-fv + hz.*m.*z + fz.*(1 + t.*power(z,2)))).*power(1 + s.*power(z,2),2) + 2.*power(f,2).*(3 + power(z,2).*(2.*power(m,2) + t.*(4 + t.*power(z,2)))).*power(1 + s.*power(z,2),2) + 2.*a.*(4.*m.*power(f,2) - az.*(1 + t.*power(z,2)) + 2.*h.*(2.*fv + 2.*h.*m - fz.*(1 + t.*power(z,2))) + 2.*f.*(-2.*hv + hz.*(1 + t.*power(z,2)))).*power(z,3).*power(1 + s.*power(z,2),2) + z.*(4.*(-4.*sv + 4.*sz + tv + tz) + 4.*h.*(m.*z.*(2.*fv - fz.*(1 + t.*power(z,2))) + (1 + t.*power(z,2)).*(-hv + hz.*(1 + t.*power(z,2)))).*power(1 + s.*power(z,2),2) + 2.*z.*power(h,2).*(3.*s.*(2 + s.*power(z,2)) + 4.*t.*power(1 + s.*power(z,2),2) + 2.*power(m,2).*power(1 + s.*power(z,2),2) + power(t,2).*power(z,2).*power(1 + s.*power(z,2),2)) + z.*(2.*(-2.*fv.*fz - 2.*hv.*hz + power(fz,2) + 2.*(power(fv,2) + power(hv,2)) + power(hz,2)) - (power(az,2) + 4.*(-(sv.*tz) + sz.*(-2.*sv + tv + tz) + power(sz,2))).*power(z,2) - t.*z.*(power(az,2).*power(z,3) + 4.*(2.*sv - tz + fv.*fz.*z + hv.*hz.*z - z.*power(fz,2) - z.*power(hz,2) + sz.*(-6 + (-2.*sv + 2.*sz + tz).*power(z,3)))) + power(s,2).*(16 - power(z,3).*(4.*(tv + tz) - 2.*z.*(-2.*fv.*fz - 2.*hv.*hz + power(fz,2) + 2.*(power(fv,2) + power(hv,2)) + power(hz,2)) + power(az,2).*power(z,3)) + 2.*power(t,2).*power(z,4).*(-2 + (power(fz,2) + power(hz,2)).*power(z,4)) - t.*power(z,2).*(4.*(-3 + (tz + fv.*fz.*z + (hv - hz).*hz.*z - z.*power(fz,2)).*power(z,3)) + power(az,2).*power(z,6))) + s.*(-2.*power(z,2).*(-2.*(-2.*fv.*fz - 2.*hv.*hz + power(fz,2) + 2.*(power(fv,2) + power(hv,2)) + power(hz,2)) + (-2.*sv.*tz + 2.*sz.*(tv + tz) + power(az,2)).*power(z,2)) + 4.*power(t,2).*power(z,2).*(2 + (-2.*sz + z.*(power(fz,2) + power(hz,2))).*power(z,3)) - 2.*t.*(-20 + 2.*power(z,3).*(-2.*sv + 2.*fv.*fz.*z + 2.*hv.*hz.*z - 2.*z.*power(fz,2) - 2.*z.*power(hz,2) + sz.*(2 + tz.*power(z,3))) + power(az,2).*power(z,6))) + 2.*power(t,2).*(power(fz,2).*power(z,4) + power(hz,2).*power(z,4) - 2.*power(-1 + sz.*power(z,3),2))))).*power(power(z,2) + s.*power(z,4),-1))/8. ; 



end





function [ Cheb Dmat ] = setupCheb( Npoints )
% Initalize Cheb

NN = Npoints - 1 ;

Cheb = 0.5*(1 + cos(pi*(NN:-1:0)/NN)) ;

x = @(kk) Cheb(kk+1) ;

Dmat = zeros(Npoints,Npoints) ;

for ii = 1:NN-1
    for jj = 1:NN-1
   
     if ii==jj   
         Dmat(ii+1,jj+1) = -(x(jj) - 0.5)/(2*(1-x(jj))*x(jj)) ;
     else
         Dmat(ii+1,jj+1) = (-1)^(ii+jj)/(x(ii)-x(jj)) ;
     end
     
    end
end

Dmat(1,1) = - ( 2*NN^2 + 1 )/ 3 ;

for jj = 1:NN-1
    
    Dmat(1,jj+1) = -2*(-1)^jj/x(jj) ;
     
end

Dmat(1,NN+1) = -(-1)^NN ;


Dmat(NN+1,NN+1) = + ( 2*NN^2 + 1 )/ 3 ;


for jj = 1:NN-1
    
    Dmat(NN+1,jj+1) = 2*(-1)^(NN+jj)/(1 - x(jj)) ;
     
end

Dmat(NN+1,1) = +(-1)^NN ;

for ii = 1:NN-1
    
    Dmat(ii+1,1) = +0.5*(-1)^ii/x(ii) ;
     
end


for ii = 1:NN-1
    
    Dmat(ii+1,NN+1) = -0.5*(-1)^(NN+ii)/(1-x(ii)) ;
     
end


D2mat = Dmat*Dmat ;

% Checks

[ evec, evals ] = eig(D2mat(2:NN,2:NN)) ;

tmp = sort(abs(diag(evals))) ;

clear tmp2  ; 
for ii=1:NN-1
    tmp2(ii) = tmp(ii)/( pi^2*ii^2 ) ;
end


end

