(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    594841,      15608]
NotebookOptionsPosition[    583062,      15291]
NotebookOutlinePosition[    584396,      15338]
CellTagsIndexPosition[    584322,      15333]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Dynamic AdS/CMT - Superconductor - Spectral - Broken phase", "Subtitle",
 CellChangeTimes->{{3.408796983010241*^9, 3.408796989128707*^9}, {
   3.415942197687789*^9, 3.415942199707787*^9}, {3.428318203595373*^9, 
   3.4283182110266533`*^9}, {3.4318556687961187`*^9, 3.431855668994246*^9}, {
   3.495174647742872*^9, 3.460515504326817*^9}, {3.503996600043788*^9, 
   3.503996603042028*^9}, {3.507011572545054*^9, 3.460340667971311*^9}, {
   3.5374843541262083`*^9, 3.537484358716886*^9}, 3.537484391202265*^9, {
   3.537484629914453*^9, 3.537484630281348*^9}, {3.5374893532274837`*^9, 
   3.537489358050692*^9}, {3.5376274940424433`*^9, 3.537627498480837*^9}}],

Cell[BoxData[
 RowBox[{"Print", "[", "\"\<hmm\>\"", "]"}]], "Input"],

Cell[CellGroupData[{

Cell["GRSetup2.nb - modified", "Subsubtitle",
 CellChangeTimes->{{3.478330969800351*^9, 3.478330971159855*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Latest", " ", "Version"}], " ", "*)"}]], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"metric", "=", 
   RowBox[{"{", 
    RowBox[{
    "gtt", ",", "grr", ",", "g\[Theta]\[Theta]", ",", "g\[Phi]\[Phi]", ",", 
     "gzz"}], "}"}]}], "\n"}], "\n", 
 RowBox[{"Gd", "=", 
  RowBox[{"DiagonalMatrix", "[", "metric", "]"}]}]}], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Gd", "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "2"}], "]"}], "]"}], "=", "grt"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"Gd", "[", 
   RowBox[{"[", 
    RowBox[{"2", ",", "1"}], "]"}], "]"}], "=", "grt"}]}], "Input"],

Cell[BoxData[
 RowBox[{"BuildMetric", ":=", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"Gu", "=", 
     RowBox[{"FullSimplify", "[", 
      RowBox[{"Inverse", "[", "Gd", "]"}], "]"}]}], ";", 
    RowBox[{"G", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"u", ",", "d"}], "}"}], ",", 
       RowBox[{"IdentityMatrix", "[", "Nind", "]"}]}], "}"}]}], ";"}], 
   ")"}]}]], "Input"],

Cell[BoxData["BuildMetric"], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ind", "=", 
   RowBox[{"{", 
    RowBox[{"t", ",", "r", ",", "\[Theta]", ",", "\[Phi]", ",", "z"}], 
    "}"}]}], "\n"}], "\n", 
 RowBox[{"Nind", "=", 
  RowBox[{"Length", "[", "ind", "]"}]}]}], "Input",
 Editable->False],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"getind", "[", "i1_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"IntegerQ", "[", "i1", "]"}], ",", "i1", ",", 
      RowBox[{
       RowBox[{"Position", "[", 
        RowBox[{"ind", ",", "i1"}], "]"}], "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "1"}], "]"}], "]"}]}], "]"}], ")"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"lstind", "[", "i1_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"lsttmp2", "=", 
      RowBox[{"{", "}"}]}], ";", 
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{"AppendTo", "[", 
        RowBox[{"lsttmp2", ",", 
         RowBox[{"getind", "[", 
          RowBox[{"i1", "[", 
           RowBox[{"[", 
            RowBox[{"lsttmp1", ",", "1"}], "]"}], "]"}], "]"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"lsttmp1", ",", "1", ",", 
         RowBox[{"Length", "[", "i1", "]"}]}], "}"}]}], "]"}], ";", 
     "lsttmp2"}], ")"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"up", "[", 
   RowBox[{"i1_", ",", "i2_"}], "]"}], ":=", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"lsttmp2", "=", 
     RowBox[{"{", "}"}]}], ";", 
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{"AppendTo", "[", 
       RowBox[{"lsttmp2", ",", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"i1", "[", 
            RowBox[{"[", 
             RowBox[{"lsttmp1", ",", "2"}], "]"}], "]"}], "=!=", 
           RowBox[{"i2", "[", 
            RowBox[{"[", "lsttmp1", "]"}], "]"}]}], ",", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"i1", "[", 
              RowBox[{"[", 
               RowBox[{"lsttmp1", ",", "2"}], "]"}], "]"}], "===", "d"}], ",",
             "d", ",", "u"}], "]"}], ",", "0"}], "]"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"lsttmp1", ",", "1", ",", 
        RowBox[{"Length", "[", "i1", "]"}]}], "}"}]}], "]"}], ";", 
    "lsttmp2"}], ")"}]}]}], "Input",
 Editable->False],

Cell[BoxData[""], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"MT", "[", 
   RowBox[{"t1_", ",", "dim_", ",", "indpos_"}], "]"}], ":=", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"MTtmp1", "=", "0"}], ";", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Length", "[", "indpos", "]"}], "=!=", "dim"}], ",", 
      RowBox[{"Print", "[", "\"\<Error in index position\>\"", "]"}]}], "]"}],
     ";", 
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{"MTtmp1", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"MTtmp1", ",", 
         RowBox[{"{", 
          RowBox[{"MTtmp3", ",", "1", ",", "Nind"}], "}"}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"MTtmp2", ",", "1", ",", "dim"}], "}"}]}], "]"}], ";", 
    RowBox[{"t1", "=", 
     RowBox[{"{", 
      RowBox[{"indpos", ",", "MTtmp1"}], "}"}]}]}], ")"}]}]], "Input",
 Editable->False],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ST", "[", 
    RowBox[{"t1_", ",", "tind_", ",", "val_"}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"STtmp1", "=", "t1"}], ";", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"up", "[", 
         RowBox[{"tind", ",", 
          RowBox[{"t1", "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "=!=", 
        RowBox[{"Table", "[", 
         RowBox[{"0", ",", 
          RowBox[{"{", 
           RowBox[{"Length", "[", "tind", "]"}], "}"}]}], "]"}]}], ",", 
       RowBox[{
        RowBox[{"Print", "[", "\"\<Error in Index Assignment!!\>\"", "]"}], 
        ";"}]}], "]"}], ";", 
     RowBox[{
      RowBox[{"STtmp1", "[", 
       RowBox[{"[", "2", "]"}], "]"}], "=", 
      RowBox[{"ReplacePart", "[", 
       RowBox[{
        RowBox[{"t1", "[", 
         RowBox[{"[", "2", "]"}], "]"}], ",", "val", ",", 
        RowBox[{"lstind", "[", "tind", "]"}]}], "]"}]}], ";", "STtmp1"}], 
    ")"}]}], "\n"}]], "Input",
 Editable->False],

Cell["\<\


Edited the expression below as 7.0 seems to complain about Sum[x] whereas 6.0 \
would just return x (ie. if there is no sum index!)

\
\>", "Text",
 CellChangeTimes->{{3.465736646430695*^9, 3.4657366879261303`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"GT", "[", 
   RowBox[{"t1_", ",", "tind_"}], "]"}], ":=", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"GTtmp2", "=", 
     RowBox[{"up", "[", 
      RowBox[{"tind", ",", 
       RowBox[{"t1", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], ";", 
    RowBox[{"GTtmp3", "=", "\"\<\>\""}], ";", 
    RowBox[{"GTtmp4", "=", "\"\<\>\""}], ";", 
    RowBox[{"GTtmp5", "=", "\"\<\>\""}], ";", 
    RowBox[{"GTtmp6", "=", "t1"}], ";", "\n", "\t\t", 
    RowBox[{"Do", "[", "\n", "\t\t\t", 
     RowBox[{
      RowBox[{
       RowBox[{"Switch", "[", 
        RowBox[{
         RowBox[{"GTtmp2", "[", 
          RowBox[{"[", "GTtmp1", "]"}], "]"}], ",", "\n", "\t\t\t\t", "0", 
         ",", "\n", "\t\t\t\t", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"GTtmp3", "=", 
            RowBox[{"GTtmp3", "<>", "\"\<,\>\"", "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{"getind", "[", 
               RowBox[{"tind", "[", 
                RowBox[{"[", 
                 RowBox[{"GTtmp1", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}]}],
            ";"}], ")"}], ",", "\n", "\t\t\t\t", "u", ",", "\n", "\t\t\t\t", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"GTtmp3", "=", 
            RowBox[{"GTtmp3", "<>", "\"\<,\>\"", "<>", "\"\<tmpind\>\"", "<>", 
             RowBox[{"ToString", "[", "GTtmp1", "]"}]}]}], ";", "\n", 
           "\t\t\t\t\t", 
           RowBox[{"GTtmp4", "=", 
            RowBox[{"GTtmp4", "<>", "\"\< Gu[[\>\"", "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{"getind", "[", 
               RowBox[{"tind", "[", 
                RowBox[{"[", 
                 RowBox[{"GTtmp1", ",", "1"}], "]"}], "]"}], "]"}], "]"}], 
             "<>", "\"\<, tmpind\>\"", "<>", 
             RowBox[{"ToString", "[", "GTtmp1", "]"}], "<>", 
             "\"\<]] \>\""}]}], ";", "\n", "\t\t\t\t\t", 
           RowBox[{"GTtmp5", "=", 
            RowBox[{"GTtmp5", "<>", "\"\<,{tmpind\>\"", "<>", 
             RowBox[{"ToString", "[", "GTtmp1", "]"}], "<>", 
             "\"\<,1,Nind}\>\""}]}]}], ")"}], ",", "\n", "\t\t\t\t", "d", ",",
          "\n", "\t\t\t\t", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"GTtmp3", "=", 
            RowBox[{"GTtmp3", "<>", "\"\<,\>\"", "<>", "\"\<tmpind\>\"", "<>", 
             RowBox[{"ToString", "[", "GTtmp1", "]"}]}]}], ";", "\n", 
           "\t\t\t\t\t", 
           RowBox[{"GTtmp4", "=", 
            RowBox[{"GTtmp4", "<>", "\"\< Gd[[\>\"", "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{"getind", "[", 
               RowBox[{"tind", "[", 
                RowBox[{"[", 
                 RowBox[{"GTtmp1", ",", "1"}], "]"}], "]"}], "]"}], "]"}], 
             "<>", "\"\<, tmpind\>\"", "<>", 
             RowBox[{"ToString", "[", "GTtmp1", "]"}], "<>", 
             "\"\<]] \>\""}]}], ";", "\n", "\t\t\t\t\t", 
           RowBox[{"GTtmp5", "=", 
            RowBox[{"GTtmp5", "<>", "\"\<,{tmpind\>\"", "<>", 
             RowBox[{"ToString", "[", "GTtmp1", "]"}], "<>", 
             "\"\<,1,Nind}\>\""}]}], ";"}], ")"}]}], "]"}], ";"}], "\n", 
      "\t\t\t", ",", 
      RowBox[{"{", 
       RowBox[{"GTtmp1", ",", "1", ",", 
        RowBox[{"Length", "[", 
         RowBox[{"t1", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], ";", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"GTtmp4", "===", "\"\<\>\""}], "&&", 
       RowBox[{"GTtmp5", "===", "\"\<\>\""}]}], ",", 
      RowBox[{"ToExpression", "[", 
       RowBox[{"\"\<GTtmp6[[2\>\"", "<>", "GTtmp3", "<>", "\"\<]]\>\""}], 
       "]"}], ",", 
      RowBox[{"ToExpression", "[", 
       RowBox[{
       "\"\<Sum[GTtmp6[[2\>\"", "<>", "GTtmp3", "<>", "\"\<]]\>\"", "<>", 
        "GTtmp4", "<>", "GTtmp5", "<>", "\"\<]\>\""}], "]"}]}], "]"}]}], 
   ")"}]}]], "Input",
 Editable->False,
 CellChangeTimes->{{3.465736640865263*^9, 3.4657366432796392`*^9}, {
  3.465736699767317*^9, 3.4657367470041943`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Trace, Outer Product and Covariant Derivative! - GREinstein.nb\
\>", "Subsubtitle",
 Editable->False],

Cell["\<\
Syntax:   trT[tensor,{{1,4},{2,3}}]   -  ie. contract 1 and 4 plus 2 and 3 \
positions\
\>", "Text",
 Editable->False],

Cell[BoxData[
 RowBox[{
  RowBox[{"trT", "[", 
   RowBox[{"t1_", ",", "lst_"}], "]"}], ":=", 
  RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"dimt1", "=", 
     RowBox[{"Length", "[", 
      RowBox[{"Dimensions", "[", 
       RowBox[{"t1", "[", 
        RowBox[{"[", "2", "]"}], "]"}], "]"}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"tmpt1", "=", "t1"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Clear", "[", "tracetmp", "]"}], ";", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"dimt1", "===", "2"}], ",", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"tracetmp", "=", 
        RowBox[{"Sum", "[", 
         RowBox[{
          RowBox[{"GT", "[", 
           RowBox[{"tmpt1", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"s1", ",", "d"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"s1", ",", "u"}], "}"}]}], "}"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"s1", ",", "1", ",", "Nind"}], "}"}]}], "]"}]}], ";"}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"MT", "[", 
        RowBox[{"tracetmp", ",", 
         RowBox[{"dimt1", "-", 
          RowBox[{"2", 
           RowBox[{"Length", "[", "lst", "]"}]}]}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{"d", ",", 
           RowBox[{"{", 
            RowBox[{"ii", ",", "1", ",", 
             RowBox[{"dimt1", "-", 
              RowBox[{"2", 
               RowBox[{"Length", "[", "lst", "]"}]}]}]}], "}"}]}], "]"}]}], 
        "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"tmpstring1", "=", "\"\<\>\""}], ";", 
       RowBox[{"tmpstring2", "=", "\"\<\>\""}], ";", 
       RowBox[{"tmpstring3", "=", "\"\<\>\""}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"Do", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"{", "}"}], "===", 
             RowBox[{"Position", "[", 
              RowBox[{"lst", ",", "indno"}], "]"}]}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"tmpstring1", "=", 
              RowBox[{"tmpstring1", "<>", "\"\<{i\>\"", "<>", 
               RowBox[{"ToString", "[", "indno", "]"}], "<>", 
               "\"\<,d},\>\""}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"tmpstring3", "=", 
              RowBox[{"tmpstring3", "<>", "\"\<{i\>\"", "<>", 
               RowBox[{"ToString", "[", "indno", "]"}], "<>", 
               "\"\<,1,Nind},\>\""}]}], ";"}]}], "\[IndentingNewLine]", "]"}],
           ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"tmpstring2", "=", 
           RowBox[{"tmpstring2", "<>", "\"\<{i\>\"", "<>", 
            RowBox[{"ToString", "[", "indno", "]"}], "<>", "\"\<,d},\>\""}]}],
           ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
         RowBox[{"{", 
          RowBox[{"indno", ",", "1", ",", "dimt1"}], "}"}]}], "]"}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"tmpstring4", "=", "\"\<\>\""}], ";", "\[IndentingNewLine]", 
       "\n", 
       RowBox[{"Do", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"tmpstring4", "=", 
           RowBox[{"tmpstring4", "<>", "\"\<{s\>\"", "<>", 
            RowBox[{"ToString", "[", "indno", "]"}], "<>", 
            "\"\<,1,Nind},\>\""}]}], ";", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"tmpstring2", "=", 
           RowBox[{"StringReplace", "[", 
            RowBox[{"tmpstring2", ",", 
             RowBox[{
              RowBox[{"\"\<i\>\"", "<>", 
               RowBox[{"ToString", "[", 
                RowBox[{"lst", "[", 
                 RowBox[{"[", 
                  RowBox[{"indno", ",", "1"}], "]"}], "]"}], "]"}]}], "->", 
              RowBox[{"\"\<s\>\"", "<>", 
               RowBox[{"ToString", "[", "indno", "]"}]}]}]}], "]"}]}], ";", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"tmpstring2", "=", 
           RowBox[{"StringReplace", "[", 
            RowBox[{"tmpstring2", ",", 
             RowBox[{
              RowBox[{"\"\<i\>\"", "<>", 
               RowBox[{"ToString", "[", 
                RowBox[{"lst", "[", 
                 RowBox[{"[", 
                  RowBox[{"indno", ",", "2"}], "]"}], "]"}], "]"}], "<>", 
               "\"\<,d}\>\""}], "->", 
              RowBox[{"\"\<s\>\"", "<>", 
               RowBox[{"ToString", "[", "indno", "]"}], "<>", 
               "\"\<,u}\>\""}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
         "\[IndentingNewLine]", ",", 
         RowBox[{"{", 
          RowBox[{"indno", ",", "1", ",", 
           RowBox[{"Length", "[", "lst", "]"}]}], "}"}]}], "]"}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"tmpeval", "=", 
        RowBox[{"\"\<Do[tracetmp=ST[tracetmp,{\>\"", "<>", 
         RowBox[{"StringDrop", "[", 
          RowBox[{"tmpstring1", ",", 
           RowBox[{"-", "1"}]}], "]"}], "<>", "\"\<},Sum[GT[tmpt1,{\>\"", "<>", 
         RowBox[{"StringDrop", "[", 
          RowBox[{"tmpstring2", ",", 
           RowBox[{"-", "1"}]}], "]"}], "<>", "\"\<}],\>\"", "<>", 
         RowBox[{"StringDrop", "[", 
          RowBox[{"tmpstring4", ",", 
           RowBox[{"-", "1"}]}], "]"}], "<>", "\"\<]],\>\"", "<>", 
         RowBox[{"StringDrop", "[", 
          RowBox[{"tmpstring3", ",", 
           RowBox[{"-", "1"}]}], "]"}], "<>", "\"\<]\>\""}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"ToExpression", "[", "tmpeval", "]"}], ";"}]}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", "tracetmp"}], 
   "\[IndentingNewLine]", ")"}]}]], "Input",
 Editable->False],

Cell["Syntax:   outerT[tensor1,tensor2] ", "Text",
 Editable->False],

Cell[BoxData[
 RowBox[{
  RowBox[{"outerT", "[", 
   RowBox[{"t1_", ",", "t2_"}], "]"}], ":=", 
  RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"dimt1", "=", 
     RowBox[{"Length", "[", 
      RowBox[{"Dimensions", "[", 
       RowBox[{"t1", "[", 
        RowBox[{"[", "2", "]"}], "]"}], "]"}], "]"}]}], ";", 
    RowBox[{"dimt2", "=", 
     RowBox[{"Length", "[", 
      RowBox[{"Dimensions", "[", 
       RowBox[{"t2", "[", 
        RowBox[{"[", "2", "]"}], "]"}], "]"}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"tmpt1", "=", "t1"}], ";", 
    RowBox[{"tmpt2", "=", "t2"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Clear", "[", "outertmp", "]"}], ";", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"MT", "[", 
     RowBox[{"outertmp", ",", 
      RowBox[{"dimt1", "+", "dimt2"}], ",", 
      RowBox[{"Table", "[", 
       RowBox[{"d", ",", 
        RowBox[{"{", 
         RowBox[{"ii", ",", "1", ",", 
          RowBox[{"dimt1", "+", "dimt2"}]}], "}"}]}], "]"}]}], "]"}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"tmpstring1", "=", "\"\<\>\""}], ";", 
    RowBox[{"tmpstring2", "=", "\"\<\>\""}], ";", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"Do", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"tmpstring1", "=", 
        RowBox[{"tmpstring1", "<>", "\"\<{i\>\"", "<>", 
         RowBox[{"ToString", "[", "indno", "]"}], "<>", "\"\<,d},\>\""}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"tmpstring2", "=", 
        RowBox[{"tmpstring2", "<>", "\"\<{i\>\"", "<>", 
         RowBox[{"ToString", "[", "indno", "]"}], "<>", 
         "\"\<,1,Nind},\>\""}]}], ";"}], "\[IndentingNewLine]", 
      "\[IndentingNewLine]", ",", 
      RowBox[{"{", 
       RowBox[{"indno", ",", "1", ",", "dimt1"}], "}"}]}], "]"}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"tmpstring3", "=", "\"\<\>\""}], ";", 
    RowBox[{"tmpstring4", "=", "\"\<\>\""}], ";", "\[IndentingNewLine]", "\n", 
    RowBox[{"Do", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"tmpstring3", "=", 
        RowBox[{"tmpstring3", "<>", "\"\<{j\>\"", "<>", 
         RowBox[{"ToString", "[", "indno", "]"}], "<>", "\"\<,d},\>\""}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"tmpstring4", "=", 
        RowBox[{"tmpstring4", "<>", "\"\<{j\>\"", "<>", 
         RowBox[{"ToString", "[", "indno", "]"}], "<>", 
         "\"\<,1,Nind},\>\""}]}], ";"}], "\[IndentingNewLine]", 
      "\[IndentingNewLine]", ",", 
      RowBox[{"{", 
       RowBox[{"indno", ",", "1", ",", "dimt2"}], "}"}]}], "]"}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"tmpeval", "=", 
     RowBox[{"\"\<Do[outertmp=ST[outertmp,{\>\"", "<>", "tmpstring1", "<>", 
      RowBox[{"StringDrop", "[", 
       RowBox[{"tmpstring3", ",", 
        RowBox[{"-", "1"}]}], "]"}], "<>", "\"\<},GT[tmpt1,{\>\"", "<>", 
      RowBox[{"StringDrop", "[", 
       RowBox[{"tmpstring1", ",", 
        RowBox[{"-", "1"}]}], "]"}], "<>", "\"\<}]GT[tmpt2,{\>\"", "<>", 
      RowBox[{"StringDrop", "[", 
       RowBox[{"tmpstring3", ",", 
        RowBox[{"-", "1"}]}], "]"}], "<>", "\"\<}]],\>\"", "<>", "tmpstring2",
       "<>", 
      RowBox[{"StringDrop", "[", 
       RowBox[{"tmpstring4", ",", 
        RowBox[{"-", "1"}]}], "]"}], "<>", "\"\<]\>\""}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"ToExpression", "[", "tmpeval", "]"}], ";", "\[IndentingNewLine]",
     "\[IndentingNewLine]", "outertmp"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", ")"}]}]], "Input",
 Editable->False],

Cell[BoxData[
 RowBox[{
  RowBox[{"scalarDT", "[", "t1_", "]"}], ":=", 
  RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"tmpt1", "=", "t1"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Clear", "[", "covDTtmp", "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"MT", "[", 
     RowBox[{"covDTtmp", ",", "1", ",", 
      RowBox[{"{", "d", "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{
    "tmpeval", "=", 
     "\"\<Do[covDTtmp=ST[covDTtmp,{{i1,d}},D[tmpt1,ind[[i1]]]],{i1,1,Nind}]\>\
\""}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"ToExpression", "[", "tmpeval", "]"}], ";", "\[IndentingNewLine]",
     "\[IndentingNewLine]", "covDTtmp"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", ")"}]}]], "Input",
 Editable->False],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"covDT", "[", "t1_", "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"dimt1", "=", 
      RowBox[{"Length", "[", 
       RowBox[{"Dimensions", "[", 
        RowBox[{"t1", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmpt1", "=", "t1"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Clear", "[", "covDTtmp", "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"MT", "[", 
      RowBox[{"covDTtmp", ",", 
       RowBox[{"dimt1", "+", "1"}], ",", 
       RowBox[{"Table", "[", 
        RowBox[{"d", ",", 
         RowBox[{"{", 
          RowBox[{"ii", ",", "1", ",", 
           RowBox[{"dimt1", "+", "1"}]}], "}"}]}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"Build", " ", "expression"}], " ", "*)"}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"tmpstring1", "=", "\"\<\>\""}], ";", 
     RowBox[{"tmpstring2", "=", "\"\<\>\""}], ";", 
     RowBox[{"tmpstring3", "=", "\"\<\>\""}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"Do", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"tmpstring1", "=", 
         RowBox[{"tmpstring1", "<>", "\"\<{i\>\"", "<>", 
          RowBox[{"ToString", "[", "indno", "]"}], "<>", "\"\<,d},\>\""}]}], 
        ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"tmpstring2", "=", 
         RowBox[{"tmpstring2", "<>", "\"\<{i\>\"", "<>", 
          RowBox[{"ToString", "[", "indno", "]"}], "<>", 
          "\"\<,1,Nind},\>\""}]}], ";"}], "\[IndentingNewLine]", 
       "\[IndentingNewLine]", ",", 
       RowBox[{"{", 
        RowBox[{"indno", ",", "1", ",", "dimt1"}], "}"}]}], "]"}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"Do", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"tmpstring4", "=", 
         RowBox[{"\"\<-Sum[GT[tmpt1,{\>\"", "<>", 
          RowBox[{"StringDrop", "[", 
           RowBox[{"tmpstring1", ",", 
            RowBox[{"-", "1"}]}], "]"}], "<>", 
          "\"\<}]GT[\[CapitalGamma],{{REPL,d},{s1,d},{s2,u}}],{s2,1,Nind}]\>\"\
"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"tmpstring4", "=", 
         RowBox[{"StringReplace", "[", 
          RowBox[{"tmpstring4", ",", 
           RowBox[{
            RowBox[{"\"\<i\>\"", "<>", 
             RowBox[{"ToString", "[", "indno", "]"}]}], "\[Rule]", " ", 
            "\"\<s2\>\""}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"tmpstring4", "=", 
         RowBox[{"StringReplace", "[", 
          RowBox[{"tmpstring4", ",", 
           RowBox[{"\"\<REPL\>\"", "\[Rule]", 
            RowBox[{"\"\<i\>\"", "<>", 
             RowBox[{"ToString", "[", "indno", "]"}]}]}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"tmpstring3", "=", 
         RowBox[{"tmpstring3", "<>", "tmpstring4"}]}], ";"}], 
       "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
       RowBox[{"{", 
        RowBox[{"indno", ",", "1", ",", "dimt1"}], "}"}]}], "]"}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"tmpeval", "=", 
      RowBox[{
      "\"\<Do[covDTtmp=ST[covDTtmp,{\>\"", "<>", "tmpstring1", "<>", 
       "\"\<{s1,d}},D[GT[tmpt1,{\>\"", "<>", 
       RowBox[{"StringDrop", "[", 
        RowBox[{"tmpstring1", ",", 
         RowBox[{"-", "1"}]}], "]"}], "<>", "\"\<}],ind[[s1]]]\>\"", "<>", 
       "tmpstring3", "<>", "\"\<],\>\"", "<>", "tmpstring2", "<>", 
       "\"\<{s1,1,Nind}]\>\""}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"ToExpression", "[", "tmpeval", "]"}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "covDTtmp"}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 Editable->False],

Cell[BoxData["."], "Input",
 CellChangeTimes->{3.399009138941909*^9},
 EmphasizeSyntaxErrors->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Buildmetric", "Subsubtitle"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Gd", "=", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"z", "^", "2"}]], 
    RowBox[{"(", GridBox[{
       {
        RowBox[{"-", 
         RowBox[{"T", "[", 
          RowBox[{"v", ",", "z"}], "]"}]}], 
        RowBox[{"-", 
         RowBox[{"gvz", "[", 
          RowBox[{"v", ",", "z"}], "]"}]}], "0", "0"},
       {
        RowBox[{"-", 
         RowBox[{"gvz", "[", 
          RowBox[{"v", ",", "z"}], "]"}]}], 
        RowBox[{"gzz", "[", 
         RowBox[{"v", ",", "z"}], "]"}], "0", "0"},
       {"0", "0", 
        RowBox[{
         RowBox[{"S", "[", 
          RowBox[{"v", ",", "z"}], "]"}], "^", "2"}], "0"},
       {"0", "0", "0", 
        RowBox[{
         RowBox[{"S", "[", 
          RowBox[{"v", ",", "z"}], "]"}], "^", "2"}]}
      }], ")"}]}]}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ind", "=", 
   RowBox[{"{", 
    RowBox[{"v", ",", "z", ",", "x1", ",", "x2"}], "}"}]}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{"Nind", "=", 
   RowBox[{"Length", "[", "ind", "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"BuildMetric", ";"}]}], "Input",
 CellChangeTimes->{{3.408796998476103*^9, 3.408797030516582*^9}, {
   3.408799071597343*^9, 3.408799082644943*^9}, {3.408949739095245*^9, 
   3.408949739644734*^9}, {3.408949841695282*^9, 3.40894984293303*^9}, {
   3.415862083663703*^9, 3.4158620851642113`*^9}, {3.415862334623486*^9, 
   3.415862336021243*^9}, {3.415862388498528*^9, 3.4158623965197372`*^9}, {
   3.4158641082437763`*^9, 3.415864116357332*^9}, {3.415865034672494*^9, 
   3.415865047473855*^9}, {3.415943026431671*^9, 3.415943056090918*^9}, {
   3.42453089354659*^9, 3.424530981705195*^9}, {3.4262330694486513`*^9, 
   3.426233078224708*^9}, {3.42831552177035*^9, 3.428315531925826*^9}, {
   3.482669504390863*^9, 3.482669559589313*^9}, {3.482669593648382*^9, 
   3.4826696108221407`*^9}, {3.4826696421684*^9, 3.460306349771068*^9}, {
   3.460306681872867*^9, 3.4603066892293873`*^9}, {3.460306743915044*^9, 
   3.460306776656151*^9}, {3.4603068906726713`*^9, 3.4603069154556093`*^9}, 
   3.4606109474491568`*^9, {3.5039972414730186`*^9, 3.503997244123049*^9}, {
   3.507011580676421*^9, 3.507011659804162*^9}, {3.507013755598536*^9, 
   3.460392698323369*^9}, {3.4604018613321533`*^9, 3.4604018646719627`*^9}, {
   3.460401965632374*^9, 3.460401968163259*^9}, {3.4604023388162813`*^9, 
   3.4604023558966084`*^9}, {3.460402422665003*^9, 3.460402426690833*^9}, {
   3.460402628586185*^9, 3.4604026419139843`*^9}, {3.460402674350209*^9, 
   3.4604026844332027`*^9}, {3.460512773931822*^9, 3.460512787444798*^9}, {
   3.4605146484667263`*^9, 3.460514650350994*^9}, {3.460514717258254*^9, 
   3.460514724283691*^9}, 3.460514770989304*^9, 3.4605223140457373`*^9, {
   3.4605327188171663`*^9, 3.460532727004561*^9}, {3.460532863547011*^9, 
   3.460532865145266*^9}, {3.460532977769042*^9, 3.4605329860852757`*^9}, {
   3.507275497143169*^9, 3.4603659980232763`*^9}, {3.537484515197036*^9, 
   3.537484572210073*^9}, 3.537484644682625*^9, {3.5374846959240923`*^9, 
   3.537484701892157*^9}, {3.537484976337736*^9, 3.5374849917355137`*^9}, {
   3.537486594817341*^9, 3.537486596777007*^9}}],

Cell[BoxData["Gd"], "Input"],

Cell[BoxData["Gu"], "Input"],

Cell[BoxData[
 RowBox[{"detg", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{"Det", "[", "Gd", "]"}], "]"}]}]], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["GRrun2.nb", "Subsubtitle"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "\[CapitalGamma]", "]"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"MT", "[", 
   RowBox[{"\[CapitalGamma]", ",", "3", ",", 
    RowBox[{"{", 
     RowBox[{"d", ",", "d", ",", "u"}], "}"}]}], "]"}], ";"}], "\n"}], "Input",
 Editable->False,
 CellTags->"calcgeom"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "R4", "]"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"MT", "[", 
   RowBox[{"R4", ",", "4", ",", 
    RowBox[{"{", 
     RowBox[{"d", ",", "d", ",", "d", ",", "u"}], "}"}]}], "]"}], 
  ";"}], "\n"}], "Input",
 Editable->False,
 CellTags->"calcgeom"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "R2", "]"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"MT", "[", 
   RowBox[{"R2", ",", "2", ",", 
    RowBox[{"{", 
     RowBox[{"d", ",", "d"}], "}"}]}], "]"}], ";"}]}], "Input",
 Editable->False,
 CellTags->"calcgeom"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "G2", "]"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"MT", "[", 
   RowBox[{"G2", ",", "2", ",", 
    RowBox[{"{", 
     RowBox[{"d", ",", "d"}], "}"}]}], "]"}], ";"}]}], "Input",
 Editable->False,
 CellTags->"calcgeom"],

Cell[BoxData[
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"\[CapitalGamma]", "=", 
    RowBox[{"ST", "[", 
     RowBox[{"\[CapitalGamma]", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ind", "[", 
           RowBox[{"[", "i1", "]"}], "]"}], ",", "d"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ind", "[", 
           RowBox[{"[", "i2", "]"}], "]"}], ",", "d"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ind", "[", 
           RowBox[{"[", "i3", "]"}], "]"}], ",", "u"}], "}"}]}], "}"}], ",", 
      RowBox[{"Sum", "[", 
       RowBox[{
        RowBox[{
         FractionBox["1", "2"], 
         RowBox[{"GT", "[", 
          RowBox[{"G", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"ind", "[", 
                RowBox[{"[", "i3", "]"}], "]"}], ",", "u"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"ind", "[", 
                RowBox[{"[", "ss1", "]"}], "]"}], ",", "u"}], "}"}]}], 
            "}"}]}], "]"}], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"D", "[", 
            RowBox[{
             RowBox[{"GT", "[", 
              RowBox[{"G", ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"ind", "[", 
                    RowBox[{"[", "i1", "]"}], "]"}], ",", "d"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"ind", "[", 
                    RowBox[{"[", "ss1", "]"}], "]"}], ",", "d"}], "}"}]}], 
                "}"}]}], "]"}], ",", 
             RowBox[{"ind", "[", 
              RowBox[{"[", "i2", "]"}], "]"}]}], "]"}], "+", 
           RowBox[{"D", "[", 
            RowBox[{
             RowBox[{"GT", "[", 
              RowBox[{"G", ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"ind", "[", 
                    RowBox[{"[", "ss1", "]"}], "]"}], ",", "d"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"ind", "[", 
                    RowBox[{"[", "i2", "]"}], "]"}], ",", "d"}], "}"}]}], 
                "}"}]}], "]"}], ",", 
             RowBox[{"ind", "[", 
              RowBox[{"[", "i1", "]"}], "]"}]}], "]"}], "-", 
           RowBox[{"D", "[", 
            RowBox[{
             RowBox[{"GT", "[", 
              RowBox[{"G", ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"ind", "[", 
                    RowBox[{"[", "i1", "]"}], "]"}], ",", "d"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"ind", "[", 
                    RowBox[{"[", "i2", "]"}], "]"}], ",", "d"}], "}"}]}], 
                "}"}]}], "]"}], ",", 
             RowBox[{"ind", "[", 
              RowBox[{"[", "ss1", "]"}], "]"}]}], "]"}]}], ")"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"ss1", ",", "1", ",", "Nind"}], "}"}]}], "]"}]}], "]"}]}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"i1", ",", "1", ",", "Nind"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"i2", ",", "1", ",", "Nind"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"i3", ",", "1", ",", "Nind"}], "}"}]}], "]"}]], "Input",
 Editable->False,
 CellTags->"calcgeom"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"FullSimplify", "[", "\[CapitalGamma]", "]"}], " ", "*)"}]], "Input",
 Editable->False,
 CellTags->"calcgeom"],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[CapitalGamma]", "=", 
   RowBox[{"FullSimplify", "[", "\[CapitalGamma]", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.426232729469757*^9, 3.426232735540435*^9}}],

Cell[BoxData[
 RowBox[{"Do", "[", "\n", "\t", 
  RowBox[{
   RowBox[{"R4", "=", 
    RowBox[{"ST", "[", 
     RowBox[{"R4", ",", "\n", "\t\t\t", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ind", "[", 
           RowBox[{"[", "i1", "]"}], "]"}], ",", "d"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ind", "[", 
           RowBox[{"[", "i2", "]"}], "]"}], ",", "d"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ind", "[", 
           RowBox[{"[", "i3", "]"}], "]"}], ",", "d"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ind", "[", 
           RowBox[{"[", "i4", "]"}], "]"}], ",", "u"}], "}"}]}], "}"}], ",", 
      "\n", "\t", "\n", "\t\t\t", 
      RowBox[{
       RowBox[{"D", "[", 
        RowBox[{
         RowBox[{"GT", "[", 
          RowBox[{"\[CapitalGamma]", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"ind", "[", 
                RowBox[{"[", "i1", "]"}], "]"}], ",", "d"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"ind", "[", 
                RowBox[{"[", "i3", "]"}], "]"}], ",", "d"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"ind", "[", 
                RowBox[{"[", "i4", "]"}], "]"}], ",", "u"}], "}"}]}], "}"}]}],
           "]"}], ",", 
         RowBox[{"ind", "[", 
          RowBox[{"[", "i2", "]"}], "]"}]}], "]"}], "-", 
       RowBox[{"D", "[", 
        RowBox[{
         RowBox[{"GT", "[", 
          RowBox[{"\[CapitalGamma]", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"ind", "[", 
                RowBox[{"[", "i2", "]"}], "]"}], ",", "d"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"ind", "[", 
                RowBox[{"[", "i3", "]"}], "]"}], ",", "d"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"ind", "[", 
                RowBox[{"[", "i4", "]"}], "]"}], ",", "u"}], "}"}]}], "}"}]}],
           "]"}], ",", 
         RowBox[{"ind", "[", 
          RowBox[{"[", "i1", "]"}], "]"}]}], "]"}], "+", "\n", "\t\t\t", 
       RowBox[{"Sum", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"GT", "[", 
            RowBox[{"\[CapitalGamma]", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"ind", "[", 
                  RowBox[{"[", "i1", "]"}], "]"}], ",", "d"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"ind", "[", 
                  RowBox[{"[", "i3", "]"}], "]"}], ",", "d"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"ind", "[", 
                  RowBox[{"[", "ss1", "]"}], "]"}], ",", "u"}], "}"}]}], 
              "}"}]}], "]"}], 
           RowBox[{"GT", "[", 
            RowBox[{"\[CapitalGamma]", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"ind", "[", 
                  RowBox[{"[", "i2", "]"}], "]"}], ",", "d"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"ind", "[", 
                  RowBox[{"[", "ss1", "]"}], "]"}], ",", "d"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"ind", "[", 
                  RowBox[{"[", "i4", "]"}], "]"}], ",", "u"}], "}"}]}], 
              "}"}]}], "]"}]}], "-", 
          RowBox[{
           RowBox[{"GT", "[", 
            RowBox[{"\[CapitalGamma]", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"ind", "[", 
                  RowBox[{"[", "i2", "]"}], "]"}], ",", "d"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"ind", "[", 
                  RowBox[{"[", "i3", "]"}], "]"}], ",", "d"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"ind", "[", 
                  RowBox[{"[", "ss1", "]"}], "]"}], ",", "u"}], "}"}]}], 
              "}"}]}], "]"}], 
           RowBox[{"GT", "[", 
            RowBox[{"\[CapitalGamma]", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"ind", "[", 
                  RowBox[{"[", "i1", "]"}], "]"}], ",", "d"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"ind", "[", 
                  RowBox[{"[", "ss1", "]"}], "]"}], ",", "d"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"ind", "[", 
                  RowBox[{"[", "i4", "]"}], "]"}], ",", "u"}], "}"}]}], 
              "}"}]}], "]"}]}]}], ",", 
         RowBox[{"{", 
          RowBox[{"ss1", ",", "1", ",", "Nind"}], "}"}]}], "]"}]}]}], "\n", 
     "\t\t", "\n", "\t\t", "]"}]}], "\n", "\t\t", ",", "\n", "\t", 
   RowBox[{"{", 
    RowBox[{"i1", ",", "1", ",", "Nind"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"i2", ",", "1", ",", "Nind"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"i3", ",", "1", ",", "Nind"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"i4", ",", "1", ",", "Nind"}], "}"}]}], "]"}]], "Input",
 Editable->False,
 CellTags->"calcgeom"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"FullSimplify", "[", "R4", "]"}], " ", "*)"}]], "Input",
 Editable->False,
 CellTags->"calcgeom"],

Cell[BoxData[
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"R2", "=", 
    RowBox[{"ST", "[", 
     RowBox[{"R2", ",", "\n", "\t\t\t", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ind", "[", 
           RowBox[{"[", "i1", "]"}], "]"}], ",", "d"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ind", "[", 
           RowBox[{"[", "i2", "]"}], "]"}], ",", "d"}], "}"}]}], "}"}], ",", 
      "\n", "\t\t\t", 
      RowBox[{"Sum", "[", 
       RowBox[{
        RowBox[{"GT", "[", 
         RowBox[{"R4", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"ind", "[", 
               RowBox[{"[", "i1", "]"}], "]"}], ",", "d"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"ind", "[", 
               RowBox[{"[", "ss1", "]"}], "]"}], ",", "u"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"ind", "[", 
               RowBox[{"[", "i2", "]"}], "]"}], ",", "d"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"ind", "[", 
               RowBox[{"[", "ss1", "]"}], "]"}], ",", "d"}], "}"}]}], "}"}]}],
          "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"ss1", ",", "1", ",", "Nind"}], "}"}]}], "]"}]}], "\n", 
     "\t\t", "]"}]}], "\n", "\t", ",", 
   RowBox[{"{", 
    RowBox[{"i1", ",", "1", ",", "Nind"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"i2", ",", "1", ",", "Nind"}], "}"}]}], "]"}]], "Input",
 Editable->False,
 CellTags->"calcgeom"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"FullSimplify", "[", "R2", "]"}], " ", "*)"}]], "Input",
 Editable->False,
 CellTags->"calcgeom"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Ricci", "=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{"GT", "[", 
      RowBox[{"R2", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"ind", "[", 
            RowBox[{"[", "ss1", "]"}], "]"}], ",", "u"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"ind", "[", 
            RowBox[{"[", "ss1", "]"}], "]"}], ",", "d"}], "}"}]}], "}"}]}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"ss1", ",", "1", ",", "Nind"}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 Editable->False,
 CellTags->"calcgeom"],

Cell[BoxData[
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"G2", "=", 
    RowBox[{"ST", "[", 
     RowBox[{"G2", ",", "\n", "\t\t\t", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ind", "[", 
           RowBox[{"[", "i1", "]"}], "]"}], ",", "d"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ind", "[", 
           RowBox[{"[", "i2", "]"}], "]"}], ",", "d"}], "}"}]}], "}"}], ",", 
      "\n", "\t\t\t", 
      RowBox[{
       RowBox[{"GT", "[", 
        RowBox[{"R2", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"ind", "[", 
              RowBox[{"[", "i1", "]"}], "]"}], ",", "d"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"ind", "[", 
              RowBox[{"[", "i2", "]"}], "]"}], ",", "d"}], "}"}]}], "}"}]}], 
        "]"}], "-", 
       RowBox[{
        FractionBox["1", "2"], 
        RowBox[{"GT", "[", 
         RowBox[{"G", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"ind", "[", 
               RowBox[{"[", "i1", "]"}], "]"}], ",", "d"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"ind", "[", 
               RowBox[{"[", "i2", "]"}], "]"}], ",", "d"}], "}"}]}], "}"}]}], 
         "]"}], "Ricci"}]}]}], "]"}]}], "\n", "\t", ",", 
   RowBox[{"{", 
    RowBox[{"i1", ",", "1", ",", "Nind"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"i2", ",", "1", ",", "Nind"}], "}"}]}], "]"}]], "Input",
 Editable->False,
 CellTags->"calcgeom"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"FullSimplify", "[", "G2", "]"}], " ", "*)"}]], "Input",
 Editable->False,
 CellTags->"calcgeom"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"FullSimplify", "[", "Ricci", "]"}], " ", "*)"}]], "Input",
 Editable->False,
 CellTags->"calcgeom"]
}, Closed]],

Cell[CellGroupData[{

Cell["Einstein equations", "Subsubtitle"],

Cell[BoxData[
 RowBox[{
  RowBox[{"R2", "=", 
   RowBox[{"Simplify", "[", "R2", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.4041067188341103`*^9, 3.404106720182616*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Ricci", "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{"GT", "[", 
       RowBox[{"R2", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"ind", "[", 
             RowBox[{"[", "ss1", "]"}], "]"}], ",", "u"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"ind", "[", 
             RowBox[{"[", "ss1", "]"}], "]"}], ",", "d"}], "}"}]}], "}"}]}], 
       "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"ss1", ",", "1", ",", "Nind"}], "}"}]}], "]"}], "]"}]}], 
  ";"}]], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Clear", "[", "A", "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MT", "[", 
    RowBox[{"A", ",", "1", ",", 
     RowBox[{"{", "d", "}"}]}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"A", "=", 
    RowBox[{"ST", "[", 
     RowBox[{"A", ",", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"v", ",", "d"}], "}"}], "}"}], ",", 
      RowBox[{"av", "[", 
       RowBox[{"v", ",", "z"}], "]"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"A", "=", 
   RowBox[{"ST", "[", 
    RowBox[{"A", ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"z", ",", "d"}], "}"}], "}"}], ",", 
     RowBox[{"az", "[", 
      RowBox[{"v", ",", "z"}], "]"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.451383976248069*^9, 3.4513840125908737`*^9}, {
  3.451384057147691*^9, 3.451384064689735*^9}, {3.451385762395092*^9, 
  3.451385762480318*^9}, {3.451385800913571*^9, 3.451385805770357*^9}, {
  3.537484677141605*^9, 3.53748468964509*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Clear", "[", "F", "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MT", "[", 
    RowBox[{"F", ",", "2", ",", 
     RowBox[{"{", 
      RowBox[{"d", ",", "d"}], "}"}]}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"F", "=", 
      RowBox[{"ST", "[", 
       RowBox[{"F", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"i1", ",", "d"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i2", ",", "d"}], "}"}]}], "}"}], ",", 
        RowBox[{
         RowBox[{"D", "[", 
          RowBox[{
           RowBox[{"GT", "[", 
            RowBox[{"A", ",", 
             RowBox[{"{", 
              RowBox[{"{", 
               RowBox[{"i1", ",", "d"}], "}"}], "}"}]}], "]"}], ",", 
           RowBox[{"ind", "[", 
            RowBox[{"[", "i2", "]"}], "]"}]}], "]"}], "-", 
         RowBox[{"D", "[", 
          RowBox[{
           RowBox[{"GT", "[", 
            RowBox[{"A", ",", 
             RowBox[{"{", 
              RowBox[{"{", 
               RowBox[{"i2", ",", "d"}], "}"}], "}"}]}], "]"}], ",", 
           RowBox[{"ind", "[", 
            RowBox[{"[", "i1", "]"}], "]"}]}], "]"}]}]}], "]"}]}], ";"}], 
    "\[IndentingNewLine]", ",", 
    RowBox[{"{", 
     RowBox[{"i1", ",", "1", ",", "Nind"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"i2", ",", "1", ",", "Nind"}], "}"}]}], "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.4041040239360247`*^9, 3.404104073416904*^9}, {
  3.4041057167733383`*^9, 3.4041057183570337`*^9}, {3.4513840707957897`*^9, 
  3.451384164343499*^9}, {3.460366100458836*^9, 3.460366108909464*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"trFF", "=", 
    RowBox[{"Simplify", "[", 
     RowBox[{"trT", "[", 
      RowBox[{
       RowBox[{"outerT", "[", 
        RowBox[{"F", ",", "F"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"2", ",", "4"}], "}"}], "}"}]}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Fsqr", "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{"trT", "[", 
     RowBox[{"trFF", ",", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"1", ",", "2"}], "}"}], "}"}]}], "]"}], "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.404103126230957*^9, 3.404103206051724*^9}, 
   3.404103788928409*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Phi]", "[", 
    RowBox[{"v_", ",", "z_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"p", "[", 
     RowBox[{"v", ",", "z"}], "]"}], "+", 
    RowBox[{"I", " ", 
     RowBox[{"\[Alpha]", "[", 
      RowBox[{"v", ",", "z"}], "]"}]}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Clear", "[", "Dp", "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MT", "[", 
    RowBox[{"Dp", ",", "1", ",", 
     RowBox[{"{", "d", "}"}]}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Do", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Dp", "=", 
       RowBox[{"ST", "[", 
        RowBox[{"Dp", ",", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"i1", ",", "d"}], "}"}], "}"}], ",", 
         RowBox[{
          RowBox[{"D", "[", 
           RowBox[{
            RowBox[{"\[Phi]", "[", 
             RowBox[{"v", ",", "z"}], "]"}], ",", 
            RowBox[{"ind", "[", 
             RowBox[{"[", "i1", "]"}], "]"}]}], "]"}], "-", 
          RowBox[{"I", " ", 
           RowBox[{"GT", "[", 
            RowBox[{"A", ",", 
             RowBox[{"{", 
              RowBox[{"{", 
               RowBox[{"i1", ",", "d"}], "}"}], "}"}]}], "]"}], 
           RowBox[{"\[Phi]", "[", 
            RowBox[{"v", ",", "z"}], "]"}]}]}]}], "]"}]}], ";"}], 
     "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"i1", ",", "1", ",", "Nind"}], "}"}]}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ConjDp", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", "d", "}"}], ",", 
      RowBox[{"Conjugate", "[", 
       RowBox[{"Dp", "[", 
        RowBox[{"[", "2", "]"}], "]"}], "]"}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DpDp", "=", 
    RowBox[{"Simplify", "[", 
     RowBox[{"ComplexExpand", "[", 
      RowBox[{"trT", "[", 
       RowBox[{
        RowBox[{"outerT", "[", 
         RowBox[{"ConjDp", ",", "Dp"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "2"}], "}"}]}], "]"}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Vterm", "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{
     RowBox[{"-", "2"}], 
     RowBox[{"ComplexExpand", "[", 
      RowBox[{
       RowBox[{"Conjugate", "[", 
        RowBox[{"\[Phi]", "[", 
         RowBox[{"v", ",", "z"}], "]"}], "]"}], 
       RowBox[{"\[Phi]", "[", 
        RowBox[{"v", ",", "z"}], "]"}]}], "]"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.4513844331121693`*^9, 3.451384521665413*^9}, {
   3.451384560554626*^9, 3.451384642158163*^9}, {3.4513849100950413`*^9, 
   3.451384915054587*^9}, 3.451385051803838*^9, {3.4513851171366262`*^9, 
   3.45138511927711*^9}, {3.451385175930884*^9, 3.451385183167452*^9}, {
   3.451385425505906*^9, 3.45138544324051*^9}, {3.451385490350021*^9, 
   3.451385493946774*^9}, {3.451385568392873*^9, 3.451385601054823*^9}, {
   3.451385813165941*^9, 3.4513858527683163`*^9}, {3.45138608116168*^9, 
   3.451386103913107*^9}, {3.46036707784975*^9, 3.460255762501432*^9}, {
   3.46025580130457*^9, 3.460255801461816*^9}, {3.53748492894665*^9, 
   3.53748495518618*^9}, {3.537485329580826*^9, 3.537485331297533*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DpDp", "=", 
   RowBox[{"(", 
    RowBox[{"DpDp", "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"Re", "[", "xx_", "]"}], "\[Rule]", "xx"}], ",", 
       RowBox[{
        RowBox[{"Im", "[", "xx_", "]"}], "\[Rule]", "0"}]}], "}"}]}], ")"}]}],
   ";"}]], "Input",
 CellChangeTimes->{{3.451385894732107*^9, 3.451385976334114*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"sqrtdetg", "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{"PowerExpand", "[", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"Det", "[", 
       RowBox[{"-", "Gd"}], "]"}], "]"}], "]"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.4041041692972*^9, 3.404104211096949*^9}, 
   3.404105293940057*^9, {3.4513842180130997`*^9, 3.4513842223260803`*^9}, {
   3.4513846617079067`*^9, 3.451384675916638*^9}}],

Cell[BoxData[
 RowBox[{"L", "=", 
  RowBox[{"sqrtdetg", 
   RowBox[{"(", 
    RowBox[{"Ricci", "+", "6", "-", 
     RowBox[{
      FractionBox["1", "4"], "Fsqr"}], "-", "DpDp", "-", "Vterm"}], 
    ")"}]}]}]], "Input",
 CellChangeTimes->{{3.451384367735067*^9, 3.451384393946628*^9}, {
   3.4513849054437723`*^9, 3.4513849068431387`*^9}, {3.451385606138598*^9, 
   3.451385607193993*^9}, 3.460366276193363*^9, {3.4603670917067547`*^9, 
   3.460255829896731*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"tmp1", "=", 
    RowBox[{"Simplify", "[", 
     RowBox[{"Coefficient", "[", 
      RowBox[{"L", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          SuperscriptBox["gvz", 
           TagBox[
            RowBox[{"(", 
             RowBox[{"2", ",", "0"}], ")"}],
            Derivative],
           MultilineFunction->None], "[", 
          RowBox[{"v", ",", "z"}], "]"}], ",", 
         RowBox[{
          SuperscriptBox["gvz", 
           TagBox[
            RowBox[{"(", 
             RowBox[{"0", ",", "2"}], ")"}],
            Derivative],
           MultilineFunction->None], "[", 
          RowBox[{"v", ",", "z"}], "]"}], ",", 
         RowBox[{
          SuperscriptBox["gvz", 
           TagBox[
            RowBox[{"(", 
             RowBox[{"1", ",", "1"}], ")"}],
            Derivative],
           MultilineFunction->None], "[", 
          RowBox[{"v", ",", "z"}], "]"}]}], "}"}]}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"tmp2", "=", 
    RowBox[{"Simplify", "[", 
     RowBox[{"Coefficient", "[", 
      RowBox[{"L", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          SuperscriptBox["gzz", 
           TagBox[
            RowBox[{"(", 
             RowBox[{"2", ",", "0"}], ")"}],
            Derivative],
           MultilineFunction->None], "[", 
          RowBox[{"v", ",", "z"}], "]"}], ",", 
         RowBox[{
          SuperscriptBox["gzz", 
           TagBox[
            RowBox[{"(", 
             RowBox[{"0", ",", "2"}], ")"}],
            Derivative],
           MultilineFunction->None], "[", 
          RowBox[{"v", ",", "z"}], "]"}], ",", 
         RowBox[{
          SuperscriptBox["gzz", 
           TagBox[
            RowBox[{"(", 
             RowBox[{"1", ",", "1"}], ")"}],
            Derivative],
           MultilineFunction->None], "[", 
          RowBox[{"v", ",", "z"}], "]"}]}], "}"}]}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"tmp3", "=", 
    RowBox[{"Simplify", "[", 
     RowBox[{"Coefficient", "[", 
      RowBox[{"L", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          SuperscriptBox["T", 
           TagBox[
            RowBox[{"(", 
             RowBox[{"2", ",", "0"}], ")"}],
            Derivative],
           MultilineFunction->None], "[", 
          RowBox[{"v", ",", "z"}], "]"}], ",", 
         RowBox[{
          SuperscriptBox["T", 
           TagBox[
            RowBox[{"(", 
             RowBox[{"0", ",", "2"}], ")"}],
            Derivative],
           MultilineFunction->None], "[", 
          RowBox[{"v", ",", "z"}], "]"}], ",", 
         RowBox[{
          SuperscriptBox["T", 
           TagBox[
            RowBox[{"(", 
             RowBox[{"1", ",", "1"}], ")"}],
            Derivative],
           MultilineFunction->None], "[", 
          RowBox[{"v", ",", "z"}], "]"}]}], "}"}]}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmp4", "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{"Coefficient", "[", 
     RowBox[{"L", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         SuperscriptBox["S", 
          TagBox[
           RowBox[{"(", 
            RowBox[{"2", ",", "0"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{"v", ",", "z"}], "]"}], ",", 
        RowBox[{
         SuperscriptBox["S", 
          TagBox[
           RowBox[{"(", 
            RowBox[{"0", ",", "2"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{"v", ",", "z"}], "]"}], ",", 
        RowBox[{
         SuperscriptBox["S", 
          TagBox[
           RowBox[{"(", 
            RowBox[{"1", ",", "1"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{"v", ",", "z"}], "]"}]}], "}"}]}], "]"}], "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.4603663459440107`*^9, 3.4603664394408617`*^9}, {
  3.53748653613297*^9, 3.5374865918283*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"GHBT", "=", 
    RowBox[{"Simplify", "[", 
     RowBox[{
      RowBox[{"D", "[", 
       RowBox[{
        RowBox[{"tmp1", ".", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            SuperscriptBox["gvz", 
             TagBox[
              RowBox[{"(", 
               RowBox[{"1", ",", "0"}], ")"}],
              Derivative],
             MultilineFunction->None], "[", 
            RowBox[{"v", ",", "z"}], "]"}], ",", "0", ",", 
           RowBox[{
            FractionBox["1", "2"], 
            RowBox[{
             SuperscriptBox["gvz", 
              TagBox[
               RowBox[{"(", 
                RowBox[{"0", ",", "1"}], ")"}],
               Derivative],
              MultilineFunction->None], "[", 
             RowBox[{"v", ",", "z"}], "]"}]}]}], "}"}]}], ",", "v"}], "]"}], 
      "+", 
      RowBox[{"D", "[", 
       RowBox[{
        RowBox[{"tmp1", ".", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{
            SuperscriptBox["gvz", 
             TagBox[
              RowBox[{"(", 
               RowBox[{"0", ",", "1"}], ")"}],
              Derivative],
             MultilineFunction->None], "[", 
            RowBox[{"v", ",", "z"}], "]"}], ",", 
           RowBox[{
            FractionBox["1", "2"], 
            RowBox[{
             SuperscriptBox["gvz", 
              TagBox[
               RowBox[{"(", 
                RowBox[{"1", ",", "0"}], ")"}],
               Derivative],
              MultilineFunction->None], "[", 
             RowBox[{"v", ",", "z"}], "]"}]}]}], "}"}]}], ",", "z"}], "]"}]}],
      "]"}]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"GHBT", "+=", 
    RowBox[{"Simplify", "[", 
     RowBox[{
      RowBox[{"D", "[", 
       RowBox[{
        RowBox[{"tmp2", ".", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            SuperscriptBox["gzz", 
             TagBox[
              RowBox[{"(", 
               RowBox[{"1", ",", "0"}], ")"}],
              Derivative],
             MultilineFunction->None], "[", 
            RowBox[{"v", ",", "z"}], "]"}], ",", "0", ",", 
           RowBox[{
            FractionBox["1", "2"], 
            RowBox[{
             SuperscriptBox["gzz", 
              TagBox[
               RowBox[{"(", 
                RowBox[{"0", ",", "1"}], ")"}],
               Derivative],
              MultilineFunction->None], "[", 
             RowBox[{"v", ",", "z"}], "]"}]}]}], "}"}]}], ",", "v"}], "]"}], 
      "+", 
      RowBox[{"D", "[", 
       RowBox[{
        RowBox[{"tmp2", ".", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{
            SuperscriptBox["gzz", 
             TagBox[
              RowBox[{"(", 
               RowBox[{"0", ",", "1"}], ")"}],
              Derivative],
             MultilineFunction->None], "[", 
            RowBox[{"v", ",", "z"}], "]"}], ",", 
           RowBox[{
            FractionBox["1", "2"], 
            RowBox[{
             SuperscriptBox["gzz", 
              TagBox[
               RowBox[{"(", 
                RowBox[{"1", ",", "0"}], ")"}],
               Derivative],
              MultilineFunction->None], "[", 
             RowBox[{"v", ",", "z"}], "]"}]}]}], "}"}]}], ",", "z"}], "]"}]}],
      "]"}]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"GHBT", "+=", 
    RowBox[{"Simplify", "[", 
     RowBox[{
      RowBox[{"D", "[", 
       RowBox[{
        RowBox[{"tmp3", ".", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            SuperscriptBox["T", 
             TagBox[
              RowBox[{"(", 
               RowBox[{"1", ",", "0"}], ")"}],
              Derivative],
             MultilineFunction->None], "[", 
            RowBox[{"v", ",", "z"}], "]"}], ",", "0", ",", 
           RowBox[{
            FractionBox["1", "2"], 
            RowBox[{
             SuperscriptBox["T", 
              TagBox[
               RowBox[{"(", 
                RowBox[{"0", ",", "1"}], ")"}],
               Derivative],
              MultilineFunction->None], "[", 
             RowBox[{"v", ",", "z"}], "]"}]}]}], "}"}]}], ",", "v"}], "]"}], 
      "+", 
      RowBox[{"D", "[", 
       RowBox[{
        RowBox[{"tmp3", ".", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{
            SuperscriptBox["T", 
             TagBox[
              RowBox[{"(", 
               RowBox[{"0", ",", "1"}], ")"}],
              Derivative],
             MultilineFunction->None], "[", 
            RowBox[{"v", ",", "z"}], "]"}], ",", 
           RowBox[{
            FractionBox["1", "2"], 
            RowBox[{
             SuperscriptBox["T", 
              TagBox[
               RowBox[{"(", 
                RowBox[{"1", ",", "0"}], ")"}],
               Derivative],
              MultilineFunction->None], "[", 
             RowBox[{"v", ",", "z"}], "]"}]}]}], "}"}]}], ",", "z"}], "]"}]}],
      "]"}]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"GHBT", "+=", 
   RowBox[{"Simplify", "[", 
    RowBox[{
     RowBox[{"D", "[", 
      RowBox[{
       RowBox[{"tmp4", ".", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           SuperscriptBox["S", 
            TagBox[
             RowBox[{"(", 
              RowBox[{"1", ",", "0"}], ")"}],
             Derivative],
            MultilineFunction->None], "[", 
           RowBox[{"v", ",", "z"}], "]"}], ",", "0", ",", 
          RowBox[{
           FractionBox["1", "2"], 
           RowBox[{
            SuperscriptBox["S", 
             TagBox[
              RowBox[{"(", 
               RowBox[{"0", ",", "1"}], ")"}],
              Derivative],
             MultilineFunction->None], "[", 
            RowBox[{"v", ",", "z"}], "]"}]}]}], "}"}]}], ",", "v"}], "]"}], 
     "+", 
     RowBox[{"D", "[", 
      RowBox[{
       RowBox[{"tmp4", ".", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{
           SuperscriptBox["S", 
            TagBox[
             RowBox[{"(", 
              RowBox[{"0", ",", "1"}], ")"}],
             Derivative],
            MultilineFunction->None], "[", 
           RowBox[{"v", ",", "z"}], "]"}], ",", 
          RowBox[{
           FractionBox["1", "2"], 
           RowBox[{
            SuperscriptBox["S", 
             TagBox[
              RowBox[{"(", 
               RowBox[{"1", ",", "0"}], ")"}],
              Derivative],
             MultilineFunction->None], "[", 
            RowBox[{"v", ",", "z"}], "]"}]}]}], "}"}]}], ",", "z"}], "]"}]}], 
    "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.460366441552243*^9, 3.460366544772176*^9}, {
  3.4603665879440317`*^9, 3.460366626391823*^9}, {3.537486655723679*^9, 
  3.537486732610427*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"L2", "=", 
   RowBox[{"L", "-", "GHBT"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.460366546941235*^9, 3.460366557341961*^9}, 
   3.460366686117609*^9, {3.4603672960654507`*^9, 3.4603672977104673`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tmp1", "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{"Coefficient", "[", 
     RowBox[{"L2", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         SuperscriptBox["gvz", 
          TagBox[
           RowBox[{"(", 
            RowBox[{"2", ",", "0"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{"v", ",", "z"}], "]"}], ",", 
        RowBox[{
         SuperscriptBox["gvz", 
          TagBox[
           RowBox[{"(", 
            RowBox[{"0", ",", "2"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{"v", ",", "z"}], "]"}], ",", 
        RowBox[{
         SuperscriptBox["gvz", 
          TagBox[
           RowBox[{"(", 
            RowBox[{"1", ",", "1"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{"v", ",", "z"}], "]"}]}], "}"}]}], "]"}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmp2", "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{"Coefficient", "[", 
     RowBox[{"L2", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         SuperscriptBox["gzz", 
          TagBox[
           RowBox[{"(", 
            RowBox[{"2", ",", "0"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{"v", ",", "z"}], "]"}], ",", 
        RowBox[{
         SuperscriptBox["gzz", 
          TagBox[
           RowBox[{"(", 
            RowBox[{"0", ",", "2"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{"v", ",", "z"}], "]"}], ",", 
        RowBox[{
         SuperscriptBox["gzz", 
          TagBox[
           RowBox[{"(", 
            RowBox[{"1", ",", "1"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{"v", ",", "z"}], "]"}]}], "}"}]}], "]"}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmp3", "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{"Coefficient", "[", 
     RowBox[{"L2", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         SuperscriptBox["T", 
          TagBox[
           RowBox[{"(", 
            RowBox[{"2", ",", "0"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{"v", ",", "z"}], "]"}], ",", 
        RowBox[{
         SuperscriptBox["T", 
          TagBox[
           RowBox[{"(", 
            RowBox[{"0", ",", "2"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{"v", ",", "z"}], "]"}], ",", 
        RowBox[{
         SuperscriptBox["T", 
          TagBox[
           RowBox[{"(", 
            RowBox[{"1", ",", "1"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{"v", ",", "z"}], "]"}]}], "}"}]}], "]"}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"tmp4", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{"Coefficient", "[", 
    RowBox[{"L2", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SuperscriptBox["S", 
         TagBox[
          RowBox[{"(", 
           RowBox[{"2", ",", "0"}], ")"}],
          Derivative],
         MultilineFunction->None], "[", 
        RowBox[{"v", ",", "z"}], "]"}], ",", 
       RowBox[{
        SuperscriptBox["S", 
         TagBox[
          RowBox[{"(", 
           RowBox[{"0", ",", "2"}], ")"}],
          Derivative],
         MultilineFunction->None], "[", 
        RowBox[{"v", ",", "z"}], "]"}], ",", 
       RowBox[{
        SuperscriptBox["S", 
         TagBox[
          RowBox[{"(", 
           RowBox[{"1", ",", "1"}], ")"}],
          Derivative],
         MultilineFunction->None], "[", 
        RowBox[{"v", ",", "z"}], "]"}]}], "}"}]}], "]"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.4603663459440107`*^9, 3.4603664394408617`*^9}, {
  3.460366666517003*^9, 3.460366674775579*^9}, {3.537486746662644*^9, 
  3.5374867639666147`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"EOM", "[", "fld_", "]"}], ":=", 
  RowBox[{"(", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"tmp", "=", 
     RowBox[{"D", "[", 
      RowBox[{"L2", ",", "fld"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"Do", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"tmp2", "=", 
           RowBox[{"D", "[", 
            RowBox[{"fld", ",", 
             RowBox[{"ind", "[", 
              RowBox[{"[", "ii", "]"}], "]"}]}], "]"}]}], ")"}], "=!=", "0"}],
         ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"tmp", "-=", 
          RowBox[{"D", "[", 
           RowBox[{
            RowBox[{"D", "[", 
             RowBox[{"L2", ",", "tmp2"}], "]"}], ",", 
            RowBox[{"ind", "[", 
             RowBox[{"[", "ii", "]"}], "]"}]}], "]"}]}], ";"}]}], 
       "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", ",", 
      RowBox[{"{", 
       RowBox[{"ii", ",", "1", ",", "Nind"}], "}"}]}], "]"}], ";", 
    "\[IndentingNewLine]", "tmp"}], "\[IndentingNewLine]", ")"}]}]], "Input",
 CellChangeTimes->{{3.4513849546200113`*^9, 3.451385039242148*^9}, {
  3.4603662728020573`*^9, 3.460366273871294*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"eqp", "=", 
    RowBox[{"EOM", "[", 
     RowBox[{"p", "[", 
      RowBox[{"v", ",", "z"}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"eq\[Alpha]", "=", 
   RowBox[{"EOM", "[", 
    RowBox[{"\[Alpha]", "[", 
     RowBox[{"v", ",", "z"}], "]"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.4513848144544163`*^9, 3.4513848150159073`*^9}, {
  3.451384869337384*^9, 3.451384875673843*^9}, {3.451384929950244*^9, 
  3.451384930100154*^9}, {3.451385060851385*^9, 3.451385213396349*^9}, {
  3.451385293160893*^9, 3.451385302528058*^9}, {3.4513853749547167`*^9, 
  3.45138537639461*^9}, {3.451385514552088*^9, 3.451385527943191*^9}, {
  3.451385862306609*^9, 3.451385882826736*^9}, {3.451386138230373*^9, 
  3.451386140019012*^9}, {3.451386241895258*^9, 3.4513862693654633`*^9}, {
  3.4603675858592987`*^9, 3.4603675914720583`*^9}, {3.537486779881022*^9, 
  3.537486784922683*^9}, {3.537486894453556*^9, 3.5374869009568243`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"eqav", "=", 
    RowBox[{"EOM", "[", 
     RowBox[{"av", "[", 
      RowBox[{"v", ",", "z"}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"eqaz", "=", 
   RowBox[{"EOM", "[", 
    RowBox[{"az", "[", 
     RowBox[{"v", ",", "z"}], "]"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.4513855403702793`*^9, 3.451385540823719*^9}, {
  3.4513861532442207`*^9, 3.45138616739637*^9}, {3.451386251199284*^9, 
  3.4513862656960487`*^9}, {3.460367593073217*^9, 3.460367597640524*^9}, {
  3.5374867866028214`*^9, 3.537486788378339*^9}, {3.537486891597521*^9, 
  3.537486937732339*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"eqgvz", "=", 
    RowBox[{"EOM", "[", 
     RowBox[{"gvz", "[", 
      RowBox[{"v", ",", "z"}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"eqgzz", "=", 
    RowBox[{"EOM", "[", 
     RowBox[{"gzz", "[", 
      RowBox[{"v", ",", "z"}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"eqT", "=", 
    RowBox[{"EOM", "[", 
     RowBox[{"T", "[", 
      RowBox[{"v", ",", "z"}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"eqS", "=", 
   RowBox[{"EOM", "[", 
    RowBox[{"S", "[", 
     RowBox[{"v", ",", "z"}], "]"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.451386275930722*^9, 3.451386303859261*^9}, {
  3.460366711720347*^9, 3.4603667226381903`*^9}, {3.460367599130735*^9, 
  3.460367611985876*^9}, {3.53748678993122*^9, 3.53748680663302*^9}, {
  3.537486911477583*^9, 3.5374869187572203`*^9}}],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{"gvz", ",", "gzz", ",", "az"}], "]"}]], "Input",
 CellChangeTimes->{{3.53748694036823*^9, 3.537486945275868*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"gvz", "[", 
    RowBox[{"v_", ",", "z_"}], "]"}], ":=", "1"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"gzz", "[", 
    RowBox[{"v_", ",", "z_"}], "]"}], ":=", "0"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"az", "[", 
   RowBox[{"v_", ",", "z_"}], "]"}], ":=", "0"}]}], "Input",
 CellChangeTimes->{{3.460366755240944*^9, 3.460366765921853*^9}, {
   3.460379717667384*^9, 3.460379720321673*^9}, {3.4603938524268913`*^9, 
   3.4603938546559877`*^9}, 3.4603939628549967`*^9, {3.5374868640225983`*^9, 
   3.537486876197587*^9}, {3.537486924492758*^9, 3.537486925572747*^9}, {
   3.537487030062772*^9, 3.537487030117689*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"eqp2", "=", 
   RowBox[{"Simplify", "[", "eqp", "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"eq\[Alpha]2", "=", 
   RowBox[{"Simplify", "[", "eq\[Alpha]", "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"eqav2", "=", 
   RowBox[{"Simplify", "[", "eqav", "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"eqaz2", "=", 
   RowBox[{"Simplify", "[", "eqaz", "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"eqgvz2", "=", 
   RowBox[{"Simplify", "[", "eqgvz", "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"eqgzz2", "=", 
   RowBox[{"Simplify", "[", "eqgzz", "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"eqT2", "=", 
   RowBox[{"Simplify", "[", "eqT", "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"eqS2", "=", 
  RowBox[{"Simplify", "[", "eqS", "]"}]}]}], "Input",
 CellChangeTimes->{{3.460366768598325*^9, 3.4603668525536737`*^9}, {
  3.5374869590367947`*^9, 3.537486972220312*^9}}],

Cell[BoxData[
 RowBox[{"Evsol", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{
    RowBox[{"Solve", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"eqgvz2", "\[Equal]", "0"}], ",", 
        RowBox[{"eqS2", "\[Equal]", "0"}], ",", 
        RowBox[{"eqp2", "\[Equal]", "0"}], ",", 
        RowBox[{"eq\[Alpha]2", "\[Equal]", "0"}], ",", 
        RowBox[{"eqaz", "\[Equal]", "0"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         SuperscriptBox["p", 
          TagBox[
           RowBox[{"(", 
            RowBox[{"1", ",", "1"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{"v", ",", "z"}], "]"}], ",", 
        RowBox[{
         SuperscriptBox["\[Alpha]", 
          TagBox[
           RowBox[{"(", 
            RowBox[{"1", ",", "1"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{"v", ",", "z"}], "]"}], ",", " ", 
        RowBox[{
         SuperscriptBox["av", 
          TagBox[
           RowBox[{"(", 
            RowBox[{"1", ",", "1"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{"v", ",", "z"}], "]"}], ",", " ", 
        RowBox[{
         SuperscriptBox["S", 
          TagBox[
           RowBox[{"(", 
            RowBox[{"1", ",", "1"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{"v", ",", "z"}], "]"}], ",", " ", 
        RowBox[{
         SuperscriptBox["T", 
          TagBox[
           RowBox[{"(", 
            RowBox[{"0", ",", "2"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{"v", ",", "z"}], "]"}]}], "}"}]}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.4603794747692738`*^9, 3.4603795051117373`*^9}, {
   3.460379770556391*^9, 3.460379778090231*^9}, {3.537487575145343*^9, 
   3.537487601737835*^9}, {3.5374876320607243`*^9, 3.537487632172414*^9}, 
   3.5374876986147537`*^9}],

Cell[BoxData[
 RowBox[{"Momsol", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{
    RowBox[{"Solve", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"eqT2", "\[Equal]", "0"}], ",", 
        RowBox[{"eqgzz", "\[Equal]", "0"}], ",", 
        RowBox[{"eqav", "\[Equal]", "0"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         SuperscriptBox["S", 
          TagBox[
           RowBox[{"(", 
            RowBox[{"2", ",", "0"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{"v", ",", "z"}], "]"}], ",", " ", 
        RowBox[{
         SuperscriptBox["S", 
          TagBox[
           RowBox[{"(", 
            RowBox[{"0", ",", "2"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{"v", ",", "z"}], "]"}], ",", " ", 
        RowBox[{
         SuperscriptBox["av", 
          TagBox[
           RowBox[{"(", 
            RowBox[{"0", ",", "2"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{"v", ",", "z"}], "]"}]}], "}"}]}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.460379791348405*^9, 3.460379854266864*^9}, {
  3.537487577120059*^9, 3.537487629667873*^9}, {3.5374877038531513`*^9, 
  3.537487709515881*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Simplify", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"D", "[", 
       RowBox[{"eqT2", ",", "v"}], "]"}], "/.", 
      RowBox[{"D", "[", 
       RowBox[{"Evsol", ",", "z"}], "]"}]}], "/.", "Evsol"}], "/.", 
    "Momsol"}], "]"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Simplify", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"D", "[", 
       RowBox[{"eqav", ",", "v"}], "]"}], "/.", 
      RowBox[{"D", "[", 
       RowBox[{"Evsol", ",", "z"}], "]"}]}], "/.", "Evsol"}], "/.", 
    "Momsol"}], "]"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"D", "[", 
      RowBox[{"eqgzz", ",", "z"}], "]"}], "/.", 
     RowBox[{"D", "[", 
      RowBox[{"Evsol", ",", "v"}], "]"}]}], "/.", "Evsol"}], "/.", "Momsol"}],
   "]"}]}], "Input",
 CellChangeTimes->{{3.460379877349128*^9, 3.460379983100644*^9}, {
  3.460380087445326*^9, 3.460380091873478*^9}, {3.537487726936469*^9, 
  3.5374877500015907`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"av", "[", 
    RowBox[{"v_", ",", "z_"}], "]"}], ":=", 
   RowBox[{"a", "[", 
    RowBox[{"v", ",", "z"}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Alpha]", "[", 
   RowBox[{"v_", ",", "z_"}], "]"}], ":=", 
  RowBox[{"h", "[", 
   RowBox[{"v", ",", "z"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.460380576942815*^9, 3.46038057950566*^9}, {
  3.4603806147948647`*^9, 3.460380638346624*^9}, {3.5374877590000763`*^9, 
  3.537487759103163*^9}, {3.537487795719556*^9, 3.537487805166259*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Const1", "=", 
   RowBox[{
    RowBox[{
     SuperscriptBox["S", 
      TagBox[
       RowBox[{"(", 
        RowBox[{"0", ",", "2"}], ")"}],
       Derivative],
      MultilineFunction->None], "[", 
     RowBox[{"v", ",", "z"}], "]"}], "-", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SuperscriptBox["S", 
        TagBox[
         RowBox[{"(", 
          RowBox[{"0", ",", "2"}], ")"}],
         Derivative],
        MultilineFunction->None], "[", 
       RowBox[{"v", ",", "z"}], "]"}], "/.", "Momsol"}], ")"}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Const2", "=", 
   RowBox[{
    RowBox[{
     SuperscriptBox["a", 
      TagBox[
       RowBox[{"(", 
        RowBox[{"0", ",", "2"}], ")"}],
       Derivative],
      MultilineFunction->None], "[", 
     RowBox[{"v", ",", "z"}], "]"}], "-", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SuperscriptBox["a", 
        TagBox[
         RowBox[{"(", 
          RowBox[{"0", ",", "2"}], ")"}],
         Derivative],
        MultilineFunction->None], "[", 
       RowBox[{"v", ",", "z"}], "]"}], "/.", "Momsol"}], ")"}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Const3", "=", 
  RowBox[{
   RowBox[{
    SuperscriptBox["S", 
     TagBox[
      RowBox[{"(", 
       RowBox[{"2", ",", "0"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{"v", ",", "z"}], "]"}], "-", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox["S", 
       TagBox[
        RowBox[{"(", 
         RowBox[{"2", ",", "0"}], ")"}],
        Derivative],
       MultilineFunction->None], "[", 
      RowBox[{"v", ",", "z"}], "]"}], "/.", "Momsol"}], ")"}]}]}]}], "Input",
 CellChangeTimes->{{3.46031768644937*^9, 3.46031772334064*^9}, {
  3.537487772329159*^9, 3.5374878178010073`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Eq1", "=", 
   RowBox[{
    RowBox[{
     SuperscriptBox["p", 
      TagBox[
       RowBox[{"(", 
        RowBox[{"1", ",", "1"}], ")"}],
       Derivative],
      MultilineFunction->None], "[", 
     RowBox[{"v", ",", "z"}], "]"}], "-", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SuperscriptBox["p", 
        TagBox[
         RowBox[{"(", 
          RowBox[{"1", ",", "1"}], ")"}],
         Derivative],
        MultilineFunction->None], "[", 
       RowBox[{"v", ",", "z"}], "]"}], "/.", "Evsol"}], ")"}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Eq2", "=", 
   RowBox[{
    RowBox[{
     SuperscriptBox["h", 
      TagBox[
       RowBox[{"(", 
        RowBox[{"1", ",", "1"}], ")"}],
       Derivative],
      MultilineFunction->None], "[", 
     RowBox[{"v", ",", "z"}], "]"}], "-", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SuperscriptBox["h", 
        TagBox[
         RowBox[{"(", 
          RowBox[{"1", ",", "1"}], ")"}],
         Derivative],
        MultilineFunction->None], "[", 
       RowBox[{"v", ",", "z"}], "]"}], "/.", "Evsol"}], ")"}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Eq3", "=", 
   RowBox[{
    RowBox[{
     SuperscriptBox["a", 
      TagBox[
       RowBox[{"(", 
        RowBox[{"1", ",", "1"}], ")"}],
       Derivative],
      MultilineFunction->None], "[", 
     RowBox[{"v", ",", "z"}], "]"}], "-", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SuperscriptBox["a", 
        TagBox[
         RowBox[{"(", 
          RowBox[{"1", ",", "1"}], ")"}],
         Derivative],
        MultilineFunction->None], "[", 
       RowBox[{"v", ",", "z"}], "]"}], "/.", "Evsol"}], ")"}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Eq4", "=", 
   RowBox[{
    RowBox[{
     SuperscriptBox["S", 
      TagBox[
       RowBox[{"(", 
        RowBox[{"1", ",", "1"}], ")"}],
       Derivative],
      MultilineFunction->None], "[", 
     RowBox[{"v", ",", "z"}], "]"}], "-", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SuperscriptBox["S", 
        TagBox[
         RowBox[{"(", 
          RowBox[{"1", ",", "1"}], ")"}],
         Derivative],
        MultilineFunction->None], "[", 
       RowBox[{"v", ",", "z"}], "]"}], "/.", "Evsol"}], ")"}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Eq5", "=", 
  RowBox[{
   RowBox[{
    SuperscriptBox["T", 
     TagBox[
      RowBox[{"(", 
       RowBox[{"0", ",", "2"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{"v", ",", "z"}], "]"}], "-", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox["T", 
       TagBox[
        RowBox[{"(", 
         RowBox[{"0", ",", "2"}], ")"}],
        Derivative],
       MultilineFunction->None], "[", 
      RowBox[{"v", ",", "z"}], "]"}], "/.", "Evsol"}], ")"}]}]}]}], "Input",
 CellChangeTimes->{{3.537489066732723*^9, 3.5374891410817547`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"p", "[", 
    RowBox[{"v_", ",", "z_"}], "]"}], ":=", 
   RowBox[{"p", "[", "z", "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"h", "[", 
    RowBox[{"v_", ",", "z_"}], "]"}], ":=", 
   RowBox[{"h", "[", "z", "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"a", "[", 
    RowBox[{"v_", ",", "z_"}], "]"}], ":=", 
   RowBox[{"a", "[", "z", "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"v_", ",", "z_"}], "]"}], ":=", 
   RowBox[{"T", "[", "z", "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"S", "[", 
   RowBox[{"v_", ",", "z_"}], "]"}], ":=", 
  RowBox[{"S", "[", "z", "]"}]}]}], "Input",
 CellChangeTimes->{{3.537627682228917*^9, 3.537627713970744*^9}, {
  3.537636882057424*^9, 3.537636897297038*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ell1", "=", 
   RowBox[{"Simplify", "[", "Eq1", "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ell2", "=", 
   RowBox[{"Simplify", "[", "Eq2", "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ellc1", "=", 
   RowBox[{"Simplify", "[", "Eq3", "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ellc2", "=", 
   RowBox[{"Simplify", "[", "Eq4", "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ell3", "=", 
   RowBox[{"Simplify", "[", "Eq5", "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ell4", "=", 
   RowBox[{"Simplify", "[", "Const1", "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ell5", "=", 
   RowBox[{"Simplify", "[", "Const2", "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"ellc3", "=", 
  RowBox[{"Simplify", "[", "Const3", "]"}]}]}], "Input",
 CellChangeTimes->{{3.537627679175139*^9, 3.537627742317072*^9}, {
  3.537636876281947*^9, 3.53763687844884*^9}, {3.5376379765369062`*^9, 
  3.537638074206946*^9}, {3.537638144466118*^9, 3.537638162905325*^9}}],

Cell[BoxData[
 RowBox[{"sol", "=", 
  RowBox[{"FullSimplify", "[", 
   RowBox[{
    RowBox[{"Solve", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"ell1", ",", "ell2", ",", "ell3", ",", "ell4", ",", "ell5"}], 
        "}"}], "\[Equal]", "0"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"p", "''"}], "[", "z", "]"}], ",", 
        RowBox[{
         RowBox[{"h", "''"}], "[", "z", "]"}], ",", 
        RowBox[{
         RowBox[{"a", "''"}], "[", "z", "]"}], ",", 
        RowBox[{
         RowBox[{"T", "''"}], "[", "z", "]"}], ",", 
        RowBox[{
         RowBox[{"S", "''"}], "[", "z", "]"}]}], "}"}]}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{
  3.537638077410537*^9, {3.5376381314247913`*^9, 3.537638256008617*^9}, {
   3.537638739449127*^9, 3.537638740135255*^9}, {3.537638891437305*^9, 
   3.5376388944848833`*^9}}],

Cell[BoxData[
 RowBox[{"Expand", "[", "ellc1", "]"}]], "Input",
 CellChangeTimes->{{3.537638754409368*^9, 3.537638756597229*^9}}],

Cell[BoxData[
 RowBox[{"Expand", "[", "ellc2", "]"}]], "Input",
 CellChangeTimes->{{3.537638758349153*^9, 3.537638760740986*^9}}],

Cell[BoxData[
 RowBox[{"Expand", "[", "ellc3", "]"}]], "Input",
 CellChangeTimes->{{3.537638761869357*^9, 3.537638765020914*^9}}],

Cell[BoxData[
 RowBox[{"sol2", "=", 
  RowBox[{"FullSimplify", "[", 
   RowBox[{
    RowBox[{"Solve", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"ellc1", ",", "ellc2"}], "}"}], "\[Equal]", "0"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"T", "'"}], "[", "z", "]"}], ",", 
        RowBox[{
         RowBox[{"p", "'"}], "[", "z", "]"}]}], "}"}]}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.537638619736205*^9, 3.53763872186449*^9}, {
  3.53763882686869*^9, 3.537638830835917*^9}, {3.537638862507595*^9, 
  3.5376388755551147`*^9}}],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{"ellc3", "/.", "sol2"}], "]"}]], "Input",
 CellChangeTimes->{{3.537638838836076*^9, 3.5376388709387693`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Simplify", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"D", "[", 
       RowBox[{"ellc1", ",", "z"}], "]"}], "+", 
      RowBox[{"2", 
       FractionBox[
        RowBox[{
         RowBox[{"S", "'"}], "[", "z", "]"}], 
        RowBox[{"S", "[", "z", "]"}]], " ", "ellc1"}]}], ")"}], "/.", "sol"}],
    "]"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"S", "[", "z", "]"}], "^", "2"}], "ellc1"}], ",", "z"}], "]"}],
    "/.", "sol"}], "]"}]}], "Input",
 CellChangeTimes->{{3.537640004014365*^9, 3.5376400814389057`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Simplify", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"D", "[", 
       RowBox[{"ellc2", ",", "z"}], "]"}], "-", 
      RowBox[{
       FractionBox[
        RowBox[{
         RowBox[{"S", "'"}], "[", "z", "]"}], 
        RowBox[{"S", "[", "z", "]"}]], " ", "ellc2"}], "+", 
      RowBox[{
       FractionBox["2", "z"], " ", "ellc2"}]}], ")"}], "/.", "sol"}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{
      FractionBox[
       RowBox[{"z", "^", "2"}], 
       RowBox[{"S", "[", "z", "]"}]], "ellc2"}], ",", "z"}], "]"}], "/.", 
   "sol"}], "]"}]}], "Input",
 CellChangeTimes->{{3.537640004014365*^9, 3.5376401691466208`*^9}, {
  3.537640206992764*^9, 3.537640234528932*^9}}],

Cell[BoxData[
 RowBox[{"Print", "[", 
  "\"\<\\n\\nSo, if c1 and c2 are zero, and they obey simple decoupled eqns, \
then c3 also zero!\\n\\n\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.5376403237255774`*^9, 3.537640353177024*^9}, {
  3.538462192473542*^9, 3.538462193016658*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Asymptotic expansion", "Subsubtitle",
 CellChangeTimes->{{3.538463067865754*^9, 3.5384630721521673`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"p", "[", "z_", "]"}], ":=", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"z", "^", "2"}], " ", "p2"}], "+", 
      RowBox[{
       RowBox[{"z", "^", "3"}], " ", "p3"}], "+", 
      RowBox[{
       RowBox[{"z", "^", "4"}], " ", "p4"}], "+", 
      RowBox[{
       RowBox[{"z", "^", "5"}], " ", "p5"}], "+", 
      RowBox[{
       RowBox[{"z", "^", "6"}], " ", "p6"}], "+", 
      RowBox[{
       RowBox[{"z", "^", "7"}], " ", "p7"}], "+", 
      RowBox[{
       RowBox[{"z", "^", "8"}], " ", "p8"}], "+", 
      RowBox[{
       RowBox[{"z", "^", "9"}], " ", "p9"}], "+", 
      RowBox[{
       RowBox[{"z", "^", "10"}], " ", "p10"}], "+", 
      RowBox[{
       RowBox[{"z", "^", "11"}], " ", "p11"}], "+", 
      RowBox[{
       RowBox[{"z", "^", "12"}], " ", "p12"}]}], ")"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"h", "[", "z_", "]"}], ":=", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"z", "^", "2"}], " ", "h2"}], "+", 
      RowBox[{
       RowBox[{"z", "^", "3"}], " ", "h3"}], "+", 
      RowBox[{
       RowBox[{"z", "^", "4"}], " ", "h4"}], "+", 
      RowBox[{
       RowBox[{"z", "^", "5"}], " ", "h5"}], "+", 
      RowBox[{
       RowBox[{"z", "^", "6"}], " ", "h6"}], "+", 
      RowBox[{
       RowBox[{"z", "^", "7"}], " ", "h7"}], "+", 
      RowBox[{
       RowBox[{"z", "^", "8"}], " ", "h8"}], "+", 
      RowBox[{
       RowBox[{"z", "^", "9"}], " ", "h9"}], "+", 
      RowBox[{
       RowBox[{"z", "^", "10"}], " ", "h10"}], "+", 
      RowBox[{
       RowBox[{"z", "^", "11"}], " ", "h11"}], "+", 
      RowBox[{
       RowBox[{"z", "^", "12"}], " ", "h12"}]}], ")"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"a", "[", "z_", "]"}], ":=", 
    RowBox[{"a0", "+", 
     RowBox[{"z", " ", "a1"}], "+", 
     RowBox[{
      RowBox[{"z", "^", "2"}], " ", "a2"}], "+", 
     RowBox[{
      RowBox[{"z", "^", "3"}], " ", "a3"}], "+", 
     RowBox[{
      RowBox[{"z", "^", "4"}], " ", "a4"}], "+", 
     RowBox[{
      RowBox[{"z", "^", "5"}], " ", "a5"}], "+", 
     RowBox[{
      RowBox[{"z", "^", "6"}], " ", "a6"}], "+", 
     RowBox[{
      RowBox[{"z", "^", "7"}], " ", "a7"}], "+", 
     RowBox[{
      RowBox[{"z", "^", "8"}], " ", "a8"}], "+", 
     RowBox[{
      RowBox[{"z", "^", "9"}], " ", "a9"}], "+", 
     RowBox[{
      RowBox[{"z", "^", "10"}], " ", "a10"}], "+", 
     RowBox[{
      RowBox[{"z", "^", "11"}], " ", "a11"}], "+", 
     RowBox[{
      RowBox[{"z", "^", "12"}], " ", "a12"}]}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", "z_", "]"}], ":=", 
    RowBox[{"1", "+", 
     RowBox[{
      RowBox[{"z", "^", "2"}], "T2"}], "+", 
     RowBox[{
      RowBox[{"z", "^", "3"}], " ", "T3"}], "+", 
     RowBox[{
      RowBox[{"z", "^", "4"}], " ", "T4"}], "+", 
     RowBox[{
      RowBox[{"z", "^", "5"}], " ", "T5"}], "+", 
     RowBox[{
      RowBox[{"z", "^", "6"}], " ", "T6"}], "+", 
     RowBox[{
      RowBox[{"z", "^", "7"}], " ", "T7"}], "+", 
     RowBox[{
      RowBox[{"z", "^", "8"}], " ", "T8"}], "+", 
     RowBox[{
      RowBox[{"z", "^", "9"}], " ", "T9"}], "+", 
     RowBox[{
      RowBox[{"z", "^", "10"}], " ", "T10"}], "+", 
     RowBox[{
      RowBox[{"z", "^", "11"}], " ", "T11"}], "+", 
     RowBox[{
      RowBox[{"z", "^", "12"}], " ", "T12"}]}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"S", "[", "z_", "]"}], ":=", 
   RowBox[{"1", "+", 
    RowBox[{
     RowBox[{"z", "^", "2"}], "S2"}], "+", 
    RowBox[{
     RowBox[{"z", "^", "3"}], " ", "S3"}], "+", 
    RowBox[{
     RowBox[{"z", "^", "4"}], " ", "S4"}], "+", 
    RowBox[{
     RowBox[{"z", "^", "5"}], " ", "S5"}], "+", 
    RowBox[{
     RowBox[{"z", "^", "6"}], " ", "S6"}], "+", 
    RowBox[{
     RowBox[{"z", "^", "7"}], " ", "S7"}], "+", 
    RowBox[{
     RowBox[{"z", "^", "8"}], " ", "S8"}], "+", 
    RowBox[{
     RowBox[{"z", "^", "9"}], " ", "S9"}], "+", 
    RowBox[{
     RowBox[{"z", "^", "10"}], " ", "S10"}], "+", 
    RowBox[{
     RowBox[{"z", "^", "11"}], " ", "S11"}], "+", 
    RowBox[{
     RowBox[{"z", "^", "12"}], " ", "S12"}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.53748941244459*^9, 3.537489445611642*^9}, {
   3.5374894786832*^9, 3.537489485162715*^9}, {3.537489733829163*^9, 
   3.537489756225297*^9}, {3.5374900951164503`*^9, 3.537490119568275*^9}, {
   3.53749015373587*^9, 3.537490153855693*^9}, {3.537490212456991*^9, 
   3.537490237348768*^9}, {3.537490394647192*^9, 3.537490453890482*^9}, {
   3.537490792048935*^9, 3.537490804720195*^9}, {3.537490860205984*^9, 
   3.537490863100896*^9}, {3.5374908962097483`*^9, 3.537490902905895*^9}, {
   3.537491099280459*^9, 3.5374911037619123`*^9}, {3.5374911421214113`*^9, 
   3.537491208593452*^9}, {3.537577393872981*^9, 3.537577398304707*^9}, {
   3.537639022648444*^9, 3.537639113606564*^9}, {3.5381377672688637`*^9, 
   3.5381378365486183`*^9}, 3.538137882235326*^9, {3.538462674627036*^9, 
   3.538462715657539*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Clear", "[", "repl", "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"runeq", ":=", 
  RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"tmp1", "=", 
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{"ellc1", "/.", "repl"}], ",", 
       RowBox[{"{", 
        RowBox[{"z", ",", "0", ",", 
         RowBox[{"pos", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"tmp2", "=", 
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{"ellc2", "/.", "repl"}], ",", 
       RowBox[{"{", 
        RowBox[{"z", ",", "0", ",", 
         RowBox[{"pos", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"tmp3", "=", 
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{"ellc3", "/.", "repl"}], ",", 
       RowBox[{"{", 
        RowBox[{"z", ",", "0", ",", 
         RowBox[{"pos", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"tmp4", "=", 
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{"ell1", "/.", "repl"}], ",", 
       RowBox[{"{", 
        RowBox[{"z", ",", "0", ",", 
         RowBox[{"pos", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"tmp5", "=", 
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{"ell2", "/.", "repl"}], ",", 
       RowBox[{"{", 
        RowBox[{"z", ",", "0", ",", 
         RowBox[{"pos", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"tmp6", "=", 
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{"ell3", "/.", "repl"}], ",", 
       RowBox[{"{", 
        RowBox[{"z", ",", "0", ",", 
         RowBox[{"pos", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"tmp7", "=", 
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{"ell4", "/.", "repl"}], ",", 
       RowBox[{"{", 
        RowBox[{"z", ",", "0", ",", 
         RowBox[{"pos", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"tmp8", "=", 
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{"ell5", "/.", "repl"}], ",", 
       RowBox[{"{", 
        RowBox[{"z", ",", "0", ",", 
         RowBox[{"pos", "-", "1"}]}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", ")"}]}]}], "Input",
 CellChangeTimes->{{3.5376392293063307`*^9, 3.5376392299215183`*^9}, {
  3.538137895519271*^9, 3.538137930215798*^9}, {3.538462288648322*^9, 
  3.538462297761071*^9}, {3.538462392692498*^9, 3.538462394764674*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"repl", "=", 
   RowBox[{"{", "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.538462300919333*^9, 3.538462302093458*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"pos", "=", "1"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"runeq", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmplist", "=", 
   RowBox[{"{", 
    RowBox[{
    "tmp1", ",", "tmp2", ",", "tmp3", ",", "tmp4", ",", "tmp5", ",", "tmp6", 
     ",", "tmp7", ",", "tmp8"}], "}"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sol2", "=", 
   RowBox[{
    RowBox[{"Solve", "[", 
     RowBox[{
      RowBox[{"tmplist", "\[Equal]", "0"}], ",", 
      RowBox[{"{", 
       RowBox[{"T2", ",", "S2", ",", "a2"}], "}"}]}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"repl", "=", "sol2"}], ";"}]}], "Input",
 CellChangeTimes->{{3.538137931998144*^9, 3.5381379817888117`*^9}, {
  3.538462209912683*^9, 3.53846221643303*^9}, {3.538462371290099*^9, 
  3.538462373609942*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"pos", "=", "2"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"runeq", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmplist", "=", 
   RowBox[{"{", 
    RowBox[{
    "tmp1", ",", "tmp2", ",", "tmp3", ",", "tmp4", ",", "tmp5", ",", "tmp6", 
     ",", "tmp7", ",", "tmp8"}], "}"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sol3", "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"tmplist", "\[Equal]", "0"}], ",", 
       RowBox[{"{", 
        RowBox[{"p3", ",", "h3", ",", "a3", ",", "S3"}], "}"}]}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"repl", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"repl", ",", "sol3"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.538137931998144*^9, 3.5381379817888117`*^9}, {
  3.538462209912683*^9, 3.53846221643303*^9}, {3.5384623133361*^9, 
  3.5384623208626213`*^9}, {3.538462364372213*^9, 3.538462367474139*^9}, {
  3.53846240258596*^9, 3.538462463009907*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"pos", "=", "3"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"runeq", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmplist", "=", 
   RowBox[{"{", 
    RowBox[{
    "tmp1", ",", "tmp2", ",", "tmp3", ",", "tmp4", ",", "tmp5", ",", "tmp6", 
     ",", "tmp7", ",", "tmp8"}], "}"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sol4", "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"tmplist", "\[Equal]", "0"}], ",", 
       RowBox[{"{", 
        RowBox[{"p4", ",", "h4", ",", "a4", ",", "S4", ",", "T4"}], "}"}]}], 
      "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"repl", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"repl", ",", "sol4"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.538137931998144*^9, 3.5381379817888117`*^9}, {
  3.538462209912683*^9, 3.53846221643303*^9}, {3.5384623133361*^9, 
  3.5384623208626213`*^9}, {3.538462364372213*^9, 3.538462367474139*^9}, {
  3.53846240258596*^9, 3.538462491570972*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"pos", "=", "4"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"runeq", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmplist", "=", 
   RowBox[{"{", 
    RowBox[{
    "tmp1", ",", "tmp2", ",", "tmp3", ",", "tmp4", ",", "tmp5", ",", "tmp6", 
     ",", "tmp7", ",", "tmp8"}], "}"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sol5", "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"tmplist", "\[Equal]", "0"}], ",", 
       RowBox[{"{", 
        RowBox[{"p5", ",", "h5", ",", "a5", ",", "S5", ",", "T5"}], "}"}]}], 
      "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"repl", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"repl", ",", "sol5"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.538137931998144*^9, 3.5381379817888117`*^9}, {
  3.538462209912683*^9, 3.53846221643303*^9}, {3.5384623133361*^9, 
  3.5384623208626213`*^9}, {3.538462364372213*^9, 3.538462367474139*^9}, {
  3.53846240258596*^9, 3.5384625169946136`*^9}, {3.538462592429839*^9, 
  3.538462602884987*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"pos", "=", "5"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"runeq", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmplist", "=", 
   RowBox[{"{", 
    RowBox[{
    "tmp1", ",", "tmp2", ",", "tmp3", ",", "tmp4", ",", "tmp5", ",", "tmp6", 
     ",", "tmp7", ",", "tmp8"}], "}"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sol6", "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"tmplist", "\[Equal]", "0"}], ",", 
       RowBox[{"{", 
        RowBox[{"p6", ",", "h6", ",", "a6", ",", "S6", ",", "T6"}], "}"}]}], 
      "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"repl", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"repl", ",", "sol6"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.538462610229724*^9, 3.5384626262991323`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"pos", "=", "6"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"runeq", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmplist", "=", 
   RowBox[{"{", 
    RowBox[{
    "tmp1", ",", "tmp2", ",", "tmp3", ",", "tmp4", ",", "tmp5", ",", "tmp6", 
     ",", "tmp7", ",", "tmp8"}], "}"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sol7", "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"tmplist", "\[Equal]", "0"}], ",", 
       RowBox[{"{", 
        RowBox[{"p7", ",", "h7", ",", "a7", ",", "S7", ",", "T7"}], "}"}]}], 
      "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"repl", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"repl", ",", "sol7"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.538462610229724*^9, 3.53846264220479*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"pos", "=", "7"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"runeq", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmplist", "=", 
   RowBox[{"{", 
    RowBox[{
    "tmp1", ",", "tmp2", ",", "tmp3", ",", "tmp4", ",", "tmp5", ",", "tmp6", 
     ",", "tmp7", ",", "tmp8"}], "}"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sol8", "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"tmplist", "\[Equal]", "0"}], ",", 
       RowBox[{"{", 
        RowBox[{"p8", ",", "h8", ",", "a8", ",", "S8", ",", "T8"}], "}"}]}], 
      "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"repl", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"repl", ",", "sol8"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.538462610229724*^9, 3.53846264220479*^9}, {
  3.5384627311973467`*^9, 3.53846274069244*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"pos", "=", "8"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"runeq", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmplist", "=", 
   RowBox[{"{", 
    RowBox[{
    "tmp1", ",", "tmp2", ",", "tmp3", ",", "tmp4", ",", "tmp5", ",", "tmp6", 
     ",", "tmp7", ",", "tmp8"}], "}"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sol9", "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"tmplist", "\[Equal]", "0"}], ",", 
       RowBox[{"{", 
        RowBox[{"p9", ",", "h9", ",", "a9", ",", "S9", ",", "T9"}], "}"}]}], 
      "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"repl", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"repl", ",", "sol9"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.538462747749477*^9, 3.5384627639226007`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"pos", "=", "9"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"runeq", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmplist", "=", 
   RowBox[{"{", 
    RowBox[{
    "tmp1", ",", "tmp2", ",", "tmp3", ",", "tmp4", ",", "tmp5", ",", "tmp6", 
     ",", "tmp7", ",", "tmp8"}], "}"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sol10", "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"tmplist", "\[Equal]", "0"}], ",", 
       RowBox[{"{", 
        RowBox[{"p10", ",", "h10", ",", "a10", ",", "S10", ",", "T10"}], 
        "}"}]}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"repl", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"repl", ",", "sol10"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.538462772165017*^9, 3.53846278770794*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"pos", "=", "10"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"runeq", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmplist", "=", 
   RowBox[{"{", 
    RowBox[{
    "tmp1", ",", "tmp2", ",", "tmp3", ",", "tmp4", ",", "tmp5", ",", "tmp6", 
     ",", "tmp7", ",", "tmp8"}], "}"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sol11", "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"tmplist", "\[Equal]", "0"}], ",", 
       RowBox[{"{", 
        RowBox[{"p11", ",", "h11", ",", "a11", ",", "S11", ",", "T11"}], 
        "}"}]}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"repl", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"repl", ",", "sol11"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.538462774004135*^9, 3.538462809307893*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"pos", "=", "11"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"runeq", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmplist", "=", 
   RowBox[{"{", 
    RowBox[{
    "tmp1", ",", "tmp2", ",", "tmp3", ",", "tmp4", ",", "tmp5", ",", "tmp6", 
     ",", "tmp7", ",", "tmp8"}], "}"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sol12", "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"tmplist", "\[Equal]", "0"}], ",", 
       RowBox[{"{", 
        RowBox[{"p12", ",", "h12", ",", "a12", ",", "S12", ",", "T12"}], 
        "}"}]}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"repl", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"repl", ",", "sol12"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.538462776243325*^9, 3.538462824259987*^9}}],

Cell[BoxData[
 RowBox[{"repl", "=", 
  RowBox[{"FullSimplify", "[", "repl", "]"}]}]], "Input",
 CellChangeTimes->{{3.538462876166841*^9, 3.5384628864493513`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"p", "[", "z", "]"}], "//.", "repl"}]], "Input",
 CellChangeTimes->{{3.538462838910104*^9, 3.538462866002865*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"h", "[", "z", "]"}], "//.", "repl"}]], "Input",
 CellChangeTimes->{3.538462864194768*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"a", "[", "z", "]"}], "//.", "repl"}]], "Input",
 CellChangeTimes->{3.53846286309058*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", "z", "]"}], "//.", "repl"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"S", "[", "z", "]"}], "//.", "repl"}]], "Input",
 CellChangeTimes->{3.5384628615876102`*^9}],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{"p", ",", "h", ",", "a", ",", "T", ",", "S"}], "]"}]], "Input",
 CellChangeTimes->{{3.537640737015723*^9, 3.5376407595390577`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Horizon expansion", "Subsubtitle",
 CellChangeTimes->{{3.538463067865754*^9, 3.5384630721521673`*^9}, {
  3.5384631960168037`*^9, 3.538463196751625*^9}}],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{"T", ",", "S", ",", "a", ",", "p", ",", "h"}], "]"}]], "Input",
 CellChangeTimes->{{3.5384635355243692`*^9, 3.5384635391803713`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Clear", "[", "repl", "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"runeq", ":=", 
  RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"tmp1", "=", 
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{"ellc1", "/.", "repl"}], ",", 
       RowBox[{"{", 
        RowBox[{"z", ",", "z0", ",", "pos"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"tmp2", "=", 
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{"ellc2", "/.", "repl"}], ",", 
       RowBox[{"{", 
        RowBox[{"z", ",", "z0", ",", "pos"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"tmp3", "=", 
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{"ellc3", "/.", "repl"}], ",", 
       RowBox[{"{", 
        RowBox[{"z", ",", "z0", ",", "pos"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"tmp4", "=", 
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{"ell1", "/.", "repl"}], ",", 
       RowBox[{"{", 
        RowBox[{"z", ",", "z0", ",", "pos"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"tmp5", "=", 
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{"ell2", "/.", "repl"}], ",", 
       RowBox[{"{", 
        RowBox[{"z", ",", "z0", ",", "pos"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"tmp6", "=", 
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{"ell3", "/.", "repl"}], ",", 
       RowBox[{"{", 
        RowBox[{"z", ",", "z0", ",", 
         RowBox[{"pos", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"tmp7", "=", 
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{"ell4", "/.", "repl"}], ",", 
       RowBox[{"{", 
        RowBox[{"z", ",", "z0", ",", 
         RowBox[{"pos", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"tmp8", "=", 
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{"ell5", "/.", "repl"}], ",", 
       RowBox[{"{", 
        RowBox[{"z", ",", "z0", ",", 
         RowBox[{"pos", "-", "1"}]}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", ")"}]}]}], "Input",
 CellChangeTimes->{{3.5376392293063307`*^9, 3.5376392299215183`*^9}, {
  3.538137895519271*^9, 3.538137930215798*^9}, {3.538462288648322*^9, 
  3.538462297761071*^9}, {3.538462392692498*^9, 3.538462394764674*^9}, {
  3.538463498120213*^9, 3.538463502943193*^9}, {3.538463596257093*^9, 
  3.538463601832757*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"T", "[", "z_", "]"}], ":=", 
   RowBox[{
    RowBox[{"t1", 
     RowBox[{"(", 
      RowBox[{"z0", "-", "z"}], ")"}]}], "+", 
    RowBox[{"t2", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"z0", "-", "z"}], ")"}], "^", "2"}]}], "+", 
    RowBox[{"t3", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"z0", "-", "z"}], ")"}], "^", "3"}]}], "+", 
    RowBox[{"t4", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"z0", "-", "z"}], ")"}], "^", "4"}]}], "+", 
    RowBox[{"t5", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"z0", "-", "z"}], ")"}], "^", "5"}]}], "+", 
    RowBox[{"t6", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"z0", "-", "z"}], ")"}], "^", "6"}]}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"S", "[", "z_", "]"}], ":=", 
   RowBox[{"s0", "+", 
    RowBox[{"s1", 
     RowBox[{"(", 
      RowBox[{"z0", "-", "z"}], ")"}]}], "+", 
    RowBox[{"s2", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"z0", "-", "z"}], ")"}], "^", "2"}]}], "+", 
    RowBox[{"s3", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"z0", "-", "z"}], ")"}], "^", "3"}]}], "+", 
    RowBox[{"s4", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"z0", "-", "z"}], ")"}], "^", "4"}]}], "+", 
    RowBox[{"s5", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"z0", "-", "z"}], ")"}], "^", "5"}]}], "+", 
    RowBox[{"s6", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"z0", "-", "z"}], ")"}], "^", "6"}]}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"a", "[", "z_", "]"}], ":=", 
   RowBox[{"a0", "+", 
    RowBox[{"a1", 
     RowBox[{"(", 
      RowBox[{"z0", "-", "z"}], ")"}]}], "+", 
    RowBox[{"a2", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"z0", "-", "z"}], ")"}], "^", "2"}]}], "+", 
    RowBox[{"a3", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"z0", "-", "z"}], ")"}], "^", "3"}]}], "+", 
    RowBox[{"a4", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"z0", "-", "z"}], ")"}], "^", "4"}]}], "+", 
    RowBox[{"a5", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"z0", "-", "z"}], ")"}], "^", "5"}]}], "+", 
    RowBox[{"a6", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"z0", "-", "z"}], ")"}], "^", "6"}]}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"p", "[", "z_", "]"}], ":=", 
   RowBox[{"p0", "+", 
    RowBox[{"p1", 
     RowBox[{"(", 
      RowBox[{"z0", "-", "z"}], ")"}]}], "+", 
    RowBox[{"p2", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"z0", "-", "z"}], ")"}], "^", "2"}]}], "+", 
    RowBox[{"p3", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"z0", "-", "z"}], ")"}], "^", "3"}]}], "+", 
    RowBox[{"p4", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"z0", "-", "z"}], ")"}], "^", "4"}]}], "+", 
    RowBox[{"p5", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"z0", "-", "z"}], ")"}], "^", "5"}]}], "+", 
    RowBox[{"p6", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"z0", "-", "z"}], ")"}], "^", "6"}]}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"h", "[", "z_", "]"}], ":=", 
  RowBox[{"h0", "+", 
   RowBox[{"h1", 
    RowBox[{"(", 
     RowBox[{"z0", "-", "z"}], ")"}]}], "+", 
   RowBox[{"h2", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"z0", "-", "z"}], ")"}], "^", "2"}]}], "+", 
   RowBox[{"h3", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"z0", "-", "z"}], ")"}], "^", "3"}]}], "+", 
   RowBox[{"h4", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"z0", "-", "z"}], ")"}], "^", "4"}]}], "+", 
   RowBox[{"h5", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"z0", "-", "z"}], ")"}], "^", "5"}]}], "+", 
   RowBox[{"h6", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"z0", "-", "z"}], ")"}], "^", "6"}]}]}]}]}], "Input",
 CellChangeTimes->{{3.537692460831832*^9, 3.537692571971863*^9}, {
   3.537692934161448*^9, 3.537692935150085*^9}, {3.5384635465997868`*^9, 
   3.5384635932491283`*^9}, 3.538463667298936*^9, {3.538463699260297*^9, 
   3.5384636995001097`*^9}, {3.538463822292626*^9, 3.538463863510054*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"repl", "=", 
   RowBox[{"{", "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.538462300919333*^9, 3.538462302093458*^9}, {
  3.538463560317108*^9, 3.538463563740576*^9}, {3.5384636102038717`*^9, 
  3.538463611852014*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"pos", "=", "0"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"runeq", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmplist", "=", 
   RowBox[{"{", 
    RowBox[{
    "tmp1", ",", "tmp2", ",", "tmp3", ",", "tmp4", ",", "tmp5", ",", "tmp6", 
     ",", "tmp7", ",", "tmp8"}], "}"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sol1", "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"tmplist", "\[Equal]", "0"}], ",", 
       RowBox[{"{", 
        RowBox[{"a0", ",", "p1", ",", "h1", ",", "s1"}], "}"}]}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"repl", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"repl", ",", "sol1"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.538137931998144*^9, 3.5381379817888117`*^9}, {
  3.538462209912683*^9, 3.53846221643303*^9}, {3.538462371290099*^9, 
  3.538462373609942*^9}, {3.5384635209823008`*^9, 3.538463551212698*^9}, {
  3.538463617916279*^9, 3.5384637274578114`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"pos", "=", "1"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"runeq", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmplist", "=", 
   RowBox[{"{", 
    RowBox[{
    "tmp1", ",", "tmp2", ",", "tmp3", ",", "tmp4", ",", "tmp5", ",", "tmp6", 
     ",", "tmp7", ",", "tmp8"}], "}"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sol2", "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"tmplist", "\[Equal]", "0"}], ",", 
       RowBox[{"{", 
        RowBox[{"a2", ",", "p2", ",", "h2", ",", "s2", ",", "t2"}], "}"}]}], 
      "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"repl", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"repl", ",", "sol2"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.538463738305477*^9, 3.5384637769691477`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"pos", "=", "2"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"runeq", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmplist", "=", 
   RowBox[{"{", 
    RowBox[{
    "tmp1", ",", "tmp2", ",", "tmp3", ",", "tmp4", ",", "tmp5", ",", "tmp6", 
     ",", "tmp7", ",", "tmp8"}], "}"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sol3", "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"tmplist", "\[Equal]", "0"}], ",", 
       RowBox[{"{", 
        RowBox[{"a3", ",", "p3", ",", "h3", ",", "s3", ",", "t3"}], "}"}]}], 
      "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"repl", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"repl", ",", "sol3"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.538463738305477*^9, 3.538463797800817*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"pos", "=", "3"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"runeq", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmplist", "=", 
   RowBox[{"{", 
    RowBox[{
    "tmp1", ",", "tmp2", ",", "tmp3", ",", "tmp4", ",", "tmp5", ",", "tmp6", 
     ",", "tmp7", ",", "tmp8"}], "}"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sol4", "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"tmplist", "\[Equal]", "0"}], ",", 
       RowBox[{"{", 
        RowBox[{"a4", ",", "p4", ",", "h4", ",", "s4", ",", "t4"}], "}"}]}], 
      "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"repl", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"repl", ",", "sol4"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.538463738305477*^9, 3.538463797800817*^9}, {
  3.5384639094954557`*^9, 3.538463917350461*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"pos", "=", "4"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"runeq", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmplist", "=", 
   RowBox[{"{", 
    RowBox[{
    "tmp1", ",", "tmp2", ",", "tmp3", ",", "tmp4", ",", "tmp5", ",", "tmp6", 
     ",", "tmp7", ",", "tmp8"}], "}"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sol5", "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"tmplist", "\[Equal]", "0"}], ",", 
       RowBox[{"{", 
        RowBox[{"a5", ",", "p5", ",", "h5", ",", "s5", ",", "t5"}], "}"}]}], 
      "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"repl", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"repl", ",", "sol5"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.538463738305477*^9, 3.538463797800817*^9}, {
  3.5384639094954557`*^9, 3.5384639327501297`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"pos", "=", "5"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"runeq", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmplist", "=", 
   RowBox[{"{", 
    RowBox[{
    "tmp1", ",", "tmp2", ",", "tmp3", ",", "tmp4", ",", "tmp5", ",", "tmp6", 
     ",", "tmp7", ",", "tmp8"}], "}"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sol6", "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"tmplist", "\[Equal]", "0"}], ",", 
       RowBox[{"{", 
        RowBox[{"a6", ",", "p6", ",", "h6", ",", "s6", ",", "t6"}], "}"}]}], 
      "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"repl", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"repl", ",", "sol6"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.538463738305477*^9, 3.538463797800817*^9}, {
  3.5384639094954557`*^9, 3.538463956934313*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"p", "[", "z", "]"}], "//.", "repl"}]], "Input",
 CellChangeTimes->{{3.538463967809574*^9, 3.5384639792942257`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"h", "[", "z", "]"}], "//.", "repl"}]], "Input",
 CellChangeTimes->{3.538463981029242*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"a", "[", "z", "]"}], "//.", "repl"}]], "Input",
 CellChangeTimes->{3.538463982933107*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", "z", "]"}], "//.", "repl"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"S", "[", "z", "]"}], "//.", "repl"}]], "Input",
 CellChangeTimes->{3.538463984821121*^9}],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{"p", ",", "h", ",", "a", ",", "T", ",", "S"}], "]"}]], "Input",
 CellChangeTimes->{{3.5384640959611263`*^9, 3.538464099700382*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Radial evolution equations", "Subsubtitle",
 CellChangeTimes->{{3.538463067865754*^9, 3.5384630910323133`*^9}}],

Cell[BoxData[
 RowBox[{"tmp", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{"Solve", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ellc1", "\[Equal]", "0"}], ",", 
       RowBox[{"ellc2", "\[Equal]", "0"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"T", "'"}], "[", "z", "]"}], ",", 
       RowBox[{
        RowBox[{"h", "'"}], "[", "z", "]"}]}], "}"}]}], "]"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.538046181988859*^9, 3.538046275572392*^9}, {
  3.538118511452941*^9, 3.5381185296755857`*^9}}],

Cell[BoxData[
 RowBox[{"Expand", "[", "tmp", "]"}]], "Input",
 CellChangeTimes->{{3.538138653550453*^9, 3.538138655138913*^9}}],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{"ellc3", "/.", "tmp"}], "]"}]], "Input",
 CellChangeTimes->{{3.538046278386948*^9, 3.538046283644046*^9}}],

Cell[BoxData[
 RowBox[{"tmp", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{"Solve", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ell1", "\[Equal]", "0"}], ",", 
       RowBox[{"ell4", "\[Equal]", "0"}], ",", 
       RowBox[{"ell5", "\[Equal]", "0"}], ",", 
       RowBox[{"ellc1", "\[Equal]", "0"}], ",", 
       RowBox[{"ellc2", "\[Equal]", "0"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"p", "''"}], "[", "z", "]"}], ",", 
       RowBox[{
        RowBox[{"a", "''"}], "[", "z", "]"}], ",", 
       RowBox[{
        RowBox[{"S", "''"}], "[", "z", "]"}], ",", 
       RowBox[{
        RowBox[{"T", "'"}], "[", "z", "]"}], ",", 
       RowBox[{
        RowBox[{"h", "'"}], "[", "z", "]"}]}], "}"}]}], "]"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.538046946386949*^9, 3.538046971865954*^9}, {
  3.538047767565443*^9, 3.538047777835328*^9}, {3.538118570663123*^9, 
  3.538118592110586*^9}}],

Cell[BoxData[
 RowBox[{"eqlist", "=", 
  RowBox[{"Thread", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"p", "''"}], "[", "z", "]"}], ",", 
      RowBox[{
       RowBox[{"a", "''"}], "[", "z", "]"}], ",", 
      RowBox[{
       RowBox[{"S", "''"}], "[", "z", "]"}], ",", 
      RowBox[{
       RowBox[{"T", "'"}], "[", "z", "]"}], ",", 
      RowBox[{
       RowBox[{"h", "'"}], "[", "z", "]"}]}], "}"}], "==", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"p", "''"}], "[", "z", "]"}], ",", 
        RowBox[{
         RowBox[{"a", "''"}], "[", "z", "]"}], ",", 
        RowBox[{
         RowBox[{"S", "''"}], "[", "z", "]"}], ",", 
        RowBox[{
         RowBox[{"T", "'"}], "[", "z", "]"}], ",", 
        RowBox[{
         RowBox[{"h", "'"}], "[", "z", "]"}]}], "}"}], "/.", 
      RowBox[{"tmp", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ")"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.538046982617304*^9, 3.538047031616665*^9}, {
  3.538047095238578*^9, 3.538047109277329*^9}, {3.538047742727194*^9, 
  3.538047743310781*^9}, {3.538047780875566*^9, 3.53804778166721*^9}, {
  3.5381186282311773`*^9, 3.5381186428306227`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Summary - Must Run.", "Subsubtitle",
 CellChangeTimes->{{3.538463037602364*^9, 3.538463043377323*^9}, {
  3.538464312857139*^9, 3.538464319392853*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"replasym", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"p2", "\[Rule]", "asymp2"}], ",", 
      RowBox[{"h2", "\[Rule]", "asymh2"}], ",", 
      RowBox[{"a0", "\[Rule]", "asyma0"}], ",", 
      RowBox[{"a1", "\[Rule]", "asyma1"}], ",", 
      RowBox[{"T3", "\[Rule]", "asymT3"}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"replhoriz", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"t1", "\[Rule]", "horizt1"}], ",", 
     RowBox[{"a1", "\[Rule]", "horiza1"}], ",", 
     RowBox[{"p0", "\[Rule]", "horizp0"}], ",", 
     RowBox[{"h0", "\[Rule]", "horizh0"}], ",", 
     RowBox[{"s0", "\[Rule]", "horizs0"}]}], "}"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.537873163678542*^9, 3.537873275606132*^9}, {
  3.538464304756454*^9, 3.53846431129167*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"horizp", "[", "z_", "]"}], ":=", 
    RowBox[{
     RowBox[{"p0", "-", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "z"}], "+", "z0"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", "p0"}], "+", 
          RowBox[{"a1", " ", "h0", " ", 
           SuperscriptBox["z0", "2"]}]}], ")"}]}], 
       RowBox[{"t1", " ", 
        SuperscriptBox["z0", "2"]}]], "+", 
      FractionBox[
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "z"}], "+", "z0"}], ")"}], "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"8", " ", 
           SuperscriptBox["p0", "3"]}], "+", 
          RowBox[{"4", " ", "p0", " ", 
           RowBox[{"(", 
            RowBox[{"8", "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["h0", "2"]}], "-", 
             RowBox[{"4", " ", "t1", " ", "z0"}], "-", 
             RowBox[{
              SuperscriptBox["a1", "2"], " ", 
              SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
          RowBox[{"a1", " ", "h0", " ", 
           SuperscriptBox["z0", "2"], " ", 
           RowBox[{"(", 
            RowBox[{"28", "-", 
             RowBox[{"8", " ", "t1", " ", "z0"}], "+", 
             RowBox[{
              SuperscriptBox["a1", "2"], " ", 
              SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["t1", "2"], " ", 
        SuperscriptBox["z0", "4"]}]], "+", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"36", " ", 
         SuperscriptBox["t1", "3"], " ", 
         SuperscriptBox["z0", "6"]}]], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "z"}], "+", "z0"}], ")"}], "3"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "24"}], " ", 
          SuperscriptBox["p0", "5"]}], "-", 
         RowBox[{"24", " ", 
          SuperscriptBox["p0", "3"], " ", 
          RowBox[{"(", 
           RowBox[{"9", "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["h0", "2"]}], "-", 
            RowBox[{"3", " ", "t1", " ", "z0"}]}], ")"}]}], "+", 
         RowBox[{"3", " ", "a1", " ", "h0", " ", 
          SuperscriptBox["p0", "2"], " ", 
          SuperscriptBox["z0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "16"}], "+", 
            RowBox[{
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
         RowBox[{"p0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "296"}], "-", 
            RowBox[{"24", " ", 
             SuperscriptBox["h0", "4"]}], "-", 
            RowBox[{"72", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"]}], "+", 
            RowBox[{"78", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"6", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "+", 
            RowBox[{"72", " ", 
             SuperscriptBox["h0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "3"}], "+", 
               RowBox[{"t1", " ", "z0"}]}], ")"}]}], "-", 
            RowBox[{"36", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "8"}], "+", 
               RowBox[{
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}], "+", 
         RowBox[{"3", " ", "a1", " ", "h0", " ", 
          SuperscriptBox["z0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "108"}], "-", 
            RowBox[{"12", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"]}], "-", 
            RowBox[{"11", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{
             SuperscriptBox["h0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "16"}], "+", 
               RowBox[{
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
            RowBox[{"3", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{"28", "+", 
               RowBox[{
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}]}], ")"}]}], 
      "+", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"2304", " ", 
         SuperscriptBox["t1", "4"], " ", 
         SuperscriptBox["z0", "8"]}]], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "z"}], "+", "z0"}], ")"}], "4"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"1152", " ", 
          SuperscriptBox["p0", "7"]}], "+", 
         RowBox[{"1728", " ", "a1", " ", "h0", " ", 
          SuperscriptBox["p0", "4"], " ", 
          SuperscriptBox["z0", "2"]}], "+", 
         RowBox[{"192", " ", 
          SuperscriptBox["p0", "5"], " ", 
          RowBox[{"(", 
           RowBox[{"85", "+", 
            RowBox[{"18", " ", 
             SuperscriptBox["h0", "2"]}], "-", 
            RowBox[{"24", " ", "t1", " ", "z0"}]}], ")"}]}], "+", 
         RowBox[{"24", " ", 
          SuperscriptBox["p0", "3"], " ", 
          RowBox[{"(", 
           RowBox[{"2352", "+", 
            RowBox[{"144", " ", 
             SuperscriptBox["h0", "4"]}], "-", 
            RowBox[{"1728", " ", "t1", " ", "z0"}], "+", 
            RowBox[{"288", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"]}], "-", 
            RowBox[{"32", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"5", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "-", 
            RowBox[{"16", " ", 
             SuperscriptBox["h0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "85"}], "+", 
               RowBox[{"24", " ", "t1", " ", "z0"}]}], ")"}]}]}], ")"}]}], 
         "-", 
         RowBox[{"6", " ", "a1", " ", "h0", " ", 
          SuperscriptBox["p0", "2"], " ", 
          SuperscriptBox["z0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "3664"}], "-", 
            RowBox[{"576", " ", 
             SuperscriptBox["h0", "2"]}], "+", 
            RowBox[{"96", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"21", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "-", 
            RowBox[{"96", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "16"}], "+", 
               RowBox[{
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}], "+", 
         RowBox[{"p0", " ", 
          RowBox[{"(", 
           RowBox[{"40960", "+", 
            RowBox[{"1152", " ", 
             SuperscriptBox["h0", "6"]}], "-", 
            RowBox[{"4608", " ", 
             SuperscriptBox["t1", "3"], " ", 
             SuperscriptBox["z0", "3"]}], "-", 
            RowBox[{"12720", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "-", 
            RowBox[{"3672", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "-", 
            RowBox[{"27", " ", 
             SuperscriptBox["a1", "6"], " ", 
             SuperscriptBox["z0", "12"]}], "-", 
            RowBox[{"192", " ", 
             SuperscriptBox["h0", "4"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "85"}], "+", 
               RowBox[{"24", " ", "t1", " ", "z0"}]}], ")"}]}], "-", 
            RowBox[{"3456", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "8"}], "+", 
               RowBox[{
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
            RowBox[{"384", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "148"}], "+", 
               RowBox[{"39", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"3", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}], "+", 
            RowBox[{"24", " ", 
             SuperscriptBox["h0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"2352", "-", 
               RowBox[{"1728", " ", "t1", " ", "z0"}], "+", 
               RowBox[{"288", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"]}], "-", 
               RowBox[{"32", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}], "+", 
         RowBox[{"2", " ", "a1", " ", "h0", " ", 
          SuperscriptBox["z0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{"23584", "+", 
            RowBox[{"864", " ", 
             SuperscriptBox["h0", "4"]}], "-", 
            RowBox[{"1152", " ", 
             SuperscriptBox["t1", "3"], " ", 
             SuperscriptBox["z0", "3"]}], "+", 
            RowBox[{"5520", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "-", 
            RowBox[{"30", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "+", 
            RowBox[{"432", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"28", "+", 
               RowBox[{
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
            RowBox[{"288", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{"108", "+", 
               RowBox[{"11", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["h0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"3664", "-", 
               RowBox[{"96", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "-", 
               RowBox[{"21", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"96", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "16"}], "+", 
                  RowBox[{
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}]}], 
           ")"}]}]}], ")"}]}], "-", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"57600", " ", 
         SuperscriptBox["t1", "5"], " ", 
         SuperscriptBox["z0", "10"]}]], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "z"}], "+", "z0"}], ")"}], "5"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"23040", " ", 
          SuperscriptBox["p0", "9"]}], "+", 
         RowBox[{"2304", " ", 
          SuperscriptBox["p0", "7"], " ", 
          RowBox[{"(", 
           RowBox[{"193", "+", 
            RowBox[{"40", " ", 
             SuperscriptBox["h0", "2"]}], "-", 
            RowBox[{"50", " ", "t1", " ", "z0"}]}], ")"}]}], "+", 
         RowBox[{"96", " ", "a1", " ", "h0", " ", 
          SuperscriptBox["p0", "6"], " ", 
          SuperscriptBox["z0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{"308", "+", 
            RowBox[{"5", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
         RowBox[{"32", " ", 
          SuperscriptBox["p0", "5"], " ", 
          RowBox[{"(", 
           RowBox[{"80860", "+", 
            RowBox[{"4320", " ", 
             SuperscriptBox["h0", "4"]}], "-", 
            RowBox[{"51000", " ", "t1", " ", "z0"}], "+", 
            RowBox[{"7200", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"]}], "+", 
            RowBox[{"354", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "-", 
            RowBox[{"75", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "-", 
            RowBox[{"216", " ", 
             SuperscriptBox["h0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "193"}], "+", 
               RowBox[{"50", " ", "t1", " ", "z0"}]}], ")"}]}]}], ")"}]}], 
         "-", 
         RowBox[{"12", " ", "a1", " ", "h0", " ", 
          SuperscriptBox["p0", "4"], " ", 
          SuperscriptBox["z0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "44576"}], "+", 
            RowBox[{"14400", " ", "t1", " ", "z0"}], "-", 
            RowBox[{"432", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"15", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "-", 
            RowBox[{"24", " ", 
             SuperscriptBox["h0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"308", "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}], "+", 
         RowBox[{"2", " ", 
          SuperscriptBox["p0", "3"], " ", 
          RowBox[{"(", 
           RowBox[{"2472064", "+", 
            RowBox[{"46080", " ", 
             SuperscriptBox["h0", "6"]}], "+", 
            RowBox[{"1036800", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"]}], "-", 
            RowBox[{"115200", " ", 
             SuperscriptBox["t1", "3"], " ", 
             SuperscriptBox["z0", "3"]}], "-", 
            RowBox[{"23856", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "-", 
            RowBox[{"6216", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "+", 
            RowBox[{"2235", " ", 
             SuperscriptBox["a1", "6"], " ", 
             SuperscriptBox["z0", "12"]}], "-", 
            RowBox[{"3456", " ", 
             SuperscriptBox["h0", "4"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "193"}], "+", 
               RowBox[{"50", " ", "t1", " ", "z0"}]}], ")"}]}], "+", 
            RowBox[{"32", " ", 
             SuperscriptBox["h0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"80860", "-", 
               RowBox[{"51000", " ", "t1", " ", "z0"}], "+", 
               RowBox[{"7200", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"]}], "+", 
               RowBox[{"354", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "-", 
               RowBox[{"75", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}], "-", 
            RowBox[{"1200", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{"2352", "-", 
               RowBox[{"32", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}], "-", 
         RowBox[{"6", " ", "a1", " ", "h0", " ", 
          SuperscriptBox["p0", "2"], " ", 
          SuperscriptBox["z0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "413408"}], "-", 
            RowBox[{"19536", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"6614", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "+", 
            RowBox[{"75", " ", 
             SuperscriptBox["a1", "6"], " ", 
             SuperscriptBox["z0", "12"]}], "+", 
            RowBox[{"4800", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "16"}], "+", 
               RowBox[{
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
            RowBox[{"48", " ", 
             SuperscriptBox["h0", "4"], " ", 
             RowBox[{"(", 
              RowBox[{"308", "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["h0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "44576"}], "+", 
               RowBox[{"14400", " ", "t1", " ", "z0"}], "-", 
               RowBox[{"432", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"15", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}], "-", 
            RowBox[{"100", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "3664"}], "+", 
               RowBox[{"96", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"21", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}], "+", 
         RowBox[{"2", " ", "p0", " ", 
          RowBox[{"(", 
           RowBox[{"1177600", "+", 
            RowBox[{"11520", " ", 
             SuperscriptBox["h0", "8"]}], "-", 
            RowBox[{"253712", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"57600", " ", 
             SuperscriptBox["t1", "4"], " ", 
             SuperscriptBox["z0", "4"]}], "-", 
            RowBox[{"258312", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "-", 
            RowBox[{"6993", " ", 
             SuperscriptBox["a1", "6"], " ", 
             SuperscriptBox["z0", "12"]}], "-", 
            RowBox[{"1152", " ", 
             SuperscriptBox["h0", "6"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "193"}], "+", 
               RowBox[{"50", " ", "t1", " ", "z0"}]}], ")"}]}], "+", 
            RowBox[{"57600", " ", 
             SuperscriptBox["t1", "3"], " ", 
             SuperscriptBox["z0", "3"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "8"}], "+", 
               RowBox[{
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
            RowBox[{"16", " ", 
             SuperscriptBox["h0", "4"], " ", 
             RowBox[{"(", 
              RowBox[{"80860", "-", 
               RowBox[{"51000", " ", "t1", " ", "z0"}], "+", 
               RowBox[{"7200", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"]}], "+", 
               RowBox[{"354", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "-", 
               RowBox[{"75", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}], "-", 
            RowBox[{"9600", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "148"}], "+", 
               RowBox[{"39", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"3", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}], "+", 
            RowBox[{"50", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "40960"}], "+", 
               RowBox[{"12720", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"3672", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"27", " ", 
                SuperscriptBox["a1", "6"], " ", 
                SuperscriptBox["z0", "12"]}]}], ")"}]}], "+", 
            RowBox[{
             SuperscriptBox["h0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"2472064", "+", 
               RowBox[{"1036800", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"]}], "-", 
               RowBox[{"115200", " ", 
                SuperscriptBox["t1", "3"], " ", 
                SuperscriptBox["z0", "3"]}], "-", 
               RowBox[{"23856", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "-", 
               RowBox[{"6216", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"2235", " ", 
                SuperscriptBox["a1", "6"], " ", 
                SuperscriptBox["z0", "12"]}], "-", 
               RowBox[{"1200", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{"2352", "-", 
                  RowBox[{"32", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}], "+", 
                  RowBox[{"5", " ", 
                   SuperscriptBox["a1", "4"], " ", 
                   SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}]}], 
           ")"}]}], "-", 
         RowBox[{"a1", " ", "h0", " ", 
          SuperscriptBox["z0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "96"}], " ", 
             SuperscriptBox["h0", "6"], " ", 
             RowBox[{"(", 
              RowBox[{"308", "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
            RowBox[{"12", " ", 
             SuperscriptBox["h0", "4"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "44576"}], "+", 
               RowBox[{"14400", " ", "t1", " ", "z0"}], "-", 
               RowBox[{"432", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"15", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}], "+", 
            RowBox[{"5", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "511616"}], "-", 
               RowBox[{"240464", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "-", 
               RowBox[{"11520", " ", 
                SuperscriptBox["t1", "4"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"1296", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"159", " ", 
                SuperscriptBox["a1", "6"], " ", 
                SuperscriptBox["z0", "12"]}], "+", 
               RowBox[{"5760", " ", 
                SuperscriptBox["t1", "3"], " ", 
                SuperscriptBox["z0", "3"], " ", 
                RowBox[{"(", 
                 RowBox[{"28", "+", 
                  RowBox[{
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
               RowBox[{"5760", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"108", "+", 
                  RowBox[{"11", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
               RowBox[{"80", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "11792"}], "-", 
                  RowBox[{"2760", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}], "+", 
                  RowBox[{"15", " ", 
                   SuperscriptBox["a1", "4"], " ", 
                   SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}], "+", 
            RowBox[{"6", " ", 
             SuperscriptBox["h0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "413408"}], "-", 
               RowBox[{"19536", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"6614", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"75", " ", 
                SuperscriptBox["a1", "6"], " ", 
                SuperscriptBox["z0", "12"]}], "+", 
               RowBox[{"4800", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "16"}], "+", 
                  RowBox[{
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
               RowBox[{"100", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "3664"}], "+", 
                  RowBox[{"96", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}], "+", 
                  RowBox[{"21", " ", 
                   SuperscriptBox["a1", "4"], " ", 
                   SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}]}], 
           ")"}]}]}], ")"}]}], "+", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"4147200", " ", 
         SuperscriptBox["t1", "6"], " ", 
         SuperscriptBox["z0", "12"]}]], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "z"}], "+", "z0"}], ")"}], "6"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"1382400", " ", 
          SuperscriptBox["p0", "11"]}], "+", 
         RowBox[{"46080", " ", 
          SuperscriptBox["p0", "9"], " ", 
          RowBox[{"(", 
           RowBox[{"731", "+", 
            RowBox[{"150", " ", 
             SuperscriptBox["h0", "2"]}], "-", 
            RowBox[{"180", " ", "t1", " ", "z0"}]}], ")"}]}], "+", 
         RowBox[{"9216", " ", "a1", " ", "h0", " ", 
          SuperscriptBox["p0", "8"], " ", 
          SuperscriptBox["z0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{"178", "+", 
            RowBox[{"5", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
         RowBox[{"4608", " ", 
          SuperscriptBox["p0", "7"], " ", 
          RowBox[{"(", 
           RowBox[{"60521", "+", 
            RowBox[{"3000", " ", 
             SuperscriptBox["h0", "4"]}], "-", 
            RowBox[{"34740", " ", "t1", " ", "z0"}], "+", 
            RowBox[{"4500", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"]}], "+", 
            RowBox[{"383", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "-", 
            RowBox[{"50", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "-", 
            RowBox[{"40", " ", 
             SuperscriptBox["h0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "731"}], "+", 
               RowBox[{"180", " ", "t1", " ", "z0"}]}], ")"}]}]}], ")"}]}], 
         "-", 
         RowBox[{"1152", " ", "a1", " ", "h0", " ", 
          SuperscriptBox["p0", "6"], " ", 
          SuperscriptBox["z0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "32684"}], "-", 
            RowBox[{"882", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"45", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "-", 
            RowBox[{"32", " ", 
             SuperscriptBox["h0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"178", "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
            RowBox[{"30", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{"308", "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}], "+", 
         RowBox[{"288", " ", 
          SuperscriptBox["p0", "5"], " ", 
          RowBox[{"(", 
           RowBox[{"3218720", "+", 
            RowBox[{"48000", " ", 
             SuperscriptBox["h0", "6"]}], "+", 
            RowBox[{"1020000", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"]}], "-", 
            RowBox[{"96000", " ", 
             SuperscriptBox["t1", "3"], " ", 
             SuperscriptBox["z0", "3"]}], "+", 
            RowBox[{"64496", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "-", 
            RowBox[{"13756", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "+", 
            RowBox[{"125", " ", 
             SuperscriptBox["a1", "6"], " ", 
             SuperscriptBox["z0", "12"]}], "-", 
            RowBox[{"960", " ", 
             SuperscriptBox["h0", "4"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "731"}], "+", 
               RowBox[{"180", " ", "t1", " ", "z0"}]}], ")"}]}], "+", 
            RowBox[{"48", " ", 
             SuperscriptBox["h0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"60521", "-", 
               RowBox[{"34740", " ", "t1", " ", "z0"}], "+", 
               RowBox[{"4500", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"]}], "+", 
               RowBox[{"383", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "-", 
               RowBox[{"50", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}], "+", 
            RowBox[{"40", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "80860"}], "-", 
               RowBox[{"354", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"75", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}], "+", 
         RowBox[{"36", " ", "a1", " ", "h0", " ", 
          SuperscriptBox["p0", "4"], " ", 
          SuperscriptBox["z0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{"7514816", "+", 
            RowBox[{"864000", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"]}], "+", 
            RowBox[{"378208", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "-", 
            RowBox[{"36984", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "+", 
            RowBox[{"1785", " ", 
             SuperscriptBox["a1", "6"], " ", 
             SuperscriptBox["z0", "12"]}], "+", 
            RowBox[{"1536", " ", 
             SuperscriptBox["h0", "4"], " ", 
             RowBox[{"(", 
              RowBox[{"178", "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
            RowBox[{"120", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "44576"}], "-", 
               RowBox[{"432", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"15", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}], "-", 
            RowBox[{"96", " ", 
             SuperscriptBox["h0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "32684"}], "-", 
               RowBox[{"882", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"45", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"30", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{"308", "+", 
                  RowBox[{"5", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}]}], 
           ")"}]}], "-", 
         RowBox[{"36", " ", "a1", " ", "h0", " ", 
          SuperscriptBox["p0", "2"], " ", 
          SuperscriptBox["z0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "18272128"}], "-", 
            RowBox[{"3170720", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"579960", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "+", 
            RowBox[{"16350", " ", 
             SuperscriptBox["a1", "6"], " ", 
             SuperscriptBox["z0", "12"]}], "+", 
            RowBox[{"45", " ", 
             SuperscriptBox["a1", "8"], " ", 
             SuperscriptBox["z0", "16"]}], "-", 
            RowBox[{"96000", " ", 
             SuperscriptBox["t1", "3"], " ", 
             SuperscriptBox["z0", "3"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "16"}], "+", 
               RowBox[{
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
            RowBox[{"1024", " ", 
             SuperscriptBox["h0", "6"], " ", 
             RowBox[{"(", 
              RowBox[{"178", "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
            RowBox[{"3000", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "3664"}], "+", 
               RowBox[{"96", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"21", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}], "-", 
            RowBox[{"60", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "413408"}], "-", 
               RowBox[{"19536", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"6614", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"75", " ", 
                SuperscriptBox["a1", "6"], " ", 
                SuperscriptBox["z0", "12"]}]}], ")"}]}], "+", 
            RowBox[{"96", " ", 
             SuperscriptBox["h0", "4"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "32684"}], "-", 
               RowBox[{"882", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"45", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"30", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{"308", "+", 
                  RowBox[{"5", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["h0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"7514816", "+", 
               RowBox[{"864000", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"]}], "+", 
               RowBox[{"378208", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "-", 
               RowBox[{"36984", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"1785", " ", 
                SuperscriptBox["a1", "6"], " ", 
                SuperscriptBox["z0", "12"]}], "+", 
               RowBox[{"120", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "44576"}], "-", 
                  RowBox[{"432", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}], "+", 
                  RowBox[{"15", " ", 
                   SuperscriptBox["a1", "4"], " ", 
                   SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}]}], 
           ")"}]}], "+", 
         RowBox[{"6", " ", 
          SuperscriptBox["p0", "3"], " ", 
          RowBox[{"(", 
           RowBox[{"193580032", "+", 
            RowBox[{"1152000", " ", 
             SuperscriptBox["h0", "8"]}], "-", 
            RowBox[{"41472000", " ", 
             SuperscriptBox["t1", "3"], " ", 
             SuperscriptBox["z0", "3"]}], "+", 
            RowBox[{"6178176", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"3456000", " ", 
             SuperscriptBox["t1", "4"], " ", 
             SuperscriptBox["z0", "4"]}], "-", 
            RowBox[{"4416240", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "+", 
            RowBox[{"677328", " ", 
             SuperscriptBox["a1", "6"], " ", 
             SuperscriptBox["z0", "12"]}], "+", 
            RowBox[{"13725", " ", 
             SuperscriptBox["a1", "8"], " ", 
             SuperscriptBox["z0", "16"]}], "-", 
            RowBox[{"30720", " ", 
             SuperscriptBox["h0", "6"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "731"}], "+", 
               RowBox[{"180", " ", "t1", " ", "z0"}]}], ")"}]}], "+", 
            RowBox[{"2304", " ", 
             SuperscriptBox["h0", "4"], " ", 
             RowBox[{"(", 
              RowBox[{"60521", "-", 
               RowBox[{"34740", " ", "t1", " ", "z0"}], "+", 
               RowBox[{"4500", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"]}], "+", 
               RowBox[{"383", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "-", 
               RowBox[{"50", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}], "+", 
            RowBox[{"72000", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"2352", "-", 
               RowBox[{"32", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}], "-", 
            RowBox[{"120", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{"2472064", "-", 
               RowBox[{"23856", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "-", 
               RowBox[{"6216", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"2235", " ", 
                SuperscriptBox["a1", "6"], " ", 
                SuperscriptBox["z0", "12"]}]}], ")"}]}], "-", 
            RowBox[{"96", " ", 
             SuperscriptBox["h0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "3218720"}], "-", 
               RowBox[{"1020000", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"]}], "+", 
               RowBox[{"96000", " ", 
                SuperscriptBox["t1", "3"], " ", 
                SuperscriptBox["z0", "3"]}], "-", 
               RowBox[{"64496", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"13756", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "-", 
               RowBox[{"125", " ", 
                SuperscriptBox["a1", "6"], " ", 
                SuperscriptBox["z0", "12"]}], "-", 
               RowBox[{"40", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "80860"}], "-", 
                  RowBox[{"354", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}], "+", 
                  RowBox[{"75", " ", 
                   SuperscriptBox["a1", "4"], " ", 
                   SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}]}], 
           ")"}]}], "-", 
         RowBox[{"3", " ", "a1", " ", "h0", " ", 
          SuperscriptBox["z0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "133539840"}], "-", 
            RowBox[{"110648384", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"1382400", " ", 
             SuperscriptBox["t1", "5"], " ", 
             SuperscriptBox["z0", "5"]}], "-", 
            RowBox[{"1007184", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "+", 
            RowBox[{"319524", " ", 
             SuperscriptBox["a1", "6"], " ", 
             SuperscriptBox["z0", "12"]}], "+", 
            RowBox[{"1125", " ", 
             SuperscriptBox["a1", "8"], " ", 
             SuperscriptBox["z0", "16"]}], "-", 
            RowBox[{"864000", " ", 
             SuperscriptBox["t1", "4"], " ", 
             SuperscriptBox["z0", "4"], " ", 
             RowBox[{"(", 
              RowBox[{"28", "+", 
               RowBox[{
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
            RowBox[{"3072", " ", 
             SuperscriptBox["h0", "8"], " ", 
             RowBox[{"(", 
              RowBox[{"178", "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
            RowBox[{"1152000", " ", 
             SuperscriptBox["t1", "3"], " ", 
             SuperscriptBox["z0", "3"], " ", 
             RowBox[{"(", 
              RowBox[{"108", "+", 
               RowBox[{"11", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
            RowBox[{"24000", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "11792"}], "-", 
               RowBox[{"2760", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"15", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}], "-", 
            RowBox[{"600", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "511616"}], "-", 
               RowBox[{"240464", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"1296", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"159", " ", 
                SuperscriptBox["a1", "6"], " ", 
                SuperscriptBox["z0", "12"]}]}], ")"}]}], "+", 
            RowBox[{"384", " ", 
             SuperscriptBox["h0", "6"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "32684"}], "-", 
               RowBox[{"882", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"45", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"30", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{"308", "+", 
                  RowBox[{"5", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}], "-", 
            RowBox[{"12", " ", 
             SuperscriptBox["h0", "4"], " ", 
             RowBox[{"(", 
              RowBox[{"7514816", "+", 
               RowBox[{"864000", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"]}], "+", 
               RowBox[{"378208", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "-", 
               RowBox[{"36984", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"1785", " ", 
                SuperscriptBox["a1", "6"], " ", 
                SuperscriptBox["z0", "12"]}], "+", 
               RowBox[{"120", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "44576"}], "-", 
                  RowBox[{"432", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}], "+", 
                  RowBox[{"15", " ", 
                   SuperscriptBox["a1", "4"], " ", 
                   SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}], "-", 
            RowBox[{"12", " ", 
             SuperscriptBox["h0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"18272128", "+", 
               RowBox[{"3170720", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "-", 
               RowBox[{"579960", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "-", 
               RowBox[{"16350", " ", 
                SuperscriptBox["a1", "6"], " ", 
                SuperscriptBox["z0", "12"]}], "-", 
               RowBox[{"45", " ", 
                SuperscriptBox["a1", "8"], " ", 
                SuperscriptBox["z0", "16"]}], "+", 
               RowBox[{"96000", " ", 
                SuperscriptBox["t1", "3"], " ", 
                SuperscriptBox["z0", "3"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "16"}], "+", 
                  RowBox[{
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
               RowBox[{"3000", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "3664"}], "+", 
                  RowBox[{"96", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}], "+", 
                  RowBox[{"21", " ", 
                   SuperscriptBox["a1", "4"], " ", 
                   SuperscriptBox["z0", "8"]}]}], ")"}]}], "+", 
               RowBox[{"60", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "413408"}], "-", 
                  RowBox[{"19536", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}], "+", 
                  RowBox[{"6614", " ", 
                   SuperscriptBox["a1", "4"], " ", 
                   SuperscriptBox["z0", "8"]}], "+", 
                  RowBox[{"75", " ", 
                   SuperscriptBox["a1", "6"], " ", 
                   SuperscriptBox["z0", "12"]}]}], ")"}]}]}], ")"}]}]}], 
           ")"}]}], "+", 
         RowBox[{"2", " ", "p0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"691200", " ", 
             SuperscriptBox["h0", "10"]}], "-", 
            RowBox[{"23040", " ", 
             SuperscriptBox["h0", "8"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "731"}], "+", 
               RowBox[{"180", " ", "t1", " ", "z0"}]}], ")"}]}], "+", 
            RowBox[{"2304", " ", 
             SuperscriptBox["h0", "6"], " ", 
             RowBox[{"(", 
              RowBox[{"60521", "-", 
               RowBox[{"34740", " ", "t1", " ", "z0"}], "+", 
               RowBox[{"4500", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"]}], "+", 
               RowBox[{"383", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "-", 
               RowBox[{"50", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}], "-", 
            RowBox[{"144", " ", 
             SuperscriptBox["h0", "4"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "3218720"}], "-", 
               RowBox[{"1020000", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"]}], "+", 
               RowBox[{"96000", " ", 
                SuperscriptBox["t1", "3"], " ", 
                SuperscriptBox["z0", "3"]}], "-", 
               RowBox[{"64496", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"13756", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "-", 
               RowBox[{"125", " ", 
                SuperscriptBox["a1", "6"], " ", 
                SuperscriptBox["z0", "12"]}], "-", 
               RowBox[{"40", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "80860"}], "-", 
                  RowBox[{"354", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}], "+", 
                  RowBox[{"75", " ", 
                   SuperscriptBox["a1", "4"], " ", 
                   SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}], "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["h0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"193580032", "-", 
               RowBox[{"41472000", " ", 
                SuperscriptBox["t1", "3"], " ", 
                SuperscriptBox["z0", "3"]}], "+", 
               RowBox[{"6178176", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"3456000", " ", 
                SuperscriptBox["t1", "4"], " ", 
                SuperscriptBox["z0", "4"]}], "-", 
               RowBox[{"4416240", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"677328", " ", 
                SuperscriptBox["a1", "6"], " ", 
                SuperscriptBox["z0", "12"]}], "+", 
               RowBox[{"13725", " ", 
                SuperscriptBox["a1", "8"], " ", 
                SuperscriptBox["z0", "16"]}], "+", 
               RowBox[{"72000", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"2352", "-", 
                  RowBox[{"32", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}], "+", 
                  RowBox[{"5", " ", 
                   SuperscriptBox["a1", "4"], " ", 
                   SuperscriptBox["z0", "8"]}]}], ")"}]}], "-", 
               RowBox[{"120", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{"2472064", "-", 
                  RowBox[{"23856", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}], "-", 
                  RowBox[{"6216", " ", 
                   SuperscriptBox["a1", "4"], " ", 
                   SuperscriptBox["z0", "8"]}], "+", 
                  RowBox[{"2235", " ", 
                   SuperscriptBox["a1", "6"], " ", 
                   SuperscriptBox["z0", "12"]}]}], ")"}]}]}], ")"}]}], "-", 
            RowBox[{"4", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "51673600"}], "+", 
               RowBox[{"196512", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"1036800", " ", 
                SuperscriptBox["t1", "5"], " ", 
                SuperscriptBox["z0", "5"]}], "+", 
               RowBox[{"19930272", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"1292418", " ", 
                SuperscriptBox["a1", "6"], " ", 
                SuperscriptBox["z0", "12"]}], "+", 
               RowBox[{"4095", " ", 
                SuperscriptBox["a1", "8"], " ", 
                SuperscriptBox["z0", "16"]}], "+", 
               RowBox[{"1296000", " ", 
                SuperscriptBox["t1", "4"], " ", 
                SuperscriptBox["z0", "4"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "8"}], "+", 
                  RowBox[{
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
               RowBox[{"288000", " ", 
                SuperscriptBox["t1", "3"], " ", 
                SuperscriptBox["z0", "3"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "148"}], "+", 
                  RowBox[{"39", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}], "+", 
                  RowBox[{"3", " ", 
                   SuperscriptBox["a1", "4"], " ", 
                   SuperscriptBox["z0", "8"]}]}], ")"}]}], "+", 
               RowBox[{"2250", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "40960"}], "+", 
                  RowBox[{"12720", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}], "+", 
                  RowBox[{"3672", " ", 
                   SuperscriptBox["a1", "4"], " ", 
                   SuperscriptBox["z0", "8"]}], "+", 
                  RowBox[{"27", " ", 
                   SuperscriptBox["a1", "6"], " ", 
                   SuperscriptBox["z0", "12"]}]}], ")"}]}], "-", 
               RowBox[{"90", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "1177600"}], "+", 
                  RowBox[{"253712", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}], "+", 
                  RowBox[{"258312", " ", 
                   SuperscriptBox["a1", "4"], " ", 
                   SuperscriptBox["z0", "8"]}], "+", 
                  RowBox[{"6993", " ", 
                   SuperscriptBox["a1", "6"], " ", 
                   SuperscriptBox["z0", "12"]}]}], ")"}]}]}], ")"}]}]}], 
           ")"}]}]}], ")"}]}]}], "//.", "replhoriz"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"horizh", "[", "z_", "]"}], ":=", 
    RowBox[{
     RowBox[{"h0", "+", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "z"}], "+", "z0"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "2"}], " ", "h0"}], "+", 
          RowBox[{"a1", " ", "p0", " ", 
           SuperscriptBox["z0", "2"]}]}], ")"}]}], 
       RowBox[{"t1", " ", 
        SuperscriptBox["z0", "2"]}]], "+", 
      FractionBox[
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "z"}], "+", "z0"}], ")"}], "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"8", " ", 
           SuperscriptBox["h0", "3"]}], "+", 
          RowBox[{"4", " ", "h0", " ", 
           RowBox[{"(", 
            RowBox[{"8", "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["p0", "2"]}], "-", 
             RowBox[{"4", " ", "t1", " ", "z0"}], "-", 
             RowBox[{
              SuperscriptBox["a1", "2"], " ", 
              SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
          RowBox[{"a1", " ", "p0", " ", 
           SuperscriptBox["z0", "2"], " ", 
           RowBox[{"(", 
            RowBox[{"28", "-", 
             RowBox[{"8", " ", "t1", " ", "z0"}], "+", 
             RowBox[{
              SuperscriptBox["a1", "2"], " ", 
              SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["t1", "2"], " ", 
        SuperscriptBox["z0", "4"]}]], "+", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"36", " ", 
         SuperscriptBox["t1", "3"], " ", 
         SuperscriptBox["z0", "6"]}]], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "z"}], "+", "z0"}], ")"}], "3"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "24"}], " ", 
          SuperscriptBox["h0", "5"]}], "-", 
         RowBox[{"24", " ", 
          SuperscriptBox["h0", "3"], " ", 
          RowBox[{"(", 
           RowBox[{"9", "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["p0", "2"]}], "-", 
            RowBox[{"3", " ", "t1", " ", "z0"}]}], ")"}]}], "-", 
         RowBox[{"3", " ", "a1", " ", 
          SuperscriptBox["h0", "2"], " ", "p0", " ", 
          SuperscriptBox["z0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "16"}], "+", 
            RowBox[{
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
         RowBox[{"h0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "296"}], "-", 
            RowBox[{"24", " ", 
             SuperscriptBox["p0", "4"]}], "-", 
            RowBox[{"72", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"]}], "+", 
            RowBox[{"78", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"6", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "+", 
            RowBox[{"72", " ", 
             SuperscriptBox["p0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "3"}], "+", 
               RowBox[{"t1", " ", "z0"}]}], ")"}]}], "-", 
            RowBox[{"36", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "8"}], "+", 
               RowBox[{
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}], "+", 
         RowBox[{"3", " ", "a1", " ", "p0", " ", 
          SuperscriptBox["z0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{"108", "+", 
            RowBox[{"12", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"]}], "+", 
            RowBox[{"11", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{
             SuperscriptBox["p0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"16", "-", 
               RowBox[{
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
            RowBox[{"3", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{"28", "+", 
               RowBox[{
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}]}], ")"}]}], 
      "+", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"2304", " ", 
         SuperscriptBox["t1", "4"], " ", 
         SuperscriptBox["z0", "8"]}]], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "z"}], "+", "z0"}], ")"}], "4"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"1152", " ", 
          SuperscriptBox["h0", "7"]}], "-", 
         RowBox[{"1728", " ", "a1", " ", 
          SuperscriptBox["h0", "4"], " ", "p0", " ", 
          SuperscriptBox["z0", "2"]}], "+", 
         RowBox[{"192", " ", 
          SuperscriptBox["h0", "5"], " ", 
          RowBox[{"(", 
           RowBox[{"85", "+", 
            RowBox[{"18", " ", 
             SuperscriptBox["p0", "2"]}], "-", 
            RowBox[{"24", " ", "t1", " ", "z0"}]}], ")"}]}], "+", 
         RowBox[{"24", " ", 
          SuperscriptBox["h0", "3"], " ", 
          RowBox[{"(", 
           RowBox[{"2352", "+", 
            RowBox[{"144", " ", 
             SuperscriptBox["p0", "4"]}], "-", 
            RowBox[{"1728", " ", "t1", " ", "z0"}], "+", 
            RowBox[{"288", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"]}], "-", 
            RowBox[{"32", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"5", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "-", 
            RowBox[{"16", " ", 
             SuperscriptBox["p0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "85"}], "+", 
               RowBox[{"24", " ", "t1", " ", "z0"}]}], ")"}]}]}], ")"}]}], 
         "+", 
         RowBox[{"6", " ", "a1", " ", 
          SuperscriptBox["h0", "2"], " ", "p0", " ", 
          SuperscriptBox["z0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "3664"}], "-", 
            RowBox[{"576", " ", 
             SuperscriptBox["p0", "2"]}], "+", 
            RowBox[{"96", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"21", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "-", 
            RowBox[{"96", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "16"}], "+", 
               RowBox[{
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}], "+", 
         RowBox[{"h0", " ", 
          RowBox[{"(", 
           RowBox[{"40960", "+", 
            RowBox[{"1152", " ", 
             SuperscriptBox["p0", "6"]}], "-", 
            RowBox[{"4608", " ", 
             SuperscriptBox["t1", "3"], " ", 
             SuperscriptBox["z0", "3"]}], "-", 
            RowBox[{"12720", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "-", 
            RowBox[{"3672", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "-", 
            RowBox[{"27", " ", 
             SuperscriptBox["a1", "6"], " ", 
             SuperscriptBox["z0", "12"]}], "-", 
            RowBox[{"192", " ", 
             SuperscriptBox["p0", "4"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "85"}], "+", 
               RowBox[{"24", " ", "t1", " ", "z0"}]}], ")"}]}], "-", 
            RowBox[{"3456", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "8"}], "+", 
               RowBox[{
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
            RowBox[{"384", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "148"}], "+", 
               RowBox[{"39", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"3", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}], "+", 
            RowBox[{"24", " ", 
             SuperscriptBox["p0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"2352", "-", 
               RowBox[{"1728", " ", "t1", " ", "z0"}], "+", 
               RowBox[{"288", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"]}], "-", 
               RowBox[{"32", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}], "+", 
         RowBox[{"2", " ", "a1", " ", "p0", " ", 
          SuperscriptBox["z0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "864"}], " ", 
             SuperscriptBox["p0", "4"]}], "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["p0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "3664"}], "+", 
               RowBox[{"96", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"21", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "-", 
               RowBox[{"96", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "16"}], "+", 
                  RowBox[{
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}], "+", 
            RowBox[{"2", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "11792"}], "+", 
               RowBox[{"576", " ", 
                SuperscriptBox["t1", "3"], " ", 
                SuperscriptBox["z0", "3"]}], "-", 
               RowBox[{"2760", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"15", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "-", 
               RowBox[{"216", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"28", "+", 
                  RowBox[{
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
               RowBox[{"144", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{"108", "+", 
                  RowBox[{"11", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}]}], 
           ")"}]}]}], ")"}]}], "-", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"57600", " ", 
         SuperscriptBox["t1", "5"], " ", 
         SuperscriptBox["z0", "10"]}]], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "z"}], "+", "z0"}], ")"}], "5"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"23040", " ", 
          SuperscriptBox["h0", "9"]}], "+", 
         RowBox[{"2304", " ", 
          SuperscriptBox["h0", "7"], " ", 
          RowBox[{"(", 
           RowBox[{"193", "+", 
            RowBox[{"40", " ", 
             SuperscriptBox["p0", "2"]}], "-", 
            RowBox[{"50", " ", "t1", " ", "z0"}]}], ")"}]}], "-", 
         RowBox[{"96", " ", "a1", " ", 
          SuperscriptBox["h0", "6"], " ", "p0", " ", 
          SuperscriptBox["z0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{"308", "+", 
            RowBox[{"5", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
         RowBox[{"32", " ", 
          SuperscriptBox["h0", "5"], " ", 
          RowBox[{"(", 
           RowBox[{"80860", "+", 
            RowBox[{"4320", " ", 
             SuperscriptBox["p0", "4"]}], "-", 
            RowBox[{"51000", " ", "t1", " ", "z0"}], "+", 
            RowBox[{"7200", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"]}], "+", 
            RowBox[{"354", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "-", 
            RowBox[{"75", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "-", 
            RowBox[{"216", " ", 
             SuperscriptBox["p0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "193"}], "+", 
               RowBox[{"50", " ", "t1", " ", "z0"}]}], ")"}]}]}], ")"}]}], 
         "+", 
         RowBox[{"12", " ", "a1", " ", 
          SuperscriptBox["h0", "4"], " ", "p0", " ", 
          SuperscriptBox["z0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "44576"}], "+", 
            RowBox[{"14400", " ", "t1", " ", "z0"}], "-", 
            RowBox[{"432", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"15", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "-", 
            RowBox[{"24", " ", 
             SuperscriptBox["p0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"308", "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}], "+", 
         RowBox[{"2", " ", 
          SuperscriptBox["h0", "3"], " ", 
          RowBox[{"(", 
           RowBox[{"2472064", "+", 
            RowBox[{"46080", " ", 
             SuperscriptBox["p0", "6"]}], "+", 
            RowBox[{"1036800", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"]}], "-", 
            RowBox[{"115200", " ", 
             SuperscriptBox["t1", "3"], " ", 
             SuperscriptBox["z0", "3"]}], "-", 
            RowBox[{"23856", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "-", 
            RowBox[{"6216", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "+", 
            RowBox[{"2235", " ", 
             SuperscriptBox["a1", "6"], " ", 
             SuperscriptBox["z0", "12"]}], "-", 
            RowBox[{"3456", " ", 
             SuperscriptBox["p0", "4"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "193"}], "+", 
               RowBox[{"50", " ", "t1", " ", "z0"}]}], ")"}]}], "+", 
            RowBox[{"32", " ", 
             SuperscriptBox["p0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"80860", "-", 
               RowBox[{"51000", " ", "t1", " ", "z0"}], "+", 
               RowBox[{"7200", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"]}], "+", 
               RowBox[{"354", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "-", 
               RowBox[{"75", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}], "-", 
            RowBox[{"1200", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{"2352", "-", 
               RowBox[{"32", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}], "+", 
         RowBox[{"6", " ", "a1", " ", 
          SuperscriptBox["h0", "2"], " ", "p0", " ", 
          SuperscriptBox["z0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "413408"}], "-", 
            RowBox[{"19536", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"6614", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "+", 
            RowBox[{"75", " ", 
             SuperscriptBox["a1", "6"], " ", 
             SuperscriptBox["z0", "12"]}], "+", 
            RowBox[{"4800", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "16"}], "+", 
               RowBox[{
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
            RowBox[{"48", " ", 
             SuperscriptBox["p0", "4"], " ", 
             RowBox[{"(", 
              RowBox[{"308", "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["p0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "44576"}], "+", 
               RowBox[{"14400", " ", "t1", " ", "z0"}], "-", 
               RowBox[{"432", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"15", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}], "-", 
            RowBox[{"100", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "3664"}], "+", 
               RowBox[{"96", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"21", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}], "+", 
         RowBox[{"2", " ", "h0", " ", 
          RowBox[{"(", 
           RowBox[{"1177600", "+", 
            RowBox[{"11520", " ", 
             SuperscriptBox["p0", "8"]}], "-", 
            RowBox[{"253712", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"57600", " ", 
             SuperscriptBox["t1", "4"], " ", 
             SuperscriptBox["z0", "4"]}], "-", 
            RowBox[{"258312", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "-", 
            RowBox[{"6993", " ", 
             SuperscriptBox["a1", "6"], " ", 
             SuperscriptBox["z0", "12"]}], "-", 
            RowBox[{"1152", " ", 
             SuperscriptBox["p0", "6"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "193"}], "+", 
               RowBox[{"50", " ", "t1", " ", "z0"}]}], ")"}]}], "+", 
            RowBox[{"57600", " ", 
             SuperscriptBox["t1", "3"], " ", 
             SuperscriptBox["z0", "3"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "8"}], "+", 
               RowBox[{
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
            RowBox[{"16", " ", 
             SuperscriptBox["p0", "4"], " ", 
             RowBox[{"(", 
              RowBox[{"80860", "-", 
               RowBox[{"51000", " ", "t1", " ", "z0"}], "+", 
               RowBox[{"7200", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"]}], "+", 
               RowBox[{"354", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "-", 
               RowBox[{"75", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}], "-", 
            RowBox[{"9600", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "148"}], "+", 
               RowBox[{"39", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"3", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}], "+", 
            RowBox[{"50", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "40960"}], "+", 
               RowBox[{"12720", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"3672", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"27", " ", 
                SuperscriptBox["a1", "6"], " ", 
                SuperscriptBox["z0", "12"]}]}], ")"}]}], "+", 
            RowBox[{
             SuperscriptBox["p0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"2472064", "+", 
               RowBox[{"1036800", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"]}], "-", 
               RowBox[{"115200", " ", 
                SuperscriptBox["t1", "3"], " ", 
                SuperscriptBox["z0", "3"]}], "-", 
               RowBox[{"23856", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "-", 
               RowBox[{"6216", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"2235", " ", 
                SuperscriptBox["a1", "6"], " ", 
                SuperscriptBox["z0", "12"]}], "-", 
               RowBox[{"1200", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{"2352", "-", 
                  RowBox[{"32", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}], "+", 
                  RowBox[{"5", " ", 
                   SuperscriptBox["a1", "4"], " ", 
                   SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}]}], 
           ")"}]}], "-", 
         RowBox[{"a1", " ", "p0", " ", 
          SuperscriptBox["z0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"96", " ", 
             SuperscriptBox["p0", "6"], " ", 
             RowBox[{"(", 
              RowBox[{"308", "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
            RowBox[{"12", " ", 
             SuperscriptBox["p0", "4"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "44576"}], "+", 
               RowBox[{"14400", " ", "t1", " ", "z0"}], "-", 
               RowBox[{"432", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"15", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}], "+", 
            RowBox[{"5", " ", 
             RowBox[{"(", 
              RowBox[{"511616", "+", 
               RowBox[{"240464", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"11520", " ", 
                SuperscriptBox["t1", "4"], " ", 
                SuperscriptBox["z0", "4"]}], "-", 
               RowBox[{"1296", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "-", 
               RowBox[{"159", " ", 
                SuperscriptBox["a1", "6"], " ", 
                SuperscriptBox["z0", "12"]}], "-", 
               RowBox[{"5760", " ", 
                SuperscriptBox["t1", "3"], " ", 
                SuperscriptBox["z0", "3"], " ", 
                RowBox[{"(", 
                 RowBox[{"28", "+", 
                  RowBox[{
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
               RowBox[{"5760", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"108", "+", 
                  RowBox[{"11", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
               RowBox[{"80", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "11792"}], "-", 
                  RowBox[{"2760", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}], "+", 
                  RowBox[{"15", " ", 
                   SuperscriptBox["a1", "4"], " ", 
                   SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}], "-", 
            RowBox[{"6", " ", 
             SuperscriptBox["p0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "413408"}], "-", 
               RowBox[{"19536", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"6614", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"75", " ", 
                SuperscriptBox["a1", "6"], " ", 
                SuperscriptBox["z0", "12"]}], "+", 
               RowBox[{"4800", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "16"}], "+", 
                  RowBox[{
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
               RowBox[{"100", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "3664"}], "+", 
                  RowBox[{"96", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}], "+", 
                  RowBox[{"21", " ", 
                   SuperscriptBox["a1", "4"], " ", 
                   SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}]}], 
           ")"}]}]}], ")"}]}], "+", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"4147200", " ", 
         SuperscriptBox["t1", "6"], " ", 
         SuperscriptBox["z0", "12"]}]], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "z"}], "+", "z0"}], ")"}], "6"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"1382400", " ", 
          SuperscriptBox["h0", "11"]}], "+", 
         RowBox[{"46080", " ", 
          SuperscriptBox["h0", "9"], " ", 
          RowBox[{"(", 
           RowBox[{"731", "+", 
            RowBox[{"150", " ", 
             SuperscriptBox["p0", "2"]}], "-", 
            RowBox[{"180", " ", "t1", " ", "z0"}]}], ")"}]}], "-", 
         RowBox[{"9216", " ", "a1", " ", 
          SuperscriptBox["h0", "8"], " ", "p0", " ", 
          SuperscriptBox["z0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{"178", "+", 
            RowBox[{"5", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
         RowBox[{"4608", " ", 
          SuperscriptBox["h0", "7"], " ", 
          RowBox[{"(", 
           RowBox[{"60521", "+", 
            RowBox[{"3000", " ", 
             SuperscriptBox["p0", "4"]}], "-", 
            RowBox[{"34740", " ", "t1", " ", "z0"}], "+", 
            RowBox[{"4500", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"]}], "+", 
            RowBox[{"383", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "-", 
            RowBox[{"50", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "-", 
            RowBox[{"40", " ", 
             SuperscriptBox["p0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "731"}], "+", 
               RowBox[{"180", " ", "t1", " ", "z0"}]}], ")"}]}]}], ")"}]}], 
         "+", 
         RowBox[{"1152", " ", "a1", " ", 
          SuperscriptBox["h0", "6"], " ", "p0", " ", 
          SuperscriptBox["z0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "32684"}], "-", 
            RowBox[{"882", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"45", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "-", 
            RowBox[{"32", " ", 
             SuperscriptBox["p0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"178", "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
            RowBox[{"30", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{"308", "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}], "+", 
         RowBox[{"288", " ", 
          SuperscriptBox["h0", "5"], " ", 
          RowBox[{"(", 
           RowBox[{"3218720", "+", 
            RowBox[{"48000", " ", 
             SuperscriptBox["p0", "6"]}], "+", 
            RowBox[{"1020000", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"]}], "-", 
            RowBox[{"96000", " ", 
             SuperscriptBox["t1", "3"], " ", 
             SuperscriptBox["z0", "3"]}], "+", 
            RowBox[{"64496", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "-", 
            RowBox[{"13756", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "+", 
            RowBox[{"125", " ", 
             SuperscriptBox["a1", "6"], " ", 
             SuperscriptBox["z0", "12"]}], "-", 
            RowBox[{"960", " ", 
             SuperscriptBox["p0", "4"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "731"}], "+", 
               RowBox[{"180", " ", "t1", " ", "z0"}]}], ")"}]}], "+", 
            RowBox[{"48", " ", 
             SuperscriptBox["p0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"60521", "-", 
               RowBox[{"34740", " ", "t1", " ", "z0"}], "+", 
               RowBox[{"4500", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"]}], "+", 
               RowBox[{"383", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "-", 
               RowBox[{"50", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}], "+", 
            RowBox[{"40", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "80860"}], "-", 
               RowBox[{"354", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"75", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}], "-", 
         RowBox[{"36", " ", "a1", " ", 
          SuperscriptBox["h0", "4"], " ", "p0", " ", 
          SuperscriptBox["z0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{"7514816", "+", 
            RowBox[{"864000", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"]}], "+", 
            RowBox[{"378208", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "-", 
            RowBox[{"36984", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "+", 
            RowBox[{"1785", " ", 
             SuperscriptBox["a1", "6"], " ", 
             SuperscriptBox["z0", "12"]}], "+", 
            RowBox[{"1536", " ", 
             SuperscriptBox["p0", "4"], " ", 
             RowBox[{"(", 
              RowBox[{"178", "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
            RowBox[{"120", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "44576"}], "-", 
               RowBox[{"432", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"15", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}], "-", 
            RowBox[{"96", " ", 
             SuperscriptBox["p0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "32684"}], "-", 
               RowBox[{"882", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"45", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"30", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{"308", "+", 
                  RowBox[{"5", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}]}], 
           ")"}]}], "+", 
         RowBox[{"36", " ", "a1", " ", 
          SuperscriptBox["h0", "2"], " ", "p0", " ", 
          SuperscriptBox["z0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "18272128"}], "-", 
            RowBox[{"3170720", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"579960", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "+", 
            RowBox[{"16350", " ", 
             SuperscriptBox["a1", "6"], " ", 
             SuperscriptBox["z0", "12"]}], "+", 
            RowBox[{"45", " ", 
             SuperscriptBox["a1", "8"], " ", 
             SuperscriptBox["z0", "16"]}], "-", 
            RowBox[{"96000", " ", 
             SuperscriptBox["t1", "3"], " ", 
             SuperscriptBox["z0", "3"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "16"}], "+", 
               RowBox[{
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
            RowBox[{"1024", " ", 
             SuperscriptBox["p0", "6"], " ", 
             RowBox[{"(", 
              RowBox[{"178", "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
            RowBox[{"3000", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "3664"}], "+", 
               RowBox[{"96", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"21", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}], "-", 
            RowBox[{"60", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "413408"}], "-", 
               RowBox[{"19536", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"6614", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"75", " ", 
                SuperscriptBox["a1", "6"], " ", 
                SuperscriptBox["z0", "12"]}]}], ")"}]}], "+", 
            RowBox[{"96", " ", 
             SuperscriptBox["p0", "4"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "32684"}], "-", 
               RowBox[{"882", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"45", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"30", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{"308", "+", 
                  RowBox[{"5", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["p0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"7514816", "+", 
               RowBox[{"864000", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"]}], "+", 
               RowBox[{"378208", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "-", 
               RowBox[{"36984", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"1785", " ", 
                SuperscriptBox["a1", "6"], " ", 
                SuperscriptBox["z0", "12"]}], "+", 
               RowBox[{"120", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "44576"}], "-", 
                  RowBox[{"432", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}], "+", 
                  RowBox[{"15", " ", 
                   SuperscriptBox["a1", "4"], " ", 
                   SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}]}], 
           ")"}]}], "+", 
         RowBox[{"6", " ", 
          SuperscriptBox["h0", "3"], " ", 
          RowBox[{"(", 
           RowBox[{"193580032", "+", 
            RowBox[{"1152000", " ", 
             SuperscriptBox["p0", "8"]}], "-", 
            RowBox[{"41472000", " ", 
             SuperscriptBox["t1", "3"], " ", 
             SuperscriptBox["z0", "3"]}], "+", 
            RowBox[{"6178176", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"3456000", " ", 
             SuperscriptBox["t1", "4"], " ", 
             SuperscriptBox["z0", "4"]}], "-", 
            RowBox[{"4416240", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "+", 
            RowBox[{"677328", " ", 
             SuperscriptBox["a1", "6"], " ", 
             SuperscriptBox["z0", "12"]}], "+", 
            RowBox[{"13725", " ", 
             SuperscriptBox["a1", "8"], " ", 
             SuperscriptBox["z0", "16"]}], "-", 
            RowBox[{"30720", " ", 
             SuperscriptBox["p0", "6"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "731"}], "+", 
               RowBox[{"180", " ", "t1", " ", "z0"}]}], ")"}]}], "+", 
            RowBox[{"2304", " ", 
             SuperscriptBox["p0", "4"], " ", 
             RowBox[{"(", 
              RowBox[{"60521", "-", 
               RowBox[{"34740", " ", "t1", " ", "z0"}], "+", 
               RowBox[{"4500", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"]}], "+", 
               RowBox[{"383", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "-", 
               RowBox[{"50", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}], "+", 
            RowBox[{"72000", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"2352", "-", 
               RowBox[{"32", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}], "-", 
            RowBox[{"120", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{"2472064", "-", 
               RowBox[{"23856", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "-", 
               RowBox[{"6216", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"2235", " ", 
                SuperscriptBox["a1", "6"], " ", 
                SuperscriptBox["z0", "12"]}]}], ")"}]}], "-", 
            RowBox[{"96", " ", 
             SuperscriptBox["p0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "3218720"}], "-", 
               RowBox[{"1020000", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"]}], "+", 
               RowBox[{"96000", " ", 
                SuperscriptBox["t1", "3"], " ", 
                SuperscriptBox["z0", "3"]}], "-", 
               RowBox[{"64496", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"13756", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "-", 
               RowBox[{"125", " ", 
                SuperscriptBox["a1", "6"], " ", 
                SuperscriptBox["z0", "12"]}], "-", 
               RowBox[{"40", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "80860"}], "-", 
                  RowBox[{"354", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}], "+", 
                  RowBox[{"75", " ", 
                   SuperscriptBox["a1", "4"], " ", 
                   SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}]}], 
           ")"}]}], "+", 
         RowBox[{"3", " ", "a1", " ", "p0", " ", 
          SuperscriptBox["z0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "133539840"}], "-", 
            RowBox[{"110648384", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"1382400", " ", 
             SuperscriptBox["t1", "5"], " ", 
             SuperscriptBox["z0", "5"]}], "-", 
            RowBox[{"1007184", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "+", 
            RowBox[{"319524", " ", 
             SuperscriptBox["a1", "6"], " ", 
             SuperscriptBox["z0", "12"]}], "+", 
            RowBox[{"1125", " ", 
             SuperscriptBox["a1", "8"], " ", 
             SuperscriptBox["z0", "16"]}], "-", 
            RowBox[{"864000", " ", 
             SuperscriptBox["t1", "4"], " ", 
             SuperscriptBox["z0", "4"], " ", 
             RowBox[{"(", 
              RowBox[{"28", "+", 
               RowBox[{
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
            RowBox[{"3072", " ", 
             SuperscriptBox["p0", "8"], " ", 
             RowBox[{"(", 
              RowBox[{"178", "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
            RowBox[{"1152000", " ", 
             SuperscriptBox["t1", "3"], " ", 
             SuperscriptBox["z0", "3"], " ", 
             RowBox[{"(", 
              RowBox[{"108", "+", 
               RowBox[{"11", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
            RowBox[{"24000", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "11792"}], "-", 
               RowBox[{"2760", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"15", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}], "-", 
            RowBox[{"600", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "511616"}], "-", 
               RowBox[{"240464", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"1296", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"159", " ", 
                SuperscriptBox["a1", "6"], " ", 
                SuperscriptBox["z0", "12"]}]}], ")"}]}], "+", 
            RowBox[{"384", " ", 
             SuperscriptBox["p0", "6"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "32684"}], "-", 
               RowBox[{"882", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"45", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"30", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{"308", "+", 
                  RowBox[{"5", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}], "-", 
            RowBox[{"12", " ", 
             SuperscriptBox["p0", "4"], " ", 
             RowBox[{"(", 
              RowBox[{"7514816", "+", 
               RowBox[{"864000", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"]}], "+", 
               RowBox[{"378208", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "-", 
               RowBox[{"36984", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"1785", " ", 
                SuperscriptBox["a1", "6"], " ", 
                SuperscriptBox["z0", "12"]}], "+", 
               RowBox[{"120", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "44576"}], "-", 
                  RowBox[{"432", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}], "+", 
                  RowBox[{"15", " ", 
                   SuperscriptBox["a1", "4"], " ", 
                   SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}], "-", 
            RowBox[{"12", " ", 
             SuperscriptBox["p0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"18272128", "+", 
               RowBox[{"3170720", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "-", 
               RowBox[{"579960", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "-", 
               RowBox[{"16350", " ", 
                SuperscriptBox["a1", "6"], " ", 
                SuperscriptBox["z0", "12"]}], "-", 
               RowBox[{"45", " ", 
                SuperscriptBox["a1", "8"], " ", 
                SuperscriptBox["z0", "16"]}], "+", 
               RowBox[{"96000", " ", 
                SuperscriptBox["t1", "3"], " ", 
                SuperscriptBox["z0", "3"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "16"}], "+", 
                  RowBox[{
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
               RowBox[{"3000", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "3664"}], "+", 
                  RowBox[{"96", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}], "+", 
                  RowBox[{"21", " ", 
                   SuperscriptBox["a1", "4"], " ", 
                   SuperscriptBox["z0", "8"]}]}], ")"}]}], "+", 
               RowBox[{"60", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "413408"}], "-", 
                  RowBox[{"19536", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}], "+", 
                  RowBox[{"6614", " ", 
                   SuperscriptBox["a1", "4"], " ", 
                   SuperscriptBox["z0", "8"]}], "+", 
                  RowBox[{"75", " ", 
                   SuperscriptBox["a1", "6"], " ", 
                   SuperscriptBox["z0", "12"]}]}], ")"}]}]}], ")"}]}]}], 
           ")"}]}], "+", 
         RowBox[{"2", " ", "h0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"691200", " ", 
             SuperscriptBox["p0", "10"]}], "-", 
            RowBox[{"23040", " ", 
             SuperscriptBox["p0", "8"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "731"}], "+", 
               RowBox[{"180", " ", "t1", " ", "z0"}]}], ")"}]}], "+", 
            RowBox[{"2304", " ", 
             SuperscriptBox["p0", "6"], " ", 
             RowBox[{"(", 
              RowBox[{"60521", "-", 
               RowBox[{"34740", " ", "t1", " ", "z0"}], "+", 
               RowBox[{"4500", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"]}], "+", 
               RowBox[{"383", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "-", 
               RowBox[{"50", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}], "-", 
            RowBox[{"144", " ", 
             SuperscriptBox["p0", "4"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "3218720"}], "-", 
               RowBox[{"1020000", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"]}], "+", 
               RowBox[{"96000", " ", 
                SuperscriptBox["t1", "3"], " ", 
                SuperscriptBox["z0", "3"]}], "-", 
               RowBox[{"64496", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"13756", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "-", 
               RowBox[{"125", " ", 
                SuperscriptBox["a1", "6"], " ", 
                SuperscriptBox["z0", "12"]}], "-", 
               RowBox[{"40", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "80860"}], "-", 
                  RowBox[{"354", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}], "+", 
                  RowBox[{"75", " ", 
                   SuperscriptBox["a1", "4"], " ", 
                   SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}], "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["p0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"193580032", "-", 
               RowBox[{"41472000", " ", 
                SuperscriptBox["t1", "3"], " ", 
                SuperscriptBox["z0", "3"]}], "+", 
               RowBox[{"6178176", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"3456000", " ", 
                SuperscriptBox["t1", "4"], " ", 
                SuperscriptBox["z0", "4"]}], "-", 
               RowBox[{"4416240", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"677328", " ", 
                SuperscriptBox["a1", "6"], " ", 
                SuperscriptBox["z0", "12"]}], "+", 
               RowBox[{"13725", " ", 
                SuperscriptBox["a1", "8"], " ", 
                SuperscriptBox["z0", "16"]}], "+", 
               RowBox[{"72000", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"2352", "-", 
                  RowBox[{"32", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}], "+", 
                  RowBox[{"5", " ", 
                   SuperscriptBox["a1", "4"], " ", 
                   SuperscriptBox["z0", "8"]}]}], ")"}]}], "-", 
               RowBox[{"120", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{"2472064", "-", 
                  RowBox[{"23856", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}], "-", 
                  RowBox[{"6216", " ", 
                   SuperscriptBox["a1", "4"], " ", 
                   SuperscriptBox["z0", "8"]}], "+", 
                  RowBox[{"2235", " ", 
                   SuperscriptBox["a1", "6"], " ", 
                   SuperscriptBox["z0", "12"]}]}], ")"}]}]}], ")"}]}], "-", 
            RowBox[{"4", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "51673600"}], "+", 
               RowBox[{"196512", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"1036800", " ", 
                SuperscriptBox["t1", "5"], " ", 
                SuperscriptBox["z0", "5"]}], "+", 
               RowBox[{"19930272", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"1292418", " ", 
                SuperscriptBox["a1", "6"], " ", 
                SuperscriptBox["z0", "12"]}], "+", 
               RowBox[{"4095", " ", 
                SuperscriptBox["a1", "8"], " ", 
                SuperscriptBox["z0", "16"]}], "+", 
               RowBox[{"1296000", " ", 
                SuperscriptBox["t1", "4"], " ", 
                SuperscriptBox["z0", "4"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "8"}], "+", 
                  RowBox[{
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
               RowBox[{"288000", " ", 
                SuperscriptBox["t1", "3"], " ", 
                SuperscriptBox["z0", "3"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "148"}], "+", 
                  RowBox[{"39", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}], "+", 
                  RowBox[{"3", " ", 
                   SuperscriptBox["a1", "4"], " ", 
                   SuperscriptBox["z0", "8"]}]}], ")"}]}], "+", 
               RowBox[{"2250", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "40960"}], "+", 
                  RowBox[{"12720", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}], "+", 
                  RowBox[{"3672", " ", 
                   SuperscriptBox["a1", "4"], " ", 
                   SuperscriptBox["z0", "8"]}], "+", 
                  RowBox[{"27", " ", 
                   SuperscriptBox["a1", "6"], " ", 
                   SuperscriptBox["z0", "12"]}]}], ")"}]}], "-", 
               RowBox[{"90", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "1177600"}], "+", 
                  RowBox[{"253712", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}], "+", 
                  RowBox[{"258312", " ", 
                   SuperscriptBox["a1", "4"], " ", 
                   SuperscriptBox["z0", "8"]}], "+", 
                  RowBox[{"6993", " ", 
                   SuperscriptBox["a1", "6"], " ", 
                   SuperscriptBox["z0", "12"]}]}], ")"}]}]}], ")"}]}]}], 
           ")"}]}]}], ")"}]}]}], "//.", "replhoriz"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"horiza", "[", "z_", "]"}], ":=", 
    RowBox[{
     RowBox[{
      RowBox[{"a1", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "z"}], "+", "z0"}], ")"}]}], "+", 
      FractionBox[
       RowBox[{"a1", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "z"}], "+", "z0"}], ")"}], "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "12"}], "+", 
          RowBox[{"4", " ", "t1", " ", "z0"}], "+", 
          RowBox[{
           SuperscriptBox["a1", "2"], " ", 
           SuperscriptBox["z0", "4"]}]}], ")"}]}], 
       RowBox[{"4", " ", "t1", " ", 
        SuperscriptBox["z0", "2"]}]], "+", 
      FractionBox[
       RowBox[{"a1", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "z"}], "+", "z0"}], ")"}], "3"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"16", " ", 
           SuperscriptBox["h0", "4"]}], "+", 
          RowBox[{"16", " ", 
           SuperscriptBox["p0", "4"]}], "+", 
          RowBox[{"4", " ", 
           SuperscriptBox["h0", "2"], " ", 
           RowBox[{"(", 
            RowBox[{"28", "+", 
             RowBox[{"8", " ", 
              SuperscriptBox["p0", "2"]}], "-", 
             RowBox[{"3", " ", 
              SuperscriptBox["a1", "2"], " ", 
              SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
          RowBox[{"3", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "12"}], "+", 
              RowBox[{"4", " ", "t1", " ", "z0"}], "+", 
              RowBox[{
               SuperscriptBox["a1", "2"], " ", 
               SuperscriptBox["z0", "4"]}]}], ")"}], "2"]}], "-", 
          RowBox[{"4", " ", 
           SuperscriptBox["p0", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "28"}], "+", 
             RowBox[{"3", " ", 
              SuperscriptBox["a1", "2"], " ", 
              SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}], 
       RowBox[{"48", " ", 
        SuperscriptBox["t1", "2"], " ", 
        SuperscriptBox["z0", "4"]}]], "+", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"192", " ", 
         SuperscriptBox["t1", "3"], " ", 
         SuperscriptBox["z0", "6"]}]], "a1", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "z"}], "+", "z0"}], ")"}], "4"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "64"}], " ", 
          SuperscriptBox["h0", "6"]}], "-", 
         RowBox[{"64", " ", 
          SuperscriptBox["p0", "6"]}], "-", 
         RowBox[{"16", " ", 
          SuperscriptBox["h0", "4"], " ", 
          RowBox[{"(", 
           RowBox[{"52", "+", 
            RowBox[{"12", " ", 
             SuperscriptBox["p0", "2"]}], "-", 
            RowBox[{"12", " ", "t1", " ", "z0"}], "-", 
            RowBox[{"3", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
         RowBox[{"3", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "12"}], "+", 
             RowBox[{"4", " ", "t1", " ", "z0"}], "+", 
             RowBox[{
              SuperscriptBox["a1", "2"], " ", 
              SuperscriptBox["z0", "4"]}]}], ")"}], "3"]}], "+", 
         RowBox[{"16", " ", 
          SuperscriptBox["p0", "4"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "52"}], "+", 
            RowBox[{"12", " ", "t1", " ", "z0"}], "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
         RowBox[{"2", " ", 
          SuperscriptBox["p0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{"1712", "-", 
            RowBox[{"272", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"9", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "+", 
            RowBox[{"24", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "28"}], "+", 
               RowBox[{"3", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}], "-", 
         RowBox[{"2", " ", 
          SuperscriptBox["h0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{"1712", "+", 
            RowBox[{"96", " ", 
             SuperscriptBox["p0", "4"]}], "-", 
            RowBox[{"672", " ", "t1", " ", "z0"}], "-", 
            RowBox[{"272", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"72", " ", 
             SuperscriptBox["a1", "2"], " ", "t1", " ", 
             SuperscriptBox["z0", "5"]}], "+", 
            RowBox[{"9", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "-", 
            RowBox[{"16", " ", 
             SuperscriptBox["p0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "52"}], "+", 
               RowBox[{"12", " ", "t1", " ", "z0"}], "+", 
               RowBox[{"3", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}]}], ")"}]}], 
      "+", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"3840", " ", 
         SuperscriptBox["t1", "4"], " ", 
         SuperscriptBox["z0", "8"]}]], "a1", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "z"}], "+", "z0"}], ")"}], "5"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"1280", " ", 
          SuperscriptBox["h0", "8"]}], "+", 
         RowBox[{"1280", " ", 
          SuperscriptBox["p0", "8"]}], "+", 
         RowBox[{"32", " ", 
          SuperscriptBox["h0", "6"], " ", 
          RowBox[{"(", 
           RowBox[{"704", "+", 
            RowBox[{"160", " ", 
             SuperscriptBox["p0", "2"]}], "-", 
            RowBox[{"160", " ", "t1", " ", "z0"}], "-", 
            RowBox[{"35", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
         RowBox[{"15", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "12"}], "+", 
             RowBox[{"4", " ", "t1", " ", "z0"}], "+", 
             RowBox[{
              SuperscriptBox["a1", "2"], " ", 
              SuperscriptBox["z0", "4"]}]}], ")"}], "4"]}], "-", 
         RowBox[{"32", " ", 
          SuperscriptBox["p0", "6"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "704"}], "+", 
            RowBox[{"160", " ", "t1", " ", "z0"}], "+", 
            RowBox[{"35", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
         RowBox[{"4", " ", 
          SuperscriptBox["p0", "4"], " ", 
          RowBox[{"(", 
           RowBox[{"34544", "+", 
            RowBox[{"1920", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"]}], "-", 
            RowBox[{"3936", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"129", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "+", 
            RowBox[{"320", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "52"}], "+", 
               RowBox[{"3", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}], "+", 
         RowBox[{"4", " ", 
          SuperscriptBox["h0", "4"], " ", 
          RowBox[{"(", 
           RowBox[{"34544", "+", 
            RowBox[{"1920", " ", 
             SuperscriptBox["p0", "4"]}], "+", 
            RowBox[{"1920", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"]}], "-", 
            RowBox[{"3936", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"129", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "+", 
            RowBox[{"320", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "52"}], "+", 
               RowBox[{"3", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
            RowBox[{"24", " ", 
             SuperscriptBox["p0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "704"}], "+", 
               RowBox[{"160", " ", "t1", " ", "z0"}], "+", 
               RowBox[{"35", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}], "-", 
         RowBox[{"2", " ", 
          SuperscriptBox["p0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "176768"}], "+", 
            RowBox[{"37808", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "-", 
            RowBox[{"2544", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "+", 
            RowBox[{"63", " ", 
             SuperscriptBox["a1", "6"], " ", 
             SuperscriptBox["z0", "12"]}], "+", 
            RowBox[{"960", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "28"}], "+", 
               RowBox[{"3", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
            RowBox[{"80", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{"1712", "-", 
               RowBox[{"272", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"9", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}], "+", 
         RowBox[{"2", " ", 
          SuperscriptBox["h0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{"176768", "+", 
            RowBox[{"2560", " ", 
             SuperscriptBox["p0", "6"]}], "-", 
            RowBox[{"37808", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"2544", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "-", 
            RowBox[{"63", " ", 
             SuperscriptBox["a1", "6"], " ", 
             SuperscriptBox["z0", "12"]}], "-", 
            RowBox[{"960", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "28"}], "+", 
               RowBox[{"3", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
            RowBox[{"48", " ", 
             SuperscriptBox["p0", "4"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "704"}], "+", 
               RowBox[{"160", " ", "t1", " ", "z0"}], "+", 
               RowBox[{"35", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
            RowBox[{"80", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{"1712", "-", 
               RowBox[{"272", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"9", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["p0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"34544", "+", 
               RowBox[{"1920", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"]}], "-", 
               RowBox[{"3936", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"129", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"320", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "52"}], "+", 
                  RowBox[{"3", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}]}], 
           ")"}]}]}], ")"}]}], "+", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"691200", " ", 
         SuperscriptBox["t1", "5"], " ", 
         SuperscriptBox["z0", "10"]}]], "a1", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "z"}], "+", "z0"}], ")"}], "6"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "230400"}], " ", 
          SuperscriptBox["h0", "10"]}], "-", 
         RowBox[{"230400", " ", 
          SuperscriptBox["p0", "10"]}], "-", 
         RowBox[{"1536", " ", 
          SuperscriptBox["h0", "8"], " ", 
          RowBox[{"(", 
           RowBox[{"3308", "+", 
            RowBox[{"750", " ", 
             SuperscriptBox["p0", "2"]}], "-", 
            RowBox[{"750", " ", "t1", " ", "z0"}], "-", 
            RowBox[{"145", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
         RowBox[{"675", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "12"}], "+", 
             RowBox[{"4", " ", "t1", " ", "z0"}], "+", 
             RowBox[{
              SuperscriptBox["a1", "2"], " ", 
              SuperscriptBox["z0", "4"]}]}], ")"}], "5"]}], "+", 
         RowBox[{"1536", " ", 
          SuperscriptBox["p0", "8"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "3308"}], "+", 
            RowBox[{"750", " ", "t1", " ", "z0"}], "+", 
            RowBox[{"145", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
         RowBox[{"96", " ", 
          SuperscriptBox["p0", "6"], " ", 
          RowBox[{"(", 
           RowBox[{"436032", "+", 
            RowBox[{"24000", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"]}], "-", 
            RowBox[{"42436", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"1185", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "+", 
            RowBox[{"300", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "704"}], "+", 
               RowBox[{"35", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}], "-", 
         RowBox[{"96", " ", 
          SuperscriptBox["h0", "6"], " ", 
          RowBox[{"(", 
           RowBox[{"436032", "+", 
            RowBox[{"24000", " ", 
             SuperscriptBox["p0", "4"]}], "+", 
            RowBox[{"24000", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"]}], "-", 
            RowBox[{"42436", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"1185", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "+", 
            RowBox[{"300", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "704"}], "+", 
               RowBox[{"35", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
            RowBox[{"64", " ", 
             SuperscriptBox["p0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "3308"}], "+", 
               RowBox[{"750", " ", "t1", " ", "z0"}], "+", 
               RowBox[{"145", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}], "+", 
         RowBox[{"4", " ", 
          SuperscriptBox["p0", "4"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "39896512"}], "+", 
            RowBox[{"576000", " ", 
             SuperscriptBox["t1", "3"], " ", 
             SuperscriptBox["z0", "3"]}], "+", 
            RowBox[{"6689136", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "-", 
            RowBox[{"428964", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "+", 
            RowBox[{"9225", " ", 
             SuperscriptBox["a1", "6"], " ", 
             SuperscriptBox["z0", "12"]}], "+", 
            RowBox[{"144000", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "52"}], "+", 
               RowBox[{"3", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
            RowBox[{"900", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{"34544", "-", 
               RowBox[{"3936", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"129", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}], "-", 
         RowBox[{"10", " ", 
          SuperscriptBox["p0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{"27742208", "-", 
            RowBox[{"7540032", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"773616", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "-", 
            RowBox[{"38412", " ", 
             SuperscriptBox["a1", "6"], " ", 
             SuperscriptBox["z0", "12"]}], "+", 
            RowBox[{"729", " ", 
             SuperscriptBox["a1", "8"], " ", 
             SuperscriptBox["z0", "16"]}], "+", 
            RowBox[{"57600", " ", 
             SuperscriptBox["t1", "3"], " ", 
             SuperscriptBox["z0", "3"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "28"}], "+", 
               RowBox[{"3", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
            RowBox[{"7200", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"1712", "-", 
               RowBox[{"272", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"9", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}], "+", 
            RowBox[{"180", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "176768"}], "+", 
               RowBox[{"37808", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "-", 
               RowBox[{"2544", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"63", " ", 
                SuperscriptBox["a1", "6"], " ", 
                SuperscriptBox["z0", "12"]}]}], ")"}]}]}], ")"}]}], "-", 
         RowBox[{"4", " ", 
          SuperscriptBox["h0", "4"], " ", 
          RowBox[{"(", 
           RowBox[{"39896512", "+", 
            RowBox[{"576000", " ", 
             SuperscriptBox["p0", "6"]}], "-", 
            RowBox[{"576000", " ", 
             SuperscriptBox["t1", "3"], " ", 
             SuperscriptBox["z0", "3"]}], "-", 
            RowBox[{"6689136", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"428964", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "-", 
            RowBox[{"9225", " ", 
             SuperscriptBox["a1", "6"], " ", 
             SuperscriptBox["z0", "12"]}], "-", 
            RowBox[{"144000", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "52"}], "+", 
               RowBox[{"3", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
            RowBox[{"2304", " ", 
             SuperscriptBox["p0", "4"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "3308"}], "+", 
               RowBox[{"750", " ", "t1", " ", "z0"}], "+", 
               RowBox[{"145", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
            RowBox[{"900", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{"34544", "-", 
               RowBox[{"3936", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"129", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}], "+", 
            RowBox[{"72", " ", 
             SuperscriptBox["p0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"436032", "+", 
               RowBox[{"24000", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"]}], "-", 
               RowBox[{"42436", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"1185", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"300", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "704"}], "+", 
                  RowBox[{"35", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}]}], 
           ")"}]}], "-", 
         RowBox[{"2", " ", 
          SuperscriptBox["h0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"576000", " ", 
             SuperscriptBox["p0", "8"]}], "-", 
            RowBox[{"3072", " ", 
             SuperscriptBox["p0", "6"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "3308"}], "+", 
               RowBox[{"750", " ", "t1", " ", "z0"}], "+", 
               RowBox[{"145", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
            RowBox[{"144", " ", 
             SuperscriptBox["p0", "4"], " ", 
             RowBox[{"(", 
              RowBox[{"436032", "+", 
               RowBox[{"24000", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"]}], "-", 
               RowBox[{"42436", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"1185", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"300", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "704"}], "+", 
                  RowBox[{"35", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["p0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "39896512"}], "+", 
               RowBox[{"576000", " ", 
                SuperscriptBox["t1", "3"], " ", 
                SuperscriptBox["z0", "3"]}], "+", 
               RowBox[{"6689136", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "-", 
               RowBox[{"428964", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"9225", " ", 
                SuperscriptBox["a1", "6"], " ", 
                SuperscriptBox["z0", "12"]}], "+", 
               RowBox[{"144000", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "52"}], "+", 
                  RowBox[{"3", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
               RowBox[{"900", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{"34544", "-", 
                  RowBox[{"3936", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}], "+", 
                  RowBox[{"129", " ", 
                   SuperscriptBox["a1", "4"], " ", 
                   SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}], "+", 
            RowBox[{"5", " ", 
             RowBox[{"(", 
              RowBox[{"27742208", "-", 
               RowBox[{"7540032", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"773616", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "-", 
               RowBox[{"38412", " ", 
                SuperscriptBox["a1", "6"], " ", 
                SuperscriptBox["z0", "12"]}], "+", 
               RowBox[{"729", " ", 
                SuperscriptBox["a1", "8"], " ", 
                SuperscriptBox["z0", "16"]}], "+", 
               RowBox[{"57600", " ", 
                SuperscriptBox["t1", "3"], " ", 
                SuperscriptBox["z0", "3"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "28"}], "+", 
                  RowBox[{"3", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
               RowBox[{"7200", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1712", "-", 
                  RowBox[{"272", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}], "+", 
                  RowBox[{"9", " ", 
                   SuperscriptBox["a1", "4"], " ", 
                   SuperscriptBox["z0", "8"]}]}], ")"}]}], "+", 
               RowBox[{"180", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "176768"}], "+", 
                  RowBox[{"37808", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}], "-", 
                  RowBox[{"2544", " ", 
                   SuperscriptBox["a1", "4"], " ", 
                   SuperscriptBox["z0", "8"]}], "+", 
                  RowBox[{"63", " ", 
                   SuperscriptBox["a1", "6"], " ", 
                   SuperscriptBox["z0", "12"]}]}], ")"}]}]}], ")"}]}]}], 
           ")"}]}]}], ")"}]}]}], "//.", "replhoriz"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"horizT", "[", "z_", "]"}], ":=", 
    RowBox[{
     RowBox[{
      RowBox[{"t1", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "z"}], "+", "z0"}], ")"}]}], "+", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "z"}], "+", "z0"}], ")"}], "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox["t1", "z0"]}], "+", 
         FractionBox[
          RowBox[{
           SuperscriptBox["a1", "2"], " ", 
           SuperscriptBox["z0", "2"]}], "2"]}], ")"}]}], "+", 
      FractionBox[
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "z"}], "+", "z0"}], ")"}], "3"], " ", 
        RowBox[{"(", 
         RowBox[{"144", "+", 
          RowBox[{"16", " ", 
           SuperscriptBox["h0", "4"]}], "+", 
          RowBox[{"64", " ", 
           SuperscriptBox["p0", "2"]}], "+", 
          RowBox[{"16", " ", 
           SuperscriptBox["p0", "4"]}], "+", 
          RowBox[{"32", " ", 
           SuperscriptBox["h0", "2"], " ", 
           RowBox[{"(", 
            RowBox[{"2", "+", 
             SuperscriptBox["p0", "2"]}], ")"}]}], "-", 
          RowBox[{"120", " ", 
           SuperscriptBox["a1", "2"], " ", 
           SuperscriptBox["z0", "4"]}], "+", 
          RowBox[{"9", " ", 
           SuperscriptBox["a1", "4"], " ", 
           SuperscriptBox["z0", "8"]}]}], ")"}]}], 
       RowBox[{"48", " ", "t1", " ", 
        SuperscriptBox["z0", "4"]}]], "+", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"48", " ", 
         SuperscriptBox["t1", "2"], " ", 
         SuperscriptBox["z0", "6"]}]], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "z"}], "+", "z0"}], ")"}], "4"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "16"}], " ", 
          SuperscriptBox["h0", "6"]}], "-", 
         RowBox[{"16", " ", 
          SuperscriptBox["p0", "6"]}], "-", 
         RowBox[{"16", " ", 
          SuperscriptBox["h0", "4"], " ", 
          RowBox[{"(", 
           RowBox[{"9", "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["p0", "2"]}], "-", 
            RowBox[{"t1", " ", "z0"}], "-", 
            RowBox[{
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
         RowBox[{"16", " ", 
          SuperscriptBox["p0", "4"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "9"}], "+", 
            RowBox[{"t1", " ", "z0"}], "+", 
            RowBox[{
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
         RowBox[{
          SuperscriptBox["p0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "400"}], "+", 
            RowBox[{"64", " ", "t1", " ", "z0"}], "+", 
            RowBox[{"88", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "-", 
            RowBox[{"9", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}]}], ")"}]}], "+", 
         RowBox[{"3", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "12"}], "+", 
            RowBox[{
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"12", "-", 
            RowBox[{"4", " ", "t1", " ", "z0"}], "-", 
            RowBox[{"13", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["a1", "2"], " ", "t1", " ", 
             SuperscriptBox["z0", "5"]}], "+", 
            RowBox[{
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}]}], ")"}]}], "+", 
         RowBox[{
          SuperscriptBox["h0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "400"}], "-", 
            RowBox[{"48", " ", 
             SuperscriptBox["p0", "4"]}], "+", 
            RowBox[{"64", " ", "t1", " ", "z0"}], "+", 
            RowBox[{"88", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "-", 
            RowBox[{"9", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "+", 
            RowBox[{"32", " ", 
             SuperscriptBox["p0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "9"}], "+", 
               RowBox[{"t1", " ", "z0"}], "+", 
               RowBox[{
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}]}], ")"}]}], 
      "+", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"3840", " ", 
         SuperscriptBox["t1", "3"], " ", 
         SuperscriptBox["z0", "8"]}]], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "z"}], "+", "z0"}], ")"}], "5"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"1280", " ", 
          SuperscriptBox["h0", "8"]}], "+", 
         RowBox[{"1280", " ", 
          SuperscriptBox["p0", "8"]}], "+", 
         RowBox[{"256", " ", 
          SuperscriptBox["h0", "6"], " ", 
          RowBox[{"(", 
           RowBox[{"67", "+", 
            RowBox[{"20", " ", 
             SuperscriptBox["p0", "2"]}], "-", 
            RowBox[{"10", " ", "t1", " ", "z0"}], "-", 
            RowBox[{"5", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
         RowBox[{"256", " ", 
          SuperscriptBox["p0", "6"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "67"}], "+", 
            RowBox[{"10", " ", "t1", " ", "z0"}], "+", 
            RowBox[{"5", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
         RowBox[{"128", " ", 
          SuperscriptBox["p0", "4"], " ", 
          RowBox[{"(", 
           RowBox[{"604", "+", 
            RowBox[{"10", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"]}], "-", 
            RowBox[{"139", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"7", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "+", 
            RowBox[{"20", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "9"}], "+", 
               RowBox[{
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}], "+", 
         RowBox[{"128", " ", 
          SuperscriptBox["h0", "4"], " ", 
          RowBox[{"(", 
           RowBox[{"604", "+", 
            RowBox[{"60", " ", 
             SuperscriptBox["p0", "4"]}], "+", 
            RowBox[{"10", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"]}], "-", 
            RowBox[{"139", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"7", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "+", 
            RowBox[{"20", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "9"}], "+", 
               RowBox[{
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
            RowBox[{"6", " ", 
             SuperscriptBox["p0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "67"}], "+", 
               RowBox[{"10", " ", "t1", " ", "z0"}], "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}], "+", 
         RowBox[{"15", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "12"}], "+", 
            RowBox[{
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"16", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "4"}], "+", 
               RowBox[{"3", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "12"}], "+", 
                RowBox[{
                 SuperscriptBox["a1", "2"], " ", 
                 SuperscriptBox["z0", "4"]}]}], ")"}], "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "4"}], "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
            RowBox[{"32", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{"12", "-", 
               RowBox[{"13", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}], "+", 
         RowBox[{"4", " ", 
          SuperscriptBox["p0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{"37120", "+", 
            RowBox[{"1280", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"]}], "-", 
            RowBox[{"18032", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"2824", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "-", 
            RowBox[{"99", " ", 
             SuperscriptBox["a1", "6"], " ", 
             SuperscriptBox["z0", "12"]}], "-", 
            RowBox[{"40", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{"400", "-", 
               RowBox[{"88", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"9", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}], "+", 
         RowBox[{"4", " ", 
          SuperscriptBox["h0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{"37120", "+", 
            RowBox[{"1280", " ", 
             SuperscriptBox["p0", "6"]}], "+", 
            RowBox[{"1280", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"]}], "-", 
            RowBox[{"18032", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"2824", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "-", 
            RowBox[{"99", " ", 
             SuperscriptBox["a1", "6"], " ", 
             SuperscriptBox["z0", "12"]}], "-", 
            RowBox[{"192", " ", 
             SuperscriptBox["p0", "4"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "67"}], "+", 
               RowBox[{"10", " ", "t1", " ", "z0"}], "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
            RowBox[{"40", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{"400", "-", 
               RowBox[{"88", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"9", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}], "+", 
            RowBox[{"64", " ", 
             SuperscriptBox["p0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"604", "+", 
               RowBox[{"10", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"]}], "-", 
               RowBox[{"139", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"7", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"20", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "9"}], "+", 
                  RowBox[{
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}]}], 
           ")"}]}]}], ")"}]}], "-", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"69120", " ", 
         SuperscriptBox["t1", "4"], " ", 
         SuperscriptBox["z0", "10"]}]], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "z"}], "+", "z0"}], ")"}], "6"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"23040", " ", 
          SuperscriptBox["h0", "10"]}], "+", 
         RowBox[{"23040", " ", 
          SuperscriptBox["p0", "10"]}], "+", 
         RowBox[{"768", " ", 
          SuperscriptBox["h0", "8"], " ", 
          RowBox[{"(", 
           RowBox[{"534", "+", 
            RowBox[{"150", " ", 
             SuperscriptBox["p0", "2"]}], "-", 
            RowBox[{"90", " ", "t1", " ", "z0"}], "-", 
            RowBox[{"35", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
         RowBox[{"768", " ", 
          SuperscriptBox["p0", "8"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "534"}], "+", 
            RowBox[{"90", " ", "t1", " ", "z0"}], "+", 
            RowBox[{"35", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
         RowBox[{"135", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "12"}], "+", 
            RowBox[{
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}]}], ")"}], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "12"}], "+", 
             RowBox[{"4", " ", "t1", " ", "z0"}], "+", 
             RowBox[{
              SuperscriptBox["a1", "2"], " ", 
              SuperscriptBox["z0", "4"]}]}], ")"}], "2"], " ", 
          RowBox[{"(", 
           RowBox[{"24", "-", 
            RowBox[{"8", " ", "t1", " ", "z0"}], "-", 
            RowBox[{"38", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"6", " ", 
             SuperscriptBox["a1", "2"], " ", "t1", " ", 
             SuperscriptBox["z0", "5"]}], "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}]}], ")"}]}], "+", 
         RowBox[{"1536", " ", 
          SuperscriptBox["p0", "6"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"45", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"]}], "+", 
            RowBox[{"9", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "67"}], "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
            RowBox[{"5", " ", 
             RowBox[{"(", 
              RowBox[{"344", "-", 
               RowBox[{"61", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"3", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}], "+", 
         RowBox[{"1536", " ", 
          SuperscriptBox["h0", "6"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"150", " ", 
             SuperscriptBox["p0", "4"]}], "+", 
            RowBox[{"45", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"]}], "+", 
            RowBox[{"9", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "67"}], "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["p0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "534"}], "+", 
               RowBox[{"90", " ", "t1", " ", "z0"}], "+", 
               RowBox[{"35", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
            RowBox[{"5", " ", 
             RowBox[{"(", 
              RowBox[{"344", "-", 
               RowBox[{"61", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"3", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}], "-", 
         RowBox[{"8", " ", 
          SuperscriptBox["p0", "4"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "979712"}], "+", 
            RowBox[{"2880", " ", 
             SuperscriptBox["t1", "3"], " ", 
             SuperscriptBox["z0", "3"]}], "+", 
            RowBox[{"377424", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "-", 
            RowBox[{"41376", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "+", 
            RowBox[{"1431", " ", 
             SuperscriptBox["a1", "6"], " ", 
             SuperscriptBox["z0", "12"]}], "+", 
            RowBox[{"8640", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "9"}], "+", 
               RowBox[{
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
            RowBox[{"864", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{"604", "-", 
               RowBox[{"139", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"7", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}], "-", 
         RowBox[{"2", " ", 
          SuperscriptBox["p0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "5474560"}], "+", 
            RowBox[{"46080", " ", 
             SuperscriptBox["t1", "3"], " ", 
             SuperscriptBox["z0", "3"]}], "+", 
            RowBox[{"4248192", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "-", 
            RowBox[{"902976", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "+", 
            RowBox[{"62424", " ", 
             SuperscriptBox["a1", "6"], " ", 
             SuperscriptBox["z0", "12"]}], "-", 
            RowBox[{"1539", " ", 
             SuperscriptBox["a1", "8"], " ", 
             SuperscriptBox["z0", "16"]}], "-", 
            RowBox[{"2160", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"400", "-", 
               RowBox[{"88", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"9", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}], "-", 
            RowBox[{"108", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "37120"}], "+", 
               RowBox[{"18032", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "-", 
               RowBox[{"2824", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"99", " ", 
                SuperscriptBox["a1", "6"], " ", 
                SuperscriptBox["z0", "12"]}]}], ")"}]}]}], ")"}]}], "+", 
         RowBox[{"8", " ", 
          SuperscriptBox["h0", "4"], " ", 
          RowBox[{"(", 
           RowBox[{"979712", "+", 
            RowBox[{"28800", " ", 
             SuperscriptBox["p0", "6"]}], "-", 
            RowBox[{"2880", " ", 
             SuperscriptBox["t1", "3"], " ", 
             SuperscriptBox["z0", "3"]}], "-", 
            RowBox[{"377424", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"41376", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "-", 
            RowBox[{"1431", " ", 
             SuperscriptBox["a1", "6"], " ", 
             SuperscriptBox["z0", "12"]}], "-", 
            RowBox[{"8640", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "9"}], "+", 
               RowBox[{
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
            RowBox[{"576", " ", 
             SuperscriptBox["p0", "4"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "534"}], "+", 
               RowBox[{"90", " ", "t1", " ", "z0"}], "+", 
               RowBox[{"35", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
            RowBox[{"864", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{"604", "-", 
               RowBox[{"139", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"7", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}], "+", 
            RowBox[{"576", " ", 
             SuperscriptBox["p0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"45", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"]}], "+", 
               RowBox[{"9", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "67"}], "+", 
                  RowBox[{"5", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
               RowBox[{"5", " ", 
                RowBox[{"(", 
                 RowBox[{"344", "-", 
                  RowBox[{"61", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}], "+", 
                  RowBox[{"3", " ", 
                   SuperscriptBox["a1", "4"], " ", 
                   SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}]}], 
           ")"}]}], "+", 
         RowBox[{"2", " ", 
          SuperscriptBox["h0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{"5474560", "+", 
            RowBox[{"57600", " ", 
             SuperscriptBox["p0", "8"]}], "-", 
            RowBox[{"46080", " ", 
             SuperscriptBox["t1", "3"], " ", 
             SuperscriptBox["z0", "3"]}], "-", 
            RowBox[{"4248192", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}], "+", 
            RowBox[{"902976", " ", 
             SuperscriptBox["a1", "4"], " ", 
             SuperscriptBox["z0", "8"]}], "-", 
            RowBox[{"62424", " ", 
             SuperscriptBox["a1", "6"], " ", 
             SuperscriptBox["z0", "12"]}], "+", 
            RowBox[{"1539", " ", 
             SuperscriptBox["a1", "8"], " ", 
             SuperscriptBox["z0", "16"]}], "-", 
            RowBox[{"1536", " ", 
             SuperscriptBox["p0", "6"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "534"}], "+", 
               RowBox[{"90", " ", "t1", " ", "z0"}], "+", 
               RowBox[{"35", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
            RowBox[{"2160", " ", 
             SuperscriptBox["t1", "2"], " ", 
             SuperscriptBox["z0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"400", "-", 
               RowBox[{"88", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "+", 
               RowBox[{"9", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}]}], ")"}]}], "+", 
            RowBox[{"108", " ", "t1", " ", "z0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "37120"}], "+", 
               RowBox[{"18032", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "-", 
               RowBox[{"2824", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"99", " ", 
                SuperscriptBox["a1", "6"], " ", 
                SuperscriptBox["z0", "12"]}]}], ")"}]}], "+", 
            RowBox[{"2304", " ", 
             SuperscriptBox["p0", "4"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"45", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"]}], "+", 
               RowBox[{"9", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "67"}], "+", 
                  RowBox[{"5", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
               RowBox[{"5", " ", 
                RowBox[{"(", 
                 RowBox[{"344", "-", 
                  RowBox[{"61", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}], "+", 
                  RowBox[{"3", " ", 
                   SuperscriptBox["a1", "4"], " ", 
                   SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["p0", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "979712"}], "+", 
               RowBox[{"2880", " ", 
                SuperscriptBox["t1", "3"], " ", 
                SuperscriptBox["z0", "3"]}], "+", 
               RowBox[{"377424", " ", 
                SuperscriptBox["a1", "2"], " ", 
                SuperscriptBox["z0", "4"]}], "-", 
               RowBox[{"41376", " ", 
                SuperscriptBox["a1", "4"], " ", 
                SuperscriptBox["z0", "8"]}], "+", 
               RowBox[{"1431", " ", 
                SuperscriptBox["a1", "6"], " ", 
                SuperscriptBox["z0", "12"]}], "+", 
               RowBox[{"8640", " ", 
                SuperscriptBox["t1", "2"], " ", 
                SuperscriptBox["z0", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "9"}], "+", 
                  RowBox[{
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
               RowBox[{"864", " ", "t1", " ", "z0", " ", 
                RowBox[{"(", 
                 RowBox[{"604", "-", 
                  RowBox[{"139", " ", 
                   SuperscriptBox["a1", "2"], " ", 
                   SuperscriptBox["z0", "4"]}], "+", 
                  RowBox[{"7", " ", 
                   SuperscriptBox["a1", "4"], " ", 
                   SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}]}], 
           ")"}]}]}], ")"}]}]}], "//.", "replhoriz"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"horizS", "[", "z_", "]"}], ":=", 
   RowBox[{
    RowBox[{"s0", "+", 
     FractionBox[
      RowBox[{"s0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "z"}], "+", "z0"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"12", "+", 
         RowBox[{"4", " ", 
          SuperscriptBox["h0", "2"]}], "+", 
         RowBox[{"4", " ", 
          SuperscriptBox["p0", "2"]}], "-", 
         RowBox[{"4", " ", "t1", " ", "z0"}], "-", 
         RowBox[{
          SuperscriptBox["a1", "2"], " ", 
          SuperscriptBox["z0", "4"]}]}], ")"}]}], 
      RowBox[{"4", " ", "t1", " ", 
       SuperscriptBox["z0", "2"]}]], "-", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["h0", "2"], "+", 
         SuperscriptBox["p0", "2"]}], ")"}], " ", "s0", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "z"}], "+", "z0"}], ")"}], "2"], " ", 
       RowBox[{"(", 
        RowBox[{"4", "+", 
         RowBox[{
          SuperscriptBox["a1", "2"], " ", 
          SuperscriptBox["z0", "4"]}]}], ")"}]}], 
      RowBox[{"4", " ", 
       SuperscriptBox["t1", "2"], " ", 
       SuperscriptBox["z0", "4"]}]], "-", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["h0", "2"], "+", 
         SuperscriptBox["p0", "2"]}], ")"}], " ", "s0", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "z"}], "+", "z0"}], ")"}], "3"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"4", " ", 
          SuperscriptBox["h0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "4"}], "+", 
            RowBox[{
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
         RowBox[{"4", " ", 
          SuperscriptBox["p0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "4"}], "+", 
            RowBox[{
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "20"}], "+", 
            RowBox[{"12", " ", "t1", " ", "z0"}], "-", 
            RowBox[{"3", " ", 
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"4", "+", 
            RowBox[{
             SuperscriptBox["a1", "2"], " ", 
             SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}], 
      RowBox[{"48", " ", 
       SuperscriptBox["t1", "3"], " ", 
       SuperscriptBox["z0", "6"]}]], "-", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"1152", " ", 
        SuperscriptBox["t1", "4"], " ", 
        SuperscriptBox["z0", "8"]}]], 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["h0", "2"], "+", 
        SuperscriptBox["p0", "2"]}], ")"}], " ", "s0", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "z"}], "+", "z0"}], ")"}], "4"], " ", 
      RowBox[{"(", 
       RowBox[{"3200", "+", 
        RowBox[{"192", " ", 
         SuperscriptBox["h0", "4"]}], "+", 
        RowBox[{"192", " ", 
         SuperscriptBox["p0", "4"]}], "-", 
        RowBox[{"3840", " ", "t1", " ", "z0"}], "+", 
        RowBox[{"1152", " ", 
         SuperscriptBox["t1", "2"], " ", 
         SuperscriptBox["z0", "2"]}], "+", 
        RowBox[{"1872", " ", 
         SuperscriptBox["a1", "2"], " ", 
         SuperscriptBox["z0", "4"]}], "-", 
        RowBox[{"1536", " ", 
         SuperscriptBox["a1", "2"], " ", "t1", " ", 
         SuperscriptBox["z0", "5"]}], "+", 
        RowBox[{"288", " ", 
         SuperscriptBox["a1", "2"], " ", 
         SuperscriptBox["t1", "2"], " ", 
         SuperscriptBox["z0", "6"]}], "+", 
        RowBox[{"432", " ", 
         SuperscriptBox["a1", "4"], " ", 
         SuperscriptBox["z0", "8"]}], "-", 
        RowBox[{"144", " ", 
         SuperscriptBox["a1", "4"], " ", "t1", " ", 
         SuperscriptBox["z0", "9"]}], "+", 
        RowBox[{"9", " ", 
         SuperscriptBox["a1", "6"], " ", 
         SuperscriptBox["z0", "12"]}], "+", 
        RowBox[{"12", " ", 
         SuperscriptBox["p0", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "44"}], "+", 
           RowBox[{"16", " ", "t1", " ", "z0"}], "-", 
           RowBox[{"5", " ", 
            SuperscriptBox["a1", "2"], " ", 
            SuperscriptBox["z0", "4"]}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", 
           RowBox[{
            SuperscriptBox["a1", "2"], " ", 
            SuperscriptBox["z0", "4"]}]}], ")"}]}], "+", 
        RowBox[{"12", " ", 
         SuperscriptBox["h0", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"32", " ", 
            SuperscriptBox["p0", "2"]}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "44"}], "+", 
              RowBox[{"16", " ", "t1", " ", "z0"}], "-", 
              RowBox[{"5", " ", 
               SuperscriptBox["a1", "2"], " ", 
               SuperscriptBox["z0", "4"]}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "4"}], "+", 
              RowBox[{
               SuperscriptBox["a1", "2"], " ", 
               SuperscriptBox["z0", "4"]}]}], ")"}]}]}], ")"}]}]}], ")"}]}], 
     "+", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"23040", " ", 
        SuperscriptBox["t1", "5"], " ", 
        SuperscriptBox["z0", "10"]}]], 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["h0", "2"], "+", 
        SuperscriptBox["p0", "2"]}], ")"}], " ", "s0", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "z"}], "+", "z0"}], ")"}], "5"], " ", 
      RowBox[{"(", 
       RowBox[{"110080", "+", 
        RowBox[{"2304", " ", 
         SuperscriptBox["h0", "6"]}], "+", 
        RowBox[{"2304", " ", 
         SuperscriptBox["p0", "6"]}], "-", 
        RowBox[{"192000", " ", "t1", " ", "z0"}], "+", 
        RowBox[{"115200", " ", 
         SuperscriptBox["t1", "2"], " ", 
         SuperscriptBox["z0", "2"]}], "-", 
        RowBox[{"23040", " ", 
         SuperscriptBox["t1", "3"], " ", 
         SuperscriptBox["z0", "3"]}], "+", 
        RowBox[{"90880", " ", 
         SuperscriptBox["a1", "2"], " ", 
         SuperscriptBox["z0", "4"]}], "-", 
        RowBox[{"112320", " ", 
         SuperscriptBox["a1", "2"], " ", "t1", " ", 
         SuperscriptBox["z0", "5"]}], "+", 
        RowBox[{"46080", " ", 
         SuperscriptBox["a1", "2"], " ", 
         SuperscriptBox["t1", "2"], " ", 
         SuperscriptBox["z0", "6"]}], "-", 
        RowBox[{"5760", " ", 
         SuperscriptBox["a1", "2"], " ", 
         SuperscriptBox["t1", "3"], " ", 
         SuperscriptBox["z0", "7"]}], "+", 
        RowBox[{"35184", " ", 
         SuperscriptBox["a1", "4"], " ", 
         SuperscriptBox["z0", "8"]}], "-", 
        RowBox[{"25920", " ", 
         SuperscriptBox["a1", "4"], " ", "t1", " ", 
         SuperscriptBox["z0", "9"]}], "+", 
        RowBox[{"4320", " ", 
         SuperscriptBox["a1", "4"], " ", 
         SuperscriptBox["t1", "2"], " ", 
         SuperscriptBox["z0", "10"]}], "+", 
        RowBox[{"2184", " ", 
         SuperscriptBox["a1", "6"], " ", 
         SuperscriptBox["z0", "12"]}], "-", 
        RowBox[{"540", " ", 
         SuperscriptBox["a1", "6"], " ", "t1", " ", 
         SuperscriptBox["z0", "13"]}], "+", 
        RowBox[{"9", " ", 
         SuperscriptBox["a1", "8"], " ", 
         SuperscriptBox["z0", "16"]}], "-", 
        RowBox[{"48", " ", 
         SuperscriptBox["p0", "4"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "816"}], "+", 
           RowBox[{"240", " ", "t1", " ", "z0"}], "+", 
           RowBox[{"12", " ", 
            SuperscriptBox["a1", "2"], " ", 
            SuperscriptBox["z0", "4"]}], "-", 
           RowBox[{"7", " ", 
            SuperscriptBox["a1", "4"], " ", 
            SuperscriptBox["z0", "8"]}]}], ")"}]}], "+", 
        RowBox[{"48", " ", 
         SuperscriptBox["h0", "4"], " ", 
         RowBox[{"(", 
          RowBox[{"816", "+", 
           RowBox[{"144", " ", 
            SuperscriptBox["p0", "2"]}], "-", 
           RowBox[{"240", " ", "t1", " ", "z0"}], "-", 
           RowBox[{"12", " ", 
            SuperscriptBox["a1", "2"], " ", 
            SuperscriptBox["z0", "4"]}], "+", 
           RowBox[{"7", " ", 
            SuperscriptBox["a1", "4"], " ", 
            SuperscriptBox["z0", "8"]}]}], ")"}]}], "-", 
        RowBox[{"12", " ", 
         SuperscriptBox["p0", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "12736"}], "+", 
           RowBox[{"208", " ", 
            SuperscriptBox["a1", "2"], " ", 
            SuperscriptBox["z0", "4"]}], "+", 
           RowBox[{"676", " ", 
            SuperscriptBox["a1", "4"], " ", 
            SuperscriptBox["z0", "8"]}], "+", 
           RowBox[{"45", " ", 
            SuperscriptBox["a1", "6"], " ", 
            SuperscriptBox["z0", "12"]}], "+", 
           RowBox[{"480", " ", 
            SuperscriptBox["t1", "2"], " ", 
            SuperscriptBox["z0", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "4"}], "+", 
              RowBox[{
               SuperscriptBox["a1", "2"], " ", 
               SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
           RowBox[{"60", " ", "t1", " ", "z0", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "176"}], "+", 
              RowBox[{"24", " ", 
               SuperscriptBox["a1", "2"], " ", 
               SuperscriptBox["z0", "4"]}], "+", 
              RowBox[{"5", " ", 
               SuperscriptBox["a1", "4"], " ", 
               SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}], "+", 
        RowBox[{"12", " ", 
         SuperscriptBox["h0", "2"], " ", 
         RowBox[{"(", 
          RowBox[{"12736", "+", 
           RowBox[{"576", " ", 
            SuperscriptBox["p0", "4"]}], "-", 
           RowBox[{"208", " ", 
            SuperscriptBox["a1", "2"], " ", 
            SuperscriptBox["z0", "4"]}], "-", 
           RowBox[{"676", " ", 
            SuperscriptBox["a1", "4"], " ", 
            SuperscriptBox["z0", "8"]}], "-", 
           RowBox[{"45", " ", 
            SuperscriptBox["a1", "6"], " ", 
            SuperscriptBox["z0", "12"]}], "-", 
           RowBox[{"480", " ", 
            SuperscriptBox["t1", "2"], " ", 
            SuperscriptBox["z0", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "4"}], "+", 
              RowBox[{
               SuperscriptBox["a1", "2"], " ", 
               SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
           RowBox[{"8", " ", 
            SuperscriptBox["p0", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "816"}], "+", 
              RowBox[{"240", " ", "t1", " ", "z0"}], "+", 
              RowBox[{"12", " ", 
               SuperscriptBox["a1", "2"], " ", 
               SuperscriptBox["z0", "4"]}], "-", 
              RowBox[{"7", " ", 
               SuperscriptBox["a1", "4"], " ", 
               SuperscriptBox["z0", "8"]}]}], ")"}]}], "+", 
           RowBox[{"60", " ", "t1", " ", "z0", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "176"}], "+", 
              RowBox[{"24", " ", 
               SuperscriptBox["a1", "2"], " ", 
               SuperscriptBox["z0", "4"]}], "+", 
              RowBox[{"5", " ", 
               SuperscriptBox["a1", "4"], " ", 
               SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}]}], ")"}]}], 
     "-", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"345600", " ", 
        SuperscriptBox["t1", "6"], " ", 
        SuperscriptBox["z0", "12"]}]], 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["h0", "2"], "+", 
        SuperscriptBox["p0", "2"]}], ")"}], " ", "s0", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "z"}], "+", "z0"}], ")"}], "6"], " ", 
      RowBox[{"(", 
       RowBox[{"3033600", "+", 
        RowBox[{"23040", " ", 
         SuperscriptBox["h0", "8"]}], "+", 
        RowBox[{"23040", " ", 
         SuperscriptBox["p0", "8"]}], "-", 
        RowBox[{"6604800", " ", "t1", " ", "z0"}], "+", 
        RowBox[{"5760000", " ", 
         SuperscriptBox["t1", "2"], " ", 
         SuperscriptBox["z0", "2"]}], "-", 
        RowBox[{"2304000", " ", 
         SuperscriptBox["t1", "3"], " ", 
         SuperscriptBox["z0", "3"]}], "+", 
        RowBox[{"3436352", " ", 
         SuperscriptBox["a1", "2"], " ", 
         SuperscriptBox["z0", "4"]}], "+", 
        RowBox[{"345600", " ", 
         SuperscriptBox["t1", "4"], " ", 
         SuperscriptBox["z0", "4"]}], "-", 
        RowBox[{"5452800", " ", 
         SuperscriptBox["a1", "2"], " ", "t1", " ", 
         SuperscriptBox["z0", "5"]}], "+", 
        RowBox[{"3369600", " ", 
         SuperscriptBox["a1", "2"], " ", 
         SuperscriptBox["t1", "2"], " ", 
         SuperscriptBox["z0", "6"]}], "-", 
        RowBox[{"921600", " ", 
         SuperscriptBox["a1", "2"], " ", 
         SuperscriptBox["t1", "3"], " ", 
         SuperscriptBox["z0", "7"]}], "+", 
        RowBox[{"1799472", " ", 
         SuperscriptBox["a1", "4"], " ", 
         SuperscriptBox["z0", "8"]}], "+", 
        RowBox[{"86400", " ", 
         SuperscriptBox["a1", "2"], " ", 
         SuperscriptBox["t1", "4"], " ", 
         SuperscriptBox["z0", "8"]}], "-", 
        RowBox[{"2111040", " ", 
         SuperscriptBox["a1", "4"], " ", "t1", " ", 
         SuperscriptBox["z0", "9"]}], "+", 
        RowBox[{"777600", " ", 
         SuperscriptBox["a1", "4"], " ", 
         SuperscriptBox["t1", "2"], " ", 
         SuperscriptBox["z0", "10"]}], "-", 
        RowBox[{"86400", " ", 
         SuperscriptBox["a1", "4"], " ", 
         SuperscriptBox["t1", "3"], " ", 
         SuperscriptBox["z0", "11"]}], "+", 
        RowBox[{"228828", " ", 
         SuperscriptBox["a1", "6"], " ", 
         SuperscriptBox["z0", "12"]}], "-", 
        RowBox[{"131040", " ", 
         SuperscriptBox["a1", "6"], " ", "t1", " ", 
         SuperscriptBox["z0", "13"]}], "+", 
        RowBox[{"16200", " ", 
         SuperscriptBox["a1", "6"], " ", 
         SuperscriptBox["t1", "2"], " ", 
         SuperscriptBox["z0", "14"]}], "+", 
        RowBox[{"3735", " ", 
         SuperscriptBox["a1", "8"], " ", 
         SuperscriptBox["z0", "16"]}], "-", 
        RowBox[{"540", " ", 
         SuperscriptBox["a1", "8"], " ", "t1", " ", 
         SuperscriptBox["z0", "17"]}], "-", 
        RowBox[{"96", " ", 
         SuperscriptBox["p0", "6"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "5464"}], "+", 
           RowBox[{"1440", " ", "t1", " ", "z0"}], "-", 
           RowBox[{"38", " ", 
            SuperscriptBox["a1", "2"], " ", 
            SuperscriptBox["z0", "4"]}], "-", 
           RowBox[{"5", " ", 
            SuperscriptBox["a1", "4"], " ", 
            SuperscriptBox["z0", "8"]}]}], ")"}]}], "+", 
        RowBox[{"96", " ", 
         SuperscriptBox["h0", "6"], " ", 
         RowBox[{"(", 
          RowBox[{"5464", "+", 
           RowBox[{"960", " ", 
            SuperscriptBox["p0", "2"]}], "-", 
           RowBox[{"1440", " ", "t1", " ", "z0"}], "+", 
           RowBox[{"38", " ", 
            SuperscriptBox["a1", "2"], " ", 
            SuperscriptBox["z0", "4"]}], "+", 
           RowBox[{"5", " ", 
            SuperscriptBox["a1", "4"], " ", 
            SuperscriptBox["z0", "8"]}]}], ")"}]}], "+", 
        RowBox[{"8", " ", 
         SuperscriptBox["p0", "4"], " ", 
         RowBox[{"(", 
          RowBox[{"432320", "+", 
           RowBox[{"43200", " ", 
            SuperscriptBox["t1", "2"], " ", 
            SuperscriptBox["z0", "2"]}], "+", 
           RowBox[{"9576", " ", 
            SuperscriptBox["a1", "2"], " ", 
            SuperscriptBox["z0", "4"]}], "+", 
           RowBox[{"2658", " ", 
            SuperscriptBox["a1", "4"], " ", 
            SuperscriptBox["z0", "8"]}], "+", 
           RowBox[{"585", " ", 
            SuperscriptBox["a1", "6"], " ", 
            SuperscriptBox["z0", "12"]}], "-", 
           RowBox[{"360", " ", "t1", " ", "z0", " ", 
            RowBox[{"(", 
             RowBox[{"816", "-", 
              RowBox[{"12", " ", 
               SuperscriptBox["a1", "2"], " ", 
               SuperscriptBox["z0", "4"]}], "+", 
              RowBox[{"7", " ", 
               SuperscriptBox["a1", "4"], " ", 
               SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}], "+", 
        RowBox[{"8", " ", 
         SuperscriptBox["h0", "4"], " ", 
         RowBox[{"(", 
          RowBox[{"432320", "+", 
           RowBox[{"17280", " ", 
            SuperscriptBox["p0", "4"]}], "+", 
           RowBox[{"43200", " ", 
            SuperscriptBox["t1", "2"], " ", 
            SuperscriptBox["z0", "2"]}], "+", 
           RowBox[{"9576", " ", 
            SuperscriptBox["a1", "2"], " ", 
            SuperscriptBox["z0", "4"]}], "+", 
           RowBox[{"2658", " ", 
            SuperscriptBox["a1", "4"], " ", 
            SuperscriptBox["z0", "8"]}], "+", 
           RowBox[{"585", " ", 
            SuperscriptBox["a1", "6"], " ", 
            SuperscriptBox["z0", "12"]}], "-", 
           RowBox[{"36", " ", 
            SuperscriptBox["p0", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "5464"}], "+", 
              RowBox[{"1440", " ", "t1", " ", "z0"}], "-", 
              RowBox[{"38", " ", 
               SuperscriptBox["a1", "2"], " ", 
               SuperscriptBox["z0", "4"]}], "-", 
              RowBox[{"5", " ", 
               SuperscriptBox["a1", "4"], " ", 
               SuperscriptBox["z0", "8"]}]}], ")"}]}], "-", 
           RowBox[{"360", " ", "t1", " ", "z0", " ", 
            RowBox[{"(", 
             RowBox[{"816", "-", 
              RowBox[{"12", " ", 
               SuperscriptBox["a1", "2"], " ", 
               SuperscriptBox["z0", "4"]}], "+", 
              RowBox[{"7", " ", 
               SuperscriptBox["a1", "4"], " ", 
               SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}], "+", 
        RowBox[{
         SuperscriptBox["p0", "2"], " ", 
         RowBox[{"(", 
          RowBox[{"6998016", "+", 
           RowBox[{"1009984", " ", 
            SuperscriptBox["a1", "2"], " ", 
            SuperscriptBox["z0", "4"]}], "-", 
           RowBox[{"480048", " ", 
            SuperscriptBox["a1", "4"], " ", 
            SuperscriptBox["z0", "8"]}], "-", 
           RowBox[{"90804", " ", 
            SuperscriptBox["a1", "6"], " ", 
            SuperscriptBox["z0", "12"]}], "-", 
           RowBox[{"2205", " ", 
            SuperscriptBox["a1", "8"], " ", 
            SuperscriptBox["z0", "16"]}], "+", 
           RowBox[{"115200", " ", 
            SuperscriptBox["t1", "3"], " ", 
            SuperscriptBox["z0", "3"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "4"}], "+", 
              RowBox[{
               SuperscriptBox["a1", "2"], " ", 
               SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
           RowBox[{"21600", " ", 
            SuperscriptBox["t1", "2"], " ", 
            SuperscriptBox["z0", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "176"}], "+", 
              RowBox[{"24", " ", 
               SuperscriptBox["a1", "2"], " ", 
               SuperscriptBox["z0", "4"]}], "+", 
              RowBox[{"5", " ", 
               SuperscriptBox["a1", "4"], " ", 
               SuperscriptBox["z0", "8"]}]}], ")"}]}], "+", 
           RowBox[{"720", " ", "t1", " ", "z0", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "12736"}], "+", 
              RowBox[{"208", " ", 
               SuperscriptBox["a1", "2"], " ", 
               SuperscriptBox["z0", "4"]}], "+", 
              RowBox[{"676", " ", 
               SuperscriptBox["a1", "4"], " ", 
               SuperscriptBox["z0", "8"]}], "+", 
              RowBox[{"45", " ", 
               SuperscriptBox["a1", "6"], " ", 
               SuperscriptBox["z0", "12"]}]}], ")"}]}]}], ")"}]}], "+", 
        RowBox[{
         SuperscriptBox["h0", "2"], " ", 
         RowBox[{"(", 
          RowBox[{"6998016", "+", 
           RowBox[{"92160", " ", 
            SuperscriptBox["p0", "6"]}], "+", 
           RowBox[{"1009984", " ", 
            SuperscriptBox["a1", "2"], " ", 
            SuperscriptBox["z0", "4"]}], "-", 
           RowBox[{"480048", " ", 
            SuperscriptBox["a1", "4"], " ", 
            SuperscriptBox["z0", "8"]}], "-", 
           RowBox[{"90804", " ", 
            SuperscriptBox["a1", "6"], " ", 
            SuperscriptBox["z0", "12"]}], "-", 
           RowBox[{"2205", " ", 
            SuperscriptBox["a1", "8"], " ", 
            SuperscriptBox["z0", "16"]}], "+", 
           RowBox[{"115200", " ", 
            SuperscriptBox["t1", "3"], " ", 
            SuperscriptBox["z0", "3"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "4"}], "+", 
              RowBox[{
               SuperscriptBox["a1", "2"], " ", 
               SuperscriptBox["z0", "4"]}]}], ")"}]}], "-", 
           RowBox[{"288", " ", 
            SuperscriptBox["p0", "4"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "5464"}], "+", 
              RowBox[{"1440", " ", "t1", " ", "z0"}], "-", 
              RowBox[{"38", " ", 
               SuperscriptBox["a1", "2"], " ", 
               SuperscriptBox["z0", "4"]}], "-", 
              RowBox[{"5", " ", 
               SuperscriptBox["a1", "4"], " ", 
               SuperscriptBox["z0", "8"]}]}], ")"}]}], "-", 
           RowBox[{"21600", " ", 
            SuperscriptBox["t1", "2"], " ", 
            SuperscriptBox["z0", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "176"}], "+", 
              RowBox[{"24", " ", 
               SuperscriptBox["a1", "2"], " ", 
               SuperscriptBox["z0", "4"]}], "+", 
              RowBox[{"5", " ", 
               SuperscriptBox["a1", "4"], " ", 
               SuperscriptBox["z0", "8"]}]}], ")"}]}], "+", 
           RowBox[{"720", " ", "t1", " ", "z0", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "12736"}], "+", 
              RowBox[{"208", " ", 
               SuperscriptBox["a1", "2"], " ", 
               SuperscriptBox["z0", "4"]}], "+", 
              RowBox[{"676", " ", 
               SuperscriptBox["a1", "4"], " ", 
               SuperscriptBox["z0", "8"]}], "+", 
              RowBox[{"45", " ", 
               SuperscriptBox["a1", "6"], " ", 
               SuperscriptBox["z0", "12"]}]}], ")"}]}], "+", 
           RowBox[{"16", " ", 
            SuperscriptBox["p0", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"432320", "+", 
              RowBox[{"43200", " ", 
               SuperscriptBox["t1", "2"], " ", 
               SuperscriptBox["z0", "2"]}], "+", 
              RowBox[{"9576", " ", 
               SuperscriptBox["a1", "2"], " ", 
               SuperscriptBox["z0", "4"]}], "+", 
              RowBox[{"2658", " ", 
               SuperscriptBox["a1", "4"], " ", 
               SuperscriptBox["z0", "8"]}], "+", 
              RowBox[{"585", " ", 
               SuperscriptBox["a1", "6"], " ", 
               SuperscriptBox["z0", "12"]}], "-", 
              RowBox[{"360", " ", "t1", " ", "z0", " ", 
               RowBox[{"(", 
                RowBox[{"816", "-", 
                 RowBox[{"12", " ", 
                  SuperscriptBox["a1", "2"], " ", 
                  SuperscriptBox["z0", "4"]}], "+", 
                 RowBox[{"7", " ", 
                  SuperscriptBox["a1", "4"], " ", 
                  SuperscriptBox["z0", "8"]}]}], ")"}]}]}], ")"}]}]}], 
          ")"}]}]}], ")"}]}]}], "//.", "replhoriz"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5384640040309467`*^9, 3.5384640865225697`*^9}, {
  3.538464329491736*^9, 3.538464352894101*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"asymp", "[", "z_", "]"}], ":=", 
    RowBox[{
     RowBox[{
      RowBox[{"p2", " ", 
       SuperscriptBox["z", "2"]}], "+", 
      RowBox[{"a0", " ", "h2", " ", 
       SuperscriptBox["z", "3"]}], "+", 
      RowBox[{
       FractionBox["1", "6"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"3", " ", "a1", " ", "h2"}], "-", 
         RowBox[{"4", " ", 
          SuperscriptBox["a0", "2"], " ", "p2"}]}], ")"}], " ", 
       SuperscriptBox["z", "4"]}], "+", 
      RowBox[{
       FractionBox["1", "3"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["a0", "3"]}], " ", "h2"}], "-", 
         RowBox[{"2", " ", "a0", " ", "a1", " ", "p2"}], "-", 
         RowBox[{"p2", " ", "T3"}]}], ")"}], " ", 
       SuperscriptBox["z", "5"]}], "+", 
      RowBox[{
       FractionBox["1", "60"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "30"}], " ", 
          SuperscriptBox["a0", "2"], " ", "a1", " ", "h2"}], "+", 
         RowBox[{"8", " ", 
          SuperscriptBox["a0", "4"], " ", "p2"}], "-", 
         RowBox[{"15", " ", 
          SuperscriptBox["a1", "2"], " ", "p2"}], "+", 
         RowBox[{"14", " ", "p2", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["h2", "2"], "+", 
            SuperscriptBox["p2", "2"]}], ")"}]}], "-", 
         RowBox[{"35", " ", "a0", " ", "h2", " ", "T3"}]}], ")"}], " ", 
       SuperscriptBox["z", "6"]}], "+", 
      RowBox[{
       FractionBox["1", "180"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"8", " ", 
          SuperscriptBox["a0", "5"], " ", "h2"}], "+", 
         RowBox[{"48", " ", 
          SuperscriptBox["a0", "3"], " ", "a1", " ", "p2"}], "+", 
         RowBox[{"a0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "69"}], " ", 
             SuperscriptBox["a1", "2"], " ", "h2"}], "+", 
            RowBox[{"60", " ", "h2", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["h2", "2"], "+", 
               SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "-", 
         RowBox[{"66", " ", "a1", " ", "h2", " ", "T3"}], "+", 
         RowBox[{"99", " ", 
          SuperscriptBox["a0", "2"], " ", "p2", " ", "T3"}]}], ")"}], " ", 
       SuperscriptBox["z", "7"]}], "+", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"280", " ", 
           SuperscriptBox["a0", "4"], " ", "a1", " ", "h2"}], "-", 
          RowBox[{"315", " ", 
           SuperscriptBox["a1", "3"], " ", "h2"}], "-", 
          RowBox[{"32", " ", 
           SuperscriptBox["a0", "6"], " ", "p2"}], "+", 
          RowBox[{"504", " ", "a1", " ", "h2", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["h2", "2"], "+", 
             SuperscriptBox["p2", "2"]}], ")"}]}], "+", 
          RowBox[{
           SuperscriptBox["a0", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"806", " ", 
              SuperscriptBox["a1", "2"], " ", "p2"}], "-", 
             RowBox[{"860", " ", "p2", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["h2", "2"], "+", 
                SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "+", 
          RowBox[{"896", " ", 
           SuperscriptBox["a0", "3"], " ", "h2", " ", "T3"}], "+", 
          RowBox[{"1649", " ", "a0", " ", "a1", " ", "p2", " ", "T3"}], "+", 
          RowBox[{"500", " ", "p2", " ", 
           SuperscriptBox["T3", "2"]}]}], ")"}], " ", 
        SuperscriptBox["z", "8"]}], "2520"], "+", 
      RowBox[{
       FractionBox["1", "1260"], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "4"}], " ", 
          SuperscriptBox["a0", "7"], " ", "h2"}], "-", 
         RowBox[{"48", " ", 
          SuperscriptBox["a0", "5"], " ", "a1", " ", "p2"}], "+", 
         RowBox[{
          SuperscriptBox["a0", "3"], " ", "h2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"235", " ", 
             SuperscriptBox["a1", "2"]}], "-", 
            RowBox[{"324", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["h2", "2"], "+", 
               SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "+", 
         RowBox[{"8", " ", "a0", " ", "a1", " ", "p2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"33", " ", 
             SuperscriptBox["a1", "2"]}], "-", 
            RowBox[{"61", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["h2", "2"], "+", 
               SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "-", 
         RowBox[{"2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "386"}], " ", 
             SuperscriptBox["a0", "2"], " ", "a1", " ", "h2"}], "+", 
            RowBox[{"110", " ", 
             SuperscriptBox["a0", "4"], " ", "p2"}], "-", 
            RowBox[{"183", " ", 
             SuperscriptBox["a1", "2"], " ", "p2"}], "+", 
            RowBox[{"167", " ", "p2", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["h2", "2"], "+", 
               SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}], " ", "T3"}], 
         "+", 
         RowBox[{"535", " ", "a0", " ", "h2", " ", 
          SuperscriptBox["T3", "2"]}]}], ")"}], " ", 
       SuperscriptBox["z", "9"]}], "+", 
      RowBox[{
       FractionBox["1", "90720"], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "1008"}], " ", 
          SuperscriptBox["a0", "6"], " ", "a1", " ", "h2"}], "+", 
         RowBox[{"64", " ", 
          SuperscriptBox["a0", "8"], " ", "p2"}], "+", 
         RowBox[{"36", " ", 
          SuperscriptBox["a0", "2"], " ", "a1", " ", "h2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"469", " ", 
             SuperscriptBox["a1", "2"]}], "-", 
            RowBox[{"1093", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["h2", "2"], "+", 
               SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "+", 
         RowBox[{"4", " ", 
          SuperscriptBox["a0", "4"], " ", "p2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "1906"}], " ", 
             SuperscriptBox["a1", "2"]}], "+", 
            RowBox[{"3641", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["h2", "2"], "+", 
               SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "+", 
         RowBox[{"54", " ", "p2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"105", " ", 
             SuperscriptBox["a1", "4"]}], "-", 
            RowBox[{"298", " ", 
             SuperscriptBox["a1", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["h2", "2"], "+", 
               SuperscriptBox["p2", "2"]}], ")"}]}], "+", 
            RowBox[{"162", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["h2", "2"], "+", 
                SuperscriptBox["p2", "2"]}], ")"}], "2"]}]}], ")"}]}], "-", 
         RowBox[{"2", " ", "a0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"3132", " ", 
             SuperscriptBox["a0", "4"], " ", "h2"}], "+", 
            RowBox[{"17768", " ", 
             SuperscriptBox["a0", "2"], " ", "a1", " ", "p2"}], "+", 
            RowBox[{"9", " ", "h2", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "2756"}], " ", 
                SuperscriptBox["a1", "2"]}], "+", 
               RowBox[{"2443", " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["h2", "2"], "+", 
                  SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}]}], ")"}], 
          " ", "T3"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"26388", " ", "a1", " ", "h2"}], "-", 
            RowBox[{"42517", " ", 
             SuperscriptBox["a0", "2"], " ", "p2"}]}], ")"}], " ", 
          SuperscriptBox["T3", "2"]}]}], ")"}], " ", 
       SuperscriptBox["z", "10"]}], "+", 
      RowBox[{
       FractionBox["1", "453600"], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "a0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"32", " ", 
             SuperscriptBox["a0", "8"], " ", "h2"}], "+", 
            RowBox[{"640", " ", 
             SuperscriptBox["a0", "6"], " ", "a1", " ", "p2"}], "+", 
            RowBox[{"38", " ", 
             SuperscriptBox["a0", "2"], " ", "a1", " ", "p2", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "680"}], " ", 
                SuperscriptBox["a1", "2"]}], "+", 
               RowBox[{"2129", " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["h2", "2"], "+", 
                  SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a0", "4"], " ", "h2", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "3506"}], " ", 
                SuperscriptBox["a1", "2"]}], "+", 
               RowBox[{"9625", " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["h2", "2"], "+", 
                  SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "+", 
            RowBox[{"3", " ", "h2", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"8445", " ", 
                SuperscriptBox["a1", "4"]}], "-", 
               RowBox[{"27322", " ", 
                SuperscriptBox["a1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["h2", "2"], "+", 
                  SuperscriptBox["p2", "2"]}], ")"}]}], "+", 
               RowBox[{"11384", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["h2", "2"], "+", 
                   SuperscriptBox["p2", "2"]}], ")"}], "2"]}]}], ")"}]}]}], 
           ")"}]}], "+", 
         RowBox[{"2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "43168"}], " ", 
             SuperscriptBox["a0", "4"], " ", "a1", " ", "h2"}], "+", 
            RowBox[{"5180", " ", 
             SuperscriptBox["a0", "6"], " ", "p2"}], "+", 
            RowBox[{"12", " ", "a1", " ", "h2", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"3795", " ", 
                SuperscriptBox["a1", "2"]}], "-", 
               RowBox[{"6062", " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["h2", "2"], "+", 
                  SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "+", 
            RowBox[{
             SuperscriptBox["a0", "2"], " ", "p2", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "122040"}], " ", 
                SuperscriptBox["a1", "2"]}], "+", 
               RowBox[{"132161", " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["h2", "2"], "+", 
                  SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}]}], ")"}], 
          " ", "T3"}], "-", 
         RowBox[{"5", " ", "a0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"31441", " ", 
             SuperscriptBox["a0", "2"], " ", "h2"}], "+", 
            RowBox[{"54768", " ", "a1", " ", "p2"}]}], ")"}], " ", 
          SuperscriptBox["T3", "2"]}], "-", 
         RowBox[{"64000", " ", "p2", " ", 
          SuperscriptBox["T3", "3"]}]}], ")"}], " ", 
       SuperscriptBox["z", "11"]}], "+", 
      RowBox[{
       FractionBox["1", "9979200"], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"6336", " ", 
          SuperscriptBox["a0", "8"], " ", "a1", " ", "h2"}], "-", 
         RowBox[{"256", " ", 
          SuperscriptBox["a0", "10"], " ", "p2"}], "+", 
         RowBox[{"198", " ", "a1", " ", "h2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"105", " ", 
             SuperscriptBox["a1", "2"]}], "-", 
            RowBox[{"302", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["h2", "2"], "+", 
               SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"15", " ", 
             SuperscriptBox["a1", "2"]}], "-", 
            RowBox[{"16", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["h2", "2"], "+", 
               SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "-", 
         RowBox[{"16", " ", 
          SuperscriptBox["a0", "6"], " ", "p2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "5999"}], " ", 
             SuperscriptBox["a1", "2"]}], "+", 
            RowBox[{"24481", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["h2", "2"], "+", 
               SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "+", 
         RowBox[{"44", " ", 
          SuperscriptBox["a0", "4"], " ", "a1", " ", "h2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "12114"}], " ", 
             SuperscriptBox["a1", "2"]}], "+", 
            RowBox[{"52981", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["h2", "2"], "+", 
               SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "-", 
         RowBox[{"4", " ", 
          SuperscriptBox["a0", "2"], " ", "p2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"261441", " ", 
             SuperscriptBox["a1", "4"]}], "-", 
            RowBox[{"1083379", " ", 
             SuperscriptBox["a1", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["h2", "2"], "+", 
               SuperscriptBox["p2", "2"]}], ")"}]}], "+", 
            RowBox[{"493120", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["h2", "2"], "+", 
                SuperscriptBox["p2", "2"]}], ")"}], "2"]}]}], ")"}]}], "+", 
         RowBox[{"2", " ", "a0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"32384", " ", 
             SuperscriptBox["a0", "6"], " ", "h2"}], "+", 
            RowBox[{"372148", " ", 
             SuperscriptBox["a0", "4"], " ", "a1", " ", "p2"}], "+", 
            RowBox[{"44", " ", 
             SuperscriptBox["a0", "2"], " ", "h2", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "40939"}], " ", 
                SuperscriptBox["a1", "2"]}], "+", 
               RowBox[{"57354", " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["h2", "2"], "+", 
                  SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "+", 
            RowBox[{"a1", " ", "p2", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "1957536"}], " ", 
                SuperscriptBox["a1", "2"]}], "+", 
               RowBox[{"3601319", " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["h2", "2"], "+", 
                  SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}]}], ")"}], 
          " ", "T3"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "6405487"}], " ", 
             SuperscriptBox["a0", "2"], " ", "a1", " ", "h2"}], "+", 
            RowBox[{"1911860", " ", 
             SuperscriptBox["a0", "4"], " ", "p2"}], "+", 
            RowBox[{"4", " ", "p2", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "739971"}], " ", 
                SuperscriptBox["a1", "2"]}], "+", 
               RowBox[{"683452", " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["h2", "2"], "+", 
                  SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}]}], ")"}], 
          " ", 
          SuperscriptBox["T3", "2"]}], "-", 
         RowBox[{"3376120", " ", "a0", " ", "h2", " ", 
          SuperscriptBox["T3", "3"]}]}], ")"}], " ", 
       SuperscriptBox["z", "12"]}]}], "//.", "replasym"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"asymh", "[", "z_", "]"}], ":=", 
    RowBox[{
     RowBox[{
      RowBox[{"h2", " ", 
       SuperscriptBox["z", "2"]}], "-", 
      RowBox[{"a0", " ", "p2", " ", 
       SuperscriptBox["z", "3"]}], "+", 
      RowBox[{
       FractionBox["1", "6"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "4"}], " ", 
          SuperscriptBox["a0", "2"], " ", "h2"}], "-", 
         RowBox[{"3", " ", "a1", " ", "p2"}]}], ")"}], " ", 
       SuperscriptBox["z", "4"]}], "+", 
      RowBox[{
       FractionBox["1", "3"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "2"}], " ", "a0", " ", "a1", " ", "h2"}], "+", 
         RowBox[{
          SuperscriptBox["a0", "3"], " ", "p2"}], "-", 
         RowBox[{"h2", " ", "T3"}]}], ")"}], " ", 
       SuperscriptBox["z", "5"]}], "+", 
      RowBox[{
       FractionBox["1", "60"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"8", " ", 
          SuperscriptBox["a0", "4"], " ", "h2"}], "-", 
         RowBox[{"15", " ", 
          SuperscriptBox["a1", "2"], " ", "h2"}], "+", 
         RowBox[{"30", " ", 
          SuperscriptBox["a0", "2"], " ", "a1", " ", "p2"}], "+", 
         RowBox[{"14", " ", "h2", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["h2", "2"], "+", 
            SuperscriptBox["p2", "2"]}], ")"}]}], "+", 
         RowBox[{"35", " ", "a0", " ", "p2", " ", "T3"}]}], ")"}], " ", 
       SuperscriptBox["z", "6"]}], "+", 
      RowBox[{
       FractionBox["1", "180"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"48", " ", 
          SuperscriptBox["a0", "3"], " ", "a1", " ", "h2"}], "-", 
         RowBox[{"8", " ", 
          SuperscriptBox["a0", "5"], " ", "p2"}], "+", 
         RowBox[{"a0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"69", " ", 
             SuperscriptBox["a1", "2"], " ", "p2"}], "-", 
            RowBox[{"60", " ", "p2", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["h2", "2"], "+", 
               SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "+", 
         RowBox[{"99", " ", 
          SuperscriptBox["a0", "2"], " ", "h2", " ", "T3"}], "+", 
         RowBox[{"66", " ", "a1", " ", "p2", " ", "T3"}]}], ")"}], " ", 
       SuperscriptBox["z", "7"]}], "+", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "32"}], " ", 
           SuperscriptBox["a0", "6"], " ", "h2"}], "-", 
          RowBox[{"280", " ", 
           SuperscriptBox["a0", "4"], " ", "a1", " ", "p2"}], "+", 
          RowBox[{"63", " ", "a1", " ", "p2", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"5", " ", 
              SuperscriptBox["a1", "2"]}], "-", 
             RowBox[{"8", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["h2", "2"], "+", 
                SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "+", 
          RowBox[{
           SuperscriptBox["a0", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"806", " ", 
              SuperscriptBox["a1", "2"], " ", "h2"}], "-", 
             RowBox[{"860", " ", "h2", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["h2", "2"], "+", 
                SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "+", 
          RowBox[{"1649", " ", "a0", " ", "a1", " ", "h2", " ", "T3"}], "-", 
          RowBox[{"896", " ", 
           SuperscriptBox["a0", "3"], " ", "p2", " ", "T3"}], "+", 
          RowBox[{"500", " ", "h2", " ", 
           SuperscriptBox["T3", "2"]}]}], ")"}], " ", 
        SuperscriptBox["z", "8"]}], "2520"], "+", 
      RowBox[{
       FractionBox["1", "1260"], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "48"}], " ", 
          SuperscriptBox["a0", "5"], " ", "a1", " ", "h2"}], "+", 
         RowBox[{"4", " ", 
          SuperscriptBox["a0", "7"], " ", "p2"}], "+", 
         RowBox[{"8", " ", "a0", " ", "a1", " ", "h2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"33", " ", 
             SuperscriptBox["a1", "2"]}], "-", 
            RowBox[{"61", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["h2", "2"], "+", 
               SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "+", 
         RowBox[{
          SuperscriptBox["a0", "3"], " ", "p2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "235"}], " ", 
             SuperscriptBox["a1", "2"]}], "+", 
            RowBox[{"324", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["h2", "2"], "+", 
               SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "-", 
         RowBox[{"2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"110", " ", 
             SuperscriptBox["a0", "4"], " ", "h2"}], "-", 
            RowBox[{"183", " ", 
             SuperscriptBox["a1", "2"], " ", "h2"}], "+", 
            RowBox[{"386", " ", 
             SuperscriptBox["a0", "2"], " ", "a1", " ", "p2"}], "+", 
            RowBox[{"167", " ", "h2", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["h2", "2"], "+", 
               SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}], " ", "T3"}], 
         "-", 
         RowBox[{"535", " ", "a0", " ", "p2", " ", 
          SuperscriptBox["T3", "2"]}]}], ")"}], " ", 
       SuperscriptBox["z", "9"]}], "+", 
      RowBox[{
       FractionBox["1", "90720"], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"64", " ", 
          SuperscriptBox["a0", "8"], " ", "h2"}], "+", 
         RowBox[{"1008", " ", 
          SuperscriptBox["a0", "6"], " ", "a1", " ", "p2"}], "+", 
         RowBox[{"36", " ", 
          SuperscriptBox["a0", "2"], " ", "a1", " ", "p2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "469"}], " ", 
             SuperscriptBox["a1", "2"]}], "+", 
            RowBox[{"1093", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["h2", "2"], "+", 
               SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "+", 
         RowBox[{"4", " ", 
          SuperscriptBox["a0", "4"], " ", "h2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "1906"}], " ", 
             SuperscriptBox["a1", "2"]}], "+", 
            RowBox[{"3641", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["h2", "2"], "+", 
               SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "+", 
         RowBox[{"54", " ", "h2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"105", " ", 
             SuperscriptBox["a1", "4"]}], "-", 
            RowBox[{"298", " ", 
             SuperscriptBox["a1", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["h2", "2"], "+", 
               SuperscriptBox["p2", "2"]}], ")"}]}], "+", 
            RowBox[{"162", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["h2", "2"], "+", 
                SuperscriptBox["p2", "2"]}], ")"}], "2"]}]}], ")"}]}], "+", 
         RowBox[{"2", " ", "a0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "17768"}], " ", 
             SuperscriptBox["a0", "2"], " ", "a1", " ", "h2"}], "+", 
            RowBox[{"3132", " ", 
             SuperscriptBox["a0", "4"], " ", "p2"}], "+", 
            RowBox[{"9", " ", "p2", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "2756"}], " ", 
                SuperscriptBox["a1", "2"]}], "+", 
               RowBox[{"2443", " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["h2", "2"], "+", 
                  SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}]}], ")"}], 
          " ", "T3"}], "-", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"42517", " ", 
             SuperscriptBox["a0", "2"], " ", "h2"}], "+", 
            RowBox[{"26388", " ", "a1", " ", "p2"}]}], ")"}], " ", 
          SuperscriptBox["T3", "2"]}]}], ")"}], " ", 
       SuperscriptBox["z", "10"]}], "+", 
      RowBox[{
       FractionBox["1", "453600"], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "a0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"640", " ", 
             SuperscriptBox["a0", "6"], " ", "a1", " ", "h2"}], "-", 
            RowBox[{"32", " ", 
             SuperscriptBox["a0", "8"], " ", "p2"}], "+", 
            RowBox[{"38", " ", 
             SuperscriptBox["a0", "2"], " ", "a1", " ", "h2", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "680"}], " ", 
                SuperscriptBox["a1", "2"]}], "+", 
               RowBox[{"2129", " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["h2", "2"], "+", 
                  SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a0", "4"], " ", "p2", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "3506"}], " ", 
                SuperscriptBox["a1", "2"]}], "+", 
               RowBox[{"9625", " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["h2", "2"], "+", 
                  SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "-", 
            RowBox[{"3", " ", "p2", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"8445", " ", 
                SuperscriptBox["a1", "4"]}], "-", 
               RowBox[{"27322", " ", 
                SuperscriptBox["a1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["h2", "2"], "+", 
                  SuperscriptBox["p2", "2"]}], ")"}]}], "+", 
               RowBox[{"11384", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["h2", "2"], "+", 
                   SuperscriptBox["p2", "2"]}], ")"}], "2"]}]}], ")"}]}]}], 
           ")"}]}], "+", 
         RowBox[{"2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"5180", " ", 
             SuperscriptBox["a0", "6"], " ", "h2"}], "+", 
            RowBox[{"43168", " ", 
             SuperscriptBox["a0", "4"], " ", "a1", " ", "p2"}], "+", 
            RowBox[{"12", " ", "a1", " ", "p2", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "3795"}], " ", 
                SuperscriptBox["a1", "2"]}], "+", 
               RowBox[{"6062", " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["h2", "2"], "+", 
                  SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "+", 
            RowBox[{
             SuperscriptBox["a0", "2"], " ", "h2", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "122040"}], " ", 
                SuperscriptBox["a1", "2"]}], "+", 
               RowBox[{"132161", " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["h2", "2"], "+", 
                  SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}]}], ")"}], 
          " ", "T3"}], "+", 
         RowBox[{"5", " ", "a0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "54768"}], " ", "a1", " ", "h2"}], "+", 
            RowBox[{"31441", " ", 
             SuperscriptBox["a0", "2"], " ", "p2"}]}], ")"}], " ", 
          SuperscriptBox["T3", "2"]}], "-", 
         RowBox[{"64000", " ", "h2", " ", 
          SuperscriptBox["T3", "3"]}]}], ")"}], " ", 
       SuperscriptBox["z", "11"]}], "+", 
      RowBox[{
       FractionBox["1", "9979200"], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "256"}], " ", 
          SuperscriptBox["a0", "10"], " ", "h2"}], "-", 
         RowBox[{"6336", " ", 
          SuperscriptBox["a0", "8"], " ", "a1", " ", "p2"}], "+", 
         RowBox[{"44", " ", 
          SuperscriptBox["a0", "4"], " ", "a1", " ", "p2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"12114", " ", 
             SuperscriptBox["a1", "2"]}], "-", 
            RowBox[{"52981", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["h2", "2"], "+", 
               SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "-", 
         RowBox[{"198", " ", "a1", " ", "p2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"105", " ", 
             SuperscriptBox["a1", "2"]}], "-", 
            RowBox[{"302", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["h2", "2"], "+", 
               SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"15", " ", 
             SuperscriptBox["a1", "2"]}], "-", 
            RowBox[{"16", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["h2", "2"], "+", 
               SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "-", 
         RowBox[{"16", " ", 
          SuperscriptBox["a0", "6"], " ", "h2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "5999"}], " ", 
             SuperscriptBox["a1", "2"]}], "+", 
            RowBox[{"24481", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["h2", "2"], "+", 
               SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "-", 
         RowBox[{"4", " ", 
          SuperscriptBox["a0", "2"], " ", "h2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"261441", " ", 
             SuperscriptBox["a1", "4"]}], "-", 
            RowBox[{"1083379", " ", 
             SuperscriptBox["a1", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["h2", "2"], "+", 
               SuperscriptBox["p2", "2"]}], ")"}]}], "+", 
            RowBox[{"493120", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["h2", "2"], "+", 
                SuperscriptBox["p2", "2"]}], ")"}], "2"]}]}], ")"}]}], "+", 
         RowBox[{"2", " ", "a0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"372148", " ", 
             SuperscriptBox["a0", "4"], " ", "a1", " ", "h2"}], "-", 
            RowBox[{"32384", " ", 
             SuperscriptBox["a0", "6"], " ", "p2"}], "-", 
            RowBox[{"44", " ", 
             SuperscriptBox["a0", "2"], " ", "p2", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "40939"}], " ", 
                SuperscriptBox["a1", "2"]}], "+", 
               RowBox[{"57354", " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["h2", "2"], "+", 
                  SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "+", 
            RowBox[{"a1", " ", "h2", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "1957536"}], " ", 
                SuperscriptBox["a1", "2"]}], "+", 
               RowBox[{"3601319", " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["h2", "2"], "+", 
                  SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}]}], ")"}], 
          " ", "T3"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"1911860", " ", 
             SuperscriptBox["a0", "4"], " ", "h2"}], "+", 
            RowBox[{"6405487", " ", 
             SuperscriptBox["a0", "2"], " ", "a1", " ", "p2"}], "+", 
            RowBox[{"4", " ", "h2", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "739971"}], " ", 
                SuperscriptBox["a1", "2"]}], "+", 
               RowBox[{"683452", " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["h2", "2"], "+", 
                  SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}]}], ")"}], 
          " ", 
          SuperscriptBox["T3", "2"]}], "+", 
         RowBox[{"3376120", " ", "a0", " ", "p2", " ", 
          SuperscriptBox["T3", "3"]}]}], ")"}], " ", 
       SuperscriptBox["z", "12"]}]}], "//.", "replasym"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"asyma", "[", "z_", "]"}], ":=", 
    RowBox[{
     RowBox[{"a0", "+", 
      RowBox[{"a1", " ", "z"}], "+", 
      RowBox[{
       FractionBox["1", "6"], " ", "a0", " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["h2", "2"], "+", 
         SuperscriptBox["p2", "2"]}], ")"}], " ", 
       SuperscriptBox["z", "4"]}], "+", 
      RowBox[{
       FractionBox["1", "6"], " ", "a1", " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["h2", "2"], "+", 
         SuperscriptBox["p2", "2"]}], ")"}], " ", 
       SuperscriptBox["z", "5"]}], "-", 
      RowBox[{
       FractionBox["1", "45"], " ", 
       SuperscriptBox["a0", "3"], " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["h2", "2"], "+", 
         SuperscriptBox["p2", "2"]}], ")"}], " ", 
       SuperscriptBox["z", "6"]}], "-", 
      RowBox[{
       FractionBox["5", "126"], " ", "a0", " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["h2", "2"], "+", 
         SuperscriptBox["p2", "2"]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"a0", " ", "a1"}], "+", 
         RowBox[{"2", " ", "T3"}]}], ")"}], " ", 
       SuperscriptBox["z", "7"]}], "+", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["h2", "2"], "+", 
          SuperscriptBox["p2", "2"]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"4", " ", 
           SuperscriptBox["a0", "5"]}], "+", 
          RowBox[{"a0", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "85"}], " ", 
              SuperscriptBox["a1", "2"]}], "+", 
             RowBox[{"127", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["h2", "2"], "+", 
                SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "-", 
          RowBox[{"200", " ", "a1", " ", "T3"}]}], ")"}], " ", 
        SuperscriptBox["z", "8"]}], "2520"], "+", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["h2", "2"], "+", 
          SuperscriptBox["p2", "2"]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"98", " ", 
           SuperscriptBox["a0", "4"], " ", "a1"}], "+", 
          RowBox[{"9", " ", "a1", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "45"}], " ", 
              SuperscriptBox["a1", "2"]}], "+", 
             RowBox[{"139", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["h2", "2"], "+", 
                SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "+", 
          RowBox[{"448", " ", 
           SuperscriptBox["a0", "3"], " ", "T3"}]}], ")"}], " ", 
        SuperscriptBox["z", "9"]}], "22680"], "-", 
      FractionBox[
       RowBox[{"a0", " ", 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["h2", "2"], "+", 
          SuperscriptBox["p2", "2"]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"8", " ", 
           SuperscriptBox["a0", "6"]}], "+", 
          RowBox[{
           SuperscriptBox["a0", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "905"}], " ", 
              SuperscriptBox["a1", "2"]}], "+", 
             RowBox[{"2224", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["h2", "2"], "+", 
                SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "-", 
          RowBox[{"4250", " ", "a0", " ", "a1", " ", "T3"}], "-", 
          RowBox[{"5480", " ", 
           SuperscriptBox["T3", "2"]}]}], ")"}], " ", 
        SuperscriptBox["z", "10"]}], "113400"], "-", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["h2", "2"], "+", 
          SuperscriptBox["p2", "2"]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           SuperscriptBox["a0", "2"], " ", "a1", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"162", " ", 
              SuperscriptBox["a0", "4"]}], "-", 
             RowBox[{"5735", " ", 
              SuperscriptBox["a1", "2"]}], "+", 
             RowBox[{"23903", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["h2", "2"], "+", 
                SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "+", 
          RowBox[{"a0", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"1314", " ", 
              SuperscriptBox["a0", "4"]}], "-", 
             RowBox[{"25115", " ", 
              SuperscriptBox["a1", "2"]}], "+", 
             RowBox[{"36858", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["h2", "2"], "+", 
                SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}], " ", "T3"}], 
          "-", 
          RowBox[{"30410", " ", "a1", " ", 
           SuperscriptBox["T3", "2"]}]}], ")"}], " ", 
        SuperscriptBox["z", "11"]}], "623700"], "+", 
      RowBox[{
       FractionBox["1", "14968800"], 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["h2", "2"], "+", 
         SuperscriptBox["p2", "2"]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"32", " ", 
          SuperscriptBox["a0", "9"]}], "+", 
         RowBox[{
          SuperscriptBox["a0", "5"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "11756"}], " ", 
             SuperscriptBox["a1", "2"]}], "+", 
            RowBox[{"58132", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["h2", "2"], "+", 
               SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "+", 
         RowBox[{"9", " ", "a0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"10845", " ", 
             SuperscriptBox["a1", "4"]}], "-", 
            RowBox[{"55822", " ", 
             SuperscriptBox["a1", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["h2", "2"], "+", 
               SuperscriptBox["p2", "2"]}], ")"}]}], "+", 
            RowBox[{"33662", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["h2", "2"], "+", 
                SuperscriptBox["p2", "2"]}], ")"}], "2"]}]}], ")"}]}], "-", 
         RowBox[{"90872", " ", 
          SuperscriptBox["a0", "4"], " ", "a1", " ", "T3"}], "+", 
         RowBox[{"72", " ", "a1", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4905", " ", 
             SuperscriptBox["a1", "2"]}], "-", 
            RowBox[{"13168", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["h2", "2"], "+", 
               SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}], " ", "T3"}], 
         "-", 
         RowBox[{"247250", " ", 
          SuperscriptBox["a0", "3"], " ", 
          SuperscriptBox["T3", "2"]}]}], ")"}], " ", 
       SuperscriptBox["z", "12"]}]}], "//.", "replasym"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"asymT", "[", "z_", "]"}], ":=", 
    RowBox[{
     RowBox[{"1", "+", 
      RowBox[{"T3", " ", 
       SuperscriptBox["z", "3"]}], "+", 
      RowBox[{
       FractionBox["1", "12"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"3", " ", 
          SuperscriptBox["a1", "2"]}], "-", 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["h2", "2"], "+", 
            SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}], " ", 
       SuperscriptBox["z", "4"]}], "+", 
      RowBox[{
       FractionBox["1", "6"], " ", 
       SuperscriptBox["a0", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["h2", "2"], "+", 
         SuperscriptBox["p2", "2"]}], ")"}], " ", 
       SuperscriptBox["z", "6"]}], "+", 
      RowBox[{
       FractionBox["1", "9"], " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["h2", "2"], "+", 
         SuperscriptBox["p2", "2"]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "a0", " ", "a1"}], "+", "T3"}], ")"}], " ", 
       SuperscriptBox["z", "7"]}], "-", 
      RowBox[{
       FractionBox["1", "630"], " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["h2", "2"], "+", 
         SuperscriptBox["p2", "2"]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"14", " ", 
          SuperscriptBox["a0", "4"]}], "-", 
         RowBox[{"75", " ", 
          SuperscriptBox["a1", "2"]}], "+", 
         RowBox[{"38", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["h2", "2"], "+", 
            SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}], " ", 
       SuperscriptBox["z", "8"]}], "-", 
      RowBox[{
       FractionBox["1", "180"], " ", 
       SuperscriptBox["a0", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["h2", "2"], "+", 
         SuperscriptBox["p2", "2"]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"9", " ", "a0", " ", "a1"}], "+", 
         RowBox[{"16", " ", "T3"}]}], ")"}], " ", 
       SuperscriptBox["z", "9"]}], "+", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["h2", "2"], "+", 
          SuperscriptBox["p2", "2"]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"36", " ", 
           SuperscriptBox["a0", "6"]}], "+", 
          RowBox[{
           SuperscriptBox["a0", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "1385"}], " ", 
              SuperscriptBox["a1", "2"]}], "+", 
             RowBox[{"1628", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["h2", "2"], "+", 
                SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "-", 
          RowBox[{"2900", " ", "a0", " ", "a1", " ", "T3"}], "-", 
          RowBox[{"860", " ", 
           SuperscriptBox["T3", "2"]}]}], ")"}], " ", 
        SuperscriptBox["z", "10"]}], "22680"], "+", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["h2", "2"], "+", 
          SuperscriptBox["p2", "2"]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"4", " ", "a0", " ", "a1", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"24", " ", 
              SuperscriptBox["a0", "4"]}], "-", 
             RowBox[{"195", " ", 
              SuperscriptBox["a1", "2"]}], "+", 
             RowBox[{"482", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["h2", "2"], "+", 
                SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"387", " ", 
              SuperscriptBox["a0", "4"]}], "-", 
             RowBox[{"1335", " ", 
              SuperscriptBox["a1", "2"]}], "+", 
             RowBox[{"1096", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["h2", "2"], "+", 
                SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}], " ", "T3"}]}], 
         ")"}], " ", 
        SuperscriptBox["z", "11"]}], "18900"], "-", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["h2", "2"], "+", 
          SuperscriptBox["p2", "2"]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"88", " ", 
           SuperscriptBox["a0", "8"]}], "+", 
          RowBox[{"3", " ", 
           SuperscriptBox["a0", "4"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "4485"}], " ", 
              SuperscriptBox["a1", "2"]}], "+", 
             RowBox[{"9886", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["h2", "2"], "+", 
                SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "+", 
          RowBox[{"9", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2025", " ", 
              SuperscriptBox["a1", "4"]}], "-", 
             RowBox[{"7905", " ", 
              SuperscriptBox["a1", "2"], " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["h2", "2"], "+", 
                SuperscriptBox["p2", "2"]}], ")"}]}], "+", 
             RowBox[{"2908", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["h2", "2"], "+", 
                 SuperscriptBox["p2", "2"]}], ")"}], "2"]}]}], ")"}]}], "-", 
          RowBox[{"63515", " ", 
           SuperscriptBox["a0", "3"], " ", "a1", " ", "T3"}], "-", 
          RowBox[{"67735", " ", 
           SuperscriptBox["a0", "2"], " ", 
           SuperscriptBox["T3", "2"]}]}], ")"}], " ", 
        SuperscriptBox["z", "12"]}], "1247400"]}], "//.", "replasym"}]}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"asymS", "[", "z_", "]"}], ":=", 
   RowBox[{
    RowBox[{"1", "+", 
     RowBox[{
      FractionBox["1", "6"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         SuperscriptBox["h2", "2"]}], "-", 
        SuperscriptBox["p2", "2"]}], ")"}], " ", 
      SuperscriptBox["z", "4"]}], "+", 
     RowBox[{
      FractionBox["1", "36"], " ", 
      SuperscriptBox["a0", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["h2", "2"], "+", 
        SuperscriptBox["p2", "2"]}], ")"}], " ", 
      SuperscriptBox["z", "6"]}], "+", 
     RowBox[{
      FractionBox["1", "63"], " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["h2", "2"], "+", 
        SuperscriptBox["p2", "2"]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"a0", " ", "a1"}], "+", 
        RowBox[{"5", " ", "T3"}]}], ")"}], " ", 
      SuperscriptBox["z", "7"]}], "-", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["h2", "2"], "+", 
         SuperscriptBox["p2", "2"]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"7", " ", 
          SuperscriptBox["a0", "4"]}], "-", 
         RowBox[{"45", " ", 
          SuperscriptBox["a1", "2"]}], "+", 
         RowBox[{"111", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["h2", "2"], "+", 
            SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}], " ", 
       SuperscriptBox["z", "8"]}], "2520"], "-", 
     FractionBox[
      RowBox[{
       SuperscriptBox["a0", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["h2", "2"], "+", 
         SuperscriptBox["p2", "2"]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"13", " ", "a0", " ", "a1"}], "+", 
         RowBox[{"74", " ", "T3"}]}], ")"}], " ", 
       SuperscriptBox["z", "9"]}], "3240"], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["h2", "2"], "+", 
         SuperscriptBox["p2", "2"]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"18", " ", 
          SuperscriptBox["a0", "6"]}], "+", 
         RowBox[{
          SuperscriptBox["a0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "785"}], " ", 
             SuperscriptBox["a1", "2"]}], "+", 
            RowBox[{"2519", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["h2", "2"], "+", 
               SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "-", 
         RowBox[{"1670", " ", "a0", " ", "a1", " ", "T3"}], "-", 
         RowBox[{"5750", " ", 
          SuperscriptBox["T3", "2"]}]}], ")"}], " ", 
       SuperscriptBox["z", "10"]}], "113400"], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["h2", "2"], "+", 
         SuperscriptBox["p2", "2"]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"a0", " ", "a1", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"26", " ", 
             SuperscriptBox["a0", "4"]}], "+", 
            RowBox[{"3", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "85"}], " ", 
                SuperscriptBox["a1", "2"]}], "+", 
               RowBox[{"426", " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["h2", "2"], "+", 
                  SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}]}], ")"}]}], 
         "+", 
         RowBox[{"3", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"79", " ", 
             SuperscriptBox["a0", "4"]}], "-", 
            RowBox[{"545", " ", 
             SuperscriptBox["a1", "2"]}], "+", 
            RowBox[{"1342", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["h2", "2"], "+", 
               SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}], " ", "T3"}]}], 
        ")"}], " ", 
       SuperscriptBox["z", "11"]}], "69300"], "-", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["h2", "2"], "+", 
         SuperscriptBox["p2", "2"]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"88", " ", 
          SuperscriptBox["a0", "8"]}], "+", 
         RowBox[{
          SuperscriptBox["a0", "4"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "15940"}], " ", 
             SuperscriptBox["a1", "2"]}], "+", 
            RowBox[{"82193", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["h2", "2"], "+", 
               SuperscriptBox["p2", "2"]}], ")"}]}]}], ")"}]}], "+", 
         RowBox[{"27", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"1575", " ", 
             SuperscriptBox["a1", "4"]}], "-", 
            RowBox[{"9430", " ", 
             SuperscriptBox["a1", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["h2", "2"], "+", 
               SuperscriptBox["p2", "2"]}], ")"}]}], "+", 
            RowBox[{"9886", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["h2", "2"], "+", 
                SuperscriptBox["p2", "2"]}], ")"}], "2"]}]}], ")"}]}], "-", 
         RowBox[{"82660", " ", 
          SuperscriptBox["a0", "3"], " ", "a1", " ", "T3"}], "-", 
         RowBox[{"275950", " ", 
          SuperscriptBox["a0", "2"], " ", 
          SuperscriptBox["T3", "2"]}]}], ")"}], " ", 
       SuperscriptBox["z", "12"]}], "14968800"]}], "//.", "replasym"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.537640798221807*^9, 3.5376408063887777`*^9}, {
  3.538462913984427*^9, 3.53846295871097*^9}, {3.538463135071212*^9, 
  3.538463146908863*^9}, {3.538464374794805*^9, 3.538464392634185*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"eqlist", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       SuperscriptBox["p", "\[Prime]\[Prime]",
        MultilineFunction->None], "[", "z", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", 
           SuperscriptBox["z", "2"], " ", 
           SuperscriptBox[
            RowBox[{"a", "[", "z", "]"}], "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"h", "[", "z", "]"}], "2"], "+", 
             SuperscriptBox[
              RowBox[{"p", "[", "z", "]"}], "2"]}], ")"}], " ", 
           RowBox[{"S", "[", "z", "]"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"z", " ", 
              SuperscriptBox[
               RowBox[{"h", "[", "z", "]"}], "2"], " ", 
              RowBox[{"S", "[", "z", "]"}], " ", 
              RowBox[{
               SuperscriptBox["p", "\[Prime]",
                MultilineFunction->None], "[", "z", "]"}]}], "+", 
             RowBox[{"z", " ", 
              SuperscriptBox[
               RowBox[{"p", "[", "z", "]"}], "2"], " ", 
              RowBox[{"S", "[", "z", "]"}], " ", 
              RowBox[{
               SuperscriptBox["p", "\[Prime]",
                MultilineFunction->None], "[", "z", "]"}]}], "-", 
             RowBox[{"4", " ", 
              RowBox[{"p", "[", "z", "]"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"S", "[", "z", "]"}], "-", 
                RowBox[{"z", " ", 
                 RowBox[{
                  SuperscriptBox["S", "\[Prime]",
                   MultilineFunction->None], "[", "z", "]"}]}]}], ")"}]}]}], 
            ")"}]}], "-", 
          RowBox[{"4", " ", "z", " ", 
           RowBox[{"a", "[", "z", "]"}], " ", 
           RowBox[{"h", "[", "z", "]"}], " ", 
           RowBox[{"T", "[", "z", "]"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              SuperscriptBox["z", "2"], " ", 
              SuperscriptBox[
               RowBox[{"h", "[", "z", "]"}], "2"], " ", 
              SuperscriptBox[
               RowBox[{"S", "[", "z", "]"}], "2"], " ", 
              SuperscriptBox[
               RowBox[{
                SuperscriptBox["p", "\[Prime]",
                 MultilineFunction->None], "[", "z", "]"}], "2"]}], "+", 
             RowBox[{"2", " ", "z", " ", 
              RowBox[{"p", "[", "z", "]"}], " ", 
              RowBox[{"S", "[", "z", "]"}], " ", 
              RowBox[{
               SuperscriptBox["p", "\[Prime]",
                MultilineFunction->None], "[", "z", "]"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 RowBox[{"S", "[", "z", "]"}]}], "+", 
                RowBox[{"z", " ", 
                 RowBox[{
                  SuperscriptBox["S", "\[Prime]",
                   MultilineFunction->None], "[", "z", "]"}]}]}], ")"}]}], 
             "+", 
             RowBox[{
              SuperscriptBox[
               RowBox[{"p", "[", "z", "]"}], "2"], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"S", "[", "z", "]"}], "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"2", "+", 
                   RowBox[{
                    SuperscriptBox["z", "2"], " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox["p", "\[Prime]",
                    MultilineFunction->None], "[", "z", "]"}], "2"]}]}], 
                  ")"}]}], "-", 
                RowBox[{"4", " ", "z", " ", 
                 RowBox[{"S", "[", "z", "]"}], " ", 
                 RowBox[{
                  SuperscriptBox["S", "\[Prime]",
                   MultilineFunction->None], "[", "z", "]"}]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["z", "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                   SuperscriptBox["S", "\[Prime]",
                    MultilineFunction->None], "[", "z", "]"}], "2"]}]}], 
               ")"}]}]}], ")"}]}], "+", 
          RowBox[{
           RowBox[{"T", "[", "z", "]"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"4", " ", "z", " ", 
              SuperscriptBox[
               RowBox[{"p", "[", "z", "]"}], "4"], " ", 
              SuperscriptBox[
               RowBox[{"S", "[", "z", "]"}], "2"], " ", 
              RowBox[{
               SuperscriptBox["p", "\[Prime]",
                MultilineFunction->None], "[", "z", "]"}]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["z", "3"], " ", 
              SuperscriptBox[
               RowBox[{"h", "[", "z", "]"}], "2"], " ", 
              SuperscriptBox[
               RowBox[{"S", "[", "z", "]"}], "2"], " ", 
              RowBox[{"T", "[", "z", "]"}], " ", 
              SuperscriptBox[
               RowBox[{
                SuperscriptBox["p", "\[Prime]",
                 MultilineFunction->None], "[", "z", "]"}], "3"]}], "-", 
             RowBox[{"8", " ", 
              SuperscriptBox[
               RowBox[{"p", "[", "z", "]"}], "3"], " ", 
              RowBox[{"S", "[", "z", "]"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"S", "[", "z", "]"}], "-", 
                RowBox[{"z", " ", 
                 RowBox[{
                  SuperscriptBox["S", "\[Prime]",
                   MultilineFunction->None], "[", "z", "]"}]}]}], ")"}]}], 
             "+", 
             RowBox[{"z", " ", 
              SuperscriptBox[
               RowBox[{"p", "[", "z", "]"}], "2"], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"4", " ", 
                 SuperscriptBox[
                  RowBox[{"h", "[", "z", "]"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{"S", "[", "z", "]"}], "2"], " ", 
                 RowBox[{
                  SuperscriptBox["p", "\[Prime]",
                   MultilineFunction->None], "[", "z", "]"}]}], "+", 
                RowBox[{"4", " ", "z", " ", 
                 RowBox[{"h", "[", "z", "]"}], " ", 
                 RowBox[{"S", "[", "z", "]"}], " ", 
                 RowBox[{
                  SuperscriptBox["a", "\[Prime]",
                   MultilineFunction->None], "[", "z", "]"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"S", "[", "z", "]"}], "-", 
                   RowBox[{"z", " ", 
                    RowBox[{
                    SuperscriptBox["S", "\[Prime]",
                    MultilineFunction->None], "[", "z", "]"}]}]}], ")"}]}], 
                "+", 
                RowBox[{
                 RowBox[{
                  SuperscriptBox["p", "\[Prime]",
                   MultilineFunction->None], "[", "z", "]"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{"S", "[", "z", "]"}], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{"12", "-", 
                    RowBox[{
                    SuperscriptBox["z", "4"], " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox["a", "\[Prime]",
                    MultilineFunction->None], "[", "z", "]"}], "2"]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{"T", "[", "z", "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "2"}], "+", 
                    RowBox[{
                    SuperscriptBox["z", "2"], " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox["p", "\[Prime]",
                    MultilineFunction->None], "[", "z", "]"}], "2"]}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                   RowBox[{"4", " ", 
                    SuperscriptBox["z", "2"], " ", 
                    RowBox[{"T", "[", "z", "]"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox["S", "\[Prime]",
                    MultilineFunction->None], "[", "z", "]"}], "2"]}]}], 
                  ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}], "/", 
       RowBox[{"(", 
        RowBox[{"4", " ", 
         SuperscriptBox["z", "2"], " ", 
         SuperscriptBox[
          RowBox[{"p", "[", "z", "]"}], "2"], " ", 
         RowBox[{"S", "[", "z", "]"}], " ", 
         SuperscriptBox[
          RowBox[{"T", "[", "z", "]"}], "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"S", "[", "z", "]"}]}], "+", 
           RowBox[{"z", " ", 
            RowBox[{
             SuperscriptBox["S", "\[Prime]",
              MultilineFunction->None], "[", "z", "]"}]}]}], ")"}]}], 
        ")"}]}]}], ",", 
     RowBox[{
      RowBox[{
       SuperscriptBox["a", "\[Prime]\[Prime]",
        MultilineFunction->None], "[", "z", "]"}], "\[Equal]", 
      FractionBox[
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"a", "[", "z", "]"}], " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"h", "[", "z", "]"}], "2"], "+", 
             SuperscriptBox[
              RowBox[{"p", "[", "z", "]"}], "2"]}], ")"}], " ", 
           RowBox[{"S", "[", "z", "]"}]}], "-", 
          RowBox[{
           SuperscriptBox["z", "2"], " ", 
           RowBox[{"T", "[", "z", "]"}], " ", 
           RowBox[{
            SuperscriptBox["a", "\[Prime]",
             MultilineFunction->None], "[", "z", "]"}], " ", 
           RowBox[{
            SuperscriptBox["S", "\[Prime]",
             MultilineFunction->None], "[", "z", "]"}]}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox["z", "2"], " ", 
        RowBox[{"S", "[", "z", "]"}], " ", 
        RowBox[{"T", "[", "z", "]"}]}]]}], ",", 
     RowBox[{
      RowBox[{
       SuperscriptBox["S", "\[Prime]\[Prime]",
        MultilineFunction->None], "[", "z", "]"}], "\[Equal]", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox[
            RowBox[{"h", "[", "z", "]"}], "2"], "+", 
           SuperscriptBox[
            RowBox[{"p", "[", "z", "]"}], "2"]}], ")"}], " ", 
         RowBox[{"S", "[", "z", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            SuperscriptBox[
             RowBox[{"a", "[", "z", "]"}], "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox[
               RowBox[{"h", "[", "z", "]"}], "2"], "+", 
              SuperscriptBox[
               RowBox[{"p", "[", "z", "]"}], "2"]}], ")"}]}], "-", 
           RowBox[{"2", " ", 
            RowBox[{"a", "[", "z", "]"}], " ", 
            RowBox[{"h", "[", "z", "]"}], " ", 
            RowBox[{"T", "[", "z", "]"}], " ", 
            RowBox[{
             SuperscriptBox["p", "\[Prime]",
              MultilineFunction->None], "[", "z", "]"}]}], "+", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"T", "[", "z", "]"}], "2"], " ", 
            SuperscriptBox[
             RowBox[{
              SuperscriptBox["p", "\[Prime]",
               MultilineFunction->None], "[", "z", "]"}], "2"]}]}], ")"}]}], 
        RowBox[{"2", " ", 
         SuperscriptBox[
          RowBox[{"p", "[", "z", "]"}], "2"], " ", 
         SuperscriptBox[
          RowBox[{"T", "[", "z", "]"}], "2"]}]]}]}], ",", 
     RowBox[{
      RowBox[{
       SuperscriptBox["T", "\[Prime]",
        MultilineFunction->None], "[", "z", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", 
          SuperscriptBox["z", "2"], " ", 
          SuperscriptBox[
           RowBox[{"a", "[", "z", "]"}], "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"h", "[", "z", "]"}], "2"], "+", 
             SuperscriptBox[
              RowBox[{"p", "[", "z", "]"}], "2"]}], ")"}], "2"], " ", 
          SuperscriptBox[
           RowBox[{"S", "[", "z", "]"}], "2"]}], "-", 
         RowBox[{"4", " ", 
          SuperscriptBox["z", "2"], " ", 
          RowBox[{"a", "[", "z", "]"}], " ", 
          RowBox[{"h", "[", "z", "]"}], " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"h", "[", "z", "]"}], "2"], "+", 
            SuperscriptBox[
             RowBox[{"p", "[", "z", "]"}], "2"]}], ")"}], " ", 
          SuperscriptBox[
           RowBox[{"S", "[", "z", "]"}], "2"], " ", 
          RowBox[{"T", "[", "z", "]"}], " ", 
          RowBox[{
           SuperscriptBox["p", "\[Prime]",
            MultilineFunction->None], "[", "z", "]"}]}], "+", 
         RowBox[{
          RowBox[{"T", "[", "z", "]"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"p", "[", "z", "]"}], "4"], " ", 
             SuperscriptBox[
              RowBox[{"S", "[", "z", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["z", "2"], " ", 
             SuperscriptBox[
              RowBox[{"h", "[", "z", "]"}], "2"], " ", 
             SuperscriptBox[
              RowBox[{"S", "[", "z", "]"}], "2"], " ", 
             RowBox[{"T", "[", "z", "]"}], " ", 
             SuperscriptBox[
              RowBox[{
               SuperscriptBox["p", "\[Prime]",
                MultilineFunction->None], "[", "z", "]"}], "2"]}], "+", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"p", "[", "z", "]"}], "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                SuperscriptBox[
                 RowBox[{"S", "[", "z", "]"}], "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"12", "+", 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"h", "[", "z", "]"}], "2"]}], "-", 
                  RowBox[{
                   SuperscriptBox["z", "4"], " ", 
                   SuperscriptBox[
                    RowBox[{
                    SuperscriptBox["a", "\[Prime]",
                    MultilineFunction->None], "[", "z", "]"}], "2"]}], "+", 
                  RowBox[{"2", " ", 
                   RowBox[{"T", "[", "z", "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "6"}], "+", 
                    RowBox[{
                    SuperscriptBox["z", "2"], " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox["p", "\[Prime]",
                    MultilineFunction->None], "[", "z", "]"}], "2"]}]}], 
                    ")"}]}]}], ")"}]}], "+", 
               RowBox[{"16", " ", "z", " ", 
                RowBox[{"S", "[", "z", "]"}], " ", 
                RowBox[{"T", "[", "z", "]"}], " ", 
                RowBox[{
                 SuperscriptBox["S", "\[Prime]",
                  MultilineFunction->None], "[", "z", "]"}]}], "-", 
               RowBox[{"4", " ", 
                SuperscriptBox["z", "2"], " ", 
                RowBox[{"T", "[", "z", "]"}], " ", 
                SuperscriptBox[
                 RowBox[{
                  SuperscriptBox["S", "\[Prime]",
                   MultilineFunction->None], "[", "z", "]"}], "2"]}]}], 
              ")"}]}]}], ")"}]}]}], ")"}], "/", 
       RowBox[{"(", 
        RowBox[{"4", " ", "z", " ", 
         SuperscriptBox[
          RowBox[{"p", "[", "z", "]"}], "2"], " ", 
         RowBox[{"S", "[", "z", "]"}], " ", 
         RowBox[{"T", "[", "z", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"S", "[", "z", "]"}]}], "+", 
           RowBox[{"z", " ", 
            RowBox[{
             SuperscriptBox["S", "\[Prime]",
              MultilineFunction->None], "[", "z", "]"}]}]}], ")"}]}], 
        ")"}]}]}], ",", 
     RowBox[{
      RowBox[{
       SuperscriptBox["h", "\[Prime]",
        MultilineFunction->None], "[", "z", "]"}], "\[Equal]", 
      FractionBox[
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          RowBox[{"a", "[", "z", "]"}]}], " ", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox[
            RowBox[{"h", "[", "z", "]"}], "2"], "+", 
           SuperscriptBox[
            RowBox[{"p", "[", "z", "]"}], "2"]}], ")"}]}], "+", 
        RowBox[{
         RowBox[{"h", "[", "z", "]"}], " ", 
         RowBox[{"T", "[", "z", "]"}], " ", 
         RowBox[{
          SuperscriptBox["p", "\[Prime]",
           MultilineFunction->None], "[", "z", "]"}]}]}], 
       RowBox[{
        RowBox[{"p", "[", "z", "]"}], " ", 
        RowBox[{"T", "[", "z", "]"}]}]]}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.53804704493528*^9, 3.538047048094969*^9}, 
   3.538047118025202*^9, 3.538118653167184*^9, {3.5384641317446833`*^9, 
   3.538464140783781*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Numerics", "Subsubtitle",
 CellChangeTimes->{{3.538463013798025*^9, 3.5384630213987093`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Clear", "[", 
    RowBox[{"inteq", ",", "zhoriz", ",", "eps"}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"inteq", "[", 
    RowBox[{
    "z0in_Real", ",", "horizp0in_Real", ",", "horiza1in_Real", ",", 
     "horizt1in_Real", ",", "horizs0in_Real", ",", "asymp2in_Real", ",", 
     "asymh2in_Real", ",", "asyma0in_Real", ",", "asyma1in_Real", ",", 
     "asymT3in_Real", ",", "output_"}], "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"z0", "=", "z0in"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"horizp0", "=", "horizp0in"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"horizh0", "=", "0"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"horiza1", "=", "horiza1in"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"horizt1", "=", "horizt1in"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"horizs0", "=", "horizs0in"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"asymp2", "=", "asymp2in"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"asymh2", "=", "asymh2in"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"asyma0", "=", "asyma0in"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"asyma1", "=", "asyma1in"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"asymT3", "=", "asymT3in"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"eps", "=", "0.01"}], " ", ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"eps2", "=", "0.001"}], " ", ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"zmid", " ", "=", " ", "0.4"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"zhoriz", "=", 
      RowBox[{"1", "-", "eps2"}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"nsol1", "=", 
      RowBox[{
       RowBox[{"NDSolve", "[", 
        RowBox[{
         RowBox[{"Join", "[", 
          RowBox[{"eqlist", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"p", "[", "eps", "]"}], "\[Equal]", 
              RowBox[{"asymp", "[", "eps", "]"}]}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"p", "'"}], "[", "eps", "]"}], "\[Equal]", 
              RowBox[{
               RowBox[{"asymp", "'"}], "[", "eps", "]"}]}], ",", 
             RowBox[{
              RowBox[{"h", "[", "eps", "]"}], "\[Equal]", 
              RowBox[{"asymh", "[", "eps", "]"}]}], ",", 
             RowBox[{
              RowBox[{"a", "[", "eps", "]"}], "\[Equal]", 
              RowBox[{"asyma", "[", "eps", "]"}]}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"a", "'"}], "[", "eps", "]"}], "\[Equal]", 
              RowBox[{
               RowBox[{"asyma", "'"}], "[", "eps", "]"}]}], ",", 
             RowBox[{
              RowBox[{"T", "[", "eps", "]"}], "\[Equal]", 
              RowBox[{"asymT", "[", "eps", "]"}]}], ",", 
             RowBox[{
              RowBox[{"S", "[", "eps", "]"}], "\[Equal]", 
              RowBox[{"asymS", "[", "eps", "]"}]}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"S", "'"}], "[", "eps", "]"}], "\[Equal]", 
              RowBox[{
               RowBox[{"asymS", "'"}], "[", "eps", "]"}]}]}], "}"}]}], "]"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"p", ",", "h", ",", "a", ",", "T", ",", "S"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"z", ",", "eps", ",", "zhoriz"}], "}"}]}], "]"}], "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"zcut1", "=", 
      RowBox[{"nsol1", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "2", ",", "1", ",", "1", ",", "2"}], "]"}], "]"}]}],
      ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"zcut1", "<", "zmid"}], ",", 
       RowBox[{"Print", "[", 
        RowBox[{"\"\<Error  \>\"", ",", "zcut2"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"nsol2", "=", 
      RowBox[{
       RowBox[{"NDSolve", "[", 
        RowBox[{
         RowBox[{"Join", "[", 
          RowBox[{"eqlist", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"p", "[", "zhoriz", "]"}], "\[Equal]", 
              RowBox[{"horizp", "[", "zhoriz", "]"}]}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"p", "'"}], "[", "zhoriz", "]"}], "\[Equal]", 
              RowBox[{
               RowBox[{"horizp", "'"}], "[", "zhoriz", "]"}]}], ",", 
             RowBox[{
              RowBox[{"h", "[", "zhoriz", "]"}], "\[Equal]", 
              RowBox[{"horizh", "[", "zhoriz", "]"}]}], ",", 
             RowBox[{
              RowBox[{"a", "[", "zhoriz", "]"}], "\[Equal]", 
              RowBox[{"horiza", "[", "zhoriz", "]"}]}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"a", "'"}], "[", "zhoriz", "]"}], "\[Equal]", 
              RowBox[{
               RowBox[{"horiza", "'"}], "[", "zhoriz", "]"}]}], ",", 
             RowBox[{
              RowBox[{"T", "[", "zhoriz", "]"}], "\[Equal]", 
              RowBox[{"horizT", "[", "zhoriz", "]"}]}], ",", 
             RowBox[{
              RowBox[{"S", "[", "zhoriz", "]"}], "\[Equal]", 
              RowBox[{"horizS", "[", "zhoriz", "]"}]}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"S", "'"}], "[", "zhoriz", "]"}], "\[Equal]", 
              RowBox[{
               RowBox[{"horizS", "'"}], "[", "zhoriz", "]"}]}]}], "}"}]}], 
          "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"p", ",", "h", ",", "a", ",", "T", ",", "S"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"z", ",", "eps", ",", "zhoriz"}], "}"}]}], "]"}], "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"zcut2", "=", 
      RowBox[{"nsol2", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "2", ",", "1", ",", "1", ",", "1"}], "]"}], "]"}]}],
      ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"zcut2", ">", "zmid"}], ",", 
       RowBox[{"Print", "[", 
        RowBox[{"\"\<Error  \>\"", ",", "zcut2"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"Clear", "[", 
      RowBox[{
      "horizp0", ",", "horizh0", ",", "horiza1", ",", "horizt1", ",", 
       "horizs0", ",", "asymp2", ",", "asymh2", ",", "asyma0", ",", "asyma1", 
       ",", "asymT3"}], "]"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"output", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"Return", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"h", "'"}], "[", "eps", "]"}], ",", 
             RowBox[{
              RowBox[{"T", "'"}], "[", "eps", "]"}]}], "}"}], "/.", "nsol2"}],
           "]"}], ";"}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"htab", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{
              RowBox[{"h", "[", "z", "]"}], "/.", "nsol2"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"20", "eps"}], ",", 
             RowBox[{"100", "eps"}], ",", 
             RowBox[{"10", "eps"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Ttab", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{
              RowBox[{
               RowBox[{"T", "[", "z", "]"}], "-", "1"}], "/.", "nsol2"}]}], 
            "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"20", "eps"}], ",", 
             RowBox[{"100", "eps"}], ",", 
             RowBox[{"10", "eps"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"hfit", "=", 
         RowBox[{"Fit", "[", 
          RowBox[{"htab", ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"z", "^", "2"}]}], "}"}], ",", "z"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Tfit", "=", 
         RowBox[{"Fit", "[", 
          RowBox[{"Ttab", ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"z", "^", "2"}]}], "}"}], ",", "z"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Return", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Coefficient", "[", 
            RowBox[{"hfit", ",", "z"}], "]"}], ",", 
           RowBox[{"Coefficient", "[", 
            RowBox[{"Tfit", ",", "z"}], "]"}]}], "}"}], "]"}], ";"}]}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"output", "\[Equal]", "2"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"list", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"p", "[", "zmid", "]"}], "/.", "nsol1"}], ")"}], "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"p", "[", "zmid", "]"}], "/.", "nsol2"}], ")"}]}], ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"h", "[", "zmid", "]"}], "/.", "nsol1"}], ")"}], "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"h", "[", "zmid", "]"}], "/.", "nsol2"}], ")"}]}], ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"a", "[", "zmid", "]"}], "/.", "nsol1"}], ")"}], "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"a", "[", "zmid", "]"}], "/.", "nsol2"}], ")"}]}], ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"T", "[", "zmid", "]"}], "/.", "nsol1"}], ")"}], "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"T", "[", "zmid", "]"}], "/.", "nsol2"}], ")"}]}], ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"S", "[", "zmid", "]"}], "/.", "nsol1"}], ")"}], "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"S", "[", "zmid", "]"}], "/.", "nsol2"}], ")"}]}]}], 
          "}"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"dlist", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"p", "'"}], "[", "zmid", "]"}], "/.", "nsol1"}], ")"}],
             "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"p", "'"}], "[", "zmid", "]"}], "/.", "nsol2"}], 
             ")"}]}], ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"a", "'"}], "[", "zmid", "]"}], "/.", "nsol1"}], ")"}],
             "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"a", "'"}], "[", "zmid", "]"}], "/.", "nsol2"}], 
             ")"}]}], ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"S", "'"}], "[", "zmid", "]"}], "/.", "nsol1"}], ")"}],
             "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"S", "'"}], "[", "zmid", "]"}], "/.", "nsol2"}], 
             ")"}]}]}], "}"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"Return", "[", 
         RowBox[{"Join", "[", 
          RowBox[{"list", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"dlist", "[", 
              RowBox[{"[", "1", "]"}], "]"}], ",", 
             RowBox[{"dlist", "[", 
              RowBox[{"[", "2", "]"}], "]"}], ",", 
             RowBox[{"dlist", "[", 
              RowBox[{"[", "3", "]"}], "]"}]}], "}"}]}], "]"}], "]"}], 
        ";"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"output", "\[Equal]", "0"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"ptab", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{
              RowBox[{"p", "[", "z", "]"}], "/.", "nsol2"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"20", "eps"}], ",", 
             RowBox[{"100", "eps"}], ",", 
             RowBox[{"10", "eps"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"htab", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{
              RowBox[{"h", "[", "z", "]"}], "/.", "nsol2"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"20", "eps"}], ",", 
             RowBox[{"100", "eps"}], ",", 
             RowBox[{"10", "eps"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"atab", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{
              RowBox[{"a", "[", "z", "]"}], "/.", "nsol2"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"20", "eps"}], ",", 
             RowBox[{"100", "eps"}], ",", 
             RowBox[{"10", "eps"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Ttab", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{
              RowBox[{
               RowBox[{"T", "[", "z", "]"}], "-", "1"}], "/.", "nsol2"}]}], 
            "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"20", "eps"}], ",", 
             RowBox[{"100", "eps"}], ",", 
             RowBox[{"10", "eps"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Stab", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{
              RowBox[{"S", "[", "z", "]"}], "/.", "nsol2"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"20", "eps"}], ",", 
             RowBox[{"100", "eps"}], ",", 
             RowBox[{"10", "eps"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"pfit", "=", 
         RowBox[{"Fit", "[", 
          RowBox[{"ptab", ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"z", "^", "2"}]}], "}"}], ",", "z"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"hfit", "=", 
         RowBox[{"Fit", "[", 
          RowBox[{"htab", ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"z", "^", "2"}]}], "}"}], ",", "z"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"afit", "=", 
         RowBox[{"Fit", "[", 
          RowBox[{"atab", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "z"}], "}"}], ",", "z"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Tfit", "=", 
         RowBox[{"Fit", "[", 
          RowBox[{"Ttab", ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"z", "^", "2"}], ",", 
             RowBox[{"z", "^", "3"}]}], "}"}], ",", "z"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Sfit", "=", 
         RowBox[{"Fit", "[", 
          RowBox[{"Stab", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "z"}], "}"}], ",", "z"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"pfit2", "=", 
         RowBox[{"Fit", "[", 
          RowBox[{"ptab", ",", 
           RowBox[{"{", 
            RowBox[{"z", "^", "2"}], "}"}], ",", "z"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"hfit2", "=", 
         RowBox[{"Fit", "[", 
          RowBox[{"htab", ",", 
           RowBox[{"{", 
            RowBox[{"z", "^", "2"}], "}"}], ",", "z"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Tfit2", "=", 
         RowBox[{"Fit", "[", 
          RowBox[{"Ttab", ",", 
           RowBox[{"{", 
            RowBox[{"z", "^", "3"}], "}"}], ",", "z"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Return", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"pf", "==", "pfit"}], ",", 
             RowBox[{"hf", "\[Equal]", "hfit"}], ",", 
             RowBox[{"af", "\[Equal]", "afit"}], ",", 
             RowBox[{"Tf", "\[Equal]", "Tfit"}], ",", 
             RowBox[{"Sf", "\[Equal]", "Sfit"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"pfit2", ",", "hfit2", ",", "Tfit2"}], "}"}]}], "}"}], 
         "]"}], ";"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], 
     ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", ")"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.5376407771099586`*^9, 3.53764077742128*^9}, {
   3.537640849432414*^9, 3.537641029700471*^9}, {3.537641083186082*^9, 
   3.5376410832815037`*^9}, {3.537641227496984*^9, 3.537641241071927*^9}, {
   3.537641278231781*^9, 3.53764129200132*^9}, {3.537811594660029*^9, 
   3.537811661635552*^9}, 3.537811712330718*^9, {3.537812313668707*^9, 
   3.537812329718534*^9}, {3.537812368025175*^9, 3.537812466952651*^9}, {
   3.537812574550178*^9, 3.53781262207281*^9}, {3.537855902100842*^9, 
   3.537855910975484*^9}, {3.537863637889791*^9, 3.537863642968212*^9}, {
   3.53786405512639*^9, 3.5378640577014513`*^9}, {3.5378642740193357`*^9, 
   3.5378642823266706`*^9}, {3.537864945886372*^9, 3.537864949610241*^9}, {
   3.537865324468916*^9, 3.5378653414829493`*^9}, {3.537865422417637*^9, 
   3.537865426010881*^9}, {3.537865668894218*^9, 3.5378656720161123`*^9}, {
   3.537866060689427*^9, 3.537866086110963*^9}, {3.537866821965849*^9, 
   3.537866824468356*^9}, {3.537866935754058*^9, 3.5378669532770844`*^9}, {
   3.537867277477654*^9, 3.537867283864683*^9}, {3.5378673736645327`*^9, 
   3.53786741047612*^9}, {3.537867724358015*^9, 3.537867770909184*^9}, {
   3.537867812374217*^9, 3.537867814824875*^9}, {3.537867862682262*^9, 
   3.537867863608501*^9}, {3.537867935345325*^9, 3.537867952471974*^9}, {
   3.537867984898217*^9, 3.5378679871300287`*^9}, {3.537870400150711*^9, 
   3.537870402077724*^9}, {3.537870448958918*^9, 3.5378704524785967`*^9}, {
   3.537870930220189*^9, 3.537870930900414*^9}, 3.537871139674671*^9, {
   3.537871192589308*^9, 3.53787120155658*^9}, {3.537871653378598*^9, 
   3.5378716648098917`*^9}, {3.537871703252593*^9, 3.537871787942024*^9}, {
   3.537871824557847*^9, 3.537871910740779*^9}, {3.537871941253039*^9, 
   3.5378719525649443`*^9}, {3.537871994498852*^9, 3.537872049059258*^9}, {
   3.537872138421897*^9, 3.537872144006673*^9}, {3.537872196836445*^9, 
   3.53787224947705*^9}, {3.5378722878468122`*^9, 3.537872372883222*^9}, {
   3.537872490150178*^9, 3.537872496093255*^9}, {3.537872547385435*^9, 
   3.537872561998753*^9}, {3.537872800792879*^9, 3.5378728967451353`*^9}, {
   3.537872969967389*^9, 3.537872993322166*^9}, {3.5378733845638*^9, 
   3.537873523491342*^9}, {3.537874990501849*^9, 3.5378750749448233`*^9}, {
   3.538046326178605*^9, 3.5380463263452587`*^9}, {3.538046359506956*^9, 
   3.5380464610359497`*^9}, {3.538046502103581*^9, 3.538046513481264*^9}, {
   3.53804657410702*^9, 3.538046614577108*^9}, {3.53804665505602*^9, 
   3.538046715360199*^9}, {3.538046757351519*^9, 3.53804676998315*^9}, {
   3.5380468595384607`*^9, 3.5380468659616413`*^9}, {3.538046897437215*^9, 
   3.538046897572302*^9}, {3.538047066640044*^9, 3.538047074544244*^9}, {
   3.538047229999874*^9, 3.5380472836305647`*^9}, {3.538047353035921*^9, 
   3.538047363818179*^9}, {3.538047476249525*^9, 3.538047522111104*^9}, {
   3.5380475966181917`*^9, 3.5380475967702713`*^9}, {3.538047801532692*^9, 
   3.538047822201064*^9}, {3.538047948516816*^9, 3.538047948684765*^9}, {
   3.538114366350466*^9, 3.5381144299925222`*^9}, {3.538114576757052*^9, 
   3.5381146749454412`*^9}, {3.538114791107875*^9, 3.5381148266944447`*^9}, {
   3.538114878968347*^9, 3.538115127215603*^9}, {3.53811552595366*^9, 
   3.538115590252236*^9}, {3.5381156363832006`*^9, 3.538115704042387*^9}, {
   3.53811589099817*^9, 3.53811590783984*^9}, {3.538115999280501*^9, 
   3.5381160364460382`*^9}, 3.538116068499432*^9, {3.5381163172614202`*^9, 
   3.5381163185592117`*^9}, 3.538116587083933*^9, {3.538116795975728*^9, 
   3.5381167961435547`*^9}, {3.538116915101754*^9, 3.538116916845715*^9}, {
   3.538117082639504*^9, 3.5381170838467207`*^9}, {3.538117120446578*^9, 
   3.538117121605109*^9}, {3.538117912630061*^9, 3.5381179255489893`*^9}, {
   3.538118168821506*^9, 3.538118170682723*^9}, {3.5381182778513527`*^9, 
   3.538118288943109*^9}, {3.5381183580154047`*^9, 3.5381183581193533`*^9}, {
   3.538118848337666*^9, 3.538118920486744*^9}, {3.538119184188271*^9, 
   3.53811918440349*^9}, {3.5381193489118156`*^9, 3.538119350612996*^9}, {
   3.538119892508926*^9, 3.538119895751055*^9}, {3.538119927591441*^9, 
   3.538119936248074*^9}, {3.538120029047421*^9, 3.538120037965654*^9}, {
   3.538120194027095*^9, 3.538120201471917*^9}, {3.53812028017563*^9, 
   3.538120301265314*^9}, {3.5381381252717533`*^9, 3.538138126469459*^9}, {
   3.538328246372367*^9, 3.5383282504354353`*^9}, {3.5383283005077343`*^9, 
   3.538328335488717*^9}, {3.538329001230315*^9, 3.538329010372521*^9}, {
   3.5383292041149054`*^9, 3.538329214953123*^9}, {3.5383314262207823`*^9, 
   3.538331427882743*^9}}],

Cell[BoxData["\"\<inteq[z0,horizp0,horiza1,horizt1,horizs0,asymp2,asymh2,\
asyma0,asyma1,asymT3,output_]\>\""], "Input",
 CellChangeTimes->{{3.5383293550725*^9, 3.538329380846671*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"a", "[", "z_", "]"}], ":=", 
   RowBox[{"q", 
    RowBox[{"(", 
     RowBox[{"1", "-", "z"}], ")"}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"T", "[", "z_", "]"}], ":=", 
   RowBox[{"1", "-", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "+", 
       FractionBox[
        SuperscriptBox["q", "2"], "4"]}], ")"}], " ", 
     RowBox[{"z", "^", "3"}]}], "+", 
    RowBox[{
     FractionBox[
      RowBox[{"q", "^", "2"}], "4"], " ", 
     RowBox[{"z", "^", "4"}]}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"S", "[", "z_", "]"}], ":=", "1"}]}], "Input",
 CellChangeTimes->{{3.538329462610435*^9, 3.53832946748561*^9}, {
  3.538329521299446*^9, 3.5383295310616198`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Simplify", "[", 
   RowBox[{"-", 
    RowBox[{
     RowBox[{"a", "'"}], "[", "1", "]"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{"-", 
   RowBox[{
    RowBox[{"T", "'"}], "[", "1", "]"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.538329559252846*^9, 3.53832957654383*^9}, {
  3.5383316175594177`*^9, 3.53833162076753*^9}}],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{"a", ",", "T", ",", "S"}], "]"}]], "Input",
 CellChangeTimes->{{3.538329687225774*^9, 3.538329690184968*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"inteq", "[", 
    RowBox[{"1.", ",", "0.0001", ",", "q", ",", 
     RowBox[{"3.", "-", 
      FractionBox[
       SuperscriptBox["q", "2"], "4"]}], ",", "1.", ",", "0.0001", ",", 
     "0.0001", ",", "q", ",", 
     RowBox[{"-", "q"}], ",", 
     RowBox[{"-", 
      RowBox[{"(", 
       RowBox[{"1.", "+", 
        FractionBox[
         SuperscriptBox["q", "2"], "4"]}], ")"}]}], ",", "2"}], "]"}], "/.", 
   RowBox[{"{", 
    RowBox[{"q", "\[Rule]", "0.3"}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.5383294791064587`*^9, 3.538329480386127*^9}, {
  3.538329552120495*^9, 3.538329698586186*^9}, {3.538331199106153*^9, 
  3.538331232043847*^9}, {3.538331650792227*^9, 3.538331661359701*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"plt1", "=", 
    RowBox[{"Plot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", "z", "]"}], "/.", "nsol1"}], ",", 
      RowBox[{"{", 
       RowBox[{"z", ",", "eps", ",", "zcut1"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"plt2", "=", 
    RowBox[{"Plot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", "z", "]"}], "/.", "nsol2"}], ",", 
      RowBox[{"{", 
       RowBox[{"z", ",", "zcut2", ",", "zhoriz"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{"plt1", ",", "plt2"}], "]"}]}], "Input",
 CellChangeTimes->{{3.5383316585937967`*^9, 3.538331734439353*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"q", "=", "0.3"}], ";"}]], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"solx", "=", 
   RowBox[{"FindRoot", "[", 
    RowBox[{
     RowBox[{"inteq", "[", 
      RowBox[{
      "1.", ",", "x1", ",", "q", ",", "x2", ",", "x3", ",", "x4", ",", "x5", 
       ",", "x6", ",", "x7", ",", "x8", ",", "2"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x1", ",", "0.001"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x2", ",", "3."}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x3", ",", "1."}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x4", ",", "0.001"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x5", ",", "0.001"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x6", ",", "q"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x7", ",", 
       RowBox[{"-", "q"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x8", ",", 
       RowBox[{"-", 
        RowBox[{"(", 
         RowBox[{"1.", "+", 
          FractionBox[
           SuperscriptBox["q", "2"], "4"]}], ")"}]}]}], "}"}]}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"inteq", "[", 
   RowBox[{
   "1.", ",", "x1", ",", "q", ",", "x2", ",", "x3", ",", "x4", ",", "x5", ",",
     "x6", ",", "x7", ",", "x8", ",", "2"}], "]"}], "/.", "solx"}]}], "Input",
 CellChangeTimes->{{3.538332379828829*^9, 3.538332479861409*^9}, {
  3.538332516308981*^9, 3.5383325571714373`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"q", "=", "0.3427"}], ";"}]], "Input",
 CellChangeTimes->{{3.538331888911525*^9, 3.538331890488124*^9}, {
  3.5383332721236134`*^9, 3.538333358209091*^9}, {3.538372556610911*^9, 
  3.538372684298564*^9}, {3.538372774294757*^9, 3.5383727935021143`*^9}, {
  3.538380435266081*^9, 3.5383804358499737`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"vec", "=", 
   RowBox[{"{", 
    RowBox[{"0.000001", ",", 
     RowBox[{"3.", "-", 
      FractionBox[
       SuperscriptBox["q", "2"], "4"]}], ",", "1.", ",", "0.000001", ",", 
     "0.000001", ",", "q", ",", 
     RowBox[{"-", "q"}], ",", 
     RowBox[{"-", 
      RowBox[{"(", 
       RowBox[{"1.", "+", 
        FractionBox[
         SuperscriptBox["q", "2"], "4"]}], ")"}]}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{
  3.5381366020899467`*^9, {3.538328422257468*^9, 3.5383284518318768`*^9}, 
   3.538328887038381*^9, {3.538331754993125*^9, 3.5383317597446136`*^9}, {
   3.538331893617297*^9, 3.538331896097275*^9}, {3.538331961393141*^9, 
   3.538331965384636*^9}, {3.538380438091875*^9, 3.538380445343212*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"mat", "=", 
    RowBox[{"{", "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"eq0", "=", 
    RowBox[{"inteq", "[", 
     RowBox[{"1.", ",", 
      RowBox[{"vec", "[", 
       RowBox[{"[", "1", "]"}], "]"}], ",", "q", ",", 
      RowBox[{"vec", "[", 
       RowBox[{"[", "2", "]"}], "]"}], ",", 
      RowBox[{"vec", "[", 
       RowBox[{"[", "3", "]"}], "]"}], ",", 
      RowBox[{"vec", "[", 
       RowBox[{"[", "4", "]"}], "]"}], ",", 
      RowBox[{"vec", "[", 
       RowBox[{"[", "5", "]"}], "]"}], ",", 
      RowBox[{"vec", "[", 
       RowBox[{"[", "6", "]"}], "]"}], ",", 
      RowBox[{"vec", "[", 
       RowBox[{"[", "7", "]"}], "]"}], ",", 
      RowBox[{"vec", "[", 
       RowBox[{"[", "8", "]"}], "]"}], ",", "2"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DX", " ", "=", " ", "0.0001"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Do", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"vec0", "=", "vec"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"vec0", "[", 
        RowBox[{"[", "jj", "]"}], "]"}], "-=", "DX"}], " ", ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"eq1", "=", 
       RowBox[{"inteq", "[", 
        RowBox[{"1.", ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", "q", ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "2", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "3", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "4", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "5", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "6", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "7", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "8", "]"}], "]"}], ",", "2"}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"vec0", "[", 
        RowBox[{"[", "jj", "]"}], "]"}], "+=", 
       RowBox[{"2", "*", "DX"}]}], " ", ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"eq2", "=", 
       RowBox[{"inteq", "[", 
        RowBox[{"1.", ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", "q", ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "2", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "3", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "4", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "5", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "6", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "7", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "8", "]"}], "]"}], ",", "2"}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"AppendTo", "[", 
       RowBox[{"mat", ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"eq2", "-", "eq1"}], ")"}], "/", 
         RowBox[{"(", 
          RowBox[{"2", "*", "DX"}], ")"}]}]}], "]"}], ";"}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"jj", ",", "1", ",", "8"}], "}"}]}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<det = \>\"", ",", 
     RowBox[{"Det", "[", "mat", "]"}]}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"dvec", "=", 
    RowBox[{
     RowBox[{"Inverse", "[", 
      RowBox[{"Transpose", "[", "mat", "]"}], "]"}], ".", "eq0"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"vec", " ", "=", " ", 
    RowBox[{"vec", "-", "dvec"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<vec = \>\"", ",", "vec", ",", "\"\<  ->  eq = \>\"", ",", "eq0"}], 
   "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.538120490121634*^9, 3.538120518932563*^9}, {
   3.5381205558741503`*^9, 3.538120610837431*^9}, {3.5381206659362717`*^9, 
   3.538120712255209*^9}, {3.5383285846229553`*^9, 3.538328585388818*^9}, {
   3.538328684844769*^9, 3.5383286852597733`*^9}, 3.538328770081517*^9, {
   3.5383289405611877`*^9, 3.5383289561436033`*^9}, {3.538329024216524*^9, 
   3.538329027272518*^9}, {3.538329231307086*^9, 3.538329245530115*^9}, {
   3.53832928014611*^9, 3.5383292802257977`*^9}, {3.538331899292232*^9, 
   3.538331918317177*^9}, {3.5383320080930357`*^9, 3.53833201029294*^9}, {
   3.5383320534615726`*^9, 3.538332054173419*^9}, {3.538332091130785*^9, 
   3.538332091290278*^9}, {3.538332148467001*^9, 3.538332166530912*^9}, {
   3.538332763655594*^9, 3.538332763839275*^9}, 3.538332811566271*^9, {
   3.5383329603107758`*^9, 3.538333014609095*^9}, {3.538372704879333*^9, 
   3.538372748091798*^9}, {3.538380094711239*^9, 3.538380095245941*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Clear", "[", "q", "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"matlist", "=", 
    RowBox[{"{", "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Do", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"vec", "=", 
       RowBox[{"{", 
        RowBox[{"0.0000000000001", ",", 
         RowBox[{"3.", "-", 
          FractionBox[
           SuperscriptBox["q", "2"], "4"]}], ",", "1.", ",", 
         "0.0000000000001", ",", "0.0000000000001", ",", "q", ",", 
         RowBox[{"-", "q"}], ",", 
         RowBox[{"-", 
          RowBox[{"(", 
           RowBox[{"1.", "+", 
            FractionBox[
             SuperscriptBox["q", "2"], "4"]}], ")"}]}]}], "}"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"mat", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"eq0", "=", 
       RowBox[{"inteq", "[", 
        RowBox[{"1.", ",", 
         RowBox[{"vec", "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", "q", ",", 
         RowBox[{"vec", "[", 
          RowBox[{"[", "2", "]"}], "]"}], ",", 
         RowBox[{"vec", "[", 
          RowBox[{"[", "3", "]"}], "]"}], ",", 
         RowBox[{"vec", "[", 
          RowBox[{"[", "4", "]"}], "]"}], ",", 
         RowBox[{"vec", "[", 
          RowBox[{"[", "5", "]"}], "]"}], ",", 
         RowBox[{"vec", "[", 
          RowBox[{"[", "6", "]"}], "]"}], ",", 
         RowBox[{"vec", "[", 
          RowBox[{"[", "7", "]"}], "]"}], ",", 
         RowBox[{"vec", "[", 
          RowBox[{"[", "8", "]"}], "]"}], ",", "2"}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"DX", " ", "=", " ", "0.000001"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"Do", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"vec0", "=", "vec"}], ";", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"vec0", "[", 
           RowBox[{"[", "jj", "]"}], "]"}], "-=", "DX"}], " ", ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"eq1", "=", 
          RowBox[{"inteq", "[", 
           RowBox[{"1.", ",", 
            RowBox[{"vec0", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", "q", ",", 
            RowBox[{"vec0", "[", 
             RowBox[{"[", "2", "]"}], "]"}], ",", 
            RowBox[{"vec0", "[", 
             RowBox[{"[", "3", "]"}], "]"}], ",", 
            RowBox[{"vec0", "[", 
             RowBox[{"[", "4", "]"}], "]"}], ",", 
            RowBox[{"vec0", "[", 
             RowBox[{"[", "5", "]"}], "]"}], ",", 
            RowBox[{"vec0", "[", 
             RowBox[{"[", "6", "]"}], "]"}], ",", 
            RowBox[{"vec0", "[", 
             RowBox[{"[", "7", "]"}], "]"}], ",", 
            RowBox[{"vec0", "[", 
             RowBox[{"[", "8", "]"}], "]"}], ",", "2"}], "]"}]}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"vec0", "[", 
           RowBox[{"[", "jj", "]"}], "]"}], "+=", 
          RowBox[{"2", "*", "DX"}]}], " ", ";", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"eq2", "=", 
          RowBox[{"inteq", "[", 
           RowBox[{"1.", ",", 
            RowBox[{"vec0", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", "q", ",", 
            RowBox[{"vec0", "[", 
             RowBox[{"[", "2", "]"}], "]"}], ",", 
            RowBox[{"vec0", "[", 
             RowBox[{"[", "3", "]"}], "]"}], ",", 
            RowBox[{"vec0", "[", 
             RowBox[{"[", "4", "]"}], "]"}], ",", 
            RowBox[{"vec0", "[", 
             RowBox[{"[", "5", "]"}], "]"}], ",", 
            RowBox[{"vec0", "[", 
             RowBox[{"[", "6", "]"}], "]"}], ",", 
            RowBox[{"vec0", "[", 
             RowBox[{"[", "7", "]"}], "]"}], ",", 
            RowBox[{"vec0", "[", 
             RowBox[{"[", "8", "]"}], "]"}], ",", "2"}], "]"}]}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"AppendTo", "[", 
          RowBox[{"mat", ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"eq2", "-", "eq1"}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"2", "*", "DX"}], ")"}]}]}], "]"}], ";"}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{"jj", ",", "1", ",", "8"}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"tmp", "=", 
       RowBox[{"Eigenvalues", "[", "mat", "]"}]}], ";", "\[IndentingNewLine]",
       "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{
       "\"\<q = \>\"", ",", "q", ",", "\"\<\\n\\n    evals = \>\"", ",", 
        RowBox[{"Sort", "[", 
         RowBox[{"Abs", "[", "tmp", "]"}], "]"}], ",", "\"\<\\n\\n\>\""}], 
       "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"AppendTo", "[", 
       RowBox[{"matlist", ",", 
        RowBox[{"{", 
         RowBox[{"q", ",", 
          RowBox[{"Eigenvalues", "[", "mat", "]"}]}], "}"}]}], "]"}], ";"}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"q", ",", "0.1", ",", "3.3", ",", "0.1"}], "}"}]}], "]"}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Clear", "[", "q", "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.538120490121634*^9, 3.538120518932563*^9}, {
   3.5381205558741503`*^9, 3.538120610837431*^9}, {3.5381206659362717`*^9, 
   3.538120712255209*^9}, {3.5383285846229553`*^9, 3.538328585388818*^9}, {
   3.538328684844769*^9, 3.5383286852597733`*^9}, 3.538328770081517*^9, {
   3.5383289405611877`*^9, 3.5383289561436033`*^9}, {3.538329024216524*^9, 
   3.538329027272518*^9}, {3.538329231307086*^9, 3.538329245530115*^9}, {
   3.53832928014611*^9, 3.5383292802257977`*^9}, {3.538331899292232*^9, 
   3.538331918317177*^9}, {3.5383320080930357`*^9, 3.53833201029294*^9}, {
   3.5383320534615726`*^9, 3.538332054173419*^9}, {3.538332091130785*^9, 
   3.538332091290278*^9}, {3.538332148467001*^9, 3.538332166530912*^9}, {
   3.538332763655594*^9, 3.538332763839275*^9}, 3.538332811566271*^9, {
   3.5383329603107758`*^9, 3.538333014609095*^9}, {3.538372704879333*^9, 
   3.538372748091798*^9}, {3.538380094711239*^9, 3.538380301811192*^9}, {
   3.538380346386833*^9, 3.53838035277041*^9}, {3.5383804228339043`*^9, 
   3.538380465316924*^9}, {3.5383805155001173`*^9, 3.538380517170929*^9}, {
   3.538394417410356*^9, 3.5383944338261538`*^9}, {3.538394492189281*^9, 
   3.538394500156169*^9}, {3.538394576260153*^9, 3.538394585499764*^9}, {
   3.538464511316242*^9, 3.538464545454879*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"q", "=", "2.979"}], ";"}]], "Input",
 CellChangeTimes->{{3.538331888911525*^9, 3.538331890488124*^9}, {
  3.5383332721236134`*^9, 3.538333358209091*^9}, {3.538372556610911*^9, 
  3.538372684298564*^9}, {3.538372774294757*^9, 3.5383727935021143`*^9}, {
  3.538380435266081*^9, 3.5383804358499737`*^9}, {3.538394561420013*^9, 
  3.538394565754445*^9}, {3.538394711436935*^9, 3.538394712492588*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"vec", "=", 
   RowBox[{"{", 
    RowBox[{"0.0000000000001", ",", 
     RowBox[{"3.", "-", 
      FractionBox[
       SuperscriptBox["q", "2"], "4"]}], ",", "1.", ",", "0.0000000000001", 
     ",", "0.0000000000001", ",", "q", ",", 
     RowBox[{"-", "q"}], ",", 
     RowBox[{"-", 
      RowBox[{"(", 
       RowBox[{"1.", "+", 
        FractionBox[
         SuperscriptBox["q", "2"], "4"]}], ")"}]}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{
  3.5381366020899467`*^9, {3.538328422257468*^9, 3.5383284518318768`*^9}, 
   3.538328887038381*^9, {3.538331754993125*^9, 3.5383317597446136`*^9}, {
   3.538331893617297*^9, 3.538331896097275*^9}, {3.538331961393141*^9, 
   3.538331965384636*^9}, {3.538380438091875*^9, 3.538380445343212*^9}, 
   3.5383946710003633`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"mat", "=", 
    RowBox[{"{", "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"eq0", "=", 
    RowBox[{"inteq", "[", 
     RowBox[{"1.", ",", 
      RowBox[{"vec", "[", 
       RowBox[{"[", "1", "]"}], "]"}], ",", "q", ",", 
      RowBox[{"vec", "[", 
       RowBox[{"[", "2", "]"}], "]"}], ",", 
      RowBox[{"vec", "[", 
       RowBox[{"[", "3", "]"}], "]"}], ",", 
      RowBox[{"vec", "[", 
       RowBox[{"[", "4", "]"}], "]"}], ",", 
      RowBox[{"vec", "[", 
       RowBox[{"[", "5", "]"}], "]"}], ",", 
      RowBox[{"vec", "[", 
       RowBox[{"[", "6", "]"}], "]"}], ",", 
      RowBox[{"vec", "[", 
       RowBox[{"[", "7", "]"}], "]"}], ",", 
      RowBox[{"vec", "[", 
       RowBox[{"[", "8", "]"}], "]"}], ",", "2"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DX", " ", "=", " ", "0.000001"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Do", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"vec0", "=", "vec"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"vec0", "[", 
        RowBox[{"[", "jj", "]"}], "]"}], "-=", "DX"}], " ", ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"eq1", "=", 
       RowBox[{"inteq", "[", 
        RowBox[{"1.", ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", "q", ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "2", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "3", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "4", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "5", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "6", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "7", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "8", "]"}], "]"}], ",", "2"}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"vec0", "[", 
        RowBox[{"[", "jj", "]"}], "]"}], "+=", 
       RowBox[{"2", "*", "DX"}]}], " ", ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"eq2", "=", 
       RowBox[{"inteq", "[", 
        RowBox[{"1.", ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", "q", ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "2", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "3", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "4", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "5", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "6", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "7", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "8", "]"}], "]"}], ",", "2"}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"AppendTo", "[", 
       RowBox[{"mat", ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"eq2", "-", "eq1"}], ")"}], "/", 
         RowBox[{"(", 
          RowBox[{"2", "*", "DX"}], ")"}]}]}], "]"}], ";"}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"jj", ",", "1", ",", "8"}], "}"}]}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<det = \>\"", ",", 
     RowBox[{"Det", "[", "mat", "]"}]}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"dvec", "=", 
    RowBox[{
     RowBox[{"Inverse", "[", 
      RowBox[{"Transpose", "[", "mat", "]"}], "]"}], ".", "eq0"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"vec", " ", "=", " ", 
    RowBox[{"vec", "-", "dvec"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<vec = \>\"", ",", "vec", ",", "\"\<  ->  eq = \>\"", ",", "eq0"}], 
   "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.538120490121634*^9, 3.538120518932563*^9}, {
   3.5381205558741503`*^9, 3.538120610837431*^9}, {3.5381206659362717`*^9, 
   3.538120712255209*^9}, {3.5383285846229553`*^9, 3.538328585388818*^9}, {
   3.538328684844769*^9, 3.5383286852597733`*^9}, 3.538328770081517*^9, {
   3.5383289405611877`*^9, 3.5383289561436033`*^9}, {3.538329024216524*^9, 
   3.538329027272518*^9}, {3.538329231307086*^9, 3.538329245530115*^9}, {
   3.53832928014611*^9, 3.5383292802257977`*^9}, {3.538331899292232*^9, 
   3.538331918317177*^9}, {3.5383320080930357`*^9, 3.53833201029294*^9}, {
   3.5383320534615726`*^9, 3.538332054173419*^9}, {3.538332091130785*^9, 
   3.538332091290278*^9}, {3.538332148467001*^9, 3.538332166530912*^9}, {
   3.538332763655594*^9, 3.538332763839275*^9}, 3.538332811566271*^9, {
   3.5383329603107758`*^9, 3.538333014609095*^9}, {3.538372704879333*^9, 
   3.538372748091798*^9}, {3.538380094711239*^9, 3.538380095245941*^9}, {
   3.538394672675757*^9, 3.538394672818479*^9}}],

Cell[BoxData[
 RowBox[{"Eigenvalues", "[", "mat", "]"}]], "Input",
 CellChangeTimes->{{3.538394632584487*^9, 3.538394636242876*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Eigensystem", "[", "mat", "]"}], "[", 
  RowBox[{"[", "1", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5383947953079863`*^9, 3.538394802096307*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Eigensystem", "[", "mat", "]"}], "[", 
  RowBox[{"[", 
   RowBox[{"2", ",", 
    RowBox[{"-", "1"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.538394806318841*^9, 3.538394810078865*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"evec", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.8940344494134517`"}], ",", 
     RowBox[{"-", "0.4044619181215`"}], ",", "3.3346699386897934`*^-7", ",", 
     RowBox[{"-", "7.75137404251833`*^-12"}], ",", 
     RowBox[{"-", "5.683965098262476`*^-13"}], ",", "0.19264724252179596`", 
     ",", 
     RowBox[{"-", "1.3338732284597615`*^-7"}], ",", 
     RowBox[{"-", "2.873927593868073`*^-7"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.5383948180312023`*^9, 3.538394843959775*^9}, {
  3.538467289519421*^9, 3.5384672925812597`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mat", ".", "evec"}], "/", "evec"}]], "Input",
 CellChangeTimes->{{3.538394822310273*^9, 3.5383948269747343`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
  "\"\<inteq[z0,horizp0,horiza1,horizt1,horizs0,asymp2,asymh2,asyma0,asyma1,\
asymT3,output_]\>\"", ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"\"\<inteq[1.,vec[[1]],q,vec[[2]],vec[[3]],vec[[4]],vec[[5]],vec[[6]]\
,vec[[7]],vec[[8]],2]\>\"", ";"}]}], "Input",
 CellChangeTimes->{{3.5383948714318027`*^9, 3.538394893951269*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"evec", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.894"}], ",", 
     RowBox[{"-", "0.404"}], ",", "0.", ",", "0.", ",", "0.", ",", "0.193", 
     ",", "0.", ",", "0."}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.5383949624752893`*^9, 3.538394977954464*^9}, {
  3.5384673050607977`*^9, 3.538467314180806*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"q", "=", "3.0"}], ";"}]], "Input",
 CellChangeTimes->{{3.538331888911525*^9, 3.538331890488124*^9}, {
  3.5383332721236134`*^9, 3.538333358209091*^9}, {3.538372556610911*^9, 
  3.538372684298564*^9}, {3.538372774294757*^9, 3.5383727935021143`*^9}, {
  3.538380435266081*^9, 3.5383804358499737`*^9}, {3.538394561420013*^9, 
  3.538394565754445*^9}, {3.538394711436935*^9, 3.538394712492588*^9}, {
  3.538395089032036*^9, 3.538395092535534*^9}, {3.5383951245277033`*^9, 
  3.5383951282713623`*^9}, {3.538395211807301*^9, 3.538395211902952*^9}, {
  3.538395388596758*^9, 3.538395440076084*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"vec", "=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"0.0000000000001", ",", 
      RowBox[{"3.", "-", 
       FractionBox[
        SuperscriptBox["q", "2"], "4"]}], ",", "1.", ",", "0.0000000000001", 
      ",", "0.0000000000001", ",", "q", ",", 
      RowBox[{"-", "q"}], ",", 
      RowBox[{"-", 
       RowBox[{"(", 
        RowBox[{"1.", "+", 
         FractionBox[
          SuperscriptBox["q", "2"], "4"]}], ")"}]}]}], "}"}], "-", 
    RowBox[{"0.2", "*", "evec"}]}]}], ";"}]], "Input",
 CellChangeTimes->{
  3.5381366020899467`*^9, {3.538328422257468*^9, 3.5383284518318768`*^9}, 
   3.538328887038381*^9, {3.538331754993125*^9, 3.5383317597446136`*^9}, {
   3.538331893617297*^9, 3.538331896097275*^9}, {3.538331961393141*^9, 
   3.538331965384636*^9}, {3.538380438091875*^9, 3.538380445343212*^9}, 
   3.5383946710003633`*^9, {3.538395044041169*^9, 3.538395050152924*^9}, 
   3.538395130768721*^9, 3.538395162688527*^9, {3.538395256440628*^9, 
   3.538395297883622*^9}, {3.538395364429879*^9, 3.53839537602993*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"mat", "=", 
    RowBox[{"{", "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"eq0", "=", 
    RowBox[{"inteq", "[", 
     RowBox[{"1.", ",", 
      RowBox[{"vec", "[", 
       RowBox[{"[", "1", "]"}], "]"}], ",", "q", ",", 
      RowBox[{"vec", "[", 
       RowBox[{"[", "2", "]"}], "]"}], ",", 
      RowBox[{"vec", "[", 
       RowBox[{"[", "3", "]"}], "]"}], ",", 
      RowBox[{"vec", "[", 
       RowBox[{"[", "4", "]"}], "]"}], ",", 
      RowBox[{"vec", "[", 
       RowBox[{"[", "5", "]"}], "]"}], ",", 
      RowBox[{"vec", "[", 
       RowBox[{"[", "6", "]"}], "]"}], ",", 
      RowBox[{"vec", "[", 
       RowBox[{"[", "7", "]"}], "]"}], ",", 
      RowBox[{"vec", "[", 
       RowBox[{"[", "8", "]"}], "]"}], ",", "2"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DX", " ", "=", " ", "0.000001"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Do", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"vec0", "=", "vec"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"vec0", "[", 
        RowBox[{"[", "jj", "]"}], "]"}], "-=", "DX"}], " ", ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"eq1", "=", 
       RowBox[{"inteq", "[", 
        RowBox[{"1.", ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", "q", ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "2", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "3", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "4", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "5", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "6", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "7", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "8", "]"}], "]"}], ",", "2"}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"vec0", "[", 
        RowBox[{"[", "jj", "]"}], "]"}], "+=", 
       RowBox[{"2", "*", "DX"}]}], " ", ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"eq2", "=", 
       RowBox[{"inteq", "[", 
        RowBox[{"1.", ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", "q", ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "2", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "3", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "4", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "5", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "6", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "7", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "8", "]"}], "]"}], ",", "2"}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"AppendTo", "[", 
       RowBox[{"mat", ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"eq2", "-", "eq1"}], ")"}], "/", 
         RowBox[{"(", 
          RowBox[{"2", "*", "DX"}], ")"}]}]}], "]"}], ";"}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"jj", ",", "1", ",", "8"}], "}"}]}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<det = \>\"", ",", 
     RowBox[{"Det", "[", "mat", "]"}]}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"dvec", "=", 
    RowBox[{
     RowBox[{"Inverse", "[", 
      RowBox[{"Transpose", "[", "mat", "]"}], "]"}], ".", "eq0"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"vec", " ", "=", " ", 
    RowBox[{"vec", "-", "dvec"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<vec = \>\"", ",", "vec", ",", "\"\<  ->  eq = \>\"", ",", "eq0"}], 
   "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.538120490121634*^9, 3.538120518932563*^9}, {
   3.5381205558741503`*^9, 3.538120610837431*^9}, {3.5381206659362717`*^9, 
   3.538120712255209*^9}, {3.5383285846229553`*^9, 3.538328585388818*^9}, {
   3.538328684844769*^9, 3.5383286852597733`*^9}, 3.538328770081517*^9, {
   3.5383289405611877`*^9, 3.5383289561436033`*^9}, {3.538329024216524*^9, 
   3.538329027272518*^9}, {3.538329231307086*^9, 3.538329245530115*^9}, {
   3.53832928014611*^9, 3.5383292802257977`*^9}, {3.538331899292232*^9, 
   3.538331918317177*^9}, {3.5383320080930357`*^9, 3.53833201029294*^9}, {
   3.5383320534615726`*^9, 3.538332054173419*^9}, {3.538332091130785*^9, 
   3.538332091290278*^9}, {3.538332148467001*^9, 3.538332166530912*^9}, {
   3.538332763655594*^9, 3.538332763839275*^9}, 3.538332811566271*^9, {
   3.5383329603107758`*^9, 3.538333014609095*^9}, {3.538372704879333*^9, 
   3.538372748091798*^9}, {3.538380094711239*^9, 3.538380095245941*^9}, {
   3.538394672675757*^9, 3.538394672818479*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"vec", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.3829468917328384`"}], ",", "0.7375309427221062`", ",", 
     "0.9658412255786136`", ",", "0.3246514074125869`", ",", 
     RowBox[{"-", "0.28242066863611487`"}], ",", "3.00617950632583`", ",", 
     RowBox[{"-", "3.022120996980998`"}], ",", 
     RowBox[{"-", "3.255070720450515`"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.538395488974235*^9, 3.538395494671344*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"q", "=", "3.0"}], ";"}]], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"nsol", "=", 
   RowBox[{"FindRoot", "[", 
    RowBox[{
     RowBox[{"inteq", "[", 
      RowBox[{
      "1.", ",", "x1", ",", "q", ",", "x2", ",", "x3", ",", "x4", ",", "x5", 
       ",", "x6", ",", "x7", ",", "x8", ",", "2"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x1", ",", 
       RowBox[{"vec", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x2", ",", 
       RowBox[{"vec", "[", 
        RowBox[{"[", "2", "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x3", ",", 
       RowBox[{"vec", "[", 
        RowBox[{"[", "3", "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x4", ",", 
       RowBox[{"vec", "[", 
        RowBox[{"[", "4", "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x5", ",", 
       RowBox[{"vec", "[", 
        RowBox[{"[", "5", "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x6", ",", 
       RowBox[{"vec", "[", 
        RowBox[{"[", "6", "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x7", ",", 
       RowBox[{"vec", "[", 
        RowBox[{"[", "7", "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x8", ",", 
       RowBox[{"vec", "[", 
        RowBox[{"[", "8", "]"}], "]"}]}], "}"}]}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
    RowBox[{"inteq", "[", 
     RowBox[{
     "1.", ",", "x1", ",", "q", ",", "x2", ",", "x3", ",", "x4", ",", "x5", 
      ",", "x6", ",", "x7", ",", "x8", ",", "2"}], "]"}], "/.", "nsol"}], 
   "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.5383955289097357`*^9, 3.538395607280014*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"plt1", "=", 
    RowBox[{"Plot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"p", "[", "z", "]"}], "^", "2"}], "+", 
          RowBox[{
           RowBox[{"h", "[", "z", "]"}], "^", "2"}]}], ")"}], "^", 
        RowBox[{"(", 
         RowBox[{"1", "/", "2"}], ")"}]}], "/.", "nsol1"}], ",", 
      RowBox[{"{", 
       RowBox[{"z", ",", "eps", ",", "zcut1"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"plt2", "=", 
    RowBox[{"Plot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"p", "[", "z", "]"}], "^", "2"}], "+", 
          RowBox[{
           RowBox[{"h", "[", "z", "]"}], "^", "2"}]}], ")"}], "^", 
        RowBox[{"(", 
         RowBox[{"1", "/", "2"}], ")"}]}], "/.", "nsol2"}], ",", 
      RowBox[{"{", 
       RowBox[{"z", ",", "zcut2", ",", "zhoriz"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{"plt1", ",", "plt2"}], "]"}]}], "Input",
 CellChangeTimes->{{3.538395735376672*^9, 3.53839575583502*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"plt1", "=", 
    RowBox[{"Plot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"p", "[", "z", "]"}], "/.", "nsol1"}], ",", 
      RowBox[{"{", 
       RowBox[{"z", ",", "eps", ",", "zcut1"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"plt2", "=", 
    RowBox[{"Plot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"p", "[", "z", "]"}], "/.", "nsol2"}], ",", 
      RowBox[{"{", 
       RowBox[{"z", ",", "zcut2", ",", "zhoriz"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{"plt1", ",", "plt2"}], "]"}]}], "Input",
 CellChangeTimes->{{3.538395645101112*^9, 3.5383956470443773`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"plt1", "=", 
    RowBox[{"Plot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"h", "[", "z", "]"}], "/.", "nsol1"}], ",", 
      RowBox[{"{", 
       RowBox[{"z", ",", "eps", ",", "zcut1"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"plt2", "=", 
    RowBox[{"Plot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"h", "[", "z", "]"}], "/.", "nsol2"}], ",", 
      RowBox[{"{", 
       RowBox[{"z", ",", "zcut2", ",", "zhoriz"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{"plt1", ",", "plt2"}], "]"}]}], "Input",
 CellChangeTimes->{{3.538395660340578*^9, 3.538395661228434*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"plt1", "=", 
    RowBox[{"Plot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", "z", "]"}], "/.", "nsol1"}], ",", 
      RowBox[{"{", 
       RowBox[{"z", ",", "eps", ",", "zcut1"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"plt2", "=", 
    RowBox[{"Plot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", "z", "]"}], "/.", "nsol2"}], ",", 
      RowBox[{"{", 
       RowBox[{"z", ",", "zcut2", ",", "zhoriz"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{"plt1", ",", "plt2"}], "]"}]}], "Input",
 CellChangeTimes->{{3.5383956126740437`*^9, 3.538395637955501*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"plt1", "=", 
    RowBox[{"Plot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"a", "[", "z", "]"}], "/.", "nsol1"}], ",", 
      RowBox[{"{", 
       RowBox[{"z", ",", "eps", ",", "zcut1"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"plt2", "=", 
    RowBox[{"Plot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"a", "[", "z", "]"}], "/.", "nsol2"}], ",", 
      RowBox[{"{", 
       RowBox[{"z", ",", "zcut2", ",", "zhoriz"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{"plt1", ",", "plt2"}], "]"}]}], "Input",
 CellChangeTimes->{{3.53839567437263*^9, 3.538395675044032*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"plt1", "=", 
    RowBox[{"Plot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"S", "[", "z", "]"}], "/.", "nsol1"}], ",", 
      RowBox[{"{", 
       RowBox[{"z", ",", "eps", ",", "zcut1"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"plt2", "=", 
    RowBox[{"Plot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"S", "[", "z", "]"}], "/.", "nsol2"}], ",", 
      RowBox[{"{", 
       RowBox[{"z", ",", "zcut2", ",", "zhoriz"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{"plt1", ",", "plt2"}], "]"}]}], "Input",
 CellChangeTimes->{{3.5383956807250023`*^9, 3.538395683147913*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"vec", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "0.3829468917328384`"}], ",", "0.7375309427221062`", ",", 
      "0.9658412255786136`", ",", "0.3246514074125869`", ",", 
      RowBox[{"-", "0.28242066863611487`"}], ",", "3.00617950632583`", ",", 
      RowBox[{"-", "3.022120996980998`"}], ",", 
      RowBox[{"-", "3.255070720450515`"}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"veclist", "=", 
    RowBox[{"{", "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"nsol", "=", 
      RowBox[{"FindRoot", "[", 
       RowBox[{
        RowBox[{"inteq", "[", 
         RowBox[{
         "1.", ",", "x1", ",", "q", ",", "x2", ",", "x3", ",", "x4", ",", 
          "x5", ",", "x6", ",", "x7", ",", "x8", ",", "2"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"x1", ",", 
          RowBox[{"vec", "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"x2", ",", 
          RowBox[{"vec", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"x3", ",", 
          RowBox[{"vec", "[", 
           RowBox[{"[", "3", "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"x4", ",", 
          RowBox[{"vec", "[", 
           RowBox[{"[", "4", "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"x5", ",", 
          RowBox[{"vec", "[", 
           RowBox[{"[", "5", "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"x6", ",", 
          RowBox[{"vec", "[", 
           RowBox[{"[", "6", "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"x7", ",", 
          RowBox[{"vec", "[", 
           RowBox[{"[", "7", "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"x8", ",", 
          RowBox[{"vec", "[", 
           RowBox[{"[", "8", "]"}], "]"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"tmp", "=", 
      RowBox[{
       RowBox[{"inteq", "[", 
        RowBox[{
        "1.", ",", "x1", ",", "q", ",", "x2", ",", "x3", ",", "x4", ",", "x5",
          ",", "x6", ",", "x7", ",", "x8", ",", "2"}], "]"}], "/.", 
       "nsol"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Norm", "[", "tmp", "]"}], "<", 
        RowBox[{"10", "^", 
         RowBox[{"-", "8"}]}]}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"vec", "=", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "x1", ",", "x2", ",", "x3", ",", "x4", ",", "x5", ",", "x6", ",", 
            "x7", ",", "x8"}], "}"}], "/.", "nsol"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<q = \>\"", ",", "q", ",", "\"\< -> \>\"", ",", 
          RowBox[{"Norm", "[", "tmp", "]"}], ",", "\"\<\\n   \>\"", ",", 
          "vec", ",", "\"\<\\n\\n\>\""}], "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"AppendTo", "[", 
         RowBox[{"veclist", ",", 
          RowBox[{"{", 
           RowBox[{"q", ",", "nsol"}], "}"}]}], "]"}], ";"}], 
       "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Print", "[", "\"\<Done\>\"", "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"q", " ", "=", " ", "10."}], " ", ";"}]}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], ";"}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
    RowBox[{"{", 
     RowBox[{"q", ",", "3.0", ",", "3.3", ",", 
      RowBox[{"+", "0.01"}]}], "}"}]}], "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.5383955289097357`*^9, 3.538395607280014*^9}, {
   3.5383960750003557`*^9, 3.538396215074095*^9}, {3.538396289910667*^9, 
   3.5383963203716497`*^9}, {3.538396509259591*^9, 3.5383965728440866`*^9}, {
   3.5383966941917267`*^9, 3.538396697847146*^9}, 3.538396737895993*^9, {
   3.53839744436998*^9, 3.538397450144785*^9}}],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{
     RowBox[{"inteq", "[", 
      RowBox[{
      "1.", ",", "x1", ",", "q", ",", "x2", ",", "x3", ",", "x4", ",", "x5", 
       ",", "x6", ",", "x7", ",", "x8", ",", "2"}], "]"}], "/.", "nsol"}], 
    "]"}], ";"}]}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Numerics - High precision", "Subsubtitle",
 CellChangeTimes->{{3.538463013798025*^9, 3.5384630213987093`*^9}, {
  3.538467402992407*^9, 3.5384674058714247`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"precision", "=", "25"}], ";"}]], "Input",
 CellChangeTimes->{{3.538467418163487*^9, 3.5384674209374638`*^9}, {
  3.538467503829393*^9, 3.538467504196958*^9}, {3.5384675867083883`*^9, 
  3.5384675867768393`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Clear", "[", 
    RowBox[{"inteq", ",", "zhoriz", ",", "eps"}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"inteq", "[", 
    RowBox[{
    "z0in_Real", ",", "horizp0in_Real", ",", "horiza1in_Real", ",", 
     "horizt1in_Real", ",", "horizs0in_Real", ",", "asymp2in_Real", ",", 
     "asymh2in_Real", ",", "asyma0in_Real", ",", "asyma1in_Real", ",", 
     "asymT3in_Real", ",", "output_"}], "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"z0", "=", "z0in"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"horizp0", "=", "horizp0in"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"horizh0", "=", "0"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"horiza1", "=", "horiza1in"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"horizt1", "=", "horizt1in"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"horizs0", "=", "horizs0in"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"asymp2", "=", "asymp2in"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"asymh2", "=", "asymh2in"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"asyma0", "=", "asyma0in"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"asyma1", "=", "asyma1in"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"asymT3", "=", "asymT3in"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"eps", "=", "0.00001"}], " ", ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"eps2", "=", "0.00001"}], " ", ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"zmid", " ", "=", " ", "0.4"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"zhoriz", "=", 
      RowBox[{"1", "-", "eps2"}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"nsol1", "=", 
      RowBox[{
       RowBox[{"NDSolve", "[", 
        RowBox[{
         RowBox[{"Join", "[", 
          RowBox[{"eqlist", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"p", "[", "eps", "]"}], "\[Equal]", 
              RowBox[{"asymp", "[", "eps", "]"}]}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"p", "'"}], "[", "eps", "]"}], "\[Equal]", 
              RowBox[{
               RowBox[{"asymp", "'"}], "[", "eps", "]"}]}], ",", 
             RowBox[{
              RowBox[{"h", "[", "eps", "]"}], "\[Equal]", 
              RowBox[{"asymh", "[", "eps", "]"}]}], ",", 
             RowBox[{
              RowBox[{"a", "[", "eps", "]"}], "\[Equal]", 
              RowBox[{"asyma", "[", "eps", "]"}]}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"a", "'"}], "[", "eps", "]"}], "\[Equal]", 
              RowBox[{
               RowBox[{"asyma", "'"}], "[", "eps", "]"}]}], ",", 
             RowBox[{
              RowBox[{"T", "[", "eps", "]"}], "\[Equal]", 
              RowBox[{"asymT", "[", "eps", "]"}]}], ",", 
             RowBox[{
              RowBox[{"S", "[", "eps", "]"}], "\[Equal]", 
              RowBox[{"asymS", "[", "eps", "]"}]}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"S", "'"}], "[", "eps", "]"}], "\[Equal]", 
              RowBox[{
               RowBox[{"asymS", "'"}], "[", "eps", "]"}]}]}], "}"}]}], "]"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"p", ",", "h", ",", "a", ",", "T", ",", "S"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"z", ",", "eps", ",", "zhoriz"}], "}"}], ",", 
         RowBox[{"WorkingPrecision", "\[Rule]", "precision"}], ",", 
         RowBox[{"MaxSteps", "\[Rule]", "100000"}]}], "]"}], "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"zcut1", "=", 
      RowBox[{"nsol1", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "2", ",", "1", ",", "1", ",", "2"}], "]"}], "]"}]}],
      ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"zcut1", "<", "zmid"}], ",", 
       RowBox[{"Print", "[", 
        RowBox[{"\"\<Error  \>\"", ",", "zcut2"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"nsol2", "=", 
      RowBox[{
       RowBox[{"NDSolve", "[", 
        RowBox[{
         RowBox[{"Join", "[", 
          RowBox[{"eqlist", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"p", "[", "zhoriz", "]"}], "\[Equal]", 
              RowBox[{"horizp", "[", "zhoriz", "]"}]}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"p", "'"}], "[", "zhoriz", "]"}], "\[Equal]", 
              RowBox[{
               RowBox[{"horizp", "'"}], "[", "zhoriz", "]"}]}], ",", 
             RowBox[{
              RowBox[{"h", "[", "zhoriz", "]"}], "\[Equal]", 
              RowBox[{"horizh", "[", "zhoriz", "]"}]}], ",", 
             RowBox[{
              RowBox[{"a", "[", "zhoriz", "]"}], "\[Equal]", 
              RowBox[{"horiza", "[", "zhoriz", "]"}]}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"a", "'"}], "[", "zhoriz", "]"}], "\[Equal]", 
              RowBox[{
               RowBox[{"horiza", "'"}], "[", "zhoriz", "]"}]}], ",", 
             RowBox[{
              RowBox[{"T", "[", "zhoriz", "]"}], "\[Equal]", 
              RowBox[{"horizT", "[", "zhoriz", "]"}]}], ",", 
             RowBox[{
              RowBox[{"S", "[", "zhoriz", "]"}], "\[Equal]", 
              RowBox[{"horizS", "[", "zhoriz", "]"}]}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"S", "'"}], "[", "zhoriz", "]"}], "\[Equal]", 
              RowBox[{
               RowBox[{"horizS", "'"}], "[", "zhoriz", "]"}]}]}], "}"}]}], 
          "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"p", ",", "h", ",", "a", ",", "T", ",", "S"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"z", ",", "eps", ",", "zhoriz"}], "}"}], ",", 
         RowBox[{"WorkingPrecision", "\[Rule]", "precision"}], ",", 
         RowBox[{"MaxSteps", "\[Rule]", "100000"}]}], "]"}], "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"zcut2", "=", 
      RowBox[{"nsol2", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "2", ",", "1", ",", "1", ",", "1"}], "]"}], "]"}]}],
      ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"zcut2", ">", "zmid"}], ",", 
       RowBox[{"Print", "[", 
        RowBox[{"\"\<Error  \>\"", ",", "zcut2"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"Clear", "[", 
      RowBox[{
      "horizp0", ",", "horizh0", ",", "horiza1", ",", "horizt1", ",", 
       "horizs0", ",", "asymp2", ",", "asymh2", ",", "asyma0", ",", "asyma1", 
       ",", "asymT3"}], "]"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"output", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"Return", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"h", "'"}], "[", "eps", "]"}], ",", 
             RowBox[{
              RowBox[{"T", "'"}], "[", "eps", "]"}]}], "}"}], "/.", "nsol2"}],
           "]"}], ";"}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"htab", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{
              RowBox[{"h", "[", "z", "]"}], "/.", "nsol2"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"20", "eps"}], ",", 
             RowBox[{"100", "eps"}], ",", 
             RowBox[{"10", "eps"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Ttab", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{
              RowBox[{
               RowBox[{"T", "[", "z", "]"}], "-", "1"}], "/.", "nsol2"}]}], 
            "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"20", "eps"}], ",", 
             RowBox[{"100", "eps"}], ",", 
             RowBox[{"10", "eps"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"hfit", "=", 
         RowBox[{"Fit", "[", 
          RowBox[{"htab", ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"z", "^", "2"}]}], "}"}], ",", "z"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Tfit", "=", 
         RowBox[{"Fit", "[", 
          RowBox[{"Ttab", ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"z", "^", "2"}]}], "}"}], ",", "z"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Return", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Coefficient", "[", 
            RowBox[{"hfit", ",", "z"}], "]"}], ",", 
           RowBox[{"Coefficient", "[", 
            RowBox[{"Tfit", ",", "z"}], "]"}]}], "}"}], "]"}], ";"}]}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"output", "\[Equal]", "2"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"list", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"p", "[", "zmid", "]"}], "/.", "nsol1"}], ")"}], "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"p", "[", "zmid", "]"}], "/.", "nsol2"}], ")"}]}], ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"h", "[", "zmid", "]"}], "/.", "nsol1"}], ")"}], "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"h", "[", "zmid", "]"}], "/.", "nsol2"}], ")"}]}], ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"a", "[", "zmid", "]"}], "/.", "nsol1"}], ")"}], "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"a", "[", "zmid", "]"}], "/.", "nsol2"}], ")"}]}], ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"T", "[", "zmid", "]"}], "/.", "nsol1"}], ")"}], "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"T", "[", "zmid", "]"}], "/.", "nsol2"}], ")"}]}], ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"S", "[", "zmid", "]"}], "/.", "nsol1"}], ")"}], "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"S", "[", "zmid", "]"}], "/.", "nsol2"}], ")"}]}]}], 
          "}"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"dlist", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"p", "'"}], "[", "zmid", "]"}], "/.", "nsol1"}], ")"}],
             "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"p", "'"}], "[", "zmid", "]"}], "/.", "nsol2"}], 
             ")"}]}], ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"a", "'"}], "[", "zmid", "]"}], "/.", "nsol1"}], ")"}],
             "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"a", "'"}], "[", "zmid", "]"}], "/.", "nsol2"}], 
             ")"}]}], ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"S", "'"}], "[", "zmid", "]"}], "/.", "nsol1"}], ")"}],
             "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"S", "'"}], "[", "zmid", "]"}], "/.", "nsol2"}], 
             ")"}]}]}], "}"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"Return", "[", 
         RowBox[{"Join", "[", 
          RowBox[{"list", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"dlist", "[", 
              RowBox[{"[", "1", "]"}], "]"}], ",", 
             RowBox[{"dlist", "[", 
              RowBox[{"[", "2", "]"}], "]"}], ",", 
             RowBox[{"dlist", "[", 
              RowBox[{"[", "3", "]"}], "]"}]}], "}"}]}], "]"}], "]"}], 
        ";"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"output", "\[Equal]", "0"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"ptab", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{
              RowBox[{"p", "[", "z", "]"}], "/.", "nsol2"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"20", "eps"}], ",", 
             RowBox[{"100", "eps"}], ",", 
             RowBox[{"10", "eps"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"htab", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{
              RowBox[{"h", "[", "z", "]"}], "/.", "nsol2"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"20", "eps"}], ",", 
             RowBox[{"100", "eps"}], ",", 
             RowBox[{"10", "eps"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"atab", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{
              RowBox[{"a", "[", "z", "]"}], "/.", "nsol2"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"20", "eps"}], ",", 
             RowBox[{"100", "eps"}], ",", 
             RowBox[{"10", "eps"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Ttab", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{
              RowBox[{
               RowBox[{"T", "[", "z", "]"}], "-", "1"}], "/.", "nsol2"}]}], 
            "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"20", "eps"}], ",", 
             RowBox[{"100", "eps"}], ",", 
             RowBox[{"10", "eps"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Stab", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{
              RowBox[{"S", "[", "z", "]"}], "/.", "nsol2"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"20", "eps"}], ",", 
             RowBox[{"100", "eps"}], ",", 
             RowBox[{"10", "eps"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"pfit", "=", 
         RowBox[{"Fit", "[", 
          RowBox[{"ptab", ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"z", "^", "2"}]}], "}"}], ",", "z"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"hfit", "=", 
         RowBox[{"Fit", "[", 
          RowBox[{"htab", ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"z", "^", "2"}]}], "}"}], ",", "z"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"afit", "=", 
         RowBox[{"Fit", "[", 
          RowBox[{"atab", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "z"}], "}"}], ",", "z"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Tfit", "=", 
         RowBox[{"Fit", "[", 
          RowBox[{"Ttab", ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"z", "^", "2"}], ",", 
             RowBox[{"z", "^", "3"}]}], "}"}], ",", "z"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Sfit", "=", 
         RowBox[{"Fit", "[", 
          RowBox[{"Stab", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "z"}], "}"}], ",", "z"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"pfit2", "=", 
         RowBox[{"Fit", "[", 
          RowBox[{"ptab", ",", 
           RowBox[{"{", 
            RowBox[{"z", "^", "2"}], "}"}], ",", "z"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"hfit2", "=", 
         RowBox[{"Fit", "[", 
          RowBox[{"htab", ",", 
           RowBox[{"{", 
            RowBox[{"z", "^", "2"}], "}"}], ",", "z"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Tfit2", "=", 
         RowBox[{"Fit", "[", 
          RowBox[{"Ttab", ",", 
           RowBox[{"{", 
            RowBox[{"z", "^", "3"}], "}"}], ",", "z"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Return", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"pf", "==", "pfit"}], ",", 
             RowBox[{"hf", "\[Equal]", "hfit"}], ",", 
             RowBox[{"af", "\[Equal]", "afit"}], ",", 
             RowBox[{"Tf", "\[Equal]", "Tfit"}], ",", 
             RowBox[{"Sf", "\[Equal]", "Sfit"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"pfit2", ",", "hfit2", ",", "Tfit2"}], "}"}]}], "}"}], 
         "]"}], ";"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], 
     ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", ")"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.5376407771099586`*^9, 3.53764077742128*^9}, {
   3.537640849432414*^9, 3.537641029700471*^9}, {3.537641083186082*^9, 
   3.5376410832815037`*^9}, {3.537641227496984*^9, 3.537641241071927*^9}, {
   3.537641278231781*^9, 3.53764129200132*^9}, {3.537811594660029*^9, 
   3.537811661635552*^9}, 3.537811712330718*^9, {3.537812313668707*^9, 
   3.537812329718534*^9}, {3.537812368025175*^9, 3.537812466952651*^9}, {
   3.537812574550178*^9, 3.53781262207281*^9}, {3.537855902100842*^9, 
   3.537855910975484*^9}, {3.537863637889791*^9, 3.537863642968212*^9}, {
   3.53786405512639*^9, 3.5378640577014513`*^9}, {3.5378642740193357`*^9, 
   3.5378642823266706`*^9}, {3.537864945886372*^9, 3.537864949610241*^9}, {
   3.537865324468916*^9, 3.5378653414829493`*^9}, {3.537865422417637*^9, 
   3.537865426010881*^9}, {3.537865668894218*^9, 3.5378656720161123`*^9}, {
   3.537866060689427*^9, 3.537866086110963*^9}, {3.537866821965849*^9, 
   3.537866824468356*^9}, {3.537866935754058*^9, 3.5378669532770844`*^9}, {
   3.537867277477654*^9, 3.537867283864683*^9}, {3.5378673736645327`*^9, 
   3.53786741047612*^9}, {3.537867724358015*^9, 3.537867770909184*^9}, {
   3.537867812374217*^9, 3.537867814824875*^9}, {3.537867862682262*^9, 
   3.537867863608501*^9}, {3.537867935345325*^9, 3.537867952471974*^9}, {
   3.537867984898217*^9, 3.5378679871300287`*^9}, {3.537870400150711*^9, 
   3.537870402077724*^9}, {3.537870448958918*^9, 3.5378704524785967`*^9}, {
   3.537870930220189*^9, 3.537870930900414*^9}, 3.537871139674671*^9, {
   3.537871192589308*^9, 3.53787120155658*^9}, {3.537871653378598*^9, 
   3.5378716648098917`*^9}, {3.537871703252593*^9, 3.537871787942024*^9}, {
   3.537871824557847*^9, 3.537871910740779*^9}, {3.537871941253039*^9, 
   3.5378719525649443`*^9}, {3.537871994498852*^9, 3.537872049059258*^9}, {
   3.537872138421897*^9, 3.537872144006673*^9}, {3.537872196836445*^9, 
   3.53787224947705*^9}, {3.5378722878468122`*^9, 3.537872372883222*^9}, {
   3.537872490150178*^9, 3.537872496093255*^9}, {3.537872547385435*^9, 
   3.537872561998753*^9}, {3.537872800792879*^9, 3.5378728967451353`*^9}, {
   3.537872969967389*^9, 3.537872993322166*^9}, {3.5378733845638*^9, 
   3.537873523491342*^9}, {3.537874990501849*^9, 3.5378750749448233`*^9}, {
   3.538046326178605*^9, 3.5380463263452587`*^9}, {3.538046359506956*^9, 
   3.5380464610359497`*^9}, {3.538046502103581*^9, 3.538046513481264*^9}, {
   3.53804657410702*^9, 3.538046614577108*^9}, {3.53804665505602*^9, 
   3.538046715360199*^9}, {3.538046757351519*^9, 3.53804676998315*^9}, {
   3.5380468595384607`*^9, 3.5380468659616413`*^9}, {3.538046897437215*^9, 
   3.538046897572302*^9}, {3.538047066640044*^9, 3.538047074544244*^9}, {
   3.538047229999874*^9, 3.5380472836305647`*^9}, {3.538047353035921*^9, 
   3.538047363818179*^9}, {3.538047476249525*^9, 3.538047522111104*^9}, {
   3.5380475966181917`*^9, 3.5380475967702713`*^9}, {3.538047801532692*^9, 
   3.538047822201064*^9}, {3.538047948516816*^9, 3.538047948684765*^9}, {
   3.538114366350466*^9, 3.5381144299925222`*^9}, {3.538114576757052*^9, 
   3.5381146749454412`*^9}, {3.538114791107875*^9, 3.5381148266944447`*^9}, {
   3.538114878968347*^9, 3.538115127215603*^9}, {3.53811552595366*^9, 
   3.538115590252236*^9}, {3.5381156363832006`*^9, 3.538115704042387*^9}, {
   3.53811589099817*^9, 3.53811590783984*^9}, {3.538115999280501*^9, 
   3.5381160364460382`*^9}, 3.538116068499432*^9, {3.5381163172614202`*^9, 
   3.5381163185592117`*^9}, 3.538116587083933*^9, {3.538116795975728*^9, 
   3.5381167961435547`*^9}, {3.538116915101754*^9, 3.538116916845715*^9}, {
   3.538117082639504*^9, 3.5381170838467207`*^9}, {3.538117120446578*^9, 
   3.538117121605109*^9}, {3.538117912630061*^9, 3.5381179255489893`*^9}, {
   3.538118168821506*^9, 3.538118170682723*^9}, {3.5381182778513527`*^9, 
   3.538118288943109*^9}, {3.5381183580154047`*^9, 3.5381183581193533`*^9}, {
   3.538118848337666*^9, 3.538118920486744*^9}, {3.538119184188271*^9, 
   3.53811918440349*^9}, {3.5381193489118156`*^9, 3.538119350612996*^9}, {
   3.538119892508926*^9, 3.538119895751055*^9}, {3.538119927591441*^9, 
   3.538119936248074*^9}, {3.538120029047421*^9, 3.538120037965654*^9}, {
   3.538120194027095*^9, 3.538120201471917*^9}, {3.53812028017563*^9, 
   3.538120301265314*^9}, {3.5381381252717533`*^9, 3.538138126469459*^9}, {
   3.538328246372367*^9, 3.5383282504354353`*^9}, {3.5383283005077343`*^9, 
   3.538328335488717*^9}, {3.538329001230315*^9, 3.538329010372521*^9}, {
   3.5383292041149054`*^9, 3.538329214953123*^9}, {3.5383314262207823`*^9, 
   3.538331427882743*^9}, {3.538467415297628*^9, 3.538467417025399*^9}, {
   3.538467483475766*^9, 3.538467496260305*^9}, {3.53846768282121*^9, 
   3.538467684491909*^9}, 3.538467751698575*^9, 3.538467834293067*^9, 
   3.538467910310305*^9, {3.538474665252652*^9, 3.5384747132015*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"inteq", "[", 
   RowBox[{
   "1.", ",", "x1", ",", "q", ",", "x2", ",", "x3", ",", "x4", ",", "x5", ",",
     "x6", ",", "x7", ",", "x8", ",", "2"}], "]"}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"x1", "\[Rule]", 
     RowBox[{"-", "0.3829783523505521`"}]}], ",", 
    RowBox[{"x2", "\[Rule]", "0.7375353380516665`"}], ",", 
    RowBox[{"x3", "\[Rule]", "0.965835601510695`"}], ",", 
    RowBox[{"x4", "\[Rule]", "0.324681251811493`"}], ",", 
    RowBox[{"x5", "\[Rule]", 
     RowBox[{"-", "0.28247228958217985`"}]}], ",", 
    RowBox[{"x6", "\[Rule]", "3.0061810011547174`"}], ",", 
    RowBox[{"x7", "\[Rule]", 
     RowBox[{"-", "3.0221253004173594`"}]}], ",", 
    RowBox[{"x8", "\[Rule]", 
     RowBox[{"-", "3.257338115215336`"}]}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.53847464194142*^9, 3.538474642222443*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"vec", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.3829468917328384`"}], ",", "0.7375309427221062`", ",", 
     "0.9658412255786136`", ",", "0.3246514074125869`", ",", 
     RowBox[{"-", "0.28242066863611487`"}], ",", "3.00617950632583`", ",", 
     RowBox[{"-", "3.022120996980998`"}], ",", 
     RowBox[{"-", "3.255070720450515`"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.538395488974235*^9, 3.538395494671344*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"q", "=", "3.0"}], ";"}]], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"nsol", "=", 
   RowBox[{"FindRoot", "[", 
    RowBox[{
     RowBox[{"inteq", "[", 
      RowBox[{
      "1.", ",", "x1", ",", "q", ",", "x2", ",", "x3", ",", "x4", ",", "x5", 
       ",", "x6", ",", "x7", ",", "x8", ",", "2"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x1", ",", 
       RowBox[{"vec", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x2", ",", 
       RowBox[{"vec", "[", 
        RowBox[{"[", "2", "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x3", ",", 
       RowBox[{"vec", "[", 
        RowBox[{"[", "3", "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x4", ",", 
       RowBox[{"vec", "[", 
        RowBox[{"[", "4", "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x5", ",", 
       RowBox[{"vec", "[", 
        RowBox[{"[", "5", "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x6", ",", 
       RowBox[{"vec", "[", 
        RowBox[{"[", "6", "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x7", ",", 
       RowBox[{"vec", "[", 
        RowBox[{"[", "7", "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x8", ",", 
       RowBox[{"vec", "[", 
        RowBox[{"[", "8", "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"WorkingPrecision", "\[Rule]", "25"}]}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
    RowBox[{"inteq", "[", 
     RowBox[{
     "1.", ",", "x1", ",", "q", ",", "x2", ",", "x3", ",", "x4", ",", "x5", 
      ",", "x6", ",", "x7", ",", "x8", ",", "2"}], "]"}], "/.", "nsol"}], 
   "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.5383955289097357`*^9, 3.538395607280014*^9}, {
  3.5384675702538347`*^9, 3.538467573581067*^9}, {3.538467922768297*^9, 
  3.5384679239991417`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"plt1", "=", 
    RowBox[{"Plot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"p", "[", "z", "]"}], "^", "2"}], "+", 
          RowBox[{
           RowBox[{"h", "[", "z", "]"}], "^", "2"}]}], ")"}], "^", 
        RowBox[{"(", 
         RowBox[{"1", "/", "2"}], ")"}]}], "/.", "nsol1"}], ",", 
      RowBox[{"{", 
       RowBox[{"z", ",", "eps", ",", "zcut1"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"plt2", "=", 
    RowBox[{"Plot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"p", "[", "z", "]"}], "^", "2"}], "+", 
          RowBox[{
           RowBox[{"h", "[", "z", "]"}], "^", "2"}]}], ")"}], "^", 
        RowBox[{"(", 
         RowBox[{"1", "/", "2"}], ")"}]}], "/.", "nsol2"}], ",", 
      RowBox[{"{", 
       RowBox[{"z", ",", "zcut2", ",", "zhoriz"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{"plt1", ",", "plt2"}], "]"}]}], "Input",
 CellChangeTimes->{{3.538395735376672*^9, 3.53839575583502*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"plt1", "=", 
    RowBox[{"Plot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"p", "[", "z", "]"}], "/.", "nsol1"}], ",", 
      RowBox[{"{", 
       RowBox[{"z", ",", "eps", ",", "zcut1"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"plt2", "=", 
    RowBox[{"Plot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"p", "[", "z", "]"}], "/.", "nsol2"}], ",", 
      RowBox[{"{", 
       RowBox[{"z", ",", "zcut2", ",", "zhoriz"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{"plt1", ",", "plt2"}], "]"}]}], "Input",
 CellChangeTimes->{{3.538395645101112*^9, 3.5383956470443773`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"plt1", "=", 
    RowBox[{"Plot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"h", "[", "z", "]"}], "/.", "nsol1"}], ",", 
      RowBox[{"{", 
       RowBox[{"z", ",", "eps", ",", "zcut1"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"plt2", "=", 
    RowBox[{"Plot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"h", "[", "z", "]"}], "/.", "nsol2"}], ",", 
      RowBox[{"{", 
       RowBox[{"z", ",", "zcut2", ",", "zhoriz"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{"plt1", ",", "plt2"}], "]"}]}], "Input",
 CellChangeTimes->{{3.538395660340578*^9, 3.538395661228434*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"plt1", "=", 
    RowBox[{"Plot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", "z", "]"}], "/.", "nsol1"}], ",", 
      RowBox[{"{", 
       RowBox[{"z", ",", "eps", ",", "zcut1"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"plt2", "=", 
    RowBox[{"Plot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", "z", "]"}], "/.", "nsol2"}], ",", 
      RowBox[{"{", 
       RowBox[{"z", ",", "zcut2", ",", "zhoriz"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{"plt1", ",", "plt2"}], "]"}]}], "Input",
 CellChangeTimes->{{3.5383956126740437`*^9, 3.538395637955501*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"plt1", "=", 
    RowBox[{"Plot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"a", "[", "z", "]"}], "/.", "nsol1"}], ",", 
      RowBox[{"{", 
       RowBox[{"z", ",", "eps", ",", "zcut1"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"plt2", "=", 
    RowBox[{"Plot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"a", "[", "z", "]"}], "/.", "nsol2"}], ",", 
      RowBox[{"{", 
       RowBox[{"z", ",", "zcut2", ",", "zhoriz"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{"plt1", ",", "plt2"}], "]"}]}], "Input",
 CellChangeTimes->{{3.53839567437263*^9, 3.538395675044032*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"plt1", "=", 
    RowBox[{"Plot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"S", "[", "z", "]"}], "/.", "nsol1"}], ",", 
      RowBox[{"{", 
       RowBox[{"z", ",", "eps", ",", "zcut1"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"plt2", "=", 
    RowBox[{"Plot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"S", "[", "z", "]"}], "/.", "nsol2"}], ",", 
      RowBox[{"{", 
       RowBox[{"z", ",", "zcut2", ",", "zhoriz"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{"plt1", ",", "plt2"}], "]"}]}], "Input",
 CellChangeTimes->{{3.5383956807250023`*^9, 3.538395683147913*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"vec", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "0.3829468917328384`"}], ",", "0.7375309427221062`", ",", 
      "0.9658412255786136`", ",", "0.3246514074125869`", ",", 
      RowBox[{"-", "0.28242066863611487`"}], ",", "3.00617950632583`", ",", 
      RowBox[{"-", "3.022120996980998`"}], ",", 
      RowBox[{"-", "3.255070720450515`"}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"veclist", "=", 
    RowBox[{"{", "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"nsol", "=", 
      RowBox[{"FindRoot", "[", 
       RowBox[{
        RowBox[{"inteq", "[", 
         RowBox[{
         "1.", ",", "x1", ",", "q", ",", "x2", ",", "x3", ",", "x4", ",", 
          "x5", ",", "x6", ",", "x7", ",", "x8", ",", "2"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"x1", ",", 
          RowBox[{"vec", "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"x2", ",", 
          RowBox[{"vec", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"x3", ",", 
          RowBox[{"vec", "[", 
           RowBox[{"[", "3", "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"x4", ",", 
          RowBox[{"vec", "[", 
           RowBox[{"[", "4", "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"x5", ",", 
          RowBox[{"vec", "[", 
           RowBox[{"[", "5", "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"x6", ",", 
          RowBox[{"vec", "[", 
           RowBox[{"[", "6", "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"x7", ",", 
          RowBox[{"vec", "[", 
           RowBox[{"[", "7", "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"x8", ",", 
          RowBox[{"vec", "[", 
           RowBox[{"[", "8", "]"}], "]"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"tmp", "=", 
      RowBox[{
       RowBox[{"inteq", "[", 
        RowBox[{
        "1.", ",", "x1", ",", "q", ",", "x2", ",", "x3", ",", "x4", ",", "x5",
          ",", "x6", ",", "x7", ",", "x8", ",", "2"}], "]"}], "/.", 
       "nsol"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Norm", "[", "tmp", "]"}], "<", 
        RowBox[{"10", "^", 
         RowBox[{"-", "8"}]}]}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"vec", "=", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "x1", ",", "x2", ",", "x3", ",", "x4", ",", "x5", ",", "x6", ",", 
            "x7", ",", "x8"}], "}"}], "/.", "nsol"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<q = \>\"", ",", "q", ",", "\"\< -> \>\"", ",", 
          RowBox[{"Norm", "[", "tmp", "]"}], ",", "\"\<\\n   \>\"", ",", 
          "vec", ",", "\"\<\\n\\n\>\""}], "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"AppendTo", "[", 
         RowBox[{"veclist", ",", 
          RowBox[{"{", 
           RowBox[{"q", ",", "nsol"}], "}"}]}], "]"}], ";"}], 
       "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Print", "[", "\"\<Done\>\"", "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"q", " ", "=", " ", "10."}], " ", ";"}]}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], ";"}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
    RowBox[{"{", 
     RowBox[{"q", ",", "3.0", ",", "3.3", ",", 
      RowBox[{"+", "0.01"}]}], "}"}]}], "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.5383955289097357`*^9, 3.538395607280014*^9}, {
   3.5383960750003557`*^9, 3.538396215074095*^9}, {3.538396289910667*^9, 
   3.5383963203716497`*^9}, {3.538396509259591*^9, 3.5383965728440866`*^9}, {
   3.5383966941917267`*^9, 3.538396697847146*^9}, 3.538396737895993*^9, {
   3.53839744436998*^9, 3.538397450144785*^9}}],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{
     RowBox[{"inteq", "[", 
      RowBox[{
      "1.", ",", "x1", ",", "q", ",", "x2", ",", "x3", ",", "x4", ",", "x5", 
       ",", "x6", ",", "x7", ",", "x8", ",", "2"}], "]"}], "/.", "nsol"}], 
    "]"}], ";"}]}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Numerics - High precision", "Subsubtitle",
 CellChangeTimes->{{3.538463013798025*^9, 3.5384630213987093`*^9}, {
  3.538467402992407*^9, 3.5384674058714247`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"precision", "=", "25"}], ";"}]], "Input",
 CellChangeTimes->{{3.538467418163487*^9, 3.5384674209374638`*^9}, {
  3.538467503829393*^9, 3.538467504196958*^9}, {3.5384675867083883`*^9, 
  3.5384675867768393`*^9}, {3.538475778689355*^9, 3.538475779473031*^9}, {
  3.5384759893975153`*^9, 3.538475989501337*^9}, {3.538483715861815*^9, 
  3.5384837159415283`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Clear", "[", 
    RowBox[{"inteq", ",", "zhoriz", ",", "eps"}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"inteq", "[", 
    RowBox[{
    "z0in_Real", ",", "horizp0in_Real", ",", "horiza1in_Real", ",", 
     "horizt1in_Real", ",", "horizs0in_Real", ",", "asymp2in_Real", ",", 
     "asymh2in_Real", ",", "asyma0in_Real", ",", "asyma1in_Real", ",", 
     "asymT3in_Real", ",", "output_"}], "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"z0", "=", "z0in"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"horizp0", "=", "horizp0in"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"horizh0", "=", "0"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"horiza1", "=", "horiza1in"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"horizt1", "=", "horizt1in"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"horizs0", "=", "horizs0in"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"asymp2", "=", "asymp2in"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"asymh2", "=", "asymh2in"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"asyma0", "=", "asyma0in"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"asyma1", "=", "asyma1in"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"asymT3", "=", "asymT3in"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"eps", "=", 
      RowBox[{"SetPrecision", "[", 
       RowBox[{"0.0001", ",", "30"}], "]"}]}], " ", ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"eps2", "=", 
      RowBox[{"SetPrecision", "[", 
       RowBox[{"0.0001", ",", "30"}], "]"}]}], " ", ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"zmid", " ", "=", " ", 
      RowBox[{"SetPrecision", "[", 
       RowBox[{"0.4", ",", "30"}], "]"}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"zhoriz", "=", 
      RowBox[{"1", "-", "eps2"}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"nsol1", "=", 
      RowBox[{
       RowBox[{"NDSolve", "[", 
        RowBox[{
         RowBox[{"Join", "[", 
          RowBox[{"eqlist", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"p", "[", "eps", "]"}], "\[Equal]", 
              RowBox[{"asymp", "[", "eps", "]"}]}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"p", "'"}], "[", "eps", "]"}], "\[Equal]", 
              RowBox[{
               RowBox[{"asymp", "'"}], "[", "eps", "]"}]}], ",", 
             RowBox[{
              RowBox[{"h", "[", "eps", "]"}], "\[Equal]", 
              RowBox[{"asymh", "[", "eps", "]"}]}], ",", 
             RowBox[{
              RowBox[{"a", "[", "eps", "]"}], "\[Equal]", 
              RowBox[{"asyma", "[", "eps", "]"}]}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"a", "'"}], "[", "eps", "]"}], "\[Equal]", 
              RowBox[{
               RowBox[{"asyma", "'"}], "[", "eps", "]"}]}], ",", 
             RowBox[{
              RowBox[{"T", "[", "eps", "]"}], "\[Equal]", 
              RowBox[{"asymT", "[", "eps", "]"}]}], ",", 
             RowBox[{
              RowBox[{"S", "[", "eps", "]"}], "\[Equal]", 
              RowBox[{"asymS", "[", "eps", "]"}]}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"S", "'"}], "[", "eps", "]"}], "\[Equal]", 
              RowBox[{
               RowBox[{"asymS", "'"}], "[", "eps", "]"}]}]}], "}"}]}], "]"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"p", ",", "h", ",", "a", ",", "T", ",", "S"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"z", ",", "eps", ",", "zhoriz"}], "}"}], ",", 
         RowBox[{"WorkingPrecision", "\[Rule]", "precision"}], ",", 
         RowBox[{"MaxSteps", "\[Rule]", "100000"}]}], "]"}], "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"zcut1", "=", 
      RowBox[{"nsol1", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "2", ",", "1", ",", "1", ",", "2"}], "]"}], "]"}]}],
      ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"zcut1", "<", "zmid"}], ",", 
       RowBox[{"Print", "[", 
        RowBox[{"\"\<Error  \>\"", ",", "zcut2"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"nsol2", "=", 
      RowBox[{
       RowBox[{"NDSolve", "[", 
        RowBox[{
         RowBox[{"Join", "[", 
          RowBox[{"eqlist", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"p", "[", "zhoriz", "]"}], "\[Equal]", 
              RowBox[{"horizp", "[", "zhoriz", "]"}]}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"p", "'"}], "[", "zhoriz", "]"}], "\[Equal]", 
              RowBox[{
               RowBox[{"horizp", "'"}], "[", "zhoriz", "]"}]}], ",", 
             RowBox[{
              RowBox[{"h", "[", "zhoriz", "]"}], "\[Equal]", 
              RowBox[{"horizh", "[", "zhoriz", "]"}]}], ",", 
             RowBox[{
              RowBox[{"a", "[", "zhoriz", "]"}], "\[Equal]", 
              RowBox[{"horiza", "[", "zhoriz", "]"}]}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"a", "'"}], "[", "zhoriz", "]"}], "\[Equal]", 
              RowBox[{
               RowBox[{"horiza", "'"}], "[", "zhoriz", "]"}]}], ",", 
             RowBox[{
              RowBox[{"T", "[", "zhoriz", "]"}], "\[Equal]", 
              RowBox[{"horizT", "[", "zhoriz", "]"}]}], ",", 
             RowBox[{
              RowBox[{"S", "[", "zhoriz", "]"}], "\[Equal]", 
              RowBox[{"horizS", "[", "zhoriz", "]"}]}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"S", "'"}], "[", "zhoriz", "]"}], "\[Equal]", 
              RowBox[{
               RowBox[{"horizS", "'"}], "[", "zhoriz", "]"}]}]}], "}"}]}], 
          "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"p", ",", "h", ",", "a", ",", "T", ",", "S"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"z", ",", "eps", ",", "zhoriz"}], "}"}], ",", 
         RowBox[{"WorkingPrecision", "\[Rule]", "precision"}], ",", 
         RowBox[{"MaxSteps", "\[Rule]", "100000"}]}], "]"}], "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"zcut2", "=", 
      RowBox[{"nsol2", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "2", ",", "1", ",", "1", ",", "1"}], "]"}], "]"}]}],
      ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"zcut2", ">", "zmid"}], ",", 
       RowBox[{"Print", "[", 
        RowBox[{"\"\<Error  \>\"", ",", "zcut2"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"Clear", "[", 
      RowBox[{
      "horizp0", ",", "horizh0", ",", "horiza1", ",", "horizt1", ",", 
       "horizs0", ",", "asymp2", ",", "asymh2", ",", "asyma0", ",", "asyma1", 
       ",", "asymT3"}], "]"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"output", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"Return", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"h", "'"}], "[", "eps", "]"}], ",", 
             RowBox[{
              RowBox[{"T", "'"}], "[", "eps", "]"}]}], "}"}], "/.", "nsol2"}],
           "]"}], ";"}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"htab", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{
              RowBox[{"h", "[", "z", "]"}], "/.", "nsol2"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"20", "eps"}], ",", 
             RowBox[{"100", "eps"}], ",", 
             RowBox[{"10", "eps"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Ttab", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{
              RowBox[{
               RowBox[{"T", "[", "z", "]"}], "-", "1"}], "/.", "nsol2"}]}], 
            "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"20", "eps"}], ",", 
             RowBox[{"100", "eps"}], ",", 
             RowBox[{"10", "eps"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"hfit", "=", 
         RowBox[{"Fit", "[", 
          RowBox[{"htab", ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"z", "^", "2"}]}], "}"}], ",", "z"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Tfit", "=", 
         RowBox[{"Fit", "[", 
          RowBox[{"Ttab", ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"z", "^", "2"}]}], "}"}], ",", "z"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Return", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Coefficient", "[", 
            RowBox[{"hfit", ",", "z"}], "]"}], ",", 
           RowBox[{"Coefficient", "[", 
            RowBox[{"Tfit", ",", "z"}], "]"}]}], "}"}], "]"}], ";"}]}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"output", "\[Equal]", "2"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"list", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"p", "[", "zmid", "]"}], "/.", "nsol1"}], ")"}], "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"p", "[", "zmid", "]"}], "/.", "nsol2"}], ")"}]}], ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"h", "[", "zmid", "]"}], "/.", "nsol1"}], ")"}], "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"h", "[", "zmid", "]"}], "/.", "nsol2"}], ")"}]}], ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"a", "[", "zmid", "]"}], "/.", "nsol1"}], ")"}], "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"a", "[", "zmid", "]"}], "/.", "nsol2"}], ")"}]}], ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"T", "[", "zmid", "]"}], "/.", "nsol1"}], ")"}], "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"T", "[", "zmid", "]"}], "/.", "nsol2"}], ")"}]}], ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"S", "[", "zmid", "]"}], "/.", "nsol1"}], ")"}], "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"S", "[", "zmid", "]"}], "/.", "nsol2"}], ")"}]}]}], 
          "}"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"dlist", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"p", "'"}], "[", "zmid", "]"}], "/.", "nsol1"}], ")"}],
             "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"p", "'"}], "[", "zmid", "]"}], "/.", "nsol2"}], 
             ")"}]}], ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"a", "'"}], "[", "zmid", "]"}], "/.", "nsol1"}], ")"}],
             "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"a", "'"}], "[", "zmid", "]"}], "/.", "nsol2"}], 
             ")"}]}], ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"S", "'"}], "[", "zmid", "]"}], "/.", "nsol1"}], ")"}],
             "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"S", "'"}], "[", "zmid", "]"}], "/.", "nsol2"}], 
             ")"}]}]}], "}"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"Return", "[", 
         RowBox[{"Join", "[", 
          RowBox[{"list", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"dlist", "[", 
              RowBox[{"[", "1", "]"}], "]"}], ",", 
             RowBox[{"dlist", "[", 
              RowBox[{"[", "2", "]"}], "]"}], ",", 
             RowBox[{"dlist", "[", 
              RowBox[{"[", "3", "]"}], "]"}]}], "}"}]}], "]"}], "]"}], 
        ";"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"output", "\[Equal]", "0"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"ptab", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{
              RowBox[{"p", "[", "z", "]"}], "/.", "nsol2"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"20", "eps"}], ",", 
             RowBox[{"100", "eps"}], ",", 
             RowBox[{"10", "eps"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"htab", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{
              RowBox[{"h", "[", "z", "]"}], "/.", "nsol2"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"20", "eps"}], ",", 
             RowBox[{"100", "eps"}], ",", 
             RowBox[{"10", "eps"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"atab", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{
              RowBox[{"a", "[", "z", "]"}], "/.", "nsol2"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"20", "eps"}], ",", 
             RowBox[{"100", "eps"}], ",", 
             RowBox[{"10", "eps"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Ttab", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{
              RowBox[{
               RowBox[{"T", "[", "z", "]"}], "-", "1"}], "/.", "nsol2"}]}], 
            "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"20", "eps"}], ",", 
             RowBox[{"100", "eps"}], ",", 
             RowBox[{"10", "eps"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Stab", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{
              RowBox[{"S", "[", "z", "]"}], "/.", "nsol2"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"20", "eps"}], ",", 
             RowBox[{"100", "eps"}], ",", 
             RowBox[{"10", "eps"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"pfit", "=", 
         RowBox[{"Fit", "[", 
          RowBox[{"ptab", ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"z", "^", "2"}]}], "}"}], ",", "z"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"hfit", "=", 
         RowBox[{"Fit", "[", 
          RowBox[{"htab", ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"z", "^", "2"}]}], "}"}], ",", "z"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"afit", "=", 
         RowBox[{"Fit", "[", 
          RowBox[{"atab", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "z"}], "}"}], ",", "z"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Tfit", "=", 
         RowBox[{"Fit", "[", 
          RowBox[{"Ttab", ",", 
           RowBox[{"{", 
            RowBox[{"z", ",", 
             RowBox[{"z", "^", "2"}], ",", 
             RowBox[{"z", "^", "3"}]}], "}"}], ",", "z"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Sfit", "=", 
         RowBox[{"Fit", "[", 
          RowBox[{"Stab", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "z"}], "}"}], ",", "z"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"pfit2", "=", 
         RowBox[{"Fit", "[", 
          RowBox[{"ptab", ",", 
           RowBox[{"{", 
            RowBox[{"z", "^", "2"}], "}"}], ",", "z"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"hfit2", "=", 
         RowBox[{"Fit", "[", 
          RowBox[{"htab", ",", 
           RowBox[{"{", 
            RowBox[{"z", "^", "2"}], "}"}], ",", "z"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Tfit2", "=", 
         RowBox[{"Fit", "[", 
          RowBox[{"Ttab", ",", 
           RowBox[{"{", 
            RowBox[{"z", "^", "3"}], "}"}], ",", "z"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Return", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"pf", "==", "pfit"}], ",", 
             RowBox[{"hf", "\[Equal]", "hfit"}], ",", 
             RowBox[{"af", "\[Equal]", "afit"}], ",", 
             RowBox[{"Tf", "\[Equal]", "Tfit"}], ",", 
             RowBox[{"Sf", "\[Equal]", "Sfit"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"pfit2", ",", "hfit2", ",", "Tfit2"}], "}"}]}], "}"}], 
         "]"}], ";"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], 
     ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", ")"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.5376407771099586`*^9, 3.53764077742128*^9}, {
   3.537640849432414*^9, 3.537641029700471*^9}, {3.537641083186082*^9, 
   3.5376410832815037`*^9}, {3.537641227496984*^9, 3.537641241071927*^9}, {
   3.537641278231781*^9, 3.53764129200132*^9}, {3.537811594660029*^9, 
   3.537811661635552*^9}, 3.537811712330718*^9, {3.537812313668707*^9, 
   3.537812329718534*^9}, {3.537812368025175*^9, 3.537812466952651*^9}, {
   3.537812574550178*^9, 3.53781262207281*^9}, {3.537855902100842*^9, 
   3.537855910975484*^9}, {3.537863637889791*^9, 3.537863642968212*^9}, {
   3.53786405512639*^9, 3.5378640577014513`*^9}, {3.5378642740193357`*^9, 
   3.5378642823266706`*^9}, {3.537864945886372*^9, 3.537864949610241*^9}, {
   3.537865324468916*^9, 3.5378653414829493`*^9}, {3.537865422417637*^9, 
   3.537865426010881*^9}, {3.537865668894218*^9, 3.5378656720161123`*^9}, {
   3.537866060689427*^9, 3.537866086110963*^9}, {3.537866821965849*^9, 
   3.537866824468356*^9}, {3.537866935754058*^9, 3.5378669532770844`*^9}, {
   3.537867277477654*^9, 3.537867283864683*^9}, {3.5378673736645327`*^9, 
   3.53786741047612*^9}, {3.537867724358015*^9, 3.537867770909184*^9}, {
   3.537867812374217*^9, 3.537867814824875*^9}, {3.537867862682262*^9, 
   3.537867863608501*^9}, {3.537867935345325*^9, 3.537867952471974*^9}, {
   3.537867984898217*^9, 3.5378679871300287`*^9}, {3.537870400150711*^9, 
   3.537870402077724*^9}, {3.537870448958918*^9, 3.5378704524785967`*^9}, {
   3.537870930220189*^9, 3.537870930900414*^9}, 3.537871139674671*^9, {
   3.537871192589308*^9, 3.53787120155658*^9}, {3.537871653378598*^9, 
   3.5378716648098917`*^9}, {3.537871703252593*^9, 3.537871787942024*^9}, {
   3.537871824557847*^9, 3.537871910740779*^9}, {3.537871941253039*^9, 
   3.5378719525649443`*^9}, {3.537871994498852*^9, 3.537872049059258*^9}, {
   3.537872138421897*^9, 3.537872144006673*^9}, {3.537872196836445*^9, 
   3.53787224947705*^9}, {3.5378722878468122`*^9, 3.537872372883222*^9}, {
   3.537872490150178*^9, 3.537872496093255*^9}, {3.537872547385435*^9, 
   3.537872561998753*^9}, {3.537872800792879*^9, 3.5378728967451353`*^9}, {
   3.537872969967389*^9, 3.537872993322166*^9}, {3.5378733845638*^9, 
   3.537873523491342*^9}, {3.537874990501849*^9, 3.5378750749448233`*^9}, {
   3.538046326178605*^9, 3.5380463263452587`*^9}, {3.538046359506956*^9, 
   3.5380464610359497`*^9}, {3.538046502103581*^9, 3.538046513481264*^9}, {
   3.53804657410702*^9, 3.538046614577108*^9}, {3.53804665505602*^9, 
   3.538046715360199*^9}, {3.538046757351519*^9, 3.53804676998315*^9}, {
   3.5380468595384607`*^9, 3.5380468659616413`*^9}, {3.538046897437215*^9, 
   3.538046897572302*^9}, {3.538047066640044*^9, 3.538047074544244*^9}, {
   3.538047229999874*^9, 3.5380472836305647`*^9}, {3.538047353035921*^9, 
   3.538047363818179*^9}, {3.538047476249525*^9, 3.538047522111104*^9}, {
   3.5380475966181917`*^9, 3.5380475967702713`*^9}, {3.538047801532692*^9, 
   3.538047822201064*^9}, {3.538047948516816*^9, 3.538047948684765*^9}, {
   3.538114366350466*^9, 3.5381144299925222`*^9}, {3.538114576757052*^9, 
   3.5381146749454412`*^9}, {3.538114791107875*^9, 3.5381148266944447`*^9}, {
   3.538114878968347*^9, 3.538115127215603*^9}, {3.53811552595366*^9, 
   3.538115590252236*^9}, {3.5381156363832006`*^9, 3.538115704042387*^9}, {
   3.53811589099817*^9, 3.53811590783984*^9}, {3.538115999280501*^9, 
   3.5381160364460382`*^9}, 3.538116068499432*^9, {3.5381163172614202`*^9, 
   3.5381163185592117`*^9}, 3.538116587083933*^9, {3.538116795975728*^9, 
   3.5381167961435547`*^9}, {3.538116915101754*^9, 3.538116916845715*^9}, {
   3.538117082639504*^9, 3.5381170838467207`*^9}, {3.538117120446578*^9, 
   3.538117121605109*^9}, {3.538117912630061*^9, 3.5381179255489893`*^9}, {
   3.538118168821506*^9, 3.538118170682723*^9}, {3.5381182778513527`*^9, 
   3.538118288943109*^9}, {3.5381183580154047`*^9, 3.5381183581193533`*^9}, {
   3.538118848337666*^9, 3.538118920486744*^9}, {3.538119184188271*^9, 
   3.53811918440349*^9}, {3.5381193489118156`*^9, 3.538119350612996*^9}, {
   3.538119892508926*^9, 3.538119895751055*^9}, {3.538119927591441*^9, 
   3.538119936248074*^9}, {3.538120029047421*^9, 3.538120037965654*^9}, {
   3.538120194027095*^9, 3.538120201471917*^9}, {3.53812028017563*^9, 
   3.538120301265314*^9}, {3.5381381252717533`*^9, 3.538138126469459*^9}, {
   3.538328246372367*^9, 3.5383282504354353`*^9}, {3.5383283005077343`*^9, 
   3.538328335488717*^9}, {3.538329001230315*^9, 3.538329010372521*^9}, {
   3.5383292041149054`*^9, 3.538329214953123*^9}, {3.5383314262207823`*^9, 
   3.538331427882743*^9}, {3.538467415297628*^9, 3.538467417025399*^9}, {
   3.538467483475766*^9, 3.538467496260305*^9}, {3.53846768282121*^9, 
   3.538467684491909*^9}, 3.538467751698575*^9, 3.538467834293067*^9, 
   3.538467910310305*^9, {3.538474665252652*^9, 3.5384747132015*^9}, {
   3.53847578605576*^9, 3.538475802638404*^9}, {3.538483710131217*^9, 
   3.5384837122828617`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"vec", "=", 
   RowBox[{"SetPrecision", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "0.38294689173"}], ",", "0.737530942", ",", "0.965841225",
        ",", "0.324651407", ",", 
       RowBox[{"-", "0.2824206686"}], ",", "3.00617950", ",", 
       RowBox[{"-", "3.022120996"}], ",", 
       RowBox[{"-", "3.2550707204"}]}], "}"}], ",", "30"}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.538395488974235*^9, 3.538395494671344*^9}, {
  3.538475270148683*^9, 3.538475278100976*^9}, {3.5384753323016653`*^9, 
  3.538475399427929*^9}, {3.5384755290732517`*^9, 3.538475544392206*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"q", "=", 
    RowBox[{"SetPrecision", "[", 
     RowBox[{"3.0", ",", "30"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"z0", "=", 
   RowBox[{"SetPrecision", "[", 
    RowBox[{"1.0", ",", "30"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5384755568817177`*^9, 3.5384755586157703`*^9}, {
  3.5384757492560873`*^9, 3.538475756552244*^9}}],

Cell[BoxData[
 RowBox[{"eq0", "=", 
  RowBox[{"inteq", "[", 
   RowBox[{"z0", ",", 
    RowBox[{"vec", "[", 
     RowBox[{"[", "1", "]"}], "]"}], ",", "q", ",", 
    RowBox[{"vec", "[", 
     RowBox[{"[", "2", "]"}], "]"}], ",", 
    RowBox[{"vec", "[", 
     RowBox[{"[", "3", "]"}], "]"}], ",", 
    RowBox[{"vec", "[", 
     RowBox[{"[", "4", "]"}], "]"}], ",", 
    RowBox[{"vec", "[", 
     RowBox[{"[", "5", "]"}], "]"}], ",", 
    RowBox[{"vec", "[", 
     RowBox[{"[", "6", "]"}], "]"}], ",", 
    RowBox[{"vec", "[", 
     RowBox[{"[", "7", "]"}], "]"}], ",", 
    RowBox[{"vec", "[", 
     RowBox[{"[", "8", "]"}], "]"}], ",", "2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.53847589349119*^9, 3.5384758939548798`*^9}}],

Cell[BoxData[
 RowBox[{"Precision", "[", "eq0", "]"}]], "Input",
 CellChangeTimes->{{3.538475941247263*^9, 3.538475945849679*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"mat", "=", 
    RowBox[{"{", "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"eq0", "=", 
    RowBox[{"inteq", "[", 
     RowBox[{"z0", ",", 
      RowBox[{"vec", "[", 
       RowBox[{"[", "1", "]"}], "]"}], ",", "q", ",", 
      RowBox[{"vec", "[", 
       RowBox[{"[", "2", "]"}], "]"}], ",", 
      RowBox[{"vec", "[", 
       RowBox[{"[", "3", "]"}], "]"}], ",", 
      RowBox[{"vec", "[", 
       RowBox[{"[", "4", "]"}], "]"}], ",", 
      RowBox[{"vec", "[", 
       RowBox[{"[", "5", "]"}], "]"}], ",", 
      RowBox[{"vec", "[", 
       RowBox[{"[", "6", "]"}], "]"}], ",", 
      RowBox[{"vec", "[", 
       RowBox[{"[", "7", "]"}], "]"}], ",", 
      RowBox[{"vec", "[", 
       RowBox[{"[", "8", "]"}], "]"}], ",", "2"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DX", " ", "=", 
    RowBox[{"SetPrecision", "[", 
     RowBox[{"0.001", ",", "30"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Do", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"vec0", "=", "vec"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"vec0", "[", 
        RowBox[{"[", "jj", "]"}], "]"}], "-=", "DX"}], " ", ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"eq1", "=", 
       RowBox[{"inteq", "[", 
        RowBox[{"z0", ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", "q", ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "2", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "3", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "4", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "5", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "6", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "7", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "8", "]"}], "]"}], ",", "2"}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"vec0", "[", 
        RowBox[{"[", "jj", "]"}], "]"}], "+=", 
       RowBox[{"2", "*", "DX"}]}], " ", ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"eq2", "=", 
       RowBox[{"inteq", "[", 
        RowBox[{"z0", ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", "q", ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "2", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "3", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "4", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "5", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "6", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "7", "]"}], "]"}], ",", 
         RowBox[{"vec0", "[", 
          RowBox[{"[", "8", "]"}], "]"}], ",", "2"}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"AppendTo", "[", 
       RowBox[{"mat", ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"eq2", "-", "eq1"}], ")"}], "/", 
         RowBox[{"(", 
          RowBox[{"2", "*", "DX"}], ")"}]}]}], "]"}], ";"}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"jj", ",", "1", ",", "8"}], "}"}]}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<det = \>\"", ",", 
     RowBox[{"Det", "[", "mat", "]"}]}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"dvec", "=", 
    RowBox[{
     RowBox[{"Inverse", "[", 
      RowBox[{"Transpose", "[", "mat", "]"}], "]"}], ".", "eq0"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"vec", " ", "=", " ", 
    RowBox[{"vec", "-", "dvec"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<vec = \>\"", ",", "vec", ",", "\"\<  ->  eq = \>\"", ",", "eq0"}], 
   "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.538120490121634*^9, 3.538120518932563*^9}, {
   3.5381205558741503`*^9, 3.538120610837431*^9}, {3.5381206659362717`*^9, 
   3.538120712255209*^9}, {3.5383285846229553`*^9, 3.538328585388818*^9}, {
   3.538328684844769*^9, 3.5383286852597733`*^9}, 3.538328770081517*^9, {
   3.5383289405611877`*^9, 3.5383289561436033`*^9}, {3.538329024216524*^9, 
   3.538329027272518*^9}, {3.538329231307086*^9, 3.538329245530115*^9}, {
   3.53832928014611*^9, 3.5383292802257977`*^9}, {3.538331899292232*^9, 
   3.538331918317177*^9}, {3.5383320080930357`*^9, 3.53833201029294*^9}, {
   3.5383320534615726`*^9, 3.538332054173419*^9}, {3.538332091130785*^9, 
   3.538332091290278*^9}, {3.538332148467001*^9, 3.538332166530912*^9}, {
   3.538332763655594*^9, 3.538332763839275*^9}, 3.538332811566271*^9, {
   3.5383329603107758`*^9, 3.538333014609095*^9}, {3.538372704879333*^9, 
   3.538372748091798*^9}, {3.538380094711239*^9, 3.538380095245941*^9}, {
   3.538475565399063*^9, 3.538475570349143*^9}, {3.538475761638802*^9, 
   3.5384757666307983`*^9}, {3.538475930088382*^9, 3.538475933711309*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"vec", "=", 
   RowBox[{"SetPrecision", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "0.3829468"}], ",", "0.737530", ",", "0.9658412", ",", 
       "0.32465140", ",", 
       RowBox[{"-", "0.28242066"}], ",", "3.006179", ",", 
       RowBox[{"-", "3.0221209"}], ",", 
       RowBox[{"-", "3.255070"}]}], "}"}], ",", "30"}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.538395488974235*^9, 3.538395494671344*^9}, {
  3.538487155497856*^9, 3.5384871600489283`*^9}, {3.538487422110376*^9, 
  3.53848743906916*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"q", "=", 
   RowBox[{"SetPrecision", "[", 
    RowBox[{"3.0", ",", "30"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.5384871726643677`*^9, 3.538487176504283*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"nsol", "=", 
   RowBox[{"FindRoot", "[", 
    RowBox[{
     RowBox[{"inteq", "[", 
      RowBox[{
       RowBox[{"SetPrecision", "[", 
        RowBox[{"1.", ",", "30"}], "]"}], ",", "x1", ",", "q", ",", "x2", ",",
        "x3", ",", "x4", ",", "x5", ",", "x6", ",", "x7", ",", "x8", ",", 
       "2"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x1", ",", 
       RowBox[{"vec", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x2", ",", 
       RowBox[{"vec", "[", 
        RowBox[{"[", "2", "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x3", ",", 
       RowBox[{"vec", "[", 
        RowBox[{"[", "3", "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x4", ",", 
       RowBox[{"vec", "[", 
        RowBox[{"[", "4", "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x5", ",", 
       RowBox[{"vec", "[", 
        RowBox[{"[", "5", "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x6", ",", 
       RowBox[{"vec", "[", 
        RowBox[{"[", "6", "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x7", ",", 
       RowBox[{"vec", "[", 
        RowBox[{"[", "7", "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x8", ",", 
       RowBox[{"vec", "[", 
        RowBox[{"[", "8", "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"WorkingPrecision", "\[Rule]", "25"}]}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
    RowBox[{"inteq", "[", 
     RowBox[{
     "1.", ",", "x1", ",", "q", ",", "x2", ",", "x3", ",", "x4", ",", "x5", 
      ",", "x6", ",", "x7", ",", "x8", ",", "2"}], "]"}], "/.", "nsol"}], 
   "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.5383955289097357`*^9, 3.538395607280014*^9}, {
  3.5384675702538347`*^9, 3.538467573581067*^9}, {3.538467922768297*^9, 
  3.5384679239991417`*^9}, {3.5384871845792227`*^9, 3.538487189060872*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"NR", "=", "20"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"NN", "=", 
   RowBox[{"NR", "-", "1"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.51763841954007*^9, 3.517638421220167*^9}, {
   3.53850182798134*^9, 3.538501830676206*^9}, {3.53873119805525*^9, 
   3.538731198141795*^9}, 3.538741113249531*^9, 3.538808539493106*^9, 
   3.538808990452856*^9, {3.5388105439971848`*^9, 3.538810586676996*^9}, {
   3.543736247015036*^9, 3.543736247074452*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ChebR", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       FractionBox["1", "2"], 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"Cos", "[", 
          FractionBox[
           RowBox[{"\[Pi]", " ", "ii"}], "NN"], "]"}]}], ")"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"ii", ",", "NN", ",", "0", ",", 
        RowBox[{"-", "1"}]}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"N", "[", "ChebR", "]"}]}], "Input",
 CellChangeTimes->{{3.5175504275379143`*^9, 3.517550473868642*^9}, {
   3.5175505088539352`*^9, 3.51755057150263*^9}, {3.5175531815270977`*^9, 
   3.517553182781066*^9}, {3.5175532841430807`*^9, 3.517553285717567*^9}, {
   3.5175533447190742`*^9, 3.517553345933249*^9}, {3.517553478839162*^9, 
   3.5175534801413918`*^9}, {3.517553697086974*^9, 3.5175537300535307`*^9}, {
   3.517636043667302*^9, 3.517636082342285*^9}, {3.517636156121964*^9, 
   3.517636163909718*^9}, 3.517636245951754*^9, {3.517637708503521*^9, 
   3.517637710805746*^9}, {3.5176384245898523`*^9, 3.5176384266140013`*^9}, {
   3.517639920088458*^9, 3.517639921413632*^9}, {3.517639981975692*^9, 
   3.517640027901559*^9}}],

Cell[BoxData[
 RowBox[{"aval", "=", 
  RowBox[{
   RowBox[{"asyma0", "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"asymp2", "\[Rule]", "x4"}], ",", 
      RowBox[{"asymh2", "\[Rule]", "x5"}], ",", 
      RowBox[{"asyma0", "\[Rule]", "x6"}], ",", 
      RowBox[{"asyma1", "\[Rule]", "x7"}], ",", 
      RowBox[{"asymT3", "\[Rule]", "x8"}]}], "}"}]}], "/.", 
   "nsol"}]}]], "Input",
 CellChangeTimes->{{3.538503869006027*^9, 3.538503871118003*^9}, {
  3.538504557033042*^9, 3.538504557751896*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"plist", "=", 
    RowBox[{"Join", "[", 
     RowBox[{
      RowBox[{"{", "0", "}"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{
         FractionBox["1", "z"], 
         RowBox[{"p", "[", "z", "]"}]}], "/.", "nsol1"}], "/.", 
       RowBox[{"{", 
        RowBox[{"z", "\[Rule]", 
         RowBox[{"ChebR", "[", 
          RowBox[{"[", 
           RowBox[{"2", ";;", 
            RowBox[{"-", "2"}]}], "]"}], "]"}]}], "}"}]}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{
          FractionBox[
           RowBox[{"horizp", "[", "z", "]"}], "z"], "/.", 
          RowBox[{"{", 
           RowBox[{"z", "\[Rule]", "1"}], "}"}]}], "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"horizp0", "\[Rule]", "x1"}], ",", 
           RowBox[{"horizh0", "\[Rule]", "0"}], ",", 
           RowBox[{"horiza1", "\[Rule]", "q"}], ",", 
           RowBox[{"horizt1", "\[Rule]", "x2"}], ",", 
           RowBox[{"horizs0", "\[Rule]", "x3"}]}], "}"}]}], "/.", "nsol"}], 
       "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"hlist", "=", 
    RowBox[{"Join", "[", 
     RowBox[{
      RowBox[{"{", "0", "}"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{
         FractionBox["1", "z"], 
         RowBox[{"h", "[", "z", "]"}]}], "/.", "nsol1"}], "/.", 
       RowBox[{"{", 
        RowBox[{"z", "\[Rule]", 
         RowBox[{"ChebR", "[", 
          RowBox[{"[", 
           RowBox[{"2", ";;", 
            RowBox[{"-", "2"}]}], "]"}], "]"}]}], "}"}]}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{
          FractionBox[
           RowBox[{"horizh", "[", "z", "]"}], "z"], "/.", 
          RowBox[{"{", 
           RowBox[{"z", "\[Rule]", "1"}], "}"}]}], "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"horizp0", "\[Rule]", "x1"}], ",", 
           RowBox[{"horizh0", "\[Rule]", "0"}], ",", 
           RowBox[{"horiza1", "\[Rule]", "q"}], ",", 
           RowBox[{"horizt1", "\[Rule]", "x2"}], ",", 
           RowBox[{"horizs0", "\[Rule]", "x3"}]}], "}"}]}], "/.", "nsol"}], 
       "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"alist", "=", 
    RowBox[{"Join", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"Expand", "[", 
           FractionBox[
            RowBox[{
             RowBox[{"asyma", "[", "z", "]"}], "-", "asyma0"}], "z"], "]"}], "/.", 
          RowBox[{"{", 
           RowBox[{"z", "\[Rule]", "0"}], "}"}]}], "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"asymp2", "\[Rule]", "x4"}], ",", 
           RowBox[{"asymh2", "\[Rule]", "x5"}], ",", 
           RowBox[{"asyma0", "\[Rule]", "x6"}], ",", 
           RowBox[{"asyma1", "\[Rule]", "x7"}], ",", 
           RowBox[{"asymT3", "\[Rule]", "x8"}]}], "}"}]}], "/.", "nsol"}], 
       "}"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           FractionBox["1", "z"], 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"a", "[", "z", "]"}], "-", "asyma0"}], ")"}]}], "/.", 
          "nsol1"}], "/.", 
         RowBox[{"{", 
          RowBox[{"z", "\[Rule]", 
           RowBox[{"ChebR", "[", 
            RowBox[{"[", 
             RowBox[{"2", ";;", 
              RowBox[{"-", "2"}]}], "]"}], "]"}]}], "}"}]}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"asymp2", "\[Rule]", "x4"}], ",", 
          RowBox[{"asymh2", "\[Rule]", "x5"}], ",", 
          RowBox[{"asyma0", "\[Rule]", "x6"}], ",", 
          RowBox[{"asyma1", "\[Rule]", "x7"}], ",", 
          RowBox[{"asymT3", "\[Rule]", "x8"}]}], "}"}]}], "/.", "nsol"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           FractionBox[
            RowBox[{
             RowBox[{"horiza", "[", "z", "]"}], "-", "asyma0"}], "z"], "/.", 
           RowBox[{"{", 
            RowBox[{"z", "\[Rule]", "1"}], "}"}]}], "/.", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"horizp0", "\[Rule]", "x1"}], ",", 
            RowBox[{"horizh0", "\[Rule]", "0"}], ",", 
            RowBox[{"horiza1", "\[Rule]", "q"}], ",", 
            RowBox[{"horizt1", "\[Rule]", "x2"}], ",", 
            RowBox[{"horizs0", "\[Rule]", "x3"}]}], "}"}]}], "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"asymp2", "\[Rule]", "x4"}], ",", 
           RowBox[{"asymh2", "\[Rule]", "x5"}], ",", 
           RowBox[{"asyma0", "\[Rule]", "x6"}], ",", 
           RowBox[{"asyma1", "\[Rule]", "x7"}], ",", 
           RowBox[{"asymT3", "\[Rule]", "x8"}]}], "}"}]}], "/.", "nsol"}], 
       "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Tlist", "=", 
    RowBox[{"Join", "[", 
     RowBox[{
      RowBox[{"{", "0", "}"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{
         FractionBox["1", 
          RowBox[{"z", "^", "2"}]], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"T", "[", "z", "]"}], "-", "1"}], ")"}]}], "/.", "nsol1"}],
        "/.", 
       RowBox[{"{", 
        RowBox[{"z", "\[Rule]", 
         RowBox[{"ChebR", "[", 
          RowBox[{"[", 
           RowBox[{"2", ";;", 
            RowBox[{"-", "2"}]}], "]"}], "]"}]}], "}"}]}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"horizT", "[", "z", "]"}], "-", "1"}], 
           RowBox[{"z", "^", "2"}]], "/.", 
          RowBox[{"{", 
           RowBox[{"z", "\[Rule]", "1"}], "}"}]}], "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"horizp0", "\[Rule]", "x1"}], ",", 
           RowBox[{"horizh0", "\[Rule]", "0"}], ",", 
           RowBox[{"horiza1", "\[Rule]", "q"}], ",", 
           RowBox[{"horizt1", "\[Rule]", "x2"}], ",", 
           RowBox[{"horizs0", "\[Rule]", "x3"}]}], "}"}]}], "/.", "nsol"}], 
       "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Slist", "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"{", "0", "}"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{
        FractionBox["1", 
         RowBox[{"z", "^", "2"}]], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"S", "[", "z", "]"}], "-", "1"}], ")"}]}], "/.", "nsol1"}], 
      "/.", 
      RowBox[{"{", 
       RowBox[{"z", "\[Rule]", 
        RowBox[{"ChebR", "[", 
         RowBox[{"[", 
          RowBox[{"2", ";;", 
           RowBox[{"-", "2"}]}], "]"}], "]"}]}], "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{
         FractionBox[
          RowBox[{
           RowBox[{"horizS", "[", "z", "]"}], "-", "1"}], 
          RowBox[{"z", "^", "2"}]], "/.", 
         RowBox[{"{", 
          RowBox[{"z", "\[Rule]", "1"}], "}"}]}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"horizp0", "\[Rule]", "x1"}], ",", 
          RowBox[{"horizh0", "\[Rule]", "0"}], ",", 
          RowBox[{"horiza1", "\[Rule]", "q"}], ",", 
          RowBox[{"horizt1", "\[Rule]", "x2"}], ",", 
          RowBox[{"horizs0", "\[Rule]", "x3"}]}], "}"}]}], "/.", "nsol"}], 
      "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.538502159684472*^9, 3.538502221978693*^9}, {
  3.538503165035289*^9, 3.538503299421774*^9}, {3.5385033330026503`*^9, 
  3.5385033914641247`*^9}, {3.5385034512324057`*^9, 3.538503487889101*^9}, {
  3.538503647371841*^9, 3.538503649375634*^9}, {3.538503718913886*^9, 
  3.538503801543604*^9}, {3.538503905800393*^9, 3.538503951275783*^9}, {
  3.538504241391078*^9, 3.53850425647017*^9}, {3.5385044634506683`*^9, 
  3.538504467631667*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"file", " ", "=", " ", 
    RowBox[{"OpenWrite", "[", 
     RowBox[{"\"\<~/Work/AdSCMTDyn3/Matlab/init.dat\>\"", ",", " ", 
      RowBox[{"BinaryFormat", " ", "\[Rule]", " ", "True"}]}], "]"}]}], ";"}],
   "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Print", "[", "file", "]"}], ";"}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{"  ", 
  RowBox[{
   RowBox[{"BinaryWrite", "[", 
    RowBox[{"file", ",", "aval", ",", " ", "\"\<Real64\>\""}], "]"}], ";"}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Do", "[", "\n", "  ", "\n", "  ", 
    RowBox[{
     RowBox[{
      RowBox[{"BinaryWrite", "[", 
       RowBox[{"file", ",", " ", 
        RowBox[{"plist", "[", 
         RowBox[{"[", "ii", "]"}], "]"}], ",", " ", "\"\<Real64\>\""}], "]"}],
       ";", "\[IndentingNewLine]", "\[IndentingNewLine]", " ", 
      RowBox[{"BinaryWrite", "[", 
       RowBox[{"file", ",", " ", 
        RowBox[{"hlist", "[", 
         RowBox[{"[", "ii", "]"}], "]"}], ",", " ", "\"\<Real64\>\""}], "]"}],
       ";", "\[IndentingNewLine]", "\[IndentingNewLine]", " ", 
      RowBox[{"BinaryWrite", "[", 
       RowBox[{"file", ",", " ", 
        RowBox[{"alist", "[", 
         RowBox[{"[", "ii", "]"}], "]"}], ",", " ", "\"\<Real64\>\""}], "]"}],
       ";", "\[IndentingNewLine]", "\[IndentingNewLine]", " ", 
      RowBox[{"BinaryWrite", "[", 
       RowBox[{"file", ",", " ", 
        RowBox[{"Tlist", "[", 
         RowBox[{"[", "ii", "]"}], "]"}], ",", " ", "\"\<Real64\>\""}], "]"}],
       ";", "\[IndentingNewLine]", "\[IndentingNewLine]", " ", 
      RowBox[{"BinaryWrite", "[", 
       RowBox[{"file", ",", " ", 
        RowBox[{"Slist", "[", 
         RowBox[{"[", "ii", "]"}], "]"}], ",", " ", "\"\<Real64\>\""}], "]"}],
       ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"ii", ",", " ", "1", ",", " ", "NR"}], "}"}]}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Close", "[", "file", "]"}], ";"}], "\n"}], "Input",
 CellChangeTimes->{{3.5385020074997997`*^9, 3.538502020253977*^9}, {
   3.538502054087071*^9, 3.5385021529179296`*^9}, {3.538504511144497*^9, 
   3.538504585717393*^9}, {3.538504623909217*^9, 3.5385046463399553`*^9}, {
   3.538726443406577*^9, 3.538726445469967*^9}, 3.54373434032411*^9}],

Cell[BoxData["aval"], "Input",
 CellChangeTimes->{{3.538727363712104*^9, 3.538727364132785*^9}, {
  3.538727421558289*^9, 3.5387274460290956`*^9}}],

Cell[BoxData["NR"], "Input",
 CellChangeTimes->{{3.538727377866576*^9, 3.538727377933123*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Numerics - Unbroken", "Subsubtitle",
 CellChangeTimes->{{3.538463013798025*^9, 3.5384630213987093`*^9}, {
  3.538467402992407*^9, 3.5384674058714247`*^9}, {3.538985525635343*^9, 
  3.538985527153359*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"NR", "=", "20"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"NN", "=", 
   RowBox[{"NR", "-", "1"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.51763841954007*^9, 3.517638421220167*^9}, {
   3.53850182798134*^9, 3.538501830676206*^9}, {3.53873119805525*^9, 
   3.538731198141795*^9}, 3.538741113249531*^9, 3.538808539493106*^9, 
   3.538808990452856*^9, {3.5388105439971848`*^9, 3.538810586676996*^9}, {
   3.543734747237671*^9, 3.5437347473106213`*^9}, 3.5437353134547043`*^9, 
   3.543749518444067*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ChebR", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       FractionBox["1", "2"], 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"Cos", "[", 
          FractionBox[
           RowBox[{"\[Pi]", " ", "ii"}], "NN"], "]"}]}], ")"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"ii", ",", "NN", ",", "0", ",", 
        RowBox[{"-", "1"}]}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"N", "[", "ChebR", "]"}]}], "Input",
 CellChangeTimes->{{3.5175504275379143`*^9, 3.517550473868642*^9}, {
   3.5175505088539352`*^9, 3.51755057150263*^9}, {3.5175531815270977`*^9, 
   3.517553182781066*^9}, {3.5175532841430807`*^9, 3.517553285717567*^9}, {
   3.5175533447190742`*^9, 3.517553345933249*^9}, {3.517553478839162*^9, 
   3.5175534801413918`*^9}, {3.517553697086974*^9, 3.5175537300535307`*^9}, {
   3.517636043667302*^9, 3.517636082342285*^9}, {3.517636156121964*^9, 
   3.517636163909718*^9}, 3.517636245951754*^9, {3.517637708503521*^9, 
   3.517637710805746*^9}, {3.5176384245898523`*^9, 3.5176384266140013`*^9}, {
   3.517639920088458*^9, 3.517639921413632*^9}, {3.517639981975692*^9, 
   3.517640027901559*^9}, {3.5389860399222803`*^9, 3.538986051129409*^9}}],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{"aval", ",", "p", ",", "h", ",", "a", ",", "T", ",", "S"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.5389856150179768`*^9, 3.538985619269599*^9}, {
  3.5389867130184183`*^9, 3.538986714170092*^9}, {3.538986804615107*^9, 
  3.538986816726158*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"p", "[", "z_", "]"}], ":=", "\[Epsilon]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"h", "[", "z_", "]"}], ":=", "0"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"a", "[", "z_", "]"}], ":=", 
   RowBox[{"3", "-", 
    RowBox[{"q", " ", "z"}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"T", "[", "z_", "]"}], ":=", 
   RowBox[{"1", "-", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "+", 
       RowBox[{
        FractionBox["1", "4"], 
        RowBox[{"q", "^", "2"}]}]}], ")"}], " ", 
     RowBox[{"z", "^", "3"}]}], "+", 
    RowBox[{
     FractionBox["1", "4"], 
     RowBox[{"q", "^", "2"}], " ", 
     RowBox[{"z", "^", "4"}]}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"S", "[", "z_", "]"}], ":=", "1"}]}], "Input",
 CellChangeTimes->{{3.507012851251483*^9, 3.50701290255637*^9}, {
   3.507012980512628*^9, 3.507013071185956*^9}, {3.50701380646482*^9, 
   3.507013808591444*^9}, {3.50701392897845*^9, 3.507014009338502*^9}, {
   3.507014045652314*^9, 3.5070140489415493`*^9}, {3.507014084805723*^9, 
   3.5070140856041527`*^9}, {3.5070141539580584`*^9, 3.507014217035973*^9}, 
   3.507014460216051*^9, {3.507014517553883*^9, 3.507014519521122*^9}, {
   3.507026986030282*^9, 3.507027007021398*^9}, {3.507027070606153*^9, 
   3.507027080174543*^9}, {3.5070273643135653`*^9, 3.507027373246945*^9}, 
   3.5070274403882923`*^9, 3.5070279834807796`*^9, {3.507028075087616*^9, 
   3.5070280889777718`*^9}, {3.507028169096327*^9, 3.507028182040041*^9}, {
   3.507028215371438*^9, 3.507028217825584*^9}, {3.507028437267254*^9, 
   3.507028504540182*^9}, {3.50702863903891*^9, 3.507028654513768*^9}, {
   3.5070286982702312`*^9, 3.46039287528255*^9}, {3.460397966335395*^9, 
   3.460397978314865*^9}, {3.460402248264339*^9, 3.460402248933331*^9}, {
   3.460402414899728*^9, 3.4604024462493258`*^9}, {3.460402479395108*^9, 
   3.460402480589229*^9}, {3.4604025220234127`*^9, 3.4604025824098186`*^9}, 
   3.4605146917556133`*^9, {3.460514753254294*^9, 3.460514758331274*^9}, {
   3.460514795295472*^9, 3.460514803263382*^9}, {3.460514836976565*^9, 
   3.460514841157256*^9}, 3.4605327642625523`*^9, {3.460532958549329*^9, 
   3.460532965277766*^9}, {3.460533012519267*^9, 3.460366754063628*^9}, {
   3.460366868363885*^9, 3.460366894840983*^9}, {3.460379729737464*^9, 
   3.4603797299742203`*^9}, {3.537487062261228*^9, 3.537487094008017*^9}, {
   3.537493957818071*^9, 3.537493959306265*^9}, {3.5374940621890287`*^9, 
   3.537494111418051*^9}, {3.538985584177477*^9, 3.538985599024313*^9}, {
   3.53898566037003*^9, 3.538985663298764*^9}, {3.538985694375431*^9, 
   3.538985752536989*^9}, 3.538985795674563*^9}],

Cell[BoxData[
 RowBox[{"T", "[", "1", "]"}]], "Input",
 CellChangeTimes->{{3.538985754767921*^9, 3.5389857560546093`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Simplify", "[", "eqlist", "]"}], "/.", 
  RowBox[{"{", 
   RowBox[{"\[Epsilon]", "\[Rule]", "0"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.5389856530849533`*^9, 3.538985700420933*^9}, {
  3.538985764598106*^9, 3.5389857663737926`*^9}}],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{"p", ",", "h", ",", "a", ",", "T", ",", "S"}], "]"}]], "Input",
 CellChangeTimes->{{3.5389867601265717`*^9, 3.538986761510334*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"plist", "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"{", "0", "}"}], ",", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         FractionBox["1", "z"], 
         RowBox[{"p", "[", "z", "]"}]}], "/.", 
        RowBox[{"z", "\[Rule]", 
         RowBox[{"ChebR", "[", 
          RowBox[{"[", "ii", "]"}], "]"}]}]}], ",", 
       RowBox[{"{", 
        RowBox[{"ii", ",", "2", ",", "NR"}], "}"}]}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"hlist", "=", 
    RowBox[{"Join", "[", 
     RowBox[{
      RowBox[{"{", "0", "}"}], ",", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          FractionBox["1", "z"], 
          RowBox[{"h", "[", "z", "]"}]}], "/.", 
         RowBox[{"z", "\[Rule]", 
          RowBox[{"ChebR", "[", 
           RowBox[{"[", "ii", "]"}], "]"}]}]}], ",", 
        RowBox[{"{", 
         RowBox[{"ii", ",", "2", ",", "NR"}], "}"}]}], "]"}]}], "]"}]}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"alist", "=", 
    RowBox[{"Join", "[", 
     RowBox[{
      RowBox[{"{", "0", "}"}], ",", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          FractionBox["1", "z"], 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"a", "[", "z", "]"}], "-", "aval"}], ")"}]}], "/.", 
         RowBox[{"z", "\[Rule]", 
          RowBox[{"ChebR", "[", 
           RowBox[{"[", "ii", "]"}], "]"}]}]}], ",", 
        RowBox[{"{", 
         RowBox[{"ii", ",", "2", ",", "NR"}], "}"}]}], "]"}]}], "]"}]}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Tlist", "=", 
    RowBox[{"Join", "[", 
     RowBox[{
      RowBox[{"{", "0", "}"}], ",", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          FractionBox["1", 
           RowBox[{"z", "^", "2"}]], 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"T", "[", "z", "]"}], "-", "1"}], ")"}]}], "/.", 
         RowBox[{"z", "\[Rule]", 
          RowBox[{"ChebR", "[", 
           RowBox[{"[", "ii", "]"}], "]"}]}]}], ",", 
        RowBox[{"{", 
         RowBox[{"ii", ",", "2", ",", "NR"}], "}"}]}], "]"}]}], "]"}]}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Slist", "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"{", "0", "}"}], ",", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         FractionBox["1", 
          RowBox[{"z", "^", "2"}]], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"S", "[", "z", "]"}], "-", "1"}], ")"}]}], "/.", 
        RowBox[{"z", "\[Rule]", 
         RowBox[{"ChebR", "[", 
          RowBox[{"[", "ii", "]"}], "]"}]}]}], ",", 
       RowBox[{"{", 
        RowBox[{"ii", ",", "2", ",", "NR"}], "}"}]}], "]"}]}], "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.538502159684472*^9, 3.538502221978693*^9}, {
  3.538503165035289*^9, 3.538503299421774*^9}, {3.5385033330026503`*^9, 
  3.5385033914641247`*^9}, {3.5385034512324057`*^9, 3.538503487889101*^9}, {
  3.538503647371841*^9, 3.538503649375634*^9}, {3.538503718913886*^9, 
  3.538503801543604*^9}, {3.538503905800393*^9, 3.538503951275783*^9}, {
  3.538504241391078*^9, 3.53850425647017*^9}, {3.5385044634506683`*^9, 
  3.538504467631667*^9}, {3.538985892124278*^9, 3.538985994625936*^9}, {
  3.538986027757465*^9, 3.5389860283252296`*^9}, {3.538986835591592*^9, 
  3.538986835671126*^9}, {3.538999265602706*^9, 3.538999328993082*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"p", "[", "z_", "]"}], ":=", "0"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"h", "[", "z_", "]"}], ":=", "0"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"a", "[", "z_", "]"}], ":=", 
   RowBox[{"3", "-", 
    RowBox[{"q", " ", "z"}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"T", "[", "z_", "]"}], ":=", 
   RowBox[{"1", "-", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "+", 
       RowBox[{
        FractionBox["1", "4"], 
        RowBox[{"q", "^", "2"}]}]}], ")"}], " ", 
     RowBox[{"z", "^", "3"}]}], "+", 
    RowBox[{
     FractionBox["1", "4"], 
     RowBox[{"q", "^", "2"}], " ", 
     RowBox[{"z", "^", "4"}]}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"S", "[", "z_", "]"}], ":=", "1"}]}], "Input",
 CellChangeTimes->{{3.507012851251483*^9, 3.50701290255637*^9}, {
   3.507012980512628*^9, 3.507013071185956*^9}, {3.50701380646482*^9, 
   3.507013808591444*^9}, {3.50701392897845*^9, 3.507014009338502*^9}, {
   3.507014045652314*^9, 3.5070140489415493`*^9}, {3.507014084805723*^9, 
   3.5070140856041527`*^9}, {3.5070141539580584`*^9, 3.507014217035973*^9}, 
   3.507014460216051*^9, {3.507014517553883*^9, 3.507014519521122*^9}, {
   3.507026986030282*^9, 3.507027007021398*^9}, {3.507027070606153*^9, 
   3.507027080174543*^9}, {3.5070273643135653`*^9, 3.507027373246945*^9}, 
   3.5070274403882923`*^9, 3.5070279834807796`*^9, {3.507028075087616*^9, 
   3.5070280889777718`*^9}, {3.507028169096327*^9, 3.507028182040041*^9}, {
   3.507028215371438*^9, 3.507028217825584*^9}, {3.507028437267254*^9, 
   3.507028504540182*^9}, {3.50702863903891*^9, 3.507028654513768*^9}, {
   3.5070286982702312`*^9, 3.46039287528255*^9}, {3.460397966335395*^9, 
   3.460397978314865*^9}, {3.460402248264339*^9, 3.460402248933331*^9}, {
   3.460402414899728*^9, 3.4604024462493258`*^9}, {3.460402479395108*^9, 
   3.460402480589229*^9}, {3.4604025220234127`*^9, 3.4604025824098186`*^9}, 
   3.4605146917556133`*^9, {3.460514753254294*^9, 3.460514758331274*^9}, {
   3.460514795295472*^9, 3.460514803263382*^9}, {3.460514836976565*^9, 
   3.460514841157256*^9}, 3.4605327642625523`*^9, {3.460532958549329*^9, 
   3.460532965277766*^9}, {3.460533012519267*^9, 3.460366754063628*^9}, {
   3.460366868363885*^9, 3.460366894840983*^9}, {3.460379729737464*^9, 
   3.4603797299742203`*^9}, {3.537487062261228*^9, 3.537487094008017*^9}, {
   3.537493957818071*^9, 3.537493959306265*^9}, {3.5374940621890287`*^9, 
   3.537494111418051*^9}, {3.538985584177477*^9, 3.538985599024313*^9}, {
   3.53898566037003*^9, 3.538985663298764*^9}, {3.538985694375431*^9, 
   3.538985752536989*^9}, 3.538985795674563*^9, 3.538986011486863*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"aval", "=", 
   RowBox[{"a", "[", "0", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.538503869006027*^9, 3.538503871118003*^9}, {
  3.538504557033042*^9, 3.538504557751896*^9}, {3.538985779939569*^9, 
  3.538985810144496*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"q", "=", "3.05"}], ";"}]], "Input",
 CellChangeTimes->{{3.5389867796132174`*^9, 3.538986782685376*^9}, {
  3.543749500757925*^9, 3.543749501435857*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"file", " ", "=", " ", 
    RowBox[{"OpenWrite", "[", 
     RowBox[{"\"\<~/Work/AdSCMTDyn3/matlab/init.dat\>\"", ",", " ", 
      RowBox[{"BinaryFormat", " ", "\[Rule]", " ", "True"}]}], "]"}]}], ";"}],
   "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Print", "[", "file", "]"}], ";"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{"  ", 
  RowBox[{
   RowBox[{"BinaryWrite", "[", 
    RowBox[{"file", ",", "aval", ",", " ", "\"\<Real64\>\""}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Do", "[", "\n", "  ", "\n", "  ", 
    RowBox[{
     RowBox[{
      RowBox[{"BinaryWrite", "[", 
       RowBox[{"file", ",", " ", 
        RowBox[{"plist", "[", 
         RowBox[{"[", "ii", "]"}], "]"}], ",", " ", "\"\<Real64\>\""}], "]"}],
       ";", "\[IndentingNewLine]", "\[IndentingNewLine]", " ", 
      RowBox[{"BinaryWrite", "[", 
       RowBox[{"file", ",", " ", 
        RowBox[{"hlist", "[", 
         RowBox[{"[", "ii", "]"}], "]"}], ",", " ", "\"\<Real64\>\""}], "]"}],
       ";", "\[IndentingNewLine]", "\[IndentingNewLine]", " ", 
      RowBox[{"BinaryWrite", "[", 
       RowBox[{"file", ",", " ", 
        RowBox[{"alist", "[", 
         RowBox[{"[", "ii", "]"}], "]"}], ",", " ", "\"\<Real64\>\""}], "]"}],
       ";", "\[IndentingNewLine]", "\[IndentingNewLine]", " ", 
      RowBox[{"BinaryWrite", "[", 
       RowBox[{"file", ",", " ", 
        RowBox[{"Tlist", "[", 
         RowBox[{"[", "ii", "]"}], "]"}], ",", " ", "\"\<Real64\>\""}], "]"}],
       ";", "\[IndentingNewLine]", "\[IndentingNewLine]", " ", 
      RowBox[{"BinaryWrite", "[", 
       RowBox[{"file", ",", " ", 
        RowBox[{"Slist", "[", 
         RowBox[{"[", "ii", "]"}], "]"}], ",", " ", "\"\<Real64\>\""}], "]"}],
       ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"ii", ",", " ", "1", ",", " ", "NR"}], "}"}]}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Close", "[", "file", "]"}], ";"}], "\n"}], "Input",
 CellChangeTimes->{{3.5385020074997997`*^9, 3.538502020253977*^9}, {
   3.538502054087071*^9, 3.5385021529179296`*^9}, {3.538504511144497*^9, 
   3.538504585717393*^9}, {3.538504623909217*^9, 3.5385046463399553`*^9}, {
   3.538726443406577*^9, 3.538726445469967*^9}, {3.5389858674047813`*^9, 
   3.538985868491022*^9}, 3.543734330538042*^9}],

Cell[BoxData["aval"], "Input",
 CellChangeTimes->{{3.538727363712104*^9, 3.538727364132785*^9}, {
  3.538727421558289*^9, 3.5387274460290956`*^9}}],

Cell[BoxData["NR"], "Input",
 CellChangeTimes->{{3.538727377866576*^9, 3.538727377933123*^9}}],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{"p", ",", "h", ",", "a", ",", "T", ",", "S"}], "]"}]], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"p", "[", "z_", "]"}], ":=", "\[Epsilon]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"h", "[", "z_", "]"}], ":=", "0"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"a", "[", "z_", "]"}], ":=", 
   RowBox[{"3", "-", 
    RowBox[{"q", " ", "z"}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"T", "[", "z_", "]"}], ":=", 
   RowBox[{"1", "-", 
    RowBox[{"m", " ", 
     RowBox[{"z", "^", "3"}]}], "+", 
    RowBox[{
     FractionBox["1", "4"], " ", 
     RowBox[{"q", "^", "2"}], " ", 
     RowBox[{"z", "^", "4"}]}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"S", "[", "z_", "]"}], ":=", "1"}]}], "Input",
 CellChangeTimes->{{3.507012851251483*^9, 3.50701290255637*^9}, {
   3.507012980512628*^9, 3.507013071185956*^9}, {3.50701380646482*^9, 
   3.507013808591444*^9}, {3.50701392897845*^9, 3.507014009338502*^9}, {
   3.507014045652314*^9, 3.5070140489415493`*^9}, {3.507014084805723*^9, 
   3.5070140856041527`*^9}, {3.5070141539580584`*^9, 3.507014217035973*^9}, 
   3.507014460216051*^9, {3.507014517553883*^9, 3.507014519521122*^9}, {
   3.507026986030282*^9, 3.507027007021398*^9}, {3.507027070606153*^9, 
   3.507027080174543*^9}, {3.5070273643135653`*^9, 3.507027373246945*^9}, 
   3.5070274403882923`*^9, 3.5070279834807796`*^9, {3.507028075087616*^9, 
   3.5070280889777718`*^9}, {3.507028169096327*^9, 3.507028182040041*^9}, {
   3.507028215371438*^9, 3.507028217825584*^9}, {3.507028437267254*^9, 
   3.507028504540182*^9}, {3.50702863903891*^9, 3.507028654513768*^9}, {
   3.5070286982702312`*^9, 3.46039287528255*^9}, {3.460397966335395*^9, 
   3.460397978314865*^9}, {3.460402248264339*^9, 3.460402248933331*^9}, {
   3.460402414899728*^9, 3.4604024462493258`*^9}, {3.460402479395108*^9, 
   3.460402480589229*^9}, {3.4604025220234127`*^9, 3.4604025824098186`*^9}, 
   3.4605146917556133`*^9, {3.460514753254294*^9, 3.460514758331274*^9}, {
   3.460514795295472*^9, 3.460514803263382*^9}, {3.460514836976565*^9, 
   3.460514841157256*^9}, 3.4605327642625523`*^9, {3.460532958549329*^9, 
   3.460532965277766*^9}, {3.460533012519267*^9, 3.460366754063628*^9}, {
   3.460366868363885*^9, 3.460366894840983*^9}, {3.460379729737464*^9, 
   3.4603797299742203`*^9}, {3.537487062261228*^9, 3.537487094008017*^9}, {
   3.537493957818071*^9, 3.537493959306265*^9}, {3.5374940621890287`*^9, 
   3.537494111418051*^9}, {3.538985584177477*^9, 3.538985599024313*^9}, {
   3.53898566037003*^9, 3.538985663298764*^9}, {3.538985694375431*^9, 
   3.538985752536989*^9}, 3.538985795674563*^9, {3.5437500541453943`*^9, 
   3.543750078325849*^9}, {3.543750150584614*^9, 3.5437501564071293`*^9}, {
   3.543750187672286*^9, 3.5437502107664747`*^9}, {3.543750291367196*^9, 
   3.543750307126504*^9}}],

Cell[BoxData[
 RowBox[{"T", "[", "zh", "]"}]], "Input",
 CellChangeTimes->{{3.538985754767921*^9, 3.5389857560546093`*^9}, {
  3.543750221565905*^9, 3.5437502487476*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Simplify", "[", "eqlist", "]"}], "/.", 
  RowBox[{"{", 
   RowBox[{"\[Epsilon]", "\[Rule]", "0"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.5389856530849533`*^9, 3.538985700420933*^9}, {
  3.538985764598106*^9, 3.5389857663737926`*^9}}],

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    FractionBox[
     RowBox[{
      RowBox[{"a", "[", "z", "]"}], "-", 
      RowBox[{"a", "[", "0", "]"}]}], "z"], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"q", "\[Rule]", "3.05"}], ",", 
      RowBox[{"m", "\[Rule]", "0"}]}], "}"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"z", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.543750351519446*^9, 3.5437503743583717`*^9}}],

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", "z", "]"}], "//.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"q", "\[Rule]", "3.05"}], ",", 
      RowBox[{"m", "\[Rule]", "4.5"}]}], "}"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"z", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.543750413519299*^9, 3.543750517452866*^9}}],

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    FractionBox[
     RowBox[{"(", 
      FractionBox[
       RowBox[{
        RowBox[{"T", "[", "z", "]"}], "-", "1"}], 
       RowBox[{"z", "^", "2"}]], ")"}], "z"], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"q", "\[Rule]", "3.05"}], ",", 
      RowBox[{"m", "\[Rule]", "4.5"}]}], "}"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"z", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "5"}], ",", "0"}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.543749538683271*^9, 3.543749603108762*^9}, {
  3.543750322598619*^9, 3.543750336989295*^9}, {3.543750527519599*^9, 
  3.543750550461568*^9}}],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{"p", ",", "h", ",", "a", ",", "T", ",", "S"}], "]"}]], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"plist", "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"{", "0", "}"}], ",", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         FractionBox["1", "z"], 
         RowBox[{"p", "[", "z", "]"}]}], "/.", 
        RowBox[{"z", "\[Rule]", 
         RowBox[{"ChebR", "[", 
          RowBox[{"[", "ii", "]"}], "]"}]}]}], ",", 
       RowBox[{"{", 
        RowBox[{"ii", ",", "2", ",", "NR"}], "}"}]}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"hlist", "=", 
    RowBox[{"Join", "[", 
     RowBox[{
      RowBox[{"{", "0", "}"}], ",", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          FractionBox["1", "z"], 
          RowBox[{"h", "[", "z", "]"}]}], "/.", 
         RowBox[{"z", "\[Rule]", 
          RowBox[{"ChebR", "[", 
           RowBox[{"[", "ii", "]"}], "]"}]}]}], ",", 
        RowBox[{"{", 
         RowBox[{"ii", ",", "2", ",", "NR"}], "}"}]}], "]"}]}], "]"}]}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"alist", "=", 
    RowBox[{"Join", "[", 
     RowBox[{
      RowBox[{"{", "0", "}"}], ",", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          FractionBox["1", "z"], 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"a", "[", "z", "]"}], "-", "aval"}], ")"}]}], "/.", 
         RowBox[{"z", "\[Rule]", 
          RowBox[{"ChebR", "[", 
           RowBox[{"[", "ii", "]"}], "]"}]}]}], ",", 
        RowBox[{"{", 
         RowBox[{"ii", ",", "2", ",", "NR"}], "}"}]}], "]"}]}], "]"}]}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Tlist", "=", 
    RowBox[{"Join", "[", 
     RowBox[{
      RowBox[{"{", "0", "}"}], ",", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          FractionBox["1", 
           RowBox[{"z", "^", "2"}]], 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"T", "[", "z", "]"}], "-", "1"}], ")"}]}], "/.", 
         RowBox[{"z", "\[Rule]", 
          RowBox[{"ChebR", "[", 
           RowBox[{"[", "ii", "]"}], "]"}]}]}], ",", 
        RowBox[{"{", 
         RowBox[{"ii", ",", "2", ",", "NR"}], "}"}]}], "]"}]}], "]"}]}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Slist", "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"{", "0", "}"}], ",", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         FractionBox["1", 
          RowBox[{"z", "^", "2"}]], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"S", "[", "z", "]"}], "-", "1"}], ")"}]}], "/.", 
        RowBox[{"z", "\[Rule]", 
         RowBox[{"ChebR", "[", 
          RowBox[{"[", "ii", "]"}], "]"}]}]}], ",", 
       RowBox[{"{", 
        RowBox[{"ii", ",", "2", ",", "NR"}], "}"}]}], "]"}]}], "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.538502159684472*^9, 3.538502221978693*^9}, {
  3.538503165035289*^9, 3.538503299421774*^9}, {3.5385033330026503`*^9, 
  3.5385033914641247`*^9}, {3.5385034512324057`*^9, 3.538503487889101*^9}, {
  3.538503647371841*^9, 3.538503649375634*^9}, {3.538503718913886*^9, 
  3.538503801543604*^9}, {3.538503905800393*^9, 3.538503951275783*^9}, {
  3.538504241391078*^9, 3.53850425647017*^9}, {3.5385044634506683`*^9, 
  3.538504467631667*^9}, {3.538985892124278*^9, 3.538985994625936*^9}, {
  3.538986027757465*^9, 3.5389860283252296`*^9}, {3.538986835591592*^9, 
  3.538986835671126*^9}, {3.538999265602706*^9, 3.538999328993082*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"p", "[", "z_", "]"}], ":=", "0"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"h", "[", "z_", "]"}], ":=", "0"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"a", "[", "z_", "]"}], ":=", 
   RowBox[{"3", "-", 
    RowBox[{"q", " ", "z"}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"T", "[", "z_", "]"}], ":=", 
   RowBox[{"1", "-", 
    RowBox[{"m", " ", 
     RowBox[{"z", "^", "3"}]}], "+", 
    RowBox[{
     FractionBox["1", "4"], " ", 
     RowBox[{"q", "^", "2"}], " ", 
     RowBox[{"z", "^", "4"}]}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"S", "[", "z_", "]"}], ":=", "1"}]}], "Input",
 CellChangeTimes->{{3.507012851251483*^9, 3.50701290255637*^9}, {
   3.507012980512628*^9, 3.507013071185956*^9}, {3.50701380646482*^9, 
   3.507013808591444*^9}, {3.50701392897845*^9, 3.507014009338502*^9}, {
   3.507014045652314*^9, 3.5070140489415493`*^9}, {3.507014084805723*^9, 
   3.5070140856041527`*^9}, {3.5070141539580584`*^9, 3.507014217035973*^9}, 
   3.507014460216051*^9, {3.507014517553883*^9, 3.507014519521122*^9}, {
   3.507026986030282*^9, 3.507027007021398*^9}, {3.507027070606153*^9, 
   3.507027080174543*^9}, {3.5070273643135653`*^9, 3.507027373246945*^9}, 
   3.5070274403882923`*^9, 3.5070279834807796`*^9, {3.507028075087616*^9, 
   3.5070280889777718`*^9}, {3.507028169096327*^9, 3.507028182040041*^9}, {
   3.507028215371438*^9, 3.507028217825584*^9}, {3.507028437267254*^9, 
   3.507028504540182*^9}, {3.50702863903891*^9, 3.507028654513768*^9}, {
   3.5070286982702312`*^9, 3.46039287528255*^9}, {3.460397966335395*^9, 
   3.460397978314865*^9}, {3.460402248264339*^9, 3.460402248933331*^9}, {
   3.460402414899728*^9, 3.4604024462493258`*^9}, {3.460402479395108*^9, 
   3.460402480589229*^9}, {3.4604025220234127`*^9, 3.4604025824098186`*^9}, 
   3.4605146917556133`*^9, {3.460514753254294*^9, 3.460514758331274*^9}, {
   3.460514795295472*^9, 3.460514803263382*^9}, {3.460514836976565*^9, 
   3.460514841157256*^9}, 3.4605327642625523`*^9, {3.460532958549329*^9, 
   3.460532965277766*^9}, {3.460533012519267*^9, 3.460366754063628*^9}, {
   3.460366868363885*^9, 3.460366894840983*^9}, {3.460379729737464*^9, 
   3.4603797299742203`*^9}, {3.537487062261228*^9, 3.537487094008017*^9}, {
   3.537493957818071*^9, 3.537493959306265*^9}, {3.5374940621890287`*^9, 
   3.537494111418051*^9}, {3.538985584177477*^9, 3.538985599024313*^9}, {
   3.53898566037003*^9, 3.538985663298764*^9}, {3.538985694375431*^9, 
   3.538985752536989*^9}, 3.538985795674563*^9, 3.538986011486863*^9, {
   3.54375228922278*^9, 3.543752289606523*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"aval", "=", 
   RowBox[{"a", "[", "0", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.538503869006027*^9, 3.538503871118003*^9}, {
  3.538504557033042*^9, 3.538504557751896*^9}, {3.538985779939569*^9, 
  3.538985810144496*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"q", "=", "3.05"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"m", "=", "4.5"}], ";"}]}], "Input",
 CellChangeTimes->{{3.5389867796132174`*^9, 3.538986782685376*^9}, {
  3.543749500757925*^9, 3.543749501435857*^9}, {3.543752292948531*^9, 
  3.543752314067997*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"file", " ", "=", " ", 
    RowBox[{"OpenWrite", "[", 
     RowBox[{"\"\<~/Work/AdSCMTDyn3/matlab/init.dat\>\"", ",", " ", 
      RowBox[{"BinaryFormat", " ", "\[Rule]", " ", "True"}]}], "]"}]}], ";"}],
   "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Print", "[", "file", "]"}], ";"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{"  ", 
  RowBox[{
   RowBox[{"BinaryWrite", "[", 
    RowBox[{"file", ",", "aval", ",", " ", "\"\<Real64\>\""}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Do", "[", "\n", "  ", "\n", "  ", 
    RowBox[{
     RowBox[{
      RowBox[{"BinaryWrite", "[", 
       RowBox[{"file", ",", " ", 
        RowBox[{"plist", "[", 
         RowBox[{"[", "ii", "]"}], "]"}], ",", " ", "\"\<Real64\>\""}], "]"}],
       ";", "\[IndentingNewLine]", "\[IndentingNewLine]", " ", 
      RowBox[{"BinaryWrite", "[", 
       RowBox[{"file", ",", " ", 
        RowBox[{"hlist", "[", 
         RowBox[{"[", "ii", "]"}], "]"}], ",", " ", "\"\<Real64\>\""}], "]"}],
       ";", "\[IndentingNewLine]", "\[IndentingNewLine]", " ", 
      RowBox[{"BinaryWrite", "[", 
       RowBox[{"file", ",", " ", 
        RowBox[{"alist", "[", 
         RowBox[{"[", "ii", "]"}], "]"}], ",", " ", "\"\<Real64\>\""}], "]"}],
       ";", "\[IndentingNewLine]", "\[IndentingNewLine]", " ", 
      RowBox[{"BinaryWrite", "[", 
       RowBox[{"file", ",", " ", 
        RowBox[{"Tlist", "[", 
         RowBox[{"[", "ii", "]"}], "]"}], ",", " ", "\"\<Real64\>\""}], "]"}],
       ";", "\[IndentingNewLine]", "\[IndentingNewLine]", " ", 
      RowBox[{"BinaryWrite", "[", 
       RowBox[{"file", ",", " ", 
        RowBox[{"Slist", "[", 
         RowBox[{"[", "ii", "]"}], "]"}], ",", " ", "\"\<Real64\>\""}], "]"}],
       ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"ii", ",", " ", "1", ",", " ", "NR"}], "}"}]}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Close", "[", "file", "]"}], ";"}], "\n"}], "Input",
 CellChangeTimes->{{3.5385020074997997`*^9, 3.538502020253977*^9}, {
   3.538502054087071*^9, 3.5385021529179296`*^9}, {3.538504511144497*^9, 
   3.538504585717393*^9}, {3.538504623909217*^9, 3.5385046463399553`*^9}, {
   3.538726443406577*^9, 3.538726445469967*^9}, {3.5389858674047813`*^9, 
   3.538985868491022*^9}, 3.543734330538042*^9}]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1188, 767},
WindowMargins->{{Automatic, 27}, {Automatic, 1}},
FrontEndVersion->"7.0 for Mac OS X x86 (32-bit) (February 18, 2009)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "calcgeom"->{
  Cell[29737, 771, 306, 9, 73, "Input",
   CellTags->"calcgeom"],
  Cell[30046, 782, 293, 10, 73, "Input",
   CellTags->"calcgeom"],
  Cell[30342, 794, 264, 9, 58, "Input",
   CellTags->"calcgeom"],
  Cell[30609, 805, 264, 9, 58, "Input",
   CellTags->"calcgeom"],
  Cell[30876, 816, 3551, 100, 139, "Input",
   CellTags->"calcgeom"],
  Cell[34430, 918, 155, 4, 27, "Input",
   CellTags->"calcgeom"],
  Cell[34792, 930, 5599, 153, 178, "Input",
   CellTags->"calcgeom"],
  Cell[40394, 1085, 142, 4, 27, "Input",
   CellTags->"calcgeom"],
  Cell[40539, 1091, 1615, 48, 88, "Input",
   CellTags->"calcgeom"],
  Cell[42157, 1141, 142, 4, 27, "Input",
   CellTags->"calcgeom"],
  Cell[42302, 1147, 633, 22, 27, "Input",
   CellTags->"calcgeom"],
  Cell[42938, 1171, 1648, 51, 113, "Input",
   CellTags->"calcgeom"],
  Cell[44589, 1224, 142, 4, 27, "Input",
   CellTags->"calcgeom"],
  Cell[44734, 1230, 145, 4, 27, "Input",
   CellTags->"calcgeom"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"calcgeom", 583352, 15301}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 664, 8, 46, "Subtitle"],
Cell[1246, 32, 68, 1, 27, "Input"],
Cell[CellGroupData[{
Cell[1339, 37, 111, 1, 26, "Subsubtitle"],
Cell[1453, 40, 95, 2, 27, "Input"],
Cell[1551, 44, 279, 8, 58, "Input"],
Cell[1833, 54, 266, 9, 58, "Input"],
Cell[2102, 65, 407, 13, 27, "Input"],
Cell[2512, 80, 37, 0, 27, "Input"],
Cell[2552, 82, 257, 8, 58, "Input"],
Cell[2812, 92, 2020, 62, 103, "Input"],
Cell[4835, 156, 26, 0, 27, "Input"],
Cell[4864, 158, 841, 25, 43, "Input"],
Cell[5708, 185, 1026, 31, 58, "Input"],
Cell[6737, 218, 227, 8, 86, "Text"],
Cell[6967, 228, 4015, 95, 238, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[11019, 328, 111, 3, 26, "Subsubtitle"],
Cell[11133, 333, 128, 4, 26, "Text"],
Cell[11264, 339, 6139, 139, 718, "Input"],
Cell[17406, 480, 68, 1, 26, "Text"],
Cell[17477, 483, 3727, 84, 523, "Input"],
Cell[21207, 569, 824, 18, 208, "Input"],
Cell[22034, 589, 4051, 89, 583, "Input"],
Cell[26088, 680, 99, 2, 27, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[26224, 687, 34, 0, 26, "Subsubtitle"],
Cell[26261, 689, 3220, 66, 175, "Input"],
Cell[29484, 757, 28, 0, 27, "Input"],
Cell[29515, 759, 28, 0, 27, "Input"],
Cell[29546, 761, 119, 3, 27, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[29702, 769, 32, 0, 26, "Subsubtitle"],
Cell[29737, 771, 306, 9, 73, "Input",
 CellTags->"calcgeom"],
Cell[30046, 782, 293, 10, 73, "Input",
 CellTags->"calcgeom"],
Cell[30342, 794, 264, 9, 58, "Input",
 CellTags->"calcgeom"],
Cell[30609, 805, 264, 9, 58, "Input",
 CellTags->"calcgeom"],
Cell[30876, 816, 3551, 100, 139, "Input",
 CellTags->"calcgeom"],
Cell[34430, 918, 155, 4, 27, "Input",
 CellTags->"calcgeom"],
Cell[34588, 924, 201, 4, 27, "Input"],
Cell[34792, 930, 5599, 153, 178, "Input",
 CellTags->"calcgeom"],
Cell[40394, 1085, 142, 4, 27, "Input",
 CellTags->"calcgeom"],
Cell[40539, 1091, 1615, 48, 88, "Input",
 CellTags->"calcgeom"],
Cell[42157, 1141, 142, 4, 27, "Input",
 CellTags->"calcgeom"],
Cell[42302, 1147, 633, 22, 27, "Input",
 CellTags->"calcgeom"],
Cell[42938, 1171, 1648, 51, 113, "Input",
 CellTags->"calcgeom"],
Cell[44589, 1224, 142, 4, 27, "Input",
 CellTags->"calcgeom"],
Cell[44734, 1230, 145, 4, 27, "Input",
 CellTags->"calcgeom"]
}, Closed]],
Cell[CellGroupData[{
Cell[44916, 1239, 41, 0, 26, "Subsubtitle"],
Cell[44960, 1241, 173, 4, 27, "Input"],
Cell[45136, 1247, 645, 21, 27, "Input"],
Cell[45784, 1270, 1146, 34, 118, "Input"],
Cell[46933, 1306, 1792, 51, 118, "Input"],
Cell[48728, 1359, 710, 23, 58, "Input"],
Cell[49441, 1384, 3424, 95, 238, "Input"],
Cell[52868, 1481, 388, 12, 27, "Input"],
Cell[53259, 1495, 434, 10, 27, "Input"],
Cell[53696, 1507, 462, 11, 46, "Input"],
Cell[54161, 1520, 4135, 133, 141, "Input"],
Cell[58299, 1655, 6843, 214, 199, "Input"],
Cell[65145, 1871, 237, 5, 27, "Input"],
Cell[65385, 1878, 3999, 129, 141, "Input"],
Cell[69387, 2009, 1262, 33, 148, "Input"],
Cell[70652, 2044, 1027, 21, 58, "Input"],
Cell[71682, 2067, 677, 17, 58, "Input"],
Cell[72362, 2086, 1027, 30, 118, "Input"],
Cell[73392, 2118, 161, 3, 27, "Input"],
Cell[73556, 2123, 745, 18, 88, "Input"],
Cell[74304, 2143, 1146, 32, 238, "Input"],
Cell[75453, 2177, 2030, 59, 33, "Input"],
Cell[77486, 2238, 1339, 40, 33, "Input"],
Cell[78828, 2280, 1074, 32, 88, "Input"],
Cell[79905, 2314, 579, 15, 58, "Input"],
Cell[80487, 2331, 1861, 66, 105, "Input"],
Cell[82351, 2399, 2996, 109, 177, "Input"],
Cell[85350, 2510, 949, 30, 148, "Input"],
Cell[86302, 2542, 1224, 33, 238, "Input"],
Cell[87529, 2577, 929, 26, 27, "Input"],
Cell[88461, 2605, 129, 2, 27, "Input"],
Cell[88593, 2609, 129, 2, 27, "Input"],
Cell[88725, 2613, 129, 2, 27, "Input"],
Cell[88857, 2617, 641, 18, 27, "Input"],
Cell[89501, 2637, 160, 3, 27, "Input"],
Cell[89664, 2642, 699, 22, 83, "Input"],
Cell[90366, 2666, 835, 26, 106, "Input"],
Cell[91204, 2694, 281, 5, 27, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[91522, 2704, 111, 1, 26, "Subsubtitle"],
Cell[91636, 2707, 5196, 153, 148, "Input"],
Cell[96835, 2862, 2758, 74, 328, "Input"],
Cell[99596, 2938, 155, 4, 27, "Input"],
Cell[99754, 2944, 970, 27, 148, "Input"],
Cell[100727, 2973, 1178, 31, 148, "Input"],
Cell[101908, 3006, 1196, 32, 148, "Input"],
Cell[103107, 3040, 1247, 33, 148, "Input"],
Cell[104357, 3075, 1005, 29, 148, "Input"],
Cell[105365, 3106, 1002, 29, 148, "Input"],
Cell[106370, 3137, 1052, 30, 148, "Input"],
Cell[107425, 3169, 1005, 29, 148, "Input"],
Cell[108433, 3200, 1011, 29, 148, "Input"],
Cell[109447, 3231, 1013, 29, 148, "Input"],
Cell[110463, 3262, 1013, 29, 148, "Input"],
Cell[111479, 3293, 162, 3, 27, "Input"],
Cell[111644, 3298, 148, 3, 27, "Input"],
Cell[111795, 3303, 124, 3, 27, "Input"],
Cell[111922, 3308, 123, 3, 27, "Input"],
Cell[112048, 3313, 82, 2, 27, "Input"],
Cell[112133, 3317, 126, 3, 27, "Input"],
Cell[112262, 3322, 179, 3, 27, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[112478, 3330, 159, 2, 26, "Subsubtitle"],
Cell[112640, 3334, 181, 3, 27, "Input"],
Cell[112824, 3339, 2714, 71, 328, "Input"],
Cell[115541, 3412, 4166, 142, 148, "Input"],
Cell[119710, 3556, 255, 6, 27, "Input"],
Cell[119968, 3564, 1183, 31, 148, "Input"],
Cell[121154, 3597, 1005, 29, 148, "Input"],
Cell[122162, 3628, 1003, 29, 148, "Input"],
Cell[123168, 3659, 1054, 30, 148, "Input"],
Cell[124225, 3691, 1056, 30, 148, "Input"],
Cell[125284, 3723, 1054, 30, 148, "Input"],
Cell[126341, 3755, 150, 3, 27, "Input"],
Cell[126494, 3760, 124, 3, 27, "Input"],
Cell[126621, 3765, 124, 3, 27, "Input"],
Cell[126748, 3770, 82, 2, 27, "Input"],
Cell[126833, 3774, 124, 3, 27, "Input"],
Cell[126960, 3779, 179, 3, 27, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[127176, 3787, 117, 1, 26, "Subsubtitle"],
Cell[127296, 3790, 563, 17, 27, "Input"],
Cell[127862, 3809, 127, 2, 27, "Input"],
Cell[127992, 3813, 157, 3, 27, "Input"],
Cell[128152, 3818, 958, 27, 27, "Input"],
Cell[129113, 3847, 1230, 35, 27, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[130380, 3887, 157, 2, 26, "Subsubtitle"],
Cell[130540, 3891, 856, 22, 58, "Input"],
Cell[131399, 3915, 197438, 4848, 4197, "Input"],
Cell[328840, 8765, 53300, 1451, 1605, "Input"],
Cell[382143, 10218, 17271, 442, 328, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[399451, 10665, 99, 1, 26, "Subsubtitle"],
Cell[399553, 10668, 23093, 527, 1768, "Input"],
Cell[422649, 11197, 184, 2, 27, "Input"],
Cell[422836, 11201, 803, 26, 116, "Input"],
Cell[423642, 11229, 416, 12, 58, "Input"],
Cell[424061, 11243, 157, 3, 27, "Input"],
Cell[424221, 11248, 745, 19, 52, "Input"],
Cell[424969, 11269, 771, 23, 88, "Input"],
Cell[425743, 11294, 69, 2, 27, "Input"],
Cell[425815, 11298, 1349, 38, 85, "Input"],
Cell[427167, 11338, 337, 6, 27, "Input"],
Cell[427507, 11346, 758, 19, 52, "Input"],
Cell[428268, 11367, 5289, 134, 448, "Input"],
Cell[433560, 11503, 6963, 158, 678, "Input"],
Cell[440526, 11663, 431, 7, 27, "Input"],
Cell[440960, 11672, 807, 20, 52, "Input"],
Cell[441770, 11694, 5341, 135, 448, "Input"],
Cell[447114, 11831, 132, 2, 27, "Input"],
Cell[447249, 11835, 185, 4, 27, "Input"],
Cell[447437, 11841, 227, 6, 27, "Input"],
Cell[447667, 11849, 590, 13, 43, "Input"],
Cell[448260, 11864, 148, 3, 27, "Input"],
Cell[448411, 11869, 385, 7, 58, "Input"],
Cell[448799, 11878, 363, 9, 27, "Input"],
Cell[449165, 11889, 626, 10, 27, "Input"],
Cell[449794, 11901, 1062, 24, 52, "Input"],
Cell[450859, 11927, 5341, 135, 448, "Input"],
Cell[456203, 12064, 475, 10, 43, "Input"],
Cell[456681, 12076, 69, 2, 27, "Input"],
Cell[456753, 12080, 1693, 50, 73, "Input"],
Cell[458449, 12132, 1266, 39, 88, "Input"],
Cell[459718, 12173, 771, 23, 88, "Input"],
Cell[460492, 12198, 769, 23, 88, "Input"],
Cell[461264, 12223, 771, 23, 88, "Input"],
Cell[462038, 12248, 768, 23, 88, "Input"],
Cell[462809, 12273, 771, 23, 88, "Input"],
Cell[463583, 12298, 4339, 107, 448, "Input"],
Cell[467925, 12407, 323, 9, 43, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[468285, 12421, 167, 2, 26, "Subsubtitle"],
Cell[468455, 12425, 246, 5, 27, "Input"],
Cell[468704, 12432, 23611, 534, 1783, "Input"],
Cell[492318, 12968, 868, 20, 43, "Input"],
Cell[493189, 12990, 475, 10, 43, "Input"],
Cell[493667, 13002, 69, 2, 27, "Input"],
Cell[493739, 13006, 1853, 53, 73, "Input"],
Cell[495595, 13061, 1266, 39, 88, "Input"],
Cell[496864, 13102, 771, 23, 88, "Input"],
Cell[497638, 13127, 769, 23, 88, "Input"],
Cell[498410, 13152, 771, 23, 88, "Input"],
Cell[499184, 13177, 768, 23, 88, "Input"],
Cell[499955, 13202, 771, 23, 88, "Input"],
Cell[500729, 13227, 4339, 107, 448, "Input"],
Cell[505071, 13336, 323, 9, 43, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[505431, 13350, 167, 2, 26, "Subsubtitle"],
Cell[505601, 13354, 394, 7, 27, "Input"],
Cell[505998, 13363, 23926, 542, 1783, "Input"],
Cell[529927, 13907, 648, 15, 27, "Input"],
Cell[530578, 13924, 437, 12, 58, "Input"],
Cell[531018, 13938, 729, 20, 27, "Input"],
Cell[531750, 13960, 130, 2, 27, "Input"],
Cell[531883, 13964, 5499, 138, 448, "Input"],
Cell[537385, 14104, 579, 15, 27, "Input"],
Cell[537967, 14121, 203, 5, 27, "Input"],
Cell[538173, 14128, 1976, 55, 73, "Input"],
Cell[540152, 14185, 536, 12, 58, "Input"],
Cell[540691, 14199, 1235, 27, 81, "Input"],
Cell[541929, 14228, 504, 13, 27, "Input"],
Cell[542436, 14243, 7873, 225, 497, "Input"],
Cell[550312, 14470, 2359, 54, 343, "Input"],
Cell[552674, 14526, 147, 2, 27, "Input"],
Cell[552824, 14530, 94, 1, 27, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[552955, 14536, 210, 3, 26, "Subsubtitle"],
Cell[553168, 14541, 588, 13, 58, "Input"],
Cell[553759, 14556, 1283, 27, 81, "Input"],
Cell[555045, 14585, 295, 6, 27, "Input"],
Cell[555343, 14593, 2828, 58, 169, "Input"],
Cell[558174, 14653, 122, 2, 27, "Input"],
Cell[558299, 14657, 271, 6, 27, "Input"],
Cell[558573, 14665, 179, 3, 27, "Input"],
Cell[558755, 14670, 3622, 105, 235, "Input"],
Cell[562380, 14777, 2841, 58, 169, "Input"],
Cell[565224, 14837, 263, 6, 27, "Input"],
Cell[565490, 14845, 187, 4, 27, "Input"],
Cell[565680, 14851, 2412, 55, 343, "Input"],
Cell[568095, 14908, 147, 2, 27, "Input"],
Cell[568245, 14912, 94, 1, 27, "Input"],
Cell[568342, 14915, 111, 2, 27, "Input"],
Cell[568456, 14919, 2903, 56, 169, "Input"],
Cell[571362, 14977, 170, 3, 27, "Input"],
Cell[571535, 14982, 271, 6, 27, "Input"],
Cell[571809, 14990, 465, 14, 46, "Input"],
Cell[572277, 15006, 482, 14, 27, "Input"],
Cell[572762, 15022, 735, 22, 55, "Input"],
Cell[573500, 15046, 111, 2, 27, "Input"],
Cell[573614, 15050, 3622, 105, 235, "Input"],
Cell[577239, 15157, 2763, 54, 169, "Input"],
Cell[580005, 15213, 263, 6, 27, "Input"],
Cell[580271, 15221, 348, 9, 58, "Input"],
Cell[580622, 15232, 2412, 55, 343, "Input"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
